/**
 *    author:  tourist
 *    created: 23.03.2021 17:36:01
**/
#include <bits/stdc++.h>

using namespace std;

template <typename A, typename B>
string to_string(pair<A, B> p);

template <typename A, typename B, typename C>
string to_string(tuple<A, B, C> p);

template <typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p);

string to_string(const string& s) {
  return '"' + s + '"';
}

string to_string(const char* s) {
  return to_string((string) s);
}

string to_string(bool b) {
  return (b ? "true" : "false");
}

string to_string(vector<bool> v) {
  bool first = true;
  string res = "{";
  for (int i = 0; i < static_cast<int>(v.size()); i++) {
    if (!first) {
      res += ", ";
    }
    first = false;
    res += to_string(v[i]);
  }
  res += "}";
  return res;
}

template <size_t N>
string to_string(bitset<N> v) {
  string res = "";
  for (size_t i = 0; i < N; i++) {
    res += static_cast<char>('0' + v[i]);
  }
  return res;
}

template <typename A>
string to_string(A v) {
  bool first = true;
  string res = "{";
  for (const auto &x : v) {
    if (!first) {
      res += ", ";
    }
    first = false;
    res += to_string(x);
  }
  res += "}";
  return res;
}

template <typename A, typename B>
string to_string(pair<A, B> p) {
  return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template <typename A, typename B, typename C>
string to_string(tuple<A, B, C> p) {
  return "(" + to_string(get<0>(p)) + ", " + to_string(get<1>(p)) + ", " + to_string(get<2>(p)) + ")";
}

template <typename A, typename B, typename C, typename D>
string to_string(tuple<A, B, C, D> p) {
  return "(" + to_string(get<0>(p)) + ", " + to_string(get<1>(p)) + ", " + to_string(get<2>(p)) + ", " + to_string(get<3>(p)) + ")";
}

void debug_out() { cerr << endl; }

template <typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
  cerr << " " << to_string(H);
  debug_out(T...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<vector<int>> g(n);
  vector<vector<int>> lst(n);
  for (int i = 0; i < n; i++) {
    int type, foo;
    cin >> type >> foo;
    if (type == 1) {
      g[i].resize(foo);
      for (int j = 0; j < foo; j++) {
        cin >> g[i][j];
        --g[i][j];
      }
    } else {
      lst[i].resize(foo);
      for (int j = 0; j < foo; j++) {
        cin >> lst[i][j];
      }
      sort(lst[i].begin(), lst[i].end());
      lst[i].resize(unique(lst[i].begin(), lst[i].end()) - lst[i].begin());
    }
  }

  vector<vector<pair<int, int>>> dp(n);
  vector<int> num(n);
  vector<int> link(n);

  function<void(int)> Dfs = [&](int v) {
    if (g[v].empty()) {
      for (int x : lst[v]) {
        dp[v].emplace_back(x, x);
      }
      dp[v].resize(min((int) dp[v].size(), 9));
      link[v] = v;
    } else {
      if (g[v].size() == 1) {
        Dfs(g[v][0]);
        link[v] = link[g[v][0]];
      } else {
        int id = -1;
        for (int u : g[v]) {
          Dfs(u);
          if (id == -1 || dp[link[u]].size() < dp[link[id]].size()) {
            id = u;
          }
        }
        sort(g[v].begin(), g[v].end());
        vector<bool> used(g[v].size(), false);
        function<void(int, int, int)> Brute = [&](int pos, int L, int R) {
          if (pos == (int) g[v].size()) {
            dp[v].emplace_back(L, R);
            return;
          }
          for (int i = 0; i < (int) g[v].size(); i++) {
            if (!used[i]) {
              used[i] = true;
              auto& z = dp[link[g[v][i]]];
              if (pos == 0) {
                for (auto& p : z) {
                  Brute(pos + 1, p.first, p.second);
                }
              } else {
                int low = 0, high = (int) z.size();
                while (low < high) {
                  int mid = (low + high) >> 1;
                  if (z[mid].first <= R) {
                    low = mid + 1;
                  } else {
                    high = mid;
                  }
                }
                if (low < (int) z.size()) {
                  Brute(pos + 1, L, z[low].second);
                }
              }
              used[i] = false;
            }
          }
        };
        Brute(0, -1, -1);
        sort(dp[v].begin(), dp[v].end());
        int j = 0;
        for (int i = 0; i < (int) dp[v].size(); i++) {
          while (j > 0 && dp[v][i].second <= dp[v][j - 1].second) {
            --j;
          }
          if (j == 0 || dp[v][i].first > dp[v][j - 1].first) {
            dp[v][j++] = dp[v][i];
          }
        }
        dp[v].resize(min(j, 9));
        if (dp[v].empty()) {
          cout << "No" << '\n';
          exit(0);
        }
        link[v] = v;
      }
    }
  };

  function<void(int, int, int)> Restore = [&](int v, int L, int R) {
    if (g[v].empty()) {
      for (int x : lst[v]) {
        if (L <= x && x <= R) {
          num[v] = x;
          break;
        }
      }
    } else {
      if (link[v] != v) {
        Restore(link[v], L, R);
        return;
      }
      sort(g[v].begin(), g[v].end());
      do {
        bool ok = true;
        int bound = L - 1;
        for (int i = 0; i < (int) g[v].size(); i++) {
          auto& z = dp[link[g[v][i]]];
          int low = 0, high = (int) z.size();
          while (low < high) {
            int mid = (low + high) >> 1;
            if (z[mid].first <= bound) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          if (low == (int) z.size()) {
            ok = false;
            break;
          }
          bound = z[low].second;
        }
        if (ok && bound <= R) {
          bound = L - 1;
          for (int i = 0; i < (int) g[v].size(); i++) {
            auto& z = dp[link[g[v][i]]];
            int low = 0, high = (int) z.size();
            while (low < high) {
              int mid = (low + high) >> 1;
              if (z[mid].first <= bound) {
                low = mid + 1;
              } else {
                high = mid;
              }
            }
            Restore(g[v][i], z[low].first, z[low].second);
            bound = z[low].second;
          }
          return;
        }
      } while (next_permutation(g[v].begin(), g[v].end()));
      assert(false);
    }
  };

  Dfs(0);
  cout << "Yes" << '\n';
  if (false) {
    int L = dp[link[0]][0].first;
    int R = dp[link[0]][0].second;
    Restore(0, L, R);
    for (int i = 0; i < n; i++) {
      if (g[i].empty()) {
        cout << num[i] << '\n';
      } else {
        for (int j = 0; j < (int) g[i].size(); j++) {
          if (j > 0) {
            cout << " ";
          }
          cout << g[i][j] + 1;
        }
        cout << '\n';
      }
    }
  }
  return 0;
}
