#include <iostream>
#include <vector>

using namespace std;

#define v vector
#define pr pair<int, char>
#define id first
#define ch second

int n, m;

string s;

v<v<pr>> card;
v<int> lst;
v<int> used_pos, used_card;

void init() {
    cin >> n >> m;
    cin >> s;
    card.resize(n);
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        card[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> card[i][j].id >> card[i][j].ch; card[i][j].id--;
        }
    }
    used_pos.resize(m, 0);
    used_card.resize(n, 0);
}

int get_new_card() {
    for (int i = 0; i < n; i++) {
        if (used_card[i]) continue;
        bool ok = true;
        for (auto [index, c] : card[i]) {
            if (!used_pos[index] && c != s[index]) {
                ok = false;
                break;
            }
        }
        if (ok) {
            used_card[i] = 1;
            for (auto [index, c] : card[i]) {
                used_pos[index] = 1;
            }
            return i;
        }
    }
    return -1;
}

void solve() {
    for (int i = 0; i < n; i++) {
        int index = get_new_card();
        if (index == -1) {
            cout << -1 << "\n";
            return;
        }
        lst.push_back(index);
    }
    for (auto j : used_pos) {
        if (!j) {
            cout << -1 << "\n";
            return;
        }
    }
    for (auto j : lst) {
        cout << j + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    init();
    solve();

    return 0;
}

/*
1 1
a
1 1 a
 */

/*
3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f
 */

/*
2 2
aa
2 1 a 2 b
2 1 b 2 a
 */
