#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<int> dfs(int v, vector<vector<int> > &ray, vector<vector<int> > &data)
{
    if (ray[v].size() != 0) return ray[v];
    vector<vector<int> > s;
    for (auto e : data[v])
        s.push_back(dfs(e, ray, data));
    sort(s.begin(), s.end());
    vector<int> p;
    for (int i = 0; i < s.size(); i++)
        for (auto e : s[i]) p.push_back(e);
    return p;
}

vector<int> restore(int v, vector<vector<int> > &ray, vector<vector<int> > &data, vector<vector<int> > &ans)
{
    if (ray[v].size() != 0)
    {
        ans[v] = ray[v];
        return ray[v];
    }
    vector<pair<vector<int>, int> > s;
    for (auto e : data[v])
        s.push_back({restore(e, ray, data, ans), e});
    sort(s.begin(), s.end());
    vector<int> p;
    for (int i = 0; i < s.size(); i++)
        for (auto e : s[i].first) p.push_back(e);
    for (int i = 0; i < s.size(); i++)
        ans[v].push_back(s[i].second);
    return p;
}

void solve1(int n, int m, vector<int> t, vector<int> k, vector<vector<int> > data)
{
    for (int mask = 0; mask < (1 << m); mask++)
    {
        vector<vector<int> > ray2(n);
        int pnt = 0;
        int T = 1;
        for (int i = 0; i < n; i++)
        {
            if (t[i] == 2)
            {
                for (int j = 0; j < data[i].size(); j++)
                {
                    if ((1 << pnt) & mask)
                        ray2[i].push_back(data[i][j]);
                    pnt++;
                }
                if (ray2[i].size() != 1)
                {
                    T = 0;
                    continue;
                }
            }
        }
        if (T)
        {
            vector<int> res = dfs(0, ray2, data);
            int tr = 1;
            for (int i = 1; i < res.size(); i++)
            {
                if (res[i] < res[i - 1]) tr = 0;
            }
            if (tr)
            {
                vector<vector<int> > ans(n);
                restore(0, ray2, data, ans);
                cout << "Yes\n";
                for (int i = 0; i < n; i++)
                {
                    for (auto e : ans[i])
                    {
                        cout << e + 1 << " ";
                    }
                    cout << "\n";
                }
                return;
            }
        }
    }
    cout << "No\n";
}

const int INF = 1e9;
const int N = 2021;
int dp[N][N];

int called[N][N];
int cnt_calls = 0;

vector<int> opt[N][N];
vector<int> meet[N];

void dfs1(int v, vector<int> &t, vector<int> &k, vector<vector<int> > &data)
{
    if (t[v] == 2)
    {
        for (auto e : data[v]) meet[v].push_back(e);
    }
    else
    {
        for (auto e : data[v])
        {
            dfs1(e, t, k, data);
            for (auto c : meet[e])
                meet[v].push_back(c);
        }
    }
    sort(meet[v].begin(), meet[v].end());
}

void dfs2(int v, vector<int> &t, vector<int> &k, vector<vector<int> > &data)
{
    //cout << v << endl;
    if (t[v] == 2)
    {
        sort(data[v].begin(), data[v].end());
        int p = 0;
        for (int i = 0; i < data[v].size(); i++)
        {
            while (p <= data[v][i])
            {
                dp[v][p] = data[v][i];
                p++;
            }
        }
    }
    else
    {
        for (auto e : data[v])
            dfs2(e, t, k, data);
        sort(data[v].begin(), data[v].end());
        for (auto i : meet[v])
        {
            while (1)
            {
                int pnt = i;
                for (auto e : data[v])
                {
                    if (!called[e][pnt]) called[e][pnt] = 1, cnt_calls++;
                    pnt = dp[e][pnt];
                    if (pnt == INF) break;
                }
                if (pnt < dp[v][i])
                {
                    opt[v][i] = data[v];
                    dp[v][i] = pnt;
                }
                if (!next_permutation(data[v].begin(), data[v].end()))
                    break;
            }
            //if (i > 0) assert(opt[v][i] == opt[v][i - 1]);
        }
        for (int i = t.size() - 1; i >= 0; i--)
        {
            if (opt[v][i].size() == 0 && opt[v][i + 1].size() != 0)
                opt[v][i] = opt[v][i + 1], dp[v][i] = dp[v][i + 1];
        }
    }
}

void call(int v, int x, vector<int> &t, vector<int> &k, vector<vector<int> > &data, vector<vector<int> > &ans)
{
    if (t[v] == 2)
    {
        x = dp[v][x];
        ans[v] = {x};
    }
    else
    {
        ans[v] = opt[v][x];
        for (auto e : ans[v])
        {
            call(e, x, t, k, data, ans);
            x = dp[e][x];
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    int m = 0;
    vector<int> t(n), k(n);
    vector<vector<int> > data(n);
    for (int i = 0; i < n; i++)
    {
        cin >> t[i] >> k[i];
        data[i] = vector<int>(k[i]);
        if (t[i] == 2) m += k[i];
        for (int j = 0; j < k[i]; j++)
            cin >> data[i][j], data[i][j]--;
    }

    //solve1(n, m, t, k, data); cout << endl;

    for (int i = 0; i < N; i++)
        for (int j = 0; j < N; j++)
            dp[i][j] = INF;

    vector<int> ids;
    for (int i = 0; i < n; i++)
    {
        if (t[i] == 2)
        {
            for (int j = 0; j < k[i]; j++)
            {
                ids.push_back(data[i][j]);
            }
        }
    }
    sort(ids.begin(), ids.end());
    map<int, int> mm;
    for (int i = 0; i < ids.size(); i++)
    {
        mm[ids[i]] = i;
    }
    for (int i = 0; i < n; i++)
    {
        if (t[i] == 2)
        {
            for (int j = 0; j < k[i]; j++)
            {
                data[i][j] = mm[data[i][j]];
            }
        }
    }

    dfs1(0, t, k, data);
    dfs2(0, t, k, data);
//    for (int i = 0; i < n; i++)
//    {
//        for (int j = 0; j < m; j++)
//        {
//            cout << dp[i][j] << " ";
//        }
//        cout << endl;
//    }
    if (dp[0][0] == INF) cout << "No\n";
    else
    {
        cout << "Yes\n";
        vector<vector<int> > ans(n);
        call(0, 0, t, k, data, ans);
        for (int i = 0; i < n; i++)
        {
            if (t[i] == 1)
            {
                for (auto e : ans[i])
                    cout << e + 1 << " ";
            }
            else
            {
                for (auto e : ans[i])
                    cout << ids[e] + 1 << " ";
            }
            cout << "\n";
        }
    }
    cerr << cnt_calls << endl;
}

/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92

3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3
*/
