#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "map"
using namespace std;
#define all(x) (x).begin(), (x).end()
vector<vector<int>> pole(32, vector<int>(32, 0));
vector<vector<int>> vals(32, vector<int>(32, 0));
int ind = 0;
string inform;
void countvals() {
    for (int i = 0; i < 32; ++i) {
        vals[31][i] = 1 - pole[31][i];
        vals[i][31] = 1 - pole[i][31];
    }
    for (int i = 30; i >= 0; --i) {
        for (int j = 30; j >= 0; --j) {
            vals[i][j] = vals[i + 1][j] + vals[i][j + 1] - vals[i + 1][j + 1] + (1 - pole[i][j]);
        }
    }
}
void turn(int i, int j) {
    //cerr << "TURN " << i << ' ' << j << ' ' << pole[i][j] << endl;
    for (int k = i; k < 32; ++k) {
        for (int l = j; l < 32; ++l) {
            pole[k][l] = 1;
            //cerr << i << ' ' << j << endl;
        }
    }
    countvals();
}
vector<pair<int, pair<int, int>>> seemoves() {
    vector<pair<int, pair<int, int>>> moves;
    for (int i = 0; i < 32; ++i) {
        for (int j = 0; j < 32; ++j) {
            if (pole[i][j] == 0)
                moves.push_back({vals[i][j], {i, j}});
        }
    }
    sort(all(moves));
    return moves;
}
pair<int, int> wingame() {
    if (pole[1][1] == 0)
        return {1, 1};
    int i = 0, j = 0;
    while (i != 32 and pole[i][0] == 0)
        i++;
    while (j != 32 and pole[0][j] == 0)
        j++;
    i--;j--;
    if (i == j)
        return {0, j};
    if (i > j)
        return {j + 1, 0};
    else
        return {0, i + 1};
}
pair<int, int> choise(vector<pair<int, pair<int, int>>> &moves) {
    int t = 0, v = 1;
    while (v <= moves.size()) {
        v *= 2;
        t++;
    }
    t -= 4;
    //cerr << moves.size() << endl;
    if (t <= 2)
        return wingame();
    int val = 0;
    for (int i = 0; i < t; ++i) {
        val *= 2;
        val += inform[ind] == '1';
        ind++;
    }
    return moves[val].second;
}
void DO(pair<int, int> move) {
    turn(move.first, move.second);
    cout << move.first + 1 << ' ' << move.second + 1 << endl;
    //cerr << move.first + 1 << ' ' << move.second + 1 << endl;
}
string understand(vector<pair<int, pair<int, int>>> &moves, pair<int, int> move) {
    int t = 0, v = 1;
    while (v <= moves.size()) {
        v *= 2;
        t++;
    }
    t -= 4;
    //cerr << moves.size();
    if (t <= 2)
        return "";
    int val = 0;
    for (int i = 0; i < moves.size(); ++i) {
        if (moves[i].second == move)
            val = i;
    }
    string s(t, '?');
    for (int i = t - 1; i >= 0; --i) {
        if (val % 2)
            s[i] = '1';
        else
            s[i] = '0';
        val /= 2;
    }
    return s;
}
void game1(int t) {
    for (int i = 0; i < 32; ++i) {
        for (int j = 0; j < 32; ++j) {
            pole[i][j] = 0;
        }
    }
    //cerr << "NEWGAME!!!\n";
    countvals();
    while (pole[0][0] != 1) {
        if (t % 2) {
            auto moves = seemoves();
            DO(choise(moves));
        } else {
            int a, b;
            cin >> a >> b;
            a--;b--;
            //cerr << "op " << a << ' ' << b << endl;
            turn(a, b);
        }
        t++;
    }
}
void solve1brain() {
    int n, k, m;
    cin >> n >> k >> m;
    cin >> inform;
    for (int i = 0; i < 1000; ++i) {
        inform.push_back('0');
    }
    int t = 1;
    while (ind < m) {
        game1(t);
        t++;
    }
    cout << 0 << endl;
}
string word;
void game2(int t) {
    for (int i = 0; i < 32; ++i) {
        for (int j = 0; j < 32; ++j) {
            pole[i][j] = 0;
        }
    }
    countvals();
    while (pole[0][0] != 1) {
        //cout << 1;
        if (t % 2) {
            int a, b;
            auto moves = seemoves();
            cin >> a >> b;
            a--;b--;
            word += understand(moves, {a, b});
            turn(a, b);
        } else {
            int a, b;
            cin >> a >> b;
            a--;b--;
            turn(a, b);
        }
        t++;
    }
}
void solve2brain() {
    int n, m, k;
    cin >> n >> k >> m;
    int t;
    cin >> t;
    int tt = 1;
    while (t--) {
        game2(tt);
        tt++;
    }
    while (word.size() > m)
        word.pop_back();
    cout << word << endl;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //freopen("sb.txt", "r", stdin);
    //freopen("\\\\.\\pipe\\game.in", "r", stdin);
    //freopen("\\\\.\\pipe\\game.out", "w", stdout);
    int k;
    cin >> k;
    if (k == 1)
        solve1brain();
    else
        solve2brain();
}
