#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <queue>

using namespace std;

#define ll long long
#define all(a) a.begin(), a.end()


const int logn = 20;
const int mxn = 1e6;
ll p = 29;
ll mod = 1e9 + 7;
vector<ll> p_pow;


void cnt_p_pow() {
	p_pow.resize(mxn + 1);
	p_pow[0] = 1;
	for (int i = 1; i <= mxn; ++i) {
		p_pow[i] = (p_pow[i - 1] * p) % mod;
	}
}



struct Hasher {
	int sz;
	ll h;

	Hasher() : h(0), sz(0) {}
	Hasher(int a) : sz(1), h(a + 1) {}
};


bool operator==(Hasher h1, Hasher h2) {
	return h1.h == h2.h;
}


Hasher operator+(Hasher h1, Hasher h2) {
	Hasher res;
	res.sz = h1.sz + h2.sz;
	res.h = ((h1.h * p_pow[h2.sz]) % mod + h2.h) % mod;
	return res;
}


const int kmx = 26;


int k, n;
vector<vector<int>> a;
vector<int> x;
vector<int> d;
vector<vector<int>> nxt;
vector<vector<Hasher>> nxt_h;
string s;
vector<string> srs;
string res;


bool comp(int i, int j) {
	for (int c = logn - 1; c >= 0; --c) {
		if (nxt_h[i][c] == nxt_h[j][c]) {
			i = nxt[i][c];
			j = nxt[j][c];
		}
	}
	if (i == n) {
		return true;
	}
	if (j == n) {
		return false;
	}
	return x[i] <= x[j];
}



void cnt_d() {
	cnt_p_pow();
	d.resize(n);
	nxt.resize(n + 1, vector<int>(logn, n));
	nxt_h.resize(n + 1, vector<Hasher>(logn));
	d[n - 1] = n;
	nxt[n - 1].assign(logn, n);
	nxt_h[n - 1].assign(logn, Hasher(x[n - 1]));
	for (int i = n - 2; i >= 0; --i) {
		int j = i + 1;
		nxt[i][0] = j;
		while (j < n && a[x[i]][x[j]] == 1) {
			if (comp(nxt[j][0], nxt[i][0])) {
				nxt[i][0] = nxt[j][0];
			}
			j = d[j];
		}
		nxt_h[i][0] = Hasher(x[i]);
		for (int j = 1; j < logn; ++j) {
			nxt[i][j] = nxt[nxt[i][j - 1]][j - 1];
			nxt_h[i][j] = nxt_h[i][j - 1] + nxt_h[nxt[i][j - 1]][j - 1];
		}
		d[i] = j;
	}
}


int32_t main() {
	cin >> k >> n;
	a.resize(k, vector<int>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char c;
			cin >> c;
			a[i][j] = c - '0';
		}
	}
	cin >> s;
	n = s.size();
	x.resize(n);
	for (int i = 0; i < n; ++i) {
		x[i] = (s[i] - 'a');
	}
	cnt_d();
	for (int i = 0; i != n; i = nxt[i][0]) {
		res.push_back(s[i]);
	}
	cout << res << "\n";
	return 0;
}


/*
3 7
010
001
100
abacaba
*/

/*
3 5
010
001
100
bcacb
*/