#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

void read_card(int *card, const string &s) {
    int k;
    cin >> k;

    for (int i = 0; i < k; ++i) {
        int a;
        char c;

        cin >> a >> c;

        --a;

        if (s[a] == c) card[a] = 1;
        else card[a] = -1;
    }
}

bool fast_check_col(int **cards, int col, int n) {
    for (int i = 0; i < n; ++i) {
        if (cards[i][col] == 1) return true;
    }
    return false;
}

bool fast_check(int **cards, int n, int m) {
    for (int i = 0; i < m; ++i) {
        if (!fast_check_col(cards, i, n)) return false;
    }

    return true;
}

bool check(int **cards, int n, int m, const int *indices) {
    bool *cells = new bool[m];
    for (int i = 0; i < m; ++i) cells[i] = false;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            switch (cards[indices[i]][j]) {
                case 1:
                    cells[j] = true;
                    break;

                case -1:
                    if (!cells[j]) return false;
            }
        }
    }

    for (int i = 0; i < m; ++i) if(!cells[i]) return false;

    return true;
}

int* my_sort(int **cards, int n, int m) {
    int *indices = new int[n];

    for (int i = 0; i < n; ++i) indices[i] = i;

    do {
        if (check(cards, n, m, indices)) return indices;
    } while (next_permutation(indices, indices + n));

    indices[0] = -1;
    return indices;
}

int main() {
    int n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    int **cards = new int*[n];

    for (int i = 0; i < n; ++i) {
        cards[i] = new int[m];

        for (int j = 0; j < m; ++j) cards[i][j] = 0;

        read_card(cards[i], s);
    }

    if (!fast_check(cards, n, m)) {
        cout << -1 << endl;
        return 0;
    }

    auto inds = my_sort(cards, n, m);

    if (inds[0] == -1) cout << -1 << endl;
    else {
        for (int i = 0; i < n; ++i) {
            cout << inds[i] + 1 << " ";
        }
        cout << endl;
    }
}
