#include <bits/extc++.h>

using namespace std;

typedef long long ll;
typedef double dl;
typedef vector<int> vi;

#define nl endl
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define sz(a) (int((a).size()))
#define forn(i, n) for (int i = 0; i < (n); i++)

#ifndef SEVA
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#endif
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,mmx,abm,fma,popcnt,tune=native")

mt19937 rnd(3456);

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

const int N = 32;

int timer;
int field[N][N];
int n, k, m;

void DoMove(int x, int y) {
    for (int i = x; i < n; i++) {
        for (int j = y; j < n; j++) {
            field[i][j] = timer;
        }
    }
}

int AskFree(int x, int y) {
    int ans = 0;
    for (int i = x; i < n; i++) {
        for (int j = y; j < n; j++) {
            ans += field[i][j] != timer;
        }
    }
    return ans;
}

pair<int, int> AskMove() {
    int x, y;
    cin >> x >> y;
    x--, y--;
    return {x, y};
}

void SayMove(int x, int y) {
    cout << x + 1 << ' ' << y + 1 << nl;
}


void Build() {
    string s;
    cin >> s;
    int coded = 0;
    bool myStart = false;
    vector<pair<int, int>> moves;
    forn(i, n) forn(j, n) if (i != 0 || j != 0) moves.emplace_back(i, j);

    while (coded < m) {
        timer++;
        myStart ^= true;
        for (int i = myStart; field[0][0] != timer; i++) {
            if (i & 1) {
                // my move
                bool did = false;
                shuffle(all(moves), rnd);
                for (auto& [x, y] : moves) {
                    int f = AskFree(x, y);
                    int need = s[coded] - '0' + 1;
                    if ((coded < m && f == need)
                        || (coded == m && f > 0)) {
                        did = true;
                        DoMove(x, y);
                        SayMove(x, y);
                        coded++;
                        break;
                    }
                }
                if (!did) {
                    SayMove(0, 0);
                    break;
                }
            } else {
                // bot move
                auto[x, y] = AskMove();
                DoMove(x, y);
            }
        }
    }
    cout << 0 << nl;
}

void Look() {
    int games;
    cin >> games;
    string ans;
    bool myStart = false;
    forn(i, games) {
        timer++;
        myStart ^= true;
        for (int i = myStart; field[0][0] != timer; i++) {
            int x, y;
            cin >> x >> y;
            x--, y--;
            int c = AskFree(x, y);
            DoMove(x, y);
            if (i & 1 && (x != 0 || y != 0)) {
                ans += char('0' + c - 1);
            }
        }
    }
    ans.resize(m);
    cout << ans << nl;
}

void Solve() {
    int type;
    cin >> type;
    cin >> n >> k >> m;
    if (type == 1) {
        Build();
    } else {
        Look();
    }
}

signed main() {
//    IO();
    Solve();
    return 0;
}