#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y)
{
    return y < x ? (x = y, true) : false;
}
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y)
{
    return y > x ? (x = y, true) : false;
}
void debug_out()
{
    cerr << endl;
}
template<typename T1, typename... T2> void debug_out(T1 A, T2... B)
{
    cerr << ' ' << A;
    debug_out(B...);
}
template<typename T> void mdebug_out(T* a, int n)
{
    for (int i = 0; i < n; ++i)
        cerr << a[i] << ' ';
    cerr << endl;
}
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T> &a)
{
    for (auto& x : a)
        stream << x << ' ';
    return stream;
}
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2>& p)
{
    return stream << p.first << ' ' << p.second;
}

const int maxN = 100005;
const int smallN = 2003;
const int INF32 = 0x3f3f3f3f;
int n;
int tp[maxN];
vector<int> G[maxN];
int rv[maxN], cv[maxN], V;

int encodePerm(vector<int> p)
{
    int res = 0;
    for (int x : p)
        res = res * 8 + x;
    return res;
}
vector<int> decodePerm(int R, int k)
{
    vector<int> p;
    for (int i = 0; i < k; ++i)
    {
        p.push_back(R % 8);
        R /= 8;
    }
    reverse(all(p));
    return p;
}

int dp[smallN][smallN];
int perm[smallN][smallN];
vector<int> rperm[smallN][smallN];
int dq[1 << 8];
int pr[1 << 8];

void dfs(int v)
{
    if (tp[v] == 1)
    {
        int k = G[v].size();
        for (int u : G[v]) dfs(u);
        for (int l = 0; l < V; ++l)
        {
            fill(dq, dq + (1 << k), INF32);
            fill(pr, pr + (1 << k), 0);
            dq[0] = -1;
            for (int mask = 1; mask < (1 << k); ++mask)
            {
                for (int i = 0; i < k; ++i) if (mask & (1 << i))
                {
                    int u = G[v][i];
                    int subm = mask ^ (1 << i);
                    if (dq[subm] < V)
                        if (chkmin(dq[mask], dp[u][max(l, dq[subm] + 1)]))
                            pr[mask] = i;
                }
            }
            dp[v][l] = dq[(1 << k) - 1];
            if (dp[v][l] < V)
            {
                vector<int> p;
                for (int mask = (1 << k) - 1; mask != 0; )
                {
                    int i = pr[mask];
                    p.push_back(i);
                    mask ^= (1 << i);
                }
                reverse(all(p));
                perm[v][l] = encodePerm(p);
                rperm[v][l] = p;
            }
        }
    }
    else
    {
        for (int x : G[v])
        {
            dp[v][cv[x]] = cv[x];
        }
    }
    for (int i = V - 1; i >= 0; --i)
    {
        if (chkmin(dp[v][i], dp[v][i + 1]))
        {
            perm[v][i] = perm[v][i + 1];
            rperm[v][i] = vector<int>(all(rperm[v][i + 1]));
        }
//        debug(v, i, (dp[v][i] == INF32 ? dp[v][i] : rv[dp[v][i]]));
    }
}

vector<int> ans[maxN];
int restore(int v, int l)
{
//    debug(v, l);
    if (tp[v] == 1)
    {
        int k = G[v].size();
        auto p = rperm[v][l];//decodePerm(perm[v][l], k);
        ans[v].resize(k);
        int last = l - 1;
        for (int i = 0; i < k; ++i)
        {
            int u = G[v][p[i]];
            ans[v][i] = u;
            last = restore(u, last + 1);
        }
        return last;
    }
    else
    {
        sort(all(G[v]));
        int i = 0;
        while (G[v][i] < rv[l])
            ++i;
        int x = G[v][i];
        ans[v] = {x};
        return cv[x];
    }
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    cin >> n;
    for (int v = 1; v <= n; ++v)
    {
        cin >> tp[v];
        int k;
        cin >> k;
        G[v].resize(k);
        for (int& u : G[v])
            cin >> u;
        if (tp[v] == 2)
        {
            for (int& u : G[v])
                rv[V++] = u;
        }
    }
    sort(rv, rv + V);
    for (int i = 0; i < V; ++i)
        cv[rv[i]] = i;
//    mdebug(rv, V);
    memset(dp, 0x3f, sizeof dp);
    dfs(1);
    if (dp[1][0] >= INF32)
    {
        cout << "No\n";
        exit(0);
    }
    cout << "Yes\n";
    restore(1, 0);
    for (int v = 1; v <= n; ++v)
        cout << ans[v] << '\n';

    return 0;
}