#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <list>
#include <stack>
#include <cassert>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)

#define all(a) a.begin(), a.end()

typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
}

void solve();
int main() {
    setup();
    solve();
    return 0;
}

#ifdef LOCAL
const int MAXN = 100 + 10;
#else
const int MAXN = 1e5 + 10;
#endif

int n;
vector<int> sns[MAXN];
vector<pair<int, int>> doks[MAXN];

void dfs(int v) {
    if (sns[v].empty()) return;
    else if (sns[v].size() == 1) {
        dfs(sns[v][0]);
        doks[v] = doks[sns[v][0]];
    } else {
        auto son0 = sns[v][0];
        auto son1 = sns[v][1];
        dfs(son0);
        dfs(son1);
        for (auto[f1, s1] : doks[son0]) {
            for (auto [f2, s2] : doks[son1]) {
                if (s1 < f2) {
                    doks[v].emplace_back(f1, s2);
                } else if (s2 < f1) {
                    doks[v].emplace_back(f2, s1);
                }
            }
        }
    }
}

void solve() {
    cin >> n;
    range(i, n) {
        int t = 0; cin >> t;
        int k; cin >> k;
        if (t == 1) {
            range(_, k) {
                int u; cin >> u; --u;
                sns[i].pb(u);
            }
        } else {
            range(_, k) {
                int u; cin >> u;
                doks[i].emplace_back(u, u);
            }
        }
    }
    dfs(0);
    if (doks[0].size()) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }
}
