#include <bits/stdc++.h>
using namespace std;

const int INF = 1e5 + 10;

int n;

vector<vector<int>> child;
vector<vector<int>> jobs;
vector<vector<int>> maxbymin;
vector<vector<int>> permi;
vector<vector<int>> ans;
vector<int> arr;

vector<int> order;

void dofus(int v) {
	for ( int to : child[v] ) {
		dofus(to);
	}

	if ( !child[v].empty() ) order.push_back(v);
}

void dfs(int v, int x) {
	if ( child[v].empty() ) {
		ans[v].push_back(arr[maxbymin[v][x]]);
	} else {
		vector<int> perm = vector<int>(child[v].size());
		for ( int i = 0; i < perm.size(); ++i ) perm[i] = i;

		for ( int step = 0; step < permi[v][x]; ++step ) {
			next_permutation(perm.begin(), perm.end());
		}

		for ( int i = 0; i < perm.size(); ++i )
			ans[v].push_back(child[v][perm[i]] + 1);

		for ( int j = 0; j < perm.size(); ++j ) {
			if ( x == INF ) break;

			dfs(child[v][perm[j]], x);

			x = maxbymin[child[v][perm[j]]][x];
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	child = vector<vector<int>>(n, vector<int>(0));
	jobs = vector<vector<int>>(n, vector<int>(0));

	int _t, _k; int _x;
	arr = {};
	for ( int i = 0; i < n; ++i ) {
		cin >> _t >> _k;

		for ( int j = 0; j < _k; ++j ) {
			if ( _t == 1 ) {
				cin >> _x;
				_x--;
				child[i].push_back(_x);
			} else {
				cin >> _x;
				jobs[i].push_back(_x);
				arr.push_back(_x);
			}
		}
	}

	sort(arr.begin(), arr.end());
	// arr.erase(unique(arr.begin(), arr.end()), arr.end());

	maxbymin = vector<vector<int>>(n, vector<int>(arr.size(), INF));
	permi = vector<vector<int>>(n, vector<int>(arr.size(), -1));

	for ( int i = 0; i < n; ++i ) {
		if ( child[i].size() > 0 ) continue;
		for ( int j = 0; j < jobs[i].size(); ++j )
			jobs[i][j] = lower_bound(arr.begin(), arr.end(), jobs[i][j]) - arr.begin();
		sort(jobs[i].begin(), jobs[i].end());

		for ( int j = 0; j < jobs[i].size(); ++j ) {
			for ( int x = (j == 0 ? 0 : jobs[i][j - 1] + 1); x <= jobs[i][j]; ++x ) {
				maxbymin[i][x] = jobs[i][j];
			}
		}
	}

	order = {};
	dofus(0);
	vector<int> perm;
	
	for ( int _v = 0; _v < order.size(); ++_v ) {
		int v = order[_v];

		perm = vector<int>(child[v].size());
		for ( int i = 0; i < perm.size(); ++i ) perm[i] = i;
		int perm_n = 0;

		do {
			int cur;
			for ( int x = 0; x < arr.size(); ++x ) {
				cur = x;

				for ( int j = 0; j < perm.size(); ++j ) {
					if ( cur == INF ) break;

					cur = maxbymin[child[v][perm[j]]][cur];
				}

				// maxbymin[v][x] = min(maxbymin[v][x], cur);
				if ( cur <= maxbymin[v][x] ) {
					maxbymin[v][x] = cur;
					permi[v][x] = perm_n;
				}
			}

			perm_n++;
		} while ( next_permutation(perm.begin(), perm.end()) );
	}

	int xval = INF;
	for ( int x = 0; x < arr.size(); ++x ) {
		if ( maxbymin[0][x] != INF ) { xval = x; break; }
	}

	if ( xval == INF ) {
		cout << "No" << "\n";
		return 0;
	}

	ans = vector<vector<int>>(n, vector<int>(0));
	dfs(0, xval);

	cout << "Yes" << "\n";
	for ( int i = 0; i < n; ++i ) {
		for ( int j = 0; j < ans[i].size(); ++j )
			cout << ans[i][j] << " ";
		cout << "\n";
	}
	return 0;
}