#include <iostream>
#include <vector>
#define ll long long

using namespace std;

const ll P = 239;
const ll M = 1e9 + 1329;

vector <ll> pref, pw;
int q;

struct symbol{
    int nt, pv; //next prev
};

ll hash_f(int l, int r) {
    q = (pref[r] - pref[l] * pw[r - l]) % M;
    if (q < 0) q += M;
    return q;
}

signed main() {
    ios_base::sync_with_stdio(false);
    int k, n; cin >> k >> n;
    pw.assign(n + 2, 1);
    pref.assign(n + 1, 0);
    for (int i = 1; i < n + 2; ++i) {
        pw[i] = pw[i - 1] * P;
        if (pw[i] >= M) {
            pw[i] %= M;
        }
    }
    bool c[k][k];
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char b; cin >> b;
            c[i][j] = b - '0';
        }
    }
    vector <char> s(n);
    vector <bool> p(n, 1);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector <symbol> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = {i - 1, i + 1};
    }
    int ind = n - 1;
    while (ind != 0) {
        //cout << ind << "\n";
        if (c[s[a[ind].nt] - 'a'][s[ind] - 'a']) {
            p[ind] = 0;
            if (a[ind].pv == n) {
                ind = a[ind].nt;
            } else {
                a[a[ind].pv].nt = a[ind].nt;
                a[a[ind].nt].pv = a[ind].pv;
                ind = a[ind].pv;
            }
        } else {
            ind = a[ind].nt;
        }
    }
    for (int i = 0; i < n; ++i) {
        a[i] = {i - 1, i + 1};
    }
    vector <int> st(n), mp(n);
    int l = 0, pl = -1, pm = -1;
    ind = n - 1;
    while (ind != 0) {
        if (pl <= l) {
            pref[l + 1] = (pref[l] * P + s[ind]);
            if (pref[l + 1] >= M) {
                pref[l + 1] %= M;
            }
            st[l] = ind;
            if (p[ind]) {
                pm = l;
                mp[l] = l;
            } else if (pm != -1) {
                int L = 0, R = mp[l - 1] + 2;
                while (R - L > 1) {
                    int MID = (L + R) / 2;
                    if (hash_f(l + 1 - MID, l + 1) == hash_f(pm + 1 - MID, pm + 1)) {
                        L = MID;
                    } else {
                        R = MID;
                    }
                }
                if (L == mp[l - 1] + 1) {
                    mp[l] = mp[l - 1];
                } else {
                    if (s[st[l - L]] < s[st[mp[l - 1] - L]]) {
                        mp[l] = l;
                    } else {
                        mp[l] = mp[l - 1];
                    }
                }
            } else {
                mp[l] = -1;
            }
        }
        if (c[s[a[ind].nt] - 'a'][s[ind] - 'a']) {
            if (mp[l] == l) {
                pm = l;
                pl = l;
                l++;
                ind = a[ind].nt;
            } else {
                if (l == pm + 1) {
                    ind = a[ind].nt;
                    pl = l;
                } else {
                    a[a[ind].pv].nt = a[ind].nt;
                    a[a[ind].nt].pv = a[ind].pv;
                    ind = a[ind].pv;
                    pl = l;
                    l--;
                }
            }
        } else {
            ind = a[ind].nt;
            pl = l;
            l++;
        }
    }
    cout << s[0];
    while (l > 0) {
        cout << s[st[l - 1]];
        l--;
    }
}
/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/
