#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

void merge(set<pair<pii, int>>& a, set<pair<pii, int>>& b) {
	if (a.size() < b.size())
		swap(a, b);
	for (auto x : b)
		a.insert(x);
	return;
}

void dfs(int x, string& s, vector<vc>& a, vi& nxt, int n, set<pair<pii, int>>& p, vc& used, vi& r) {
	used[x] = 1;
	int i = x + 1;
	while (i < n) {
		if (!a[s[x] - 'a'][s[i] - 'a'])
			break;
		set<pair<pii, int>> p1;
		dfs(i, s, a, nxt, n, p1, used, r);
		i = r[i];
		merge(p, p1);
	}
	if (x == n - 1)
		p.insert({ { ' ', 0 }, n });
	else
		p.insert({ {s[x + 1], r[x + 1]}, x + 1 });
	nxt[x] = p.begin()->second;
	r[x] = i;
	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int k, n;
	cin >> k >> n;
	vector<vc> a(k, vc(k));
	for (int i = 0; i < k; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < k; ++j)
			if (s[j] == '1')
				a[i][j] = 1;
	}
	string s;
	cin >> s;
	vi nxt(n);
	vc used(n);
	vi r(n);
	for (int i = 0; i < n; ++i)
		r[i] = i + 1;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			set<pair<pii, int>> p;
			dfs(i, s, a, nxt, n, p, used, r);
		}
	}
	string ans;
	int cur = 0;
	while (cur != n) {
		ans += s[cur];
		cur = nxt[cur];
	}
	cout << ans;

	return 0;
}