#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;
const int K = 19;
const int P = 23;

int dfs1(int x, string& s, vector<vc>& a, vc& used, int n) {
	used[x] = 1;
	int i = x + 1;
	while (i < n) {
		if (!a[s[x] - 'a'][s[i] - 'a'])
			break;
		i = dfs1(i, s, a, used, n);
	}
	return i;
}

int n;
string s;
vvi nxt(N, vi(K));
vvi h(N, vi(K));
vi pp(N);

struct C {
	int x;
	C(int x = 0) : x(x) {}

	bool operator < (const C& y) const {
		if (x == n && y.x != n)
			return 1;
		if (y.x == n)
			return 0;
		if (s[x] != s[y.x])
			return s[x] < s[y.x];
		int a = x, b = y.x;
		for (int i = K - 1; i >= 0; --i) {
			if (nxt[a][i] == n || nxt[b][i] == n || h[a][i] == h[b][i])
				continue;
			a = nxt[a][i];
			b = nxt[b][i];
		}
		if (nxt[a][0] == n && nxt[b][0] != n)
			return 1;
		if (nxt[b][0] == n)
			return 0;
		return s[nxt[a][0]] < s[nxt[b][0]];
	}
};

void merge(set<C>& a, set<C>& b) {
	if (a.size() < b.size())
		swap(a, b);
	for (auto x : b)
		a.insert(x);
	return;
}

int dfs(int x, string& s, vector<vc>& a, set<C>& p) {
	int i = x + 1;
	while (i < n) {
		if (!a[s[x] - 'a'][s[i] - 'a'])
			break;
		set<C> p1;
		i = dfs(i, s, a, p1);
		merge(p, p1);
	}
	if (x == n - 1)
		p.insert({ n });
	else
		p.insert({ x + 1 });
	nxt[x][0] = p.begin()->x;
	h[x][0] = s[x];
	for (int k = 1; k < K; ++k) {
		if (nxt[x][k - 1] == n) {
			nxt[x][k] = n;
			h[x][k] = h[x][k - 1];
		}
		else {
			nxt[x][k] = nxt[nxt[x][k - 1]][k - 1];
			h[x][k] = (h[x][k - 1] * pp[k - 1] % MOD + h[nxt[x][k - 1]][k - 1]) % MOD;
		}
	}
	return i;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	pp[0] = 1;
	for (int i = 1; i < N; ++i)
		pp[i] = (pp[i - 1] * P) % MOD;

	int k;
	cin >> k >> n;
	vector<vc> a(k, vc(k));
	for (int i = 0; i < k; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < k; ++j)
			if (s[j] == '1')
				a[i][j] = 1;
	}
	cin >> s;
	vc used(n);
	vi rt;
	for (int i = 0; i < n; ++i) {
		nxt[i][0] = i + 1;
		h[i][0] = s[i];
	}
	for (int k = 1; k < K; ++k) {
		for (int i = 0; i < n; ++i) {
			if (nxt[i][k - 1] == n) {
				nxt[i][k] = n;
				h[i][k] = h[i][k - 1];
			}
			else {
				nxt[i][k] = nxt[nxt[i][k - 1]][k - 1];
				h[i][k] = (h[i][k - 1] * pp[k - 1] % MOD + h[nxt[i][k - 1]][k - 1]) % MOD;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs1(i, s, a, used, n);
			rt.pb(i);
		}
	}
	reverse(rt.begin(), rt.end());
	for (int i : rt) {
		set<C> p;
		dfs(i, s, a, p);
	}
	string ans;
	int cur = 0;
	while (cur != n) {
		ans += s[cur];
		cur = nxt[cur][0];
	}
	cout << ans;

	return 0;
}