#include <bits/stdc++.h>

using namespace std;


vector< vector<int> > adj;
vector< vector<int> > vals;
vector< vector< pair<int, int> > > dp;

void dfs(int u) {
	if(adj[u].size() == 0) {
		sort(vals[u].begin(), vals[u].end());
		for(int x: vals[u]) {
			dp[u].emplace_back(x, x);
		}
		return;
	}

	sort(adj[u].begin(), adj[u].end());

	for(int v: adj[u]) {
		dfs(v);
	}

	vector< pair<int, int> > selfdp;
	do {
		for(auto [first, _]: dp[adj[u][0]]) {
			int cur = first;
			bool ok = true;
			for(int v: adj[u]) {
				auto it = lower_bound(dp[v].begin(), dp[v].end(), make_pair(v, v));
				if(it == dp[v].end()) {
					ok = false;
					break;
				}
				cur = it->second;
			}
			if(ok) {
				selfdp.emplace_back(first, cur);
			}
		}
	} while(next_permutation(adj[u].begin(), adj[u].end()));

	sort(selfdp.begin(), selfdp.end());
	for(auto [l, r]: selfdp) {
		while(dp[u].size() > 0 && dp[u].back().second >= r) {
			dp[u].pop_back();
		}
		dp[u].emplace_back(l, r);
	}
}

signed main() {
	int n;
	cin >> n;

	adj.resize(n);
	vals.resize(n);
	for(int i = 0; i < n; i++) {
		int t;
		cin >> t;

		int k;
		cin >> k;

		if(t == 1) {
			for(int j = 0; j < k; j++) {
				int x;
				cin >> x;
				x--;
				adj[i].push_back(x);
			}
		} else {
			for(int j = 0; j < k; j++) {
				int x;
				cin >> x;
				vals[i].push_back(x);
			}
		}
	}

	dp.resize(n);
	dfs(0);

	cout << (dp[0].size() == 0 ? "No" : "Yes") << endl;

	return 0;
}