#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

const pair<int, int> NEUTRAL = make_pair(-1, -1);

bool used[32][32];

void initGame() {
	for (int i = 0; i < 32; ++i) {
		for (int j = 0; j < 32; ++j) {
			used[i][j] = false;
		}
	}
}

int getCnt(pair<int, int> pos) {
	int ans = 0;
	int y = pos.first;
	int x = pos.second;
	for (int i = y; i < 32; ++i) {
		for (int j = x; j < 32; ++j) {
			if (!used[i][j]) ++ans;
		}
	}
	return ans;
}

pair<int, int> findNum(int num) {
	for (int i = 31; i >= 0; --i) {
		for (int j = 31; j >= 0; --j) {
			if (i == 0 && j == 0) break;
			if (getCnt(make_pair(i, j)) == num) {
				return make_pair(i, j);
			}
		}
	}
	return NEUTRAL;
}

void addToPos(pair<int, int> pos) {
	int y = pos.first;
	int x = pos.second;
	for (int i = y; i < 32; ++i) {
		for (int j = x; j < 32; ++j) {
			used[i][j] = true;
		}
	}
}


int main() {
	int t, n, k, m;
	cin >> t;
	cin >> n >> k >> m;
	if (t == 1) {
		string s;
		cin >> s;
		int num = -1;
		int cnt = 0;
		while (cnt < m) {
			bool flag = true;
			initGame();
			++num;
			if (num & 1) {
				pair<int, int> addPos;
				cin >> addPos.second >> addPos.first;
				--addPos.second; --addPos.first;
				if (addPos == make_pair(0, 0)) {
					flag = false;
					break;
				}
				addToPos(addPos);
			}
			while (flag) {
				pair<int, int> addPos = NEUTRAL;
				if (cnt < m) {
					if (s[cnt] == '0') {
						addPos = findNum(2);
					}
					else {
						addPos = findNum(3);
					}
				}
				else {
					//addPos = make_pair(0, 0);
				}
				if (addPos == NEUTRAL) {
					addPos = findNum(1);
				}
				else {
					++cnt;
				}
				if (addPos == NEUTRAL) {
					cout << "1 1" << endl;
					flag = false;
					break;
				}
				else {
					addToPos(addPos);
					cout << addPos.second + 1 << " " << addPos.first + 1 << endl;
				}
				cin >> addPos.second >> addPos.first;
				--addPos.second; --addPos.first;
				if (addPos == make_pair(0, 0)) {
					flag = false;
					break;
				}
				addToPos(addPos);
			}
		}
		cout << "0" << endl;
	}
	else {
		string sans;
		pair<int, int> addPos = NEUTRAL;
		int k;
		cin >> k;
		for (int i = 0; i < k; ++i) {
			initGame();
			if (i & 1) {
				cin >> addPos.second >> addPos.first;
				--addPos.second; --addPos.first;
				addToPos(addPos);
			}
			cin >> addPos.second >> addPos.first;
			--addPos.second; --addPos.first;
			while (addPos != make_pair(0, 0)) {
				int ans = getCnt(addPos);
				//cout << "!" << ans << "\n";
				if (ans == 2) {
					sans += "0";
				}
				else if (ans == 3) {
					sans += "1";
				}
				addToPos(addPos);
				cin >> addPos.second >> addPos.first;
				--addPos.second; --addPos.first;
				if (addPos == make_pair(0, 0)) break;
				addToPos(addPos);
				cin >> addPos.second >> addPos.first;
				--addPos.second; --addPos.first;
			}
		}
		cout << sans << endl;
	}
}