#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAX_N = 1337;

vector<int> upgrades[MAX_N];
vector<int> childrens[MAX_N];

bool dfs(int v, int leftBound, int rightBound) {
    if (childrens[v].size() == 0) {
        auto x = lower_bound(upgrades[v].begin(), upgrades[v].end(), leftBound);
        if (x == upgrades[v].end()) {
            return false;
        }
        if (*x <= rightBound) {
            return true;
        }
        return false;
    }
    if (childrens[v].size() == 1) {
        return dfs(childrens[v][0], leftBound, rightBound);
    }
    for (int i = leftBound; i <= rightBound; i++) {
        if (dfs(childrens[v][0], leftBound, i) && dfs(childrens[v][0], i, rightBound)) {
            return true;
        }
    }
    return false;
}

int main() {
    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        int t; cin >> t;
        if (t == 1) {
            int k; cin >> k;
            for (int j = 0; j < k; j++) {
                int x; cin >> x; x--;
                childrens[i].push_back(x);
            }
        }
        if (t == 2) {
            int m; cin >> m;
            if (m == 0) {
                cout << "No" << endl;
                return 0;
            }
            for (int j = 0; j < m; j++) {
                int x; cin >> x;
                upgrades[i].push_back(x);
            }
            sort(upgrades[i].begin(), upgrades[i].end());
        }
    }
    if (dfs(0, 0, 100228)) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }
}
