#include <bits/stdc++.h>

template<class T>
std::istream& operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}
template<class T>
std::ostream& operator<<(std::ostream &out, const std::vector<T> &a) {
    for (auto &x : a)
        out << x << " ";
    return out;
}
template<class T, class U>
std::istream& operator>>(std::istream &in, std::pair<T, U> &a) {
    in >> a.first >> a.second;
    return in;
}
template<class T, class U>
std::ostream& operator<<(std::ostream &out, const std::pair<T, U> &a) {
    out << a.first << " " << a.second;
    return out;
}

signed main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0), std::cout.tie(0);
    int32_t n, m;
    std::cin >> n >> m;
    std::string s;
    std::cin >> s;
    std::vector<std::vector<std::pair<int32_t, char>>> a(n);
    std::vector<std::map<int32_t, char>> perfos(n);
    for (int32_t ind = 0; ind < n; ++ind) {
        int32_t k;
        std::cin >> k;
        for (int32_t prf_it = 0; prf_it < k; ++prf_it) {
            int32_t pos;
            char c;
            std::cin >> pos >> c;
            a[ind].emplace_back(pos - 1, c);
            perfos[ind][pos - 1] = c;
        }
    }
    std::vector<bool> used_c(m), used_perfo(n);
    std::vector<int32_t> erorrs(n);
    std::vector<std::set<int32_t>> inv_pos2prf(m);
    std::set<std::pair<int32_t, int32_t>> prf_q; // { (erorrs count,  perfo index) }
    for (int32_t ind = 0; ind < n; ++ind) {
        int32_t erorrs_cnt = 0;
        for (auto &[pos, c] : a[ind]) {
            inv_pos2prf[pos].emplace(ind);
            if (s[pos] != c) {
                ++erorrs_cnt;
            }
        }
        erorrs[ind] = erorrs_cnt;
        prf_q.emplace(erorrs_cnt, ind);
    }
    std::vector<int32_t> ans;
//    for (auto x : prf_q)
//        std::cerr << x << " ";
    while (!prf_q.empty()) {
        auto cnt_und_ind = *prf_q.begin();
        prf_q.erase(prf_q.begin());
        int32_t cnt = cnt_und_ind.first, ind = cnt_und_ind.second;
        if (cnt != 0) {
            std::cout << -1 << "\n";
            return 0;
        }
        ans.emplace_back(ind + 1);
        for (auto &[pos, c] : a[ind]) {
            inv_pos2prf[pos].erase(ind);
            if (!used_c[pos]) {
                used_c[pos] = 1;
                for (auto &oth_perfo : inv_pos2prf[pos]) {
                    prf_q.erase(std::make_pair(erorrs[oth_perfo], oth_perfo));
                    if (perfos[oth_perfo][pos] != s[pos]) {
                        erorrs[oth_perfo]--;
                    }
                    prf_q.emplace(erorrs[oth_perfo], oth_perfo);
                }
            }
        }
    }
    std::cout << ans;
    return 0;
}
