#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>
#include <cstring>
#include <bitset>
#include <queue>
#include <deque>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>

// #pragma GCC target("avx2")

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxN = 20 + 1;
vector<int> g[maxN];
vector<int> v[maxN];

vector<pair<int, int> > form;
vector<int> chosen(maxN, -1);
vector<vector<int> > dp0;
vector<vector<int> > ans;

vector<int> con(const vector<int> &v1, const vector<int> &v2) {
    vector<int> res = v1;
    for (auto i : v2) {
        res.push_back(i);
    }
    return res;
}

void dfs(int vert) {
    if (v[vert].size() != 0) {
        dp0[vert] = {chosen[vert]};
        ans[vert] = {chosen[vert]};
        return;
    }
    for (auto u : g[vert]) {
        dfs(u);
    }
    if (g[vert].size() == 1) {
        dp0[vert] = dp0[g[vert][0]];
        ans[vert] = {g[vert][0] + 1};
        return;
    }
    int u1 = g[vert][0], u2 = g[vert][1];

    if (dp0[u1].size() > 0 && dp0[u2].size() > 0) {
        if (dp0[u1].back() < dp0[u2][0]) {
            dp0[vert] = con(dp0[u1], dp0[u2]);
            ans[vert] = {u1 + 1, u2 + 1};
        } else {
            swap(u1, u2);
            ans[vert] = {u1 + 1, u2 + 1};
            if (dp0[u1].back() < dp0[u2][0]) {
                dp0[vert] = con(dp0[u1], dp0[u2]);
            }
        }
    }
}

void solve() {
    int n;
    cin >> n;
    int total = 0;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            g[i].resize(k);
            for (int j = 0; j < k; ++j) {
                cin >> g[i][j];
                g[i][j]--;
            }
        } else {
            int m;
            cin >> m;
            total += m;
            v[i].resize(m);
            for (int j = 0; j < m; ++j) {
                cin >> v[i][j];
                form.push_back(make_pair(i, j));
            }
        }
    }
    for (int mask = 0; mask < (1LL << total); ++mask) {
        chosen.assign(maxN, -1);
        ans.assign(n, vector<int>(0));
        bool out = false;
        for (int i = 0; i < total; ++i) {
            if ((mask >> i) & 1) {
                if (chosen[form[i].first] != -1) {
                    out = true;
                    break;
                } else {
                    chosen[form[i].first] = v[form[i].first][form[i].second];
                }
            }
            if (out) break;
        }
        for (int i = 0; i < n; ++i) {
            if (g[i].size() == 0 && chosen[i] == -1) {
                out = true;
            }
        }
        if (out) continue;
        dp0.assign(n, vector<int>(0));
        dfs(0);
        if (dp0[0].size() > 0) {
            cout << "Yes\n";

            for (int i = 0; i < n; ++i) {
                for (auto j : ans[i]) {
                    cout << j << ' ';
                }
                cout << '\n';
            }


            return;
        }
    }
    cout << "No\n";
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}