#include <iostream>
#include <string>
#include <unordered_map>
#include <algorithm>
#include <utility>
#include <vector>

#define maxN 100000

long long n, m, k, a, perfocards[maxN];
char c;
bool check[maxN];
std::string s;
std::unordered_map<long long, std::unordered_map<long long, long long>> dict;
std::vector<long long> a1, a2;

bool checker(long long card) {
	bool f = true;
	for (std::pair<long long, long long> ans : dict[card]) {
		if (!check[ans.first] && ans.second != s[ans.first] - 'a' + 1) {
			f = false;
			break;
		}
	}
	return f;
}

bool comp(long long a, long long b) {
	long long s1 = 0, s2 = 0;
	for (long long i = 0; i < m; i++) {
		if (dict.find(a) == dict.end() || dict[a].find(i) == dict[a].end()) {
			s1 = 0;
		}
		else if (dict[a][i] == s[i] - 'a' + 1) {
			s1 = 1;
		}
		else {
			s1 = 2;
		}
		if (dict.find(b) == dict.end() || dict[b].find(i) == dict[b].end()) {
			s2 = 0;
		}
		else if (dict[b][i] == s[i] - 'a' + 1) {
			s2 = 1;
		}
		else {
			s2 = 2;
		}
		if (s1 < s2) {
			return true;
		}
		else if (s1 > s2) {
			return false;
		}
	}
	return a < b;
}

int main() {
	std::cin >> n >> m >> s;
	for (long long i = 0; i < n; i++) {
		std::cin >> k;
		perfocards[i] = i;
		for (long long j = 0; j < k; j++) {
			std::cin >> a >> c;
			dict[i][a - 1] = c - 'a' + 1;
		}
	}
	std::sort(perfocards, perfocards + n, comp);
	for (long long i = 0; i < n; i++) {
		if (checker(perfocards[i])) {
			a1.push_back(i);
			for (std::pair<long long, long long> ans : dict[perfocards[i]]) {
				if (ans.second == s[ans.first] - 'a' + 1) {
					check[ans.first] = true;
				}
			}
		}
		else {
			a2.push_back(i);
		}
	}
	for (long long i = 0; i < m; i++) {
		if (!check[i]) {
			for (long long j = 0; j < a2.size(); j++) {
				if (a2[j] != -1) {
					if (checker(perfocards[a2[j]])) {
						a1.push_back(a2[j]);
						for (std::pair<long long, long long> ans : dict[perfocards[a2[j]]]) {
							if (ans.second == s[ans.first] - 'a' + 1) {
								check[ans.first] = true;
							}
						}
						a2[j] = -1;
						break;
					}
				}
			}
			if (!check[i]) {
				std::cout << -1 << std::endl;
				return 0;
			}
		}
	}
	for (long long i = 0; i < a1.size(); i++) {
		std::cout << perfocards[a1[i]] + 1 << " ";
	}
	for (long long i = 0; i < a2.size(); i++) {
		std::cout << perfocards[a2[i]] + 1 << " ";
	}
	std::cout << std::endl;
	return 0;
}