#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <cassert>
using namespace std;
typedef long long ll;

const int send = 1;

int n, k, m;

inline void set(vector <vector <bool>>& a, int i, int j)
{
	for (int x = i; x <= n; ++x)
	{
		for (int y = j; y <= n; ++y)
		{
			a[x][y] = true;
		}
	}
}

inline void move_my(vector <vector <bool>>& a, int i, int j)
{
	cout << i << ' ' << j << endl;
	set(a, i, j);
}

inline void move_bot(vector <vector <bool>>& a)
{
	int i, j;
	cin >> i >> j;

	/*vector <pair <int, int>> free;
	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= n; ++j)
		{
			if (!a[i][j])
			{
				free.push_back({ i, j });
			}
		}
	}
	random_shuffle(free.begin(), free.end());
	int i = free[0].first;
	int j = free[0].second;
	cout << i << ' ' << j << endl;*/
	set(a, i, j);
}

inline void print(vector <vector <bool>>& a)
{
	for (int i = n; i >= 1; --i)
	{
		for (int j = 1; j <= n; ++j)
		{
			cout << a[i][j];
		}
		cout << endl;
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;

	if (t == 1)
	{

		cin >> n >> k >> m;

		vector <int> code(m);

		for (int i = 0; i < m; ++i)
		{
			char c;
			cin >> c;
			code[i] = c - '0';
		}

		int to_code = 0;

		bool my_turn = true;
		while (to_code < m)
		{
			//if (to_code >= 70000) assert(false);
			vector <vector <bool>> bad(n + 1, vector <bool>(n + 1));
			bool turn = my_turn;

			while (true)
			{
				if (turn)
				{
					vector <pair <int, pair <int, int>>> free;
					for (int i = 1; i <= n; ++i)
					{
						for (int j = 1; j <= n; ++j)
						{
							if (!bad[i][j])
							{
								free.push_back({ n - i + n - j, {i, j} });
								if (free.size() >= 2) break;
							}
						}
						if (free.size() >= 2) break;
					}

					if (free.size() == 0) break;
					if (free.size() == 1)
					{
						move_my(bad, 1, 1);
						break;
					}
					else
					{
						if (to_code == m)
						{
							move_my(bad, 1, 1);
							break;
						}

						auto to = free[code[to_code++]];

						move_my(bad, to.second.first, to.second.second);
						if (to.second == make_pair(1, 1)) break;
					}
				}
				else
				{
					move_bot(bad);
				}
				turn = !turn;
				//print(bad);
			}

			my_turn = !my_turn;
		}


		assert(false);
		cout << 0 << endl;
		return 0;
	}
	else
	{
		cin >> n >> k >> m;

		vector <int> code(m);

		int to_code = 0;

		bool my_turn = true;
		while (to_code < m)
		{
			vector <vector <bool>> bad(n + 1, vector <bool>(n + 1));
			bool turn = my_turn;

			while (true)
			{
				if (turn)
				{
					vector <pair <int, pair <int, int>>> free;
					for (int i = 1; i <= n; ++i)
					{
						for (int j = 1; j <= n; ++j)
						{
							if (!bad[i][j])
							{
								free.push_back({ n - i + n - j, {i, j} });
								if (free.size() >= 2) break;
							}
							if (free.size() >= 2) break;
						}
					}

					if (free.size() == 0) break;
					if (free.size() == 1)
					{
						pair <int, int> inp;
						cin >> inp.first >> inp.second;
						break;
					}
					else
					{
						if (to_code == m)
						{
							pair <int, int> inp;
							cin >> inp.first >> inp.second;
							break;
						}

						pair <int, int> inp;
						cin >> inp.first >> inp.second;
						set(bad, inp.first, inp.second);
						if (inp == free[0].second) code[to_code++] = 0;
						else code[to_code++] = 1;
					}
				}
				else
				{
					pair <int, int> inp;
					cin >> inp.first >> inp.second;
					set(bad, inp.first, inp.second);
				}
				turn = !turn;
				//print(bad);
			}

			//my_turn = !my_turn;
		}

		for (int i = 0; i < m; ++i)
		{
			cout << code[i];
		}
		cout << endl;
		return 0;
	}
}