#include <iostream>

#include <queue>
#include <set>

using namespace std;

int main() {
    int number_of_cards, size_of_cards;
    cin >> number_of_cards >> size_of_cards;

    string to_be_constructed;
    cin >> to_be_constructed;

    vector <bool> used_colums(size_of_cards, false);

    vector <vector <pair <int, char> > > raw_cards_data(number_of_cards, vector <pair <int, char> > (0));
    for (int i = 0; i < number_of_cards; ++i) {
        int number_of_symbols;
        cin >> number_of_symbols;

        for (int j = 0; j < number_of_symbols; ++j) {
            int symbol_position;
            char symbol_char;

            cin >> symbol_position >> symbol_char;

            --symbol_position;

            raw_cards_data[i].push_back(make_pair(symbol_position, symbol_char));
            used_colums[symbol_position] = true;
        }
    }

    for (int i = 0; i < size_of_cards; ++i) {
        if (!used_colums[i]) {
            cout << -1;
            return 0;
        }
    }

    vector <string> constructed_cards;
    vector <int> constructed_cards_size;
    vector <int> previous_constructed_card;
    vector <int> last_applied_card;

    string empty_card = "";
    for (int i = 0; i < size_of_cards; ++i) {
        empty_card += "#";
    }

    constructed_cards.push_back(empty_card);
    constructed_cards_size.push_back(0);
    previous_constructed_card.push_back(-1);
    last_applied_card.push_back(-1);

    int current_index = 0;

    while (current_index < constructed_cards.size()) {
        string current_constructed_card = constructed_cards[current_index];
        int current_size = constructed_cards_size[current_index];

        for (int i = 0; i < number_of_cards; ++i) {
            string new_card = current_constructed_card;
            int new_card_size = current_size;

            bool new_card_satisfies_goal = true;

            for (int j = 0; j < raw_cards_data[i].size(); ++j) {
                if (new_card[raw_cards_data[i][j].first] == '#') {
                    new_card[raw_cards_data[i][j].first] = raw_cards_data[i][j].second;
                    ++new_card_size;

                    if (raw_cards_data[i][j].second != to_be_constructed[raw_cards_data[i][j].first]) {
                        new_card_satisfies_goal = false;
                        break;
                    }
                }
            }

            if (new_card_satisfies_goal) {
                if (new_card_size != current_size) {
                    constructed_cards.push_back(new_card);
                    constructed_cards_size.push_back(new_card_size);
                    previous_constructed_card.push_back(current_index);
                    last_applied_card.push_back(i);

                    if (new_card_size == size_of_cards) {
                        int backward_traversal = constructed_cards.size() - 1;

                        vector <int> ans;
                        set <int> already_in_ans;
                        while (last_applied_card[backward_traversal] != -1) {
                            ans.push_back(last_applied_card[backward_traversal] + 1);
                            already_in_ans.insert(last_applied_card[backward_traversal] + 1);
                            backward_traversal = previous_constructed_card[backward_traversal];
                        }

                        for (int j = 0; j < ans.size(); ++j) {
                            cout << ans[ans.size() - j - 1] << ' ';
                        }

                        for (int j = 0; j < number_of_cards; ++j) {
                            if (already_in_ans.find(j + 1) == already_in_ans.end()) {
                                cout << j + 1 << ' ';
                            }
                        }

                        return 0;
                    }
                }
            }
        }

        ++current_index;
    }

    cout << -1;
    return 0;
}
