#include <iostream>
#include <cstdio>
#include <vector>
#include <set>

using namespace std;

bool is_less_than(string a, string b) {
    int j = 0;
    while (j < a.length() && j < b.length() && a[j] == b[j]) {
        ++j;
    }

    if (j == a.length() + 1) {
        return true;
    }

    if (j == b.length() + 1) {
        return false;
    }

    if (a[j] < b[j]) {
        return true;
    }

    return false;
}

int main() {
    int number_of_crystal_types, number_of_crystals;
    scanf("%d%d", &number_of_crystal_types, &number_of_crystals);

    vector <vector <int> > allowed_table(number_of_crystal_types, vector <int> (number_of_crystal_types));
    for (int i = 0; i < number_of_crystal_types; ++i) {
        for (int j = 0; j < number_of_crystal_types; ++j) {
            scanf("%1d", &allowed_table[i][j]);
        }
    }

    string initial_crystal_pattern;
    for (int i = 0; i < number_of_crystals; ++i) {
        char crystal_type;
        cin >> crystal_type;

        initial_crystal_pattern += crystal_type;
    }

    set <string> achieved_crystal_patterns;
    achieved_crystal_patterns.insert(initial_crystal_pattern);

    string min_achieved_crystal_pattern = initial_crystal_pattern;

    while (!achieved_crystal_patterns.empty()) {
        string current_crystal_pattern = *achieved_crystal_patterns.begin();
        achieved_crystal_patterns.erase(achieved_crystal_patterns.begin());

        for (int i = 1; i < current_crystal_pattern.length(); ++i) {
            int previous_symbol_code = current_crystal_pattern[i - 1] - 'a';
            int current_symbol_code = current_crystal_pattern[i] - 'a';
            if (allowed_table[previous_symbol_code][current_symbol_code]) {
                string new_crystal_pattern = current_crystal_pattern.substr(0, i) + current_crystal_pattern.substr(i + 1);
                achieved_crystal_patterns.insert(new_crystal_pattern);

                if (is_less_than(new_crystal_pattern, min_achieved_crystal_pattern)) {
                    min_achieved_crystal_pattern = new_crystal_pattern;
                }
            }
        }
    }

    for (int i = 0; i < min_achieved_crystal_pattern.length(); ++i) {
        printf("%c", min_achieved_crystal_pattern[i]);
    }

    return 0;
}
