#include <iostream>
#include <map>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

vector<int> g[100010];

vector<map<int,char>> cards;
vector<int> perm;
string s;
int n,m;

bool panic = false;
vector<bool> done;

bool used[100010];
int tout[100010];
int ticker = 0;

void dfs(int from){
    used[from] = 1;
    for(int to : g[from]){
        if(!used[to]){
            dfs(to);
        }
    }
    tout[from] = ticker++;
}

bool cmp(int a, int b){
    return tout[a] > tout[b];
}

int main() {

    cin >> n >> m;
    cin >> s;

    cards.resize(n);
    done.resize(m);

    for (int i = 0; i < n; ++i) {
        perm.push_back(i);

        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int pos;
            string c;
            cin >> pos >> c;
            cards[i][pos-1] = c[0];
        }
    }

    do {
        panic = false;

        for (int i = 0; i < n; ++i) {
            for(auto pp : cards[perm[i]]){
                if(!done[pp.first] && pp.second != s[pp.first]){
                    panic = true;
                    break;
                }else{
                    done[pp.first] = true;
                }
            }
            if(panic) break;
        }

        for(bool b : done){
            panic = panic || !b;
        }
    }while(panic && next_permutation(perm.begin(), perm.end()));
/*
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if(cards[j].count(i) && cards[j][i] == s[i]){
                for (int k = 0; k < n; ++k) {
                    if(cards[k].count(i) && cards[k][i] != s[i]){
                        g[j].push_back(k);
                    }
                }
            }
        }
    }

    fill(used, used + n+10, false);
    for (int i = 0; i < n; ++i) {
        if(!used[i]) dfs(i);
    }
    sort(perm.begin(), perm.end(), cmp);
*/

    if(panic){
        cout << -1 << endl;
        return 0;
    }

    for (int i = 0; i < n; ++i) {
        cout << perm[i] + 1 << " ";
    }
    cout << endl;

    return 0;
}
/*
1 1
a
1 1 a


3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f

2 2
aa
2 1 a 2 b
2 1 b 2 a

*/