#include <bits/stdc++.h>

using namespace std;

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    solve();
}

using segment = pair<int, int>;
#define l first
#define r second

vector<segment> compress(vector<segment> v) {
    if (v.empty()) return v;
    sort(v.rbegin(), v.rend());
    vector<segment> res{v[0]};
    for (int i = 1; i < v.size(); ++i) {
        if (v[i].r >= res.back().r) continue;
        res.push_back(v[i]);
    }
    return res;
}

vector<segment> operator+=(vector<segment> &a, const vector<segment> &b) {
    for (auto x : b) a.push_back(x);
    return a = compress(a);
}

vector<segment> merge(vector<segment> a, vector<segment> b) {
    vector<segment> res;
    for (auto[l1, r1] : a) {
        for (auto[l2, r2] : b) {
            if (r1 <= l2) res.emplace_back(l1, r2);
            if (r2 <= l1) res.emplace_back(l2, r1);
        }
    }
    return compress(res);
}

void dfs(vector<vector<segment>> &segments, const vector<vector<int>> &tree, int cur) {
    if (tree[cur].empty()) return;
    for (int next : tree[cur]) {
        dfs(segments, tree, next);
        if (segments[next].empty()) return;
    }
    int sz = tree[cur].size();
    vector<vector<segment>> dp(1 << sz);
    for (int mask = 1; mask < dp.size(); ++mask) {
        for (int bit = 0; bit < sz; ++bit) {
            if (!(mask & (1 << bit))) continue;
            if (mask == (1 << bit)) {
                dp[mask] = segments[tree[cur][bit]];
            } else {
                int other = mask & (~(1 << bit));
                dp[mask] += merge(dp[other], dp[1 << bit]);
            }
        }
    }
    segments[cur] = dp.back();
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> tree(n);
    vector<vector<segment>> segments(n);
    for (int i = 0; i < n; ++i) {
        int l;
        cin >> l;
        int k;
        cin >> k;
        bool leaf = (l == 2);
        if (leaf) {
            for (int j = 0; j < k; ++j) {
                int x;
                cin >> x;
                segments[i].emplace_back(x, x + 1);
            }
        } else {
            for (int j = 0; j < k; ++j) {
                int x;
                cin >> x;
                tree[i].emplace_back(x - 1);
            }
        }
    }
    dfs(segments, tree, 0);
    if (segments[0].empty()) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
    }
}