#include "bits/stdc++.h"

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef long double ld;

namespace {
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {return in >> p.first >> p.second;}
    template<typename T>
    istream& operator>>(istream& in, vector<T>& v) {
        for (auto& e : v)
            in >> e;
        return in;
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("gen.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    solve();
}

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<pair<int, char>>> ps(n);
    for (int i = 0; i < n; i++) {
        int sz;
        cin >> sz;
        ps[i] = vector<pair<int, char>>(sz);
        cin >> ps[i];
    }

    set<pair<int, int>> conflictsQueue;
    vector<int> conflictsCnt(n, 0);

    auto decrease = [&](int i) {
        conflictsQueue.erase({conflictsCnt[i], i});
        conflictsCnt[i]--;
        conflictsQueue.insert({conflictsCnt[i], i});
    };

    vector<vector<int>> conflictsAtHole(m);

    for (int i = 0; i < n; i++) {
        for (auto [idx, ch] : ps[i]) {
            if (s[idx - 1] == ch)
                continue;
            conflictsAtHole[idx - 1].push_back(i);
            conflictsCnt[i]++;
        }
    }

    for (int i = 0; i < n; i++)
        conflictsQueue.insert({conflictsCnt[i], i});

    deque<int> ans;

    vector<bool> completed(m, false);

    while (!conflictsQueue.empty()) {
        auto [cnt, idx] = *conflictsQueue.begin();
        conflictsQueue.erase(conflictsQueue.begin());
        if (cnt != 0) {
            cout << "-1\n";
            return;
        }
        ans.push_back(idx + 1);
        for (auto [pos, ch] : ps[idx]) {
            if (s[pos - 1] != ch)
                continue;
            if (completed[pos - 1])
                continue;
            completed[pos - 1] = true;
            for (int u : conflictsAtHole[pos - 1])
                decrease(u);
        }
    }

    for (bool e : completed) {
        if (!e) {
            cout << "-1\n";
            return;
        }
    }
    for (int e : ans)
        cout << e << ' ';
    cout << '\n';
}