#include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

string to_string(const char* a) {
    return (string) a;
}

string to_string(string a) {
    return a;
}

string to_string(bool a) {
    return (a ? "true" : "false");
}

void debug_out() {
    cerr << endl;
}

string to_string(const vector<int> &a) {
    string res = "";
    bool first = 1;
    for (auto &i : a) {
        if (!first) {
            res += ", ";
        }
        first = 0;
        res += to_string(i);
    }
    return res;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << ' ' << to_string(H);
    debug_out(T...);
}

//#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__);
//#else
//#define debug(...) 42

//#define int long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) (int) a.size()

const int N = 5e2 + 5;
const int INF = 1e9 + 7;

bool can[26][26], dp[N][N][26];

void solve() {
    int k, n;
    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char x;
            cin >> x;
            can[i][j] = x - '0';
        }
    }
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        for (int color = 0; color < k; color++) {
            dp[i][i][s[i] - 'a'] = 1;
        }
    }
    for (int len = 2; len < n; len++) {
        for (int color = 0; color < k; color++) {
            for (int i = 1; i + len - 1 < n; i++) {
                int j = i + len - 1;
                for (int r = i; r < j && !dp[i][j][color]; r++) {
                    for (int color_other = 0; color_other < k && !dp[i][j][color]; color_other++) {
                        int prev = s[i - 1] - 'a';
                        // удаляем левый
                        dp[i][j][color] |= can[prev][color_other] && dp[i][r][color_other] && dp[r + 1][j][color];
                        // удаляем правый
                        dp[i][j][color] |= dp[i][r][color] && dp[r + 1][j][color_other] && can[color][color_other];
                    }
                }
            }
        }
    }
    string res = "";
    res += s[0];
    vector<int> indexes;
    indexes.pb(0);
    int prev_color = s[0] - 'a';
    while (sz(indexes)) {
        vector<int> new_indexes;
        int best = INF;
        for (auto &i : indexes) {
            if (i + 1 < n) {
                for (int color = 0; color < 26; color++) {
                    if (can[prev_color][color] && dp[i + 1][n - 1][color]) {
                        cout << res;
                        return;
                    }
                }
            }
            if (i + 1 < n && s[i + 1] - 'a' < best) {
                best = s[i + 1] - 'a';
            }
            for (int j = i + 2; j < n; j++) {
                int q = s[j] - 'a';
                for (int color = 0; color < k; color++) {
                    if (q < best && can[prev_color][color] && dp[i + 1][j - 1][color]) {
                        best = q;
                    }
                }
            }
        }
        vector<bool> added(n);
        for (auto &i : indexes) {
            if (i + 1 < n && s[i + 1] - 'a' == best && !added[i + 1]) {
                new_indexes.pb(i + 1);
                added[i + 1] = 1;
            }
            for (int j = i + 2; j < n; j++) {
                if (added[j]) continue;
                int q = s[j] - 'a';
                for (int color = 0; color < k; color++) {
                    if (q == best && can[prev_color][color] && dp[i + 1][j - 1][color]) {
                        added[j] = 1;
                        new_indexes.pb(j);
                    }
                }
            }
        }
        if (best == INF) {
            break;
        }
        res += best + 'a';
        prev_color = best;
        indexes = new_indexes;
    }
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
//    cin >> T;

    while (T-- > 0) {
        solve();
    }
    return 0;
}
