#include <iostream>
#include <vector>
#include <queue>
#include <ios>
#include <set>
using namespace std;

const int MAX_K = 26;
bool can_delete[MAX_K][MAX_K];

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			can_delete[i][j] = (c == '1');
		}
	}

	string s;
	cin >> s;
	for (int i = 0; i < n; i++) {
		s[i] -= 'a';
	}

	vector<int> max_delete_after(n);
	for (int i = n - 1; i >= 0; i--) {
		while (max_delete_after[i] != n - 1 - i) {
			int next = i + max_delete_after[i] + 1;
			if (!can_delete[s[i]][s[next]])
				break;
			max_delete_after[i] += 1 + max_delete_after[next];
		}
	}

	vector<string> min_string_starting_with(n + 1);
	for (int i = n - 1; i >= 0; i--) {
		int max_delete = max_delete_after[i];
		string min_string = min_string_starting_with[i + 1];
		for (int j = i + 1; j <= i + 1 + max_delete_after[i]; j++) {
			min_string = min(min_string, min_string_starting_with[j]);
		}
		min_string_starting_with[i] = s[i] + min_string;
	}

	string ans = min_string_starting_with[0];
	for (char c : ans)
		cout << (char) (c + 'a');
}