#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <deque>

using namespace std;

deque<int> all;
vector<int> val;
int n, k;
vector<vector<int>> matrix;

bool check(int l, int r) {
	deque<int> seq;
	seq.push_front(val[r - 1]);
	for (int i = r - 2; i >= l - 1; i--) {
		while (!seq.empty()) {
			int t = seq.front();
			if (matrix[val[i]][t]) {
				seq.pop_front();
			}
			else {
				break;
			}
		}
		seq.push_front({val[i]});
	}
	if (seq.size() != 1) {
		return false;
	}
	return true;
}


bool comp(deque<int> a, deque<int> b) {
	if (a.size() == 0) {
		return true;
	}
	if (b.size() == 0) {
		return false;
	}
	int t = min(a.size(), b.size());
	for (int i = 0; i < t; i++) {
		int x = a.front();
		int y = b.front();
		if (x < y) {
			return true;
		}
		if (x > y) {
			return false;
		}
		a.pop_front();
		b.pop_front();
	}
	if (a.size() == 0) {
		return true;
	} else {
		return false;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> k >> n;
	matrix.resize(k, vector<int>(k));
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			matrix[i][j] = c - '0';
		}
	}
	string s;
	cin >> s;
	val.resize(n);
	for (int i = 0; i < n; i++) {
		val[i] = s[i] - 'a';
		all.push_back(val[i]);
	}
	vector<deque<int>> ans(n);

	vector <deque<int>> pref(n);

	ans[n - 1].push_back(val[n - 1]);
	pref[n - 1] = ans[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		int l = i + 1, r = n;
		if (matrix[val[i]][val[l]] == 0) {
			ans[i] = ans[i + 1];
			ans[i].push_front(val[i]);
			pref[i] = ans[i];
			for (int j = i + 1; j < n; j++) {
				if (comp(ans[i], pref[j])) {
					pref[j] = ans[i];
				}
				else {
					break;
				}
			}
			continue;
		}
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (check(i + 1, m + 1)) {
				l = m;
			} else {
				r = m;
			}
		}
		//cout << i << " " << l << endl;
		if (l == n - 1) {
			ans[i].push_back(val[i]);
			pref[i] = ans[i];
			for (int j = i + 1; j < n; j++) {
				if (comp(ans[i], pref[j])) {
					pref[j] = ans[i];
				}
				else {
					break;
				}
			}
			continue;
		}
		/*int ind_min = i + 1;
		for (int j = i + 2; j <= l + 1; j++) {
			/*if (val[j] > val[ind_min]) {
				continue;
			}
			if (comp(ans[j], ans[ind_min])) {
				ind_min = j;
			}
		}*/
		//cout << i << " ------- " << char('a' + val[i]) << " " << ind_min << endl;
		//ans[i] = ans[ind_min];
	//	cout << i << " " << l << endl;
		ans[i] = pref[l + 1];
		ans[i].push_front(val[i]);
		pref[i] = ans[i];
		for (int j = i + 1; j < n; j++) {
			if (comp(ans[i], pref[j])) {
				pref[j] = ans[i];
			} else {
				break;
			}
		}
	}
	for (int k = 0; k < 1; k++) {
		for (int i = 0; i < ans[k].size(); i++) {
			cout << char('a' + ans[k][i]);
		}
		cout << endl;
	}
	cin >> n;
	return 0;
}

