#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <numeric>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const int N = 1.1e5;
int tr[4 * N];

// st max
int Get(int l, int r, int ndx = 1, int L = 0, int R = N - 1) {
	if (r < L || R < l || L > R) return 0;
	if (l <= L && R <= r) return tr[ndx];
	return max(Get(l, r, 2 * ndx, L, (L + R) / 2),
		Get(l, r, 2 * ndx + 1, 1 + (L + R) / 2, R));
}

void Set(int pos, int val, int ndx = 1, int L = 0, int R = N - 1) {
	if (pos < L || R < pos || L > R) return;
	if (pos <= L && R <= pos) tr[ndx] = val;
	else {
		Set(pos, val, 2 * ndx, L, (L + R) / 2),
		Set(pos, val , 2 * ndx + 1, 1 + (L + R) / 2, R);
		tr[ndx] = max(tr[2 * ndx], tr[2 * ndx + 1]);
	}
}

bool IsDel(string s, vector <string>& v) {
	while (s.size() > 1) {
		bool ok = false;
		for (int j = s.size() - 1; j > 0; j--) {
			if (v[s[j - 1] - 'a'][s[j] - 'a'] == '1') {
				s.erase(s.begin() + j);
				ok = true;
				break;
			}
		}
		if (!ok) return false;
	}
	return true;
}

void Solve() {
	int k, n; cin >> k >> n;
	vector <string> v(k);
	for (auto& j : v) cin >> j;
	string s;
	cin >> s;
	 
	string ans; ans += s[0];
	int pos = 0;
	while (1) {
		if (IsDel(s.substr(pos), v)) break;
		vector <int> nxt(k, INF);
		for (int j = pos + 1; j < s.size(); j++)
			nxt[s[j] - 'a'] = min(nxt[s[j] - 'a'], j);
		int ndx = 0;
		while (ndx < k && (nxt[ndx] == INF || !IsDel(s.substr(pos, nxt[ndx] - pos), v)))
			ndx++;
		if (ndx == k) {
			break;
		}
		else {
			ans += s[nxt[ndx]];
			pos = nxt[ndx];
		}
	}
	cout << ans;

}

void Easy() {
	int k, n; cin >> k >> n;
	vector <string> v(k);
	for (auto& j : v) cin >> j;
	string s;
	cin >> s;

	vector <bool> dp(1 << (n - 1));
	dp[0] = true;
	string ans = s;
	for (int i = 0; i < (1 << (n - 1)); i++) {
		if (!dp[i]) continue;
		string st; st += s[0];
		vector <int> poses = { -1 };
		for (int j = 0; j < n - 1; j++) {
			if (((1 << j) & i)) continue;
			st += s[j + 1];
			poses.push_back(j);
		}
		ans = min(ans, st);
		for (int j = 1; j < st.size(); j++) {
			if (v[st[j-1] - 'a'][st[j] - 'a'] == '1')
				dp[((1 << poses[j]) ^ i)] = true;
		}
	}
	cout << ans;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Easy();
}