#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <numeric>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const int N = 1.1e5;

vector <vector <int>> result;
pair <int, int> Dfs(int v, vector <vector <int>>& g, vector <int>& u) {
	if (u[v] != -1) {
		result[v] = { u[v] };
		return { u[v], u[v] };
	}
	vector <vector <int>> results;
	for (auto i : g[v]) {
		auto p = Dfs(i, g, u);
		if (p == make_pair(INF, -INF)) return p;
		results.push_back({ p.first, p.second, i+1 });
	}
	sort(results.begin(), results.end());
	for (int i = 1; i < results.size(); i++) {
		if (results[i - 1][1] >= results[i][0]) {
			return { INF, -INF };
		}
	}
	for (auto& i : results)
		result[v].push_back(i[2]);
	return { results[0][0], results.back()[1] };
}

void Solve() {
	int n;
	cin >> n;

	vector <vector <int>> g(n);
	vector <vector <int>> l(n);
	vector <pair <int, int>> clerks;
	int res = 1;
	for (int i = 0; i < n; i++) {
		int type, t;
		cin >> type >> t;
		if (type == 1) {
			for (int j = 0; j < t; j++) {
				int a;
				cin >> a;
				g[i].push_back(a - 1);
			}
		}
		else {
			for (int j = 0; j < t; j++) {
				int a;
				cin >> a;
				l[i].push_back(a);
			}
			clerks.push_back({ i, t });
			res *= t;
		}
	}
	for (int i = 0; i < res; i++) {
		int seed = i;
		vector <int> init(n, -1);
		for (int i = 0; i < clerks.size(); i++) {
			init[clerks[i].first] = l[clerks[i].first][seed % clerks[i].second];
			seed /= clerks[i].second;
		}
		result.clear();
		result.resize(n);
		if (Dfs(0, g, init) != make_pair(INF, -INF)) {
			cout << "Yes\n";
			for (auto &i : result) {
				for (auto j : i)
					cout << j << " ";
				cout << "\n";
			}
			return;
		}
	}
	cout << "No";
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}