#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

struct keep {
    int l, r;
    vector<int> perm;
    vector<int> took;
};


bool operator<(keep &a, keep &b) {
    return make_pair(a.l, a.r) < make_pair(b.l, b.r);
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n), jobs(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            while (k--) {
                int u;
                cin >> u;
                u--;
                g[i].pb(u);
            }
            sort(all(g[i]));
        } else {
            int m;
            cin >> m;
            while (m--) {
                int x;
                cin >> x;
                jobs[i].pb(x);
            }
            sort(all(jobs[i]));
        }
    }

    vector<vector<keep>> dp(n);
    int l0;
    vector<int> ind;

    function<void(int, int, int)> gen = [&](int i, int lst, int v) {
        if (i == g[v].size()) {
            dp[v].pb({l0, lst, g[v], ind});
            return;
        }
        ind.pb(0);
        for (auto &p : dp[g[v][i]]) {
            if (p.l < lst) {
                ind.back()++;
                continue;
            }
            if (i == 0) {
                l0 = p.l;
            }
            gen(i + 1, p.r, v);
            ind.back()++;
        }
        ind.pop_back();
    };

    function<void(int)> dfs = [&](int v) {
        if (g[v].empty()) {
            for (int x : jobs[v]) {
                dp[v].push_back({x, x});
            }
            return;
        }
        for (auto u : g[v]) {
            dfs(u);
        }
        do {
            gen(0, -1, v);
        } while (next_permutation(all(g[v])));
        sort(all(dp[v]));
        vector<keep> res;
        for (auto &p : dp[v]) {
            while (!res.empty() and res.back().r > p.r) {
                res.pop_back();
            }
            res.pb(p);
        }
        dp[v] = res;
    };

    dfs(0);
    if (dp[0].empty()) {
        cout << "No\n";
        return;
    } else {
        cout << "Yes\n";
    }
    vector<vector<int>> answer(n);

    function<void(int, keep)> regen = [&](int v, keep state) {
        if (g[v].empty()) {
            answer[v].pb(state.l);
            return;
        }
        answer[v] = state.perm;
        for (auto &i : answer[v]) {
            i++;
        }
        for (int i = 0; i < state.perm.size(); i++) {
            regen(state.perm[i], dp[state.perm[i]][state.took[i]]);
        }
    };

    regen(0, dp[0][0]);
    for (int i = 0; i < n; i++) {
        for (auto x : answer[i]) {
            cout << x << " ";
        }
        cout << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
