#include <iostream>
#include <vector>
#include <set>
#include <cstring>
#include <algorithm>

using namespace std;

vector<int>* gr, * docs, * now_docs;
int* doc;
vector<int> leaves;

bool check_dfs(int v)
{
	if (doc[v] != -1)
	{
		now_docs[v] = { doc[v] };
		return true;
	}
	vector<pair<int, int>> children;
	for (int u : gr[v])
	{
		if (!check_dfs(u))
			return false;
		children.push_back({ now_docs[u][0], u });
	}
	sort(children.begin(), children.end());
	now_docs[v].clear();
	for (int i = 0; i < children.size(); i++)
	{
		if (now_docs[v].size() > 0 && children[i].first <= now_docs[v].back())
			return false;
		for (int d : now_docs[children[i].second])
			now_docs[v].push_back(d);
	}
	return true;
}

vector<int>* ans;

void fill_ans_dfs(int v)
{
	if (doc[v] != -1)
	{
		ans[v] = { doc[v] };
		return;
	}
	vector<pair<int, int>> children;
	for (int u : gr[v])
	{
		fill_ans_dfs(u);
		children.push_back({ now_docs[u][0], u });
	}
	sort(children.begin(), children.end());
	for (const auto& el : children)
		ans[v].push_back(el.second + 1);
}

bool find_ans(int i)
{
	if (i == leaves.size())
		return check_dfs(0);

	for (int d : docs[leaves[i]])
	{
		doc[leaves[i]] = d;
		if (find_ans(i + 1))
			return true;
	}
	return false;
}

int main()
{
	int n;
	cin >> n;
	gr = new vector<int>[n], docs = new vector<int>[n], now_docs = new vector<int>[n];
	for (int i = 0; i < n; i++)
	{
		int type;
		cin >> type;
		if (type == 1)
		{
			int k;
			cin >> k;
			gr[i].resize(k);
			for (int j = 0; j < k; j++)
			{
				cin >> gr[i][j];
				gr[i][j]--;
			}
		}
		else
		{
			int m;
			cin >> m;
			docs[i].resize(m);
			for (int j = 0; j < m; j++)
				cin >> docs[i][j];
			leaves.push_back(i);
		}
	}
	doc = new int[n];
	memset(doc, -1, n * sizeof(int));
	if (!find_ans(0))
		cout << "No" << "\n";
	else
	{
		cout << "Yes" << "\n";
		ans = new vector<int>[n];
		fill_ans_dfs(0);
		for (int i = 0; i < n; i++)
		{
			for (int el : ans[i])
				cout << el << " ";
			cout << "\n";
		}
	}
}
