#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <random>
#include <chrono>

using namespace std;
using ll = long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll n, m, k, q;

vector <string> opa;

ll cnt(ll x, ll y) {
	ll ans = 0;
	for (int i = n - 1; i >= x; --i) {
		for (int j = n - 1; j >= y; --j) {
			if (opa[i][j] == ' ') ++ans;
		}
	}
	return ans;
}

pair <ll, ll> simul() {
	ll x = rnd() % n, y = rnd() % n;
	while (opa[x][y] == '#' || cnt(x, y) > k) {
		x = rnd() % n, y = rnd() % n;
	}
	cout << x + 1 << ' ' << y + 1 << '\n';
	return { x, y };
}

pair <ll, ll> move(ll x, ll y) {
	cout << x + 1 << ' ' << y + 1 << endl;
	for (int i = n - 1; i >= x; --i) {
		for (int j = n - 1; j >= y; --j) {
			opa[i][j] = '#';
		}
	}
	ll a, b;
//	cin >> a >> b;
//	--a; --b;

	auto t = simul();
	a = t.first, b = t.second;
	for (int i = n - 1; i >= a; --i) {
		for (int j = n - 1; j >= b; --j) {
			opa[i][j] = '#';
		}
	}
	return { a, b };
}

pair <ll, ll> move2(ll x, ll y) {
	cout << x + 1 << ' ' << y + 1 << endl;
	for (int i = n - 1; i >= x; --i) {
		for (int j = n - 1; j >= y; --j) {
			opa[i][j] = '#';
		}
	}
	return { x, y };
}

pair <ll, ll> get() {
	ll a, b;
//	cin >> a >> b;
//	--a; --b;
	auto t = simul();
	a = t.first, b = t.second; 
	for (int i = n - 1; i >= a; --i) {
		for (int j = n - 1; j >= b; --j) {
			opa[i][j] = '#';
		}
	}
	return { a, b };
}

pair <ll, pair <ll, ll>> gett() {
	ll a, b;
	cin >> a >> b;
	--a; --b;

	ll cnt = 0;
	for (int i = n - 1; i >= a; --i) {
		for (int j = n - 1; j >= b; --j) {
			if (opa[i][j] == ' ') {
				opa[i][j] = '#';
				++cnt;
			}
		}
	}
	return { cnt, { a, b } };
}


int main() {
	ll t;
	cin >> t;
	cin >> n >> k >> m;
	if (t == 1) {
		string s;
		cin >> s;
		ll games = 1;
		ll ptr = 0;
		pair <ll, ll> last;
		ll cur = 0;
		opa.assign(n, string(n, ' '));
		while (ptr < s.size()) {
			if (games & 1) {
				if (s[ptr] == '0') {
					for (int i = n - 1; i >= 0; --i) {
						for (int j = n - 1; j >= 0; --j) {
							if (cnt(i, j) == 2) {
								last = move(i, j);
							}
						}
					}
				}
				else {
					for (int i = n - 1; i >= 0; --i) {
						for (int j = n - 1; j >= 0; --j) {
							if (cnt(i, j) == 1) {
								last = move(i, j);
							}
						}
					}
				}
			}
			else {
				get();

				if (s[ptr] == '0') {
					for (int i = n - 1; i >= 0; --i) {
						for (int j = n - 1; j >= 0; --j) {
							if (cnt(i, j) == 2) {
								last = move2(i, j);
							}
						}
					}
				}
				else {
					for (int i = n - 1; i >= 0; --i) {
						for (int j = n - 1; j >= 0; --j) {
							if (cnt(i, j) == 1) {
								last = move2(i, j);
							}
						}
					}
				}
			}
			++cur;
			if (cur == 100 || ptr == s.size() - 1) {
				if (last == make_pair(0ll, 0ll)) {
					++games;
					cur = 0;
					opa.assign(n, string(n, ' '));
				}
				else {
					if (games & 1) {
						move2(0, 0);
					}
					else {
						get();
						move2(0, 0);
					}
					++games;
					cur = 0;
					opa.assign(n, string(n, ' '));
				}
				if (ptr == s.size() - 1) {
					cout << 0 << endl;
					return 0;
				}
			}
			++ptr;
		}
	}
	else if (t == 2) {
		ll games;
		cin >> games;
		string ans(m, ' ');
		ll ptr = 0;
		for (int i = 0; i < games; ++i) {
			opa.assign(n, string(n, ' '));
			auto it = gett();
			vector <pair <ll, pair <ll, ll>>> opa;
			while (it.second != make_pair(1ll, 1ll)) {
				opa.push_back(it);
				it = gett();
			}
			vector <pair <ll, pair <ll, ll>>> act;
			if ((i + 1) & games) {
				for (int j = 0; j < opa.size(); j += 2) {
					act.push_back(opa[j]);
				}
			}
			else {
				for (int j = 1; j < opa.size(); j += 2) {
					act.push_back(opa[j]);
				}
			}
			act.pop_back();
			ll cnt = 0;
			for (auto& x : act) {
				ans[ptr++] = x.first % 2 + 48;
				if (cnt == 100 || ptr == ans.size()) {
					break;
				}
			}
		}
		cout << ans << '\n';
	}
	return 0;
}
/*
1
32 8 16
1111000011110000


2
32 8 16
1
32 32
26 32
32 31
32 25
32 24
28 30
32 23
31 25
32 22
28 28
32 21
29 26
32 20
32 19
32 18
23 32
32 17
28 26
32 16
24 31
32 15
26 28
32 14
20 31
32 13
32 5
32 4
17 31
32 3
26 27
32 2
24 27
32 1
31 17
31 16
29 24
31 15
23 27
31 14
30 21
31 13
13 32
31 12
27 26
31 11
23 26
31 10
28 24
31 9
31 3
31 2
12 31
31 1
22 27
30 20
20 28
30 19
27 24
30 18
6 32
30 17
19 30
30 16
23 24
30 15
28 21
30 14
28 18
30 13
20 25
30 12
15 30
30 11
17 29
30 10
29 11
30 9
30 7
30 6
16 28
30 5
11 30
30 4
29 10
30 3
8 30
30 2
25 22
30 1
29 7
29 6
19 24
29 5
28 12
29 4
24 23
29 3
26 18
29 2
28 9
29 1
14 28
28 8
27 16
28 7
12 28
28 6
13 27
28 5
17 26
28 4
7 30
28 3
6 30
28 2
10 27
28 1
21 23
27 15
24 22
27 14
25 19
27 13
24 19
27 12
27 5
27 4
7 28
27 3
5 31
27 2
26 13
27 1
10 26
26 12
21 22
26 11
19 23
26 10
3 32
26 9
26 3
26 2
25 12
26 1
8 27
25 11
8 26
25 10
18 22
25 9
23 20
25 8
16 24
25 7
25 2
25 1
23 19
24 18
3 31
24 17
14 25
24 16
22 18
24 15
22 15
24 14
19 21
24 13
4 28
24 12
23 11
24 10
1 32
24 9
2 30
24 8
23 7
24 6
1 30
24 5
22 7
24 4
22 6
24 3
10 25
24 2
7 25
24 1
14 24
23 5
11 24
23 4
3 29
23 3
22 1
21 20
14 22
21 19
13 22
21 18
4 26
21 17
9 24
21 16
6 25
21 15
20 16
21 14
3 25
21 13
7 24
21 12
19 18
21 11
21 5
21 4
21 1
20 15
18 17
20 14
18 14
20 13
20 7
20 6
16 19
20 5
17 13
20 4
5 24
20 3
4 24
20 2
2 27
20 1
5 23
19 12
19 8
19 7
18 11
19 6
19 4
19 3
13 21
19 2
13 20
19 1
5 22
18 10
1 28
18 9
3 22
18 8
9 20
18 7
16 18
18 6
5 20
18 5
14 19
18 4
17 10
18 3
2 22
18 2
15 18
18 1
14 17
17 9
14 16
17 8
1 27
17 7
1 25
17 6
14 15
17 5
16 10
17 4
12 18
17 3
11 18
17 2
11 17
17 1
14 12
16 9
2 20
16 8
14 8
16 7
15 7
16 6
1 20
16 5
15 6
16 4
16 3
16 2
14 7
16 1
7 18
15 5
14 4
15 3
6 19
15 2
5 19
15 1
14 1
13 16
13 9
13 8
12 9
13 7
12 8
13 6
12 6
13 5
5 18
13 4
9 15
13 3
12 2
13 1
6 16
12 1
4 17
11 14
11 7
11 6
1 18
11 5
4 16
11 4
3 16
11 3
9 12
11 2
10 7
11 1
1 16
10 6
10 3
10 2
1 15
10 1
8 10
9 9
2 14
9 8
7 9
9 7
9 3
9 2
5 11
9 1
7 8
8 7
6 6
8 5
6 3
8 2
5 6
8 1
3 12
7 2
1 13
7 1
5 3
6 2
2 10
6 1
4 3
5 2
3 4
5 1
1 8
4 2
2 2
4 1
1 3
3 1
1 2
2 1
1 1
*/