#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <tuple>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

const ll SZ = 40;
const ll MX = 15;

bool grid[SZ][SZ];
ll n, k, m;

void clr() {
	for (int i = 1; i <= MX; i++) {
		for (int j = 1; j <= MX; j++) grid[i][j] = 0;
	}
}

ll calc(int x, int y) {
	ll cnt = 0;

	for (int i = MX; i >= x; i--) {
		for (int j = MX; j >= y; j--) {
			if (grid[i][j] == 0) cnt++;
		}
	}

	return cnt;
}

vector<pair<int, int>> dir = { {0, 1}, {1, 0} };
void paint(int x, int y) {
	queue<pair<int, int>> q;
	q.push({ x, y });
	grid[x][y] = 1;

	while (!q.empty()) {
		pair<int, int> v = q.front();
		q.pop();

		for (auto c : dir) {
			if (v.first + c.first <= MX && v.second + c.second <= MX && !grid[v.first + c.first][v.second + c.second]) {
				grid[v.first + c.first][v.second + c.second] = 1;
				q.push({ v.first + c.first, v.second + c.second });
			}
		}
	}
}

vector<pair<ll, ll>> check;

void sol1() {
	cin >> n >> k >> m;
	string s;
	cin >> s;

	ll it = 0, hd = 0;

	//check.erase(check.begin());
	while (true) {
		clr();

		if (it == s.size()) {
			break;
		}
		if (hd) {
			pair<ll, ll> ans;
			cin >> ans.first >> ans.second;
			paint(ans.first, ans.second);
			if (ans == make_pair(1ll, 1ll)) {
				hd = !hd;
				continue;
			}
		}

		hd = !hd;

		pair<int, int> bst = { MX, MX };

		while (true) {
			if (it == s.size()) {
				cout << "1 1" << endl;
				break;
			}
			
			while (grid[bst.first][bst.second] || (bst.first + bst.second) % 2 != (s[it] - '0')) {
				bst.second--;
				if (bst.second <= 0) {
					bst.second = MX;
					bst.first--;
				}
			}
			pair<int, int> cur = bst;
			if (bst.first <= 0 || bst.second <= 0) {
				cout << "1 1" << endl;
				break;
			}
	
			cout << cur.first << " " << cur.second << endl;
			paint(cur.first, cur.second);
			if (bst == make_pair(1, 1)) {
				break;
			}
			it++;

			pair<ll, ll> ans;
			cin >> ans.first >> ans.second;
			paint(ans.first, ans.second);
			if (ans == make_pair(1ll, 1ll)) {
				break;
			}
		}
	}

	cout << "0" << endl;
	exit(0);
}

/*
1
32 8 16
1111000011110000
*/
void sol2() {
	cin >> n >> k >> m;
	ll g;
	cin >> g;

	string ans;
	ll it = 0, hd = 0;
	while (g--) {
		if (hd) it = !it;
		hd = !hd;
		while (true) {
			pair<ll, ll> pos;
			cin >> pos.first >> pos.second;

			if (pos == make_pair(1ll, 1ll)) {
				it = 0;
				break;
			}

			if (it == 0) {
				ans.push_back((pos.first + pos.second) % 2 + '0');
			}

			it = !it;
		}
	}

	cout << ans << endl;
	exit(0);
}

int main() {
	//fastInp;
	/*freopen("\\\\.\\pipe\\game.in", "r", stdin);
	freopen("\\\\.\\pipe\\game.out", "w", stdout);*/

	ll t;
	cin >> t;

	if (t == 1) {
		sol1();
	}
	else {
		sol2();
	}

	return 0;
}