#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define int long long
const int SZ = 1e5 + 4;

int n, m;
string s;
vector<int> a[SZ];
int cnt[SZ];
map<int, char> x[SZ];

void read() {
    cin >> m >> n >> s;
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int b;
            char c;
            cin >> b >> c;
            --b;
            a[b].push_back(i);
            if (s[b] == c) {
                ++cnt[i];
            }
            x[i][b] = c;
        }
    }
}

set<int> gg;

void solve() {
    for (int i = 0; i < m; ++i) {
        if (x[i].size() == cnt[i]) {
            gg.insert(i);
        }
    }
    vector<int> ans;
    set<int> used;

    int ready = 0;
    while (ready < n && !gg.empty()) {
        auto i = *gg.begin();
        gg.erase(gg.begin());

        ready += cnt[i];
        used.insert(i);
        ans.push_back(i);

        for (auto [u, v] : x[i]) {
            for (int j : a[u]) {
                if (i != j) {
                    if (s[u] == x[j][u]) {
                        --cnt[j];
                    }
                    x[j].erase(u);
                    if (cnt[j] == x[j].size()) {
                        gg.insert(j);
                    }
                }
            }
        }
    }

    if (ready < n) {
        cout << -1 << "\n";
        return;
    }

    for (int i = 0; i < m; ++i) {
        if (used.count(i)) continue;
        ans.push_back(i);
    }

    for (int i = 0; i < m; ++i) {
        cout << ans[i] + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}
