#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>

using namespace std;

#define int long long
const int SZ = 1e5 + 4;

int k, n;
int a[26][26];
string s;

void read() {
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    cin >> s;
}

set<int> kek;
int d = 0;

void del(int cur, int l) {
    auto it = kek.lower_bound(cur);
    if (it == kek.begin()) {
        if (a[s[l] - 'a'][s[cur] - 'a']) {
            ++d;

            ++it;
            if (it == kek.end()) {
                kek.erase(cur);
                return;
            }
            int x = *it;

            kek.erase(cur);

            del(x, l);
        }
    } else {
        --it;
        int j = *it;
        ++it;
        if (a[s[j] - 'a'][s[cur] - 'a']) {
            ++d;

            ++it;
            if (it == kek.end()) {
                kek.erase(cur);
                return;
            }
            int x = *it;

            kek.erase(cur);

            del(x, l);
        }
    }
}

bool check(int l, int r) {
    assert(l > 0);
    kek.clear();
    d = 0;
    for (int i = l; i <= r; ++i) {
        kek.insert(i);
    }

    for (int i = r; i >= l; --i) {
        del(i, l - 1);
    }

    if (d == r - l + 1) {
        return true;
    }

    return false;
}

map<char, vector<int>> g[SZ];
string ans;

string dfs(int u) {
    if (g[u].empty()) return "";
    ans.push_back(g[u].begin()->first);
    string mn = "$";
    for (int v : g[u].begin()->second) {
        string tmp = g[u].begin()->first + dfs(v);
        if (mn == "$" || mn > tmp) {
            mn = tmp;
        }
    }
    return mn;
}

void solve() {
    for (int i = 0; i < n; ++i) {
        int lo = i, hi = n;
        while (hi - lo > 1) {
            int m = lo + ((hi - lo) >> 1);
            if (check(i + 1, m)) {
                lo = m;
            } else {
                hi = m;
            }
        }

        if (lo == n - 1) {
            continue;
        }

        for (int j = i + 1; j <= lo + 1; ++j) {
            g[i][s[j]].push_back(j);
        }
    }

    cout << s[0] + dfs(0) << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}
