#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <ctime>
#include <queue>
#include <deque>
#include <fstream>
#include <iomanip>
#include <bitset>
// #pragma GCC optimize("O2,O3,Ofast")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;


void print(const string& s) {
    for (char ch : s) {
        cout << (char)(ch + 'a');
    }
    cout << "\n";
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> A(k, vector<bool>(k));
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < k; ++j) {
            A[i][j] = s[j] == '1';
        }
    }
    //
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        s[i] -= 'a';
    }
    //
    vector<vector<int>> right(k, vector<int>(n + 1, 0));
    for (int i = n - 1; i >= 0; --i) {
        for (int j = 0; j < k; ++j) {
            if (!A[j][s[i]]) {
                continue;
            }
            int x = 1 + right[s[i]][i + 1];
            right[j][i] = x + right[j][i + x];
        }
    }
    //
    vector<string> dp(n + 1);
    dp[n] = "";
    for (int i = n - 1; i >= 0; --i) {
        dp[i] = dp[i + 1];
        for (int j = 1; j <= right[s[i]][i + 1]; ++j) {
            dp[i] = min(dp[i], dp[i + j + 1]);
        }
        dp[i] = s[i] + dp[i];
    }
    print(dp[0]);
    return 0;
}