#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector < vector < char > > a;

int k, n;
string s;

const long long base = 31;
const long long mod = 1e9 + 7;

vector < long long > calc_pref(string& s) {
	int l = s.size();
	vector < long long > res(l);
	res[0] = s[0] - 'a' + 1;
	for (int i = 1; i < l; i++)
		res[i] = ((res[i - 1] * base) % mod + s[i] - 'a' + 1) % mod;
	return res;
}

vector < long long > b;
long long get_hash(int l, int r, vector < long long > pref) {
	if (l == 0)
		return pref[r];
	return (pref[r] - pref[l] * b[r - l + 1] + mod) % mod;
}

bool lesss(int id1, int id2, vector < string >& ans, vector < vector < long long > >& p) {
	int l = 0, r = min(ans[id1].size(), ans[id2].size());
	while (l < r) {
		int mid = (l + r + 1) / 2;
		if (mid == 0) {
			l = mid;
			continue;
		}
		if (get_hash(0, mid - 1, p[id1]) == get_hash(0, mid - 1, p[id2]))
			l = mid;
		else
			r = mid - 1;
	}
	ans[id1] += '#';
	ans[id2] += '#';
	bool re = ans[id1][l] < ans[id2][l];
	ans[id1].pop_back();
	ans[id2].pop_back();
	return re;
}

string solve50() {
	b.assign(n + 1, 1);
	for (int i = 1; i <= n; i++) {
		b[i] = (b[i - 1] * base) % mod;
	}

	s += "#";
	vector < vector < int > > nearestpos(n, vector < int >(k, -1));
	vector < int > todel(n, -1);
	for (int i = 1; i < n; i++) {
		nearestpos[i] = nearestpos[i - 1];
		if (a[s[i - 1] - 'a'][s[i] - 'a'] == '1')
			nearestpos[i][s[i - 1] - 'a'] = i - 1;
		for (int j = 0; j < k; j++) {
			if (a[j][s[i] - 'a'] == '0') continue;
			int tmp = i;
			while (tmp != -1) {
				tmp = nearestpos[tmp][j];
				if (tmp == -1 || tmp < todel[i])
					break;
				bool ok = true;
				for (int w = tmp + 1; w < i; w++) {
					if (todel[w] < tmp)
						ok = false;
				}
				if (ok) {
					todel[i] = max(todel[i], tmp);
					break;
				}
			}
		}
	}

//	for (auto e : todel) cout << e + 1 << " ";

	vector < string > answers(n);
	vector < vector < long long > > p(n);
	for (int i = n - 1; i >= 0; i--) {
		int start = i;
		int id = i + 1;
		string ans;
		ans.push_back(s[i]);

		int takepos = id;
		while (id < n && todel[id] >= start) {
			id++;
			if (s[id] < s[takepos])
				takepos = id;
			else if (s[id] == s[takepos])
				if(lesss(id, takepos, answers, p))
					takepos = id;
		}
		if (takepos < n)
			ans += answers[takepos];

		answers[i] = ans;
		p[i] = calc_pref(ans);
	}

	cout << answers[0];
	return answers[0];
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int te = 1;

	for (int w = 0; w < te; w++) {
		cin >> k >> n;
		a.assign(k, vector < char >(k, 0));
		for (int i = 0; i < k; i++)
			for (int j = 0; j < k; j++) {
				cin >> a[i][j];
			}
		cin >> s;

		string t2 = solve50();
	}
}