#include <map>
#include <set>
#include <deque>
#include <bitset>
#include <cstdio>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

int A[26][26];
bitset<2000> dp[2000];

vector<pair<int, char>> G[2001];
bool can_get[2001];
bool used[2001];

void dfs(int v, int need) {
  used[v] = true;
  if (v == need)
    can_get[v] = true;
  for (auto t : G[v]) {
    if (!used[t.first])
      dfs(t.first, need);
    can_get[v] |= can_get[t.first];
  }
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int k, n;
  cin >> k >> n;
  for (int i = 0; i < k; ++i) {
    for (int j = 0; j < k; ++j) {
      char c;
      cin >> c;
      A[i][j] = c - '0';
    }
  }
  string s;
  cin >> s;
  for (int i = n - 1; i >= 0; --i) {
    dp[i][i] = true;
    for (int j = i; j + 1 < n; ++j) {
      if (dp[i][j] && A[s[i] - 'a'][s[j + 1] - 'a'])
        dp[i] |= dp[j + 1];
    }
  }
  for (int i = 0; i < n; ++i) {
    for (int j = i; j < n; ++j) {
      if (dp[i][j])
        G[i].emplace_back(j + 1, s[i]);
    }
  }
  dfs(0, n);
  string ans = "";
  set<int> cur;
  cur.emplace(0);
  while (!cur.count(n)) {
    char mn_char = 0;
    for (int v : cur) {
      for (auto t : G[v]) {
        if (can_get[t.first]) {
          if (mn_char == 0 || mn_char > t.second)
            mn_char = t.second;
        }
      }
    }
    ans += mn_char;
    set<int> cur2;
    for (int v : cur) {
      for (auto t : G[v]) {
        if (t.second == mn_char && can_get[t.first])
          cur2.emplace(t.first);
      }
    }
    swap(cur, cur2);
  }
  cout << ans << '\n';
  return 0;
}
