#include <map>
#include <set>
#include <deque>
#include <bitset>
#include <cstdio>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 2000;

vector<int> G[MAXN];
vector<int> tasks[MAXN];

map<int, int> dp[MAXN];
map<int, int> dp_tmp[1 << 8];
map<int, int> par_tmp[1 << 8];

void dfs(int v) {
  if (G[v].empty()) {
    for (int x : tasks[v])
      dp[v][x] = x;
    return;
  }
  for (int u : G[v])
    dfs(u);
  int k = G[v].size();
  for (int mask = 1; mask < (1 << k); ++mask) {
    for (int i = 0; i < k; ++i) {
      if (mask & (1 << i)) {
        if (mask == (1 << i)) {
          dp_tmp[mask] = dp[G[v][i]];
          break;
        }
        for (auto t1 : dp_tmp[mask ^ (1 << i)]) {
          for (auto t2 : dp[G[v][i]]) {
            if (t1.second < t2.first) {
              if (dp_tmp[mask].count(t1.first))
                dp_tmp[mask][t1.first] = min(dp_tmp[mask][t1.first], t2.second);
              else
                dp_tmp[mask][t1.first] = t2.second;
            }
          }
        }
      }
    }
  }
  dp[v] = dp_tmp[(1 << k) - 1];
  for (int mask = 1; mask < (1 << k); ++mask)
    dp_tmp[mask].clear();
}

vector<int> ans[MAXN];

void zhfs(int v, int ll, int rr) {
  if (G[v].empty()) {
    ans[v].emplace_back(ll);
    return;
  }
  int k = G[v].size();
  for (int mask = 1; mask < (1 << k); ++mask) {
    for (int i = 0; i < k; ++i) {
      if (mask & (1 << i)) {
        if (mask == (1 << i)) {
          dp_tmp[mask] = dp[G[v][i]];
          break;
        }
        for (auto t1 : dp_tmp[mask ^ (1 << i)]) {
          for (auto t2 : dp[G[v][i]]) {
            if (t1.second < t2.first) {
              if (dp_tmp[mask].count(t1.first)) {
                if (dp_tmp[mask][t1.first] > t2.second) {
                  par_tmp[mask][t1.first] = i;
                  dp_tmp[mask][t1.first] = t2.second;
                }
              } else {
                par_tmp[mask][t1.first] = i;
                dp_tmp[mask][t1.first] = t2.second;
              }
            }
          }
        }
      }
    }
  }
  int cur = (1 << k) - 1;
  int cur_l = ll, cur_r = rr;
  vector<pair<int, int>> need(k);
  while (true) {
    if (__builtin_popcount(cur) == 1) {
      int id = 31 - __builtin_clz(cur);
      ans[v].emplace_back(G[v][id] + 1);
      need[id] = make_pair(cur_l, cur_r);
      break;
    }
    int id = par_tmp[cur][cur_l];
    ans[v].emplace_back(G[v][id] + 1);
    int t1 = dp_tmp[cur ^ (1 << id)][cur_l];
    for (auto t2 : dp[G[v][id]]) {
      if (t2.first > t1 && t2.second == cur_r)
        need[id] = t2;
    }
    cur ^= 1 << id;
    cur_r = t1;
  }
  for (int mask = 1; mask < (1 << k); ++mask)
    dp_tmp[mask].clear();
  for (int i = 0; i < k; ++i)
    zhfs(G[v][i], need[i].first, need[i].second);
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n;
  cin >> n;
  for (int i = 0; i < n; ++i) {
    int t;
    cin >> t;
    if (t == 1) {
      int k;
      cin >> k;
      G[i].resize(k);
      for (int j = 0; j < k; ++j) {
        cin >> G[i][j];
        --G[i][j];
      }
    } else {
      int k;
      cin >> k;
      tasks[i].resize(k);
      for (int j = 0; j < k; ++j)
        cin >> tasks[i][j];
    }
  }
  dfs(0);
  if (dp[0].empty())  {
    cout << "No\n";
    return 0;
  }
  cout << "Yes\n";
  zhfs(0, dp[0].begin()->first, dp[0].begin()->second);
  for (int i = 0; i < n; ++i) {
    reverse(ans[i].begin(), ans[i].end());
    for (int x : ans[i])
      cout << x << ' ';
    cout << '\n';
  }
  return 0;
}
