#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>

using itn = int;

using namespace std;

bool used[100000];

vector <int> cards;

int n, m;

vector <set<int>> cool_cards;
vector <set <int>> bad_cards;

string s;

bool check(int ind) {
	for (itn i = 0; i < cards.size(); ++i) {
		if (cool_cards[ind].find(cards[i]) != cool_cards[ind].end())
			return true;
		if (bad_cards[ind].find(cards[i]) != bad_cards[ind].end())
			return false;
	}
	return false;
}

bool check_all() {
	for (int i = 0; i < m; ++i) {
		if (!check(i))
			return false;
	}
	return true;
}

bool is_first() {
	for (itn i = n - 1; i >= 0; --i)
		if (cards[i] != i)
			return false;
	return true;
}

int main() {
	cin >> n >> m;
	int ki, p;
	char r;
	cin >> s;
	cool_cards.resize(m);
	bad_cards.resize(m);
	for (int i = 0; i < n; ++i) {
		cin >> ki;
		for (int j = 0; j < ki; ++j) {
			cin >> p >> r;
			--p;
			if (s[p] == r)
				cool_cards[p].insert(i);
			else
				bad_cards[p].insert(i);
		}
	}
	for (int i = 0; i < m; ++i) {
		if (cool_cards[i].size() == 0) {
			cout << -1;
			return 0;
		}
	}
	for (int i = 0; i < n; ++i) {
		cards.push_back(i);
	}
	if (check_all()) {
		for (int i = 0; i < n; ++i) {
			cout << cards[i] + 1 << " ";
		}
		return 0;
	}
	next_permutation(cards.begin(), cards.end());
	while (!is_first()) {
		if (check_all()) {
			for (int i = 0; i < n; ++i) {
				cout << cards[i] + 1 << " ";
			}
			return 0;
		}
		next_permutation(cards.begin(), cards.end());
	}
	cout << -1;
}