#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<map>
using namespace std;

const int INF = 1e9;
vector<int> a;
vector<pair<int, int>> tree;

int left_s(int root) {
	return 2 * root + 1;
}

int right_s(int root) {
	return 2 * root + 2;
}

void build(int root, int l, int r) {
	if (l + 1 == r) {
		tree[root] = { a[l], l };
		return;
	}
	int m = (l + r) / 2;
	build(left_s(root), l, m);
	build(right_s(root), m, r);
	tree[root] = min(tree[left_s(root)], tree[right_s(root)]);
}

pair<int, int> get_min() {
	return tree[0];
}

void update(int root, int l, int r, int ind, int val){
	if (l > ind || r <= ind) {
		return;
	}
	if (l + 1 == r) {
		tree[root].first += val;
		return;
	}
	int m = (l + r) / 2;
	update(left_s(root), l, m, ind, val);
	update(right_s(root), m, r, ind, val);
	tree[root] = min(tree[left_s(root)], tree[right_s(root)]);
}

int main() {
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	a.assign(n, 0);
	map<int, vector<int>> hah, pos_by_card;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int pos;
			char c;
			cin >> pos >> c;
			if (c != s[pos - 1]) {
				hah[pos - 1].push_back(i);
				++a[i];
			}
			else {
				pos_by_card[i].push_back(pos - 1);
			}
		}
	}
	tree.resize(4 * n);
	build(0, 0, n);
	vector<int> used(m, 0);
	vector<int> ans;
	for (int i = 0; i < n; ++i) {
		auto res = get_min();
		if (res.first != 0) {
			cout << -1;
			return 0;
		}
		int cur_card = res.second;
		ans.push_back(cur_card);
		for (auto pos : pos_by_card[cur_card]) {
			if (!used[pos]) {
				for (auto card : hah[pos]) {
					update(0, 0, n, card, -1);
				}
				used[pos] = 1;
			}
		}
		update(0, 0, n, cur_card, INF);
	}
	for (auto x : used) {
		if (x == 0) {
			cout << -1;
			return 0;
		}
	}
	for (auto x : ans) {
		cout << x + 1 << ' ';
	}
}

//3 4
//glhf
//3 1 r 3 h 4 i
//3 1 r 2 l 3 o
//2 1 g 4 f