#include <iostream>
#include <algorithm>

using namespace std;

#define int long long

const int INF = 1e18 + 239;
const int N = 3e5 + 7;
const int A = 26;

int val[A];

void init() {
	val[0] = 1;
	for (int i = 0; i + 1 < A; i++) {
		if (i % 2 == 0) {
			val[i + 1] = val[i] * 5;
		} else {
			val[i + 1] = val[i] * 2;
		}
	}
}

int dp[N][A];
pair<int, int> wr[N][A];

void solve() {
	string s;
	cin >> s;
	int n = (int)s.size();
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j < A; j++) {
			dp[i][j] = -INF;
			wr[i][j] = {-1, -1};
		}
	}
	dp[n][0] = 0;
	for (int i = n; i > 0; i--) {
		for (int c = 0; c < A; c++) {
			for (int nw = 0; nw < A; nw++) {
				if (s[i - 1] != '?' && s[i - 1] - 'A' != nw) continue;
				int to = max(c, nw);
				int add = val[nw];
				if (nw < c) {
					add *= -1;
				}
				if (dp[i - 1][to] < dp[i][c] + add) {
					dp[i - 1][to] = dp[i][c] + add;
					wr[i - 1][to] = {c, nw};
				}
			}
		}
	}
	int best = max_element(dp[0], dp[0] + A) - dp[0];
	cout << dp[0][best] << '\n';
	for (int i = 0; i < n; i++) {
		cout << (char)(wr[i][best].second + 'A');
		best = wr[i][best].first;
	}
	cout << '\n';
}

signed main() {
	init();

	int q;
	cin >> q;
	while (q--) {
		solve();
	}
}