#pragma GCC optimize("Ofast")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>
#include <random>
#include <queue>

using namespace std;

const int N = 5001;

int used[N];
int x[N];
int h[N];

namespace DSU {
	int p[N];
	int rank[N];
	int mn[N];
	int mx[N];

	int get(int v) {
		if (p[v] != v) {
			p[v] = get(p[v]);
		}
		return p[v];
	}

	int gmin(int v) {
		v = get(v);
		return mn[v];
	}

	int gmax(int v) {
		v = get(v);
		return mx[v];
	}

	void merge(int a, int b) {
		a = get(a);
		b = get(b);
		if (a != b) {
			if (rank[a] < rank[b]) swap(a, b);
			p[b] = a;
			mn[a] = min(mn[a], mn[b]);
			mx[a] = max(mx[a], mx[b]);
			if (rank[a] == rank[b]) rank[a]++;
		}
	}
}

void solve(int l, int r) {
	for (int i = l - 1; i <= r + 1; i++) {
		DSU::rank[i] = 0;
		DSU::p[i] = i;
		DSU::mn[i] = i;
		DSU::mx[i] = i;
	}
	auto can_l = [&](int i) {
		int L = DSU::gmin(i);
		return x[L - 1] <= x[i] - h[i];		
	};
	auto can_r = [&](int i) {
		int R = DSU::gmax(i);
		return x[i] + h[i] <= x[R + 1];
	};
	queue<int> q;
	for (int i = l; i <= r; i++) {
		used[i] = 0;
		if (can_l(i) || can_r(i)) {
			q.push(i);
			used[i] = 1;
		}
	}
	int ans = 0;
	while (!q.empty()) {
		int i = q.front();
		q.pop();
		ans++;
		int pr = DSU::gmin(i) - 1;
		int nx = DSU::gmax(i) + 1;
		if (i != l) {
			DSU::merge(i - 1, i);
		}
		if (i != r) {
			DSU::merge(i, i + 1);
		}
		if (pr != l - 1 && can_r(pr) && !used[pr]) {
			used[pr] = 1;
			q.push(pr);
		}
		if (nx != r + 1 && can_l(nx) && !used[nx]) {
			used[nx] = 1;
			q.push(nx);
		}
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	for (int i = 1; i <= n; i++) {
		cin >> x[i] >> h[i];
	}
	x[0] = x[1];
	x[n + 1] = x[n];
	n += 2;
	while (q--) {
		int l, r;
		cin >> l >> r;
		solve(l, r);
	}
}