#pragma GCC optimize("Ofast")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>
#include <random>
#include <queue>

using namespace std;

const int N = 10001;

namespace DSU {
	int p[N];
	int rank[N];
	int mn[N];
	int mx[N];

	int get(int v) {
		if (p[v] != v) {
			p[v] = get(p[v]);
		}
		return p[v];
	}

	int gmin(int v) {
		v = get(v);
		return mn[v];
	}

	int gmax(int v) {
		v = get(v);
		return mx[v];
	}

	void merge(int a, int b) {
		a = get(a);
		b = get(b);
		if (a != b) {
			if (rank[a] < rank[b]) swap(a, b);
			p[b] = a;
			mn[a] = min(mn[a], mn[b]);
			mx[a] = max(mx[a], mx[b]);
			if (rank[a] == rank[b]) rank[a]++;
		}
	}
}

int used[N];
int poped[N];
int x[N];
int h[N];


int get_l(int i) {
	int L = i - 1;
	if (poped[L]) L = DSU::gmin(i - 1) - 1;
	return L;
}

int get_r(int i) {
	int R = i + 1;
	if (poped[R]) R = DSU::gmax(i + 1) + 1;
	return R;
}

int can_l(int i) {
	return x[get_l(i)] <= x[i] - h[i];
}

int can_r(int i) {
	return x[i] + h[i] <= x[get_r(i)];
}

int Q[N];
int hd = 0;
int tl = 0;

void solve(int l, int r) {
	for (int i = l - 1; i <= r + 1; i++) {
		DSU::rank[i] = 0;
		DSU::p[i] = i;
		DSU::mn[i] = i;
		DSU::mx[i] = i;
		used[i] = 0;
		poped[i] = 0;
	}
	hd = 0;
	tl = 0;
	for (int i = l; i <= r; i++) {
		if (can_l(i) || can_r(i)) {
			Q[hd++] = i;
			used[i] = 1;
		}
	}
	int ans = 0;
	while (hd != tl) {
		int i = Q[tl++];
		poped[i] = 1;
		ans++;
		if (poped[i - 1]) {
			DSU::merge(i - 1, i);
		}
		if (poped[i + 1]) {
			DSU::merge(i, i + 1);
		}
		int pr = get_l(i);
		int nx = get_r(i);
		if (pr != l - 1 && can_r(pr) && !used[pr]) {
			used[pr] = 1;
			Q[hd++] = pr;
		}
		if (nx != r + 1 && can_l(nx) && !used[nx]) {
			used[nx] = 1;
			Q[hd++] = nx;
		}
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	for (int i = 1; i <= n; i++) {
		cin >> x[i] >> h[i];
	}
	x[0] = x[1];
	x[n + 1] = x[n];
	n += 2;
	while (q--) {
		int l, r;
		cin >> l >> r;
		solve(l, r);
	}
}