#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <cmath>
#include <set>
#include <string>

using namespace std;
typedef long long ll;
int inf = -1e9;

vector<vector<pair<int,int>>>g;

struct vertex {
	int v, mn, mx;
	bool operator<(vertex b) const {
		return (mn + mx) < (b.mn + b.mx);
	}
	bool operator>(vertex b) const {
		return (mn + mx) > (b.mn + b.mx);
	}
};

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
	int n, m; cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int u, v, c; cin >> u >> v >> c;
		u--; v--;
		g[v].push_back({ u, c });
		g[u].push_back({ v, c });
	}
	vector<vertex>ans(n, vertex({ -1, -inf, -inf }));
	for (int i = 0; i < n; i++)
		ans[i].v = i;
	ans[0] = vertex({ 0, -inf, inf });
	set<vertex>s;
	s.insert(ans[0]);
	while (!s.empty()) {
		int v = (*s.begin()).v;
		s.erase(s.begin());
		for (auto u : g[v]) {
			if (vertex({ v, min(ans[v].mn, u.second), max(ans[v].mx, u.second) }) < ans[u.first]) {
				ans[u.first].mn = min(ans[v].mn, u.second);
				/*if (ans[u.first].mx == -inf)
					ans[u.first].mx = u.second;
				else*/
				ans[u.first].mx = max(ans[v].mx, u.second);
				s.insert(ans[u.first]);
			}
		}
	}
	for (int i = 1; i < n; i++)
		cout << ans[i].mx + ans[i].mn << '\n';
	return 0;
}