#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <set>
#include <string>

using namespace std;
typedef long long ll;

struct tree {
	int x, h, l = 0, r = 0, i;
	bool operator< (tree b) const{
		pair<bool, pair<int, int>> a1 = { (max(l, r) >= h), {l + r, i} }, b1 = { (max(b.l, b.r) >= b.h), {b.l + b.r, b.i} };
		return a1 < b1;
	}
};

vector<tree>arr;
set<tree>s;
set<int>live;
unordered_map<int, tree>trees;

int get_ans(int l, int r) {
	while (s.size() != 0) {
		tree x = *(--s.end());
		if (max(x.l, x.r) < x.h)
			break;
		auto it = live.find(x.i);
		s.erase(x);
		if (it != live.begin()) {
			it--;
			tree left = trees[*it];
			s.erase(left);
			left.r += x.r;
			s.insert(left);
			trees[left.i] = left;
			it++;
		}
		it++;
		if (it != live.end()) {
			tree right = trees[*it];
			s.erase(right);
			right.l += x.l;
			s.insert(right);
			trees[right.i] = right;
		}
		live.erase(x.i);
	}
	return (r - l) + 1 - s.size();
}

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
	int n, Q; cin >> n >> Q;
	arr.resize(n);
	trees.max_load_factor(0.25);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].h;
		arr[i].i = i;
		if (i != 0) {
			arr[i].l = abs(arr[i].x - arr[i - 1].x);
			arr[i - 1].r = abs(arr[i].x - arr[i - 1].x);
		}
	}
	for (int z = 0; z < Q; z++) {
		int l, r; cin >> l >> r;
		l--; r--;
		for (int i = l; i <= r; i++) {
			s.insert(arr[i]);
			live.insert(i);
			trees[i] = arr[i];
		}
		int ans = get_ans(l, r);
		cout << ans << '\n';
		s.clear();
		live.clear();
	}
	return 0;
}