#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <set>
#include <string>

using namespace std;
typedef long long ll;

struct tree {
	int x, h, l = 0, r = 0, i;
	bool operator< (tree b) const{
		pair<bool, pair<int, int>> a1 = { (max(l, r) >= h), {l + r, i} }, b1 = { (max(b.l, b.r) >= b.h), {b.l + b.r, b.i} };
		return a1 < b1;
	}
};

vector<tree>arr;
set<tree>s;
vector<int>rght, lft;
unordered_map<int, tree>trees;

int get_ans(int l, int r) {
	while (s.size() != 0) {
		tree x = *(--s.end());
		if (max(x.l, x.r) < x.h)
			break;
		int l1 = lft[x.i], r1 = rght[x.i];
		s.erase(x);
		if (l1 != -1) {
			tree left = trees[l1];
			s.erase(left);
			left.r += x.r;
			s.insert(left);
			trees[left.i] = left;
			rght[l1] = -1;
		}
		if (r1 != -1) {
			tree right = trees[r1];
			s.erase(right);
			right.l += x.l;
			s.insert(right);
			trees[right.i] = right;
			lft[r1] = -1;
		}
		if (r1 != -1 && l1 != -1) {
			lft[r1] = l1;
			rght[l1] = r1;
		}
	}
	return (r - l) + 1 - s.size();
}

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
	int n, Q; cin >> n >> Q;
	arr.resize(n);
	trees.max_load_factor(0.25);
	lft.resize(n);
	rght.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].h;
		arr[i].i = i;
		if (i != 0) {
			arr[i].l = abs(arr[i].x - arr[i - 1].x);
			arr[i - 1].r = abs(arr[i].x - arr[i - 1].x);
		}
	}
	for (int z = 0; z < Q; z++) {
		int l, r; cin >> l >> r;
		l--; r--;
		for (int i = l; i <= r; i++) {
			s.insert(arr[i]);
			trees[i] = arr[i];
			if (i != l)
				lft[i] = i - 1;
			else
				lft[i] = -1;
			if (i != r)
				rght[i] = i + 1;
			else
				rght[i] = -1;
		}
		int ans = get_ans(l, r);
		cout << ans << '\n';
		s.clear();
	}
	return 0;
}