#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
#include <cmath>
#include <set>
#include <string>

using namespace std;
typedef long long ll;
int inf = 1e9;

vector<vector<pair<int, int>>>g;

struct vertex {
	int v, mn, mx;
	bool operator<(vertex b) const {
		return (mn + mx) < (b.mn + b.mx);
	}
	bool operator>(vertex b) const {
		return (mn + mx) > (b.mn + b.mx);
	}
};

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
	int n, m; cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int u, v, c; cin >> u >> v >> c;
		u--; v--;
		g[v].push_back({ u, c });
		g[u].push_back({ v, c });
	}
	vector<int>ans(n, inf);
	ans[0] = 0;
	set<pair<int,int>>s;
	s.insert({ 0, 0 });
	while (!s.empty()) {
		int v = (*s.begin()).second;
		s.erase(s.begin());
		for (auto u : g[v]) {
			if (ans[u.first] > max(u.second, ans[v])) {
				ans[u.first] = max(u.second, ans[v]);
				s.insert({ ans[u.first], u.first });
			}
		}
	}
	for (int i = 1; i < n; i++)
		cout << ans[i] << '\n';
	return 0;
}