#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
 
struct Edge {
    int u, v, w;
    Edge(int u, int v, int w) : u(u), v(v), w(w) {}
    bool operator <(const Edge &other) const {
        return w < other.w;
    }
};

const ll Inf = 2e9;

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    int n, m;
    cin >> n >> m;
    vector <Edge> E;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        E.emplace_back(u, v, w);
    }
    sort(E.begin(), E.end());
    vector <int> par(n);
    for (int i = 0; i < n; ++i) par[i] = i;
    function <int(int)> get = [&] (int a) {
        return (a == par[a] ? a : par[a] = get(par[a]));
    };
    auto join = [&] (int a, int b) {
        a = get(a);
        b = get(b);
        par[a] = b;
    };
    vector <int> in_tr(m);
    vector <vector <pair <int, int>>> g(n);
    for (int i = 0; i < (int)E.size(); ++i) {
        if (get(E[i].u) != get(E[i].v)) {
            join(E[i].u, E[i].v);
            g[E[i].u].push_back({E[i].v, i});
            g[E[i].v].push_back({E[i].u, i});
            in_tr[i] = 1;
        }
    }
    const int K = 20;
    vector <vector <int>> go(K, vector <int> (n));
    vector <int> l(n), r(n);
    vector <int> e;
    vector <int> ed_id(n);
    function <void(int, int)> dfs = [&] (int u, int p) {
        e.push_back(u);
        l[u] = (int)e.size() - 1;
        go[0][u] = p;
        for (int i = 1; i < K; ++i) {
            go[i][u] = go[i - 1][go[i - 1][u]];
        }
        for (auto [v, id] : g[u]) {
            if (v != p) {
                ed_id[v] = id;
                dfs(v, u);
            }
        }
        r[u] = (int)e.size() - 1;
    };
    dfs(0, 0);
    auto anc = [&] (int a, int b) {
        return l[a] <= l[b] && r[b] <= r[a];
    };
    auto lca = [&] (int a, int b) {
        if (anc(a, b)) return a;
        for (int i = K - 1; i >= 0; --i) {
            if (!anc(go[i][a], b)) {
                a = go[i][a];
            }
        }
        return go[0][a];
    };
    vector <int> alive(m);
    vector <int> delta(n);
    vector <ll> ans(n, Inf);
    for (int i = 0; i < m; ++i) {
        alive[i] = 1;
        if (!in_tr[i]) {
            //cout << "add " << E[i].u << ' ' << E[i].v << ' ' << lca(E[i].u, E[i].v) endl;
            ++delta[E[i].u];
            ++delta[E[i].v];
            delta[lca(E[i].u, E[i].v)] -= 2;
        }
        vector <int> cur = delta;
        for (int j = (int)e.size() - 1; j > 0; --j) {
            int u = e[j];
            cur[go[0][u]] += cur[u];
        }
        for (int i = 0; i < n; ++i) par[i] = i;
        for (int i = 1; i < n; ++i) {
            if (cur[i] > 0) {
                assert(alive[ed_id[i]]);
                join(i, go[0][i]);
            }
        }
        vector <ll> best(n, Inf);
        vector <int> is_r(n);
        is_r[get(0)] = 1;
        for (int i = 1; i < n; ++i) {
            if (alive[ed_id[i]]) best[get(i)] = min(best[get(i)], (ll)E[ed_id[i]].w);
        }
        for (int i : e) {
            if (i == 0) continue;
            if (get(i) != get(go[0][i]) && alive[ed_id[i]]) {
                is_r[get(i)] |= is_r[get(go[0][i])];
                best[get(i)] = min(best[get(i)], best[get(go[0][i])]);
            }
        }
        /*for (int i = 1; i < n; ++i) {
            cout << best[get(i)] << ' ';
        }
        cout << endl;*/
        for (int j = 1; j < n; ++j) {
            if (!is_r[get(j)]) continue;
            //cout << E[i].w << endl;
            ans[j] = min(ans[j], best[get(j)] + E[i].w);
            /*if (j == n - 1 && ans[j] == 8) {
                for (int i = 0; i < n; ++i) {
                    cout << cur[i] << ' ';
                }
                cout << endl;
                exit(0);
            }*/
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << '\n';
    }
}