#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;
constexpr int MAXN = (int)15e4;
constexpr int MAXM = (int)3e5;
vector<int> g[MAXN];
vector<int> h[MAXM];
int edg[MAXM];
int mark[MAXM];

void dfs(int v, int part = 0) {
	mark[v] = part;
	for (int to : h[v]) {
		if (mark[to] != -1)
			continue;
		dfs(to, 1 - part);
	}
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &p) {
	return out << p.first << ' ' << p.second;
}

vector<int> conn[MAXM];
pair<int, int> full_edge[MAXM];
int match[MAXM];
int used[MAXM];
int timer = 0;

bool kuhn(int v) {
	if (used[v] == timer)
		return false;
	used[v] = timer;
	for (int to : conn[v]) {
		if (match[to] == -1 || kuhn(match[to])) {
			match[to] = v;
			return true;
		}
	}
	return false;
}

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int v, to;
		cin >> v >> to;
		full_edge[i] = make_pair(v, to);
		edg[i] = to - 1;
		g[v - 1].push_back(i);
	}

	for (int v = 0; v < n; ++v) {
		for (int e : g[v]) {
			int to = edg[e];
			for (int f : g[to]) {
				h[e].push_back(f);
				h[f].push_back(e);
			}
		}
	}

	fill(mark, mark + m, -1);
	for (int v = 0; v < m; ++v)
		if (mark[v] == -1)
			dfs(v);

	for (int v = 0; v < m; ++v) {
		if (mark[v] == 1)
			continue;
		for (int to : h[v])
			conn[v].push_back(to);
	}
	fill(match, match + m, -1);

	for (int v = 0; v < m; ++v) {
		if (mark[v] == 1)
			continue;
		++timer;
		kuhn(v);
	}

	vector<pair<int, int>> pairs;
	for (int i = 0; i < m; ++i)
		if (match[i] != -1)
			pairs.emplace_back(i, match[i]);

	if (2 * pairs.size() == m) {
		cout << "Yes\n";
		for (const auto &[a, b] : pairs)
			cout << full_edge[a] << ' ' << full_edge[b] << '\n';
	} else {
		cout << "No\n";
	}

	return 0;
}