#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <algorithm>
#include <cassert>
using namespace std;
#define cap(x) (x).size()
#define pb push_back
using ll = long long;
const int N = 3e5 + 100, inf = 1e9;
vector<pair<int, int>> g[N];
int bridge[N], cost[N];
int h[N], f[N], used[N];
int ans[N];
int val[N];
int cmp[N];
pair<int, int> e[N];
vector<pair<int, int>> t[N];
void dfs(int v, int p = -1) {
	f[v] = h[v];
	used[v] = 1;
	for (auto e : g[v]) {
		int to = e.first, i = e.second;
		if (i == p) continue;
		if (used[to])
			f[v] = min(f[v], h[to]);
		else {
			h[to] = h[v] + 1;
			dfs(to, i);
			f[v] = min(f[v], f[to]);
			if (f[to] > h[v])
				bridge[i] = 1;
		}
	}
}
void calc(int v, int cur) {
	cmp[v] = cur;
	for (auto e : g[v]) {
		int to = e.first, i = e.second;
		if (bridge[i]) continue;
		if (!cmp[to])
			calc(to, cur);
	}
}
void rec(int v, int p = -1, int mn = inf) {
	mn = min(mn, val[v]);
	ans[v] = mn;
	for (auto e : t[v]) {
		int to = e.first, w = e.second;
		if (to != p) rec(to, v, min(mn, w));
	}
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int x, y, t;
		cin >> x >> y >> t;
		g[x].pb({ y, i });
		g[y].pb({ x, i });
		cost[i] = t;
		e[i] = { x, y };
	}
	for (int i = 1; i <= n; i++) val[i] = 1e9;
	dfs(1);
	int cur = 1;
	for (int i = 1; i <= n; i++) {
		if (cmp[i] == 0) {
			calc(i, cur);
			cur++;
		}
	}
	for (int i = 0; i < m; i++) {
		int x = e[i].first, y = e[i].second;
		if (!bridge[i]) {
			assert(cmp[x] == cmp[y]);
			val[cmp[x]] = min(val[cmp[x]], cost[i]);
		}
		else {
			x = cmp[x], y = cmp[y];
			t[x].pb({ y, cost[i] });
			t[y].pb({ x, cost[i] });
		}
	}
	rec(1);
	for (int i = 2; i <= n; i++) cout << ans[cmp[i]] + inf << ' ';
	return 0;
}
/*

6 7
1 2 10
2 3 12
1 3 10
3 4 4
4 5 5
4 5 6
3 6 7
*/