#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <algorithm>
#include <cassert>
using namespace std;
#define cap(x) (x).size()
#define pb push_back
#define all(x) (x).begin(), (x).end()
using ll = long long;
const int N = 3e5 + 100, inf = 1e9 + 10;
vector<pair<int, int>> g[N];
int bridge[N], cost[N];
int h[N], f[N], used[N];
int ans[N];
int val[N];
int cmp[N];
int tot_ans[N];
pair<int, int> e[N];
vector<pair<int, int>> t[N];
void dfs(int v, int p = -1) {
	f[v] = h[v];
	used[v] = 1;
	for (auto e : g[v]) {
		int to = e.first, i = e.second;
		if (i == p) continue;
		if (used[to])
			f[v] = min(f[v], h[to]);
		else {
			h[to] = h[v] + 1;
			dfs(to, i);
			f[v] = min(f[v], f[to]);
			if (f[to] > h[v])
				bridge[i] = 1;
		}
	}
}
void calc(int v, int cur) {
	cmp[v] = cur;
	for (auto e : g[v]) {
		int to = e.first, i = e.second;
		if (bridge[i]) continue;
		if (!cmp[to])
			calc(to, cur);
	}
}
void rec(int v, int p = -1, int mn = inf) {
	mn = min(mn, val[v]);
	ans[v] = mn;
	for (auto e : t[v]) {
		int to = e.first, w = e.second;
		if (to != p) rec(to, v, min(mn, w));
	}
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<int> ord;
	for (int i = 0; i < m; i++) {
		int x, y, t;
		ord.pb(i);
		cin >> x >> y >> t;
		cost[i] = t;
		e[i] = { x, y };
	}
	sort(all(ord), [&](int x, int y) {
		return cost[x] < cost[y];
		});
	for (int i = 1; i <= n; i++) tot_ans[i] = 2 * inf;
	vector<int> incl(m);
	for (int cur_e : ord) {
		incl[cur_e] = 1;
		int x = e[cur_e].first, y = e[cur_e].second;
		g[x].pb({ y, cur_e }), g[y].pb({ x, cur_e });
		for (int i = 1; i <= n; i++) {
			val[i] = inf;
			t[i].clear();
			cmp[i] = 0;
			used[i] = 0;
			ans[i] = inf;
		}
		for (int i = 0; i < m; i++) bridge[i] = 0;
		dfs(1);
		int cur = 1;
		for (int i = 1; i <= n; i++) {
			if (cmp[i] == 0) {
				calc(i, cur);
				cur++;
			}
		}
		for (int i = 0; i < m; i++) if (incl[i]) {
			int x = e[i].first, y = e[i].second;
			if (!bridge[i]) {
				assert(cmp[x] == cmp[y]);
				val[cmp[x]] = min(val[cmp[x]], cost[i]);
			}
			else {
				x = cmp[x], y = cmp[y];
				t[x].pb({ y, cost[i] });
				t[y].pb({ x, cost[i] });
			}
		}
		rec(1);
		for (int i = 2; i <= n; i++) {
			int x = cmp[i];
			if (ans[x] != inf)
				tot_ans[i] = min(tot_ans[i], ans[x] + cost[cur_e]);
		}
	}
	for (int i = 2; i <= n; i++) cout << tot_ans[i] << '\n';
	return 0;
}
/*

6 7
1 2 10
2 3 12
1 3 10
3 4 4
4 5 5
4 5 6
3 6 7

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9

4 4
1 2 2
3 2 0
2 4 3
4 3 1
*/

