#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void dfs(int v, int p, int d, vector<vector<int> > &g, vector<int> &vis, vector<pair<int, int> > &order, vector<int> &depth)
{
    depth[v] = d;
    order.push_back({d, v});
    vis[v] = 1;
    for (auto u : g[v]) if (u != p)
    {
        dfs(u, v, d + 1, g, vis, order, depth);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n, m;
    cin >> n >> m;

    set<pair<int, int> > s;

    vector<vector<int> > dir(n), rev(n);
    vector<int> dir_pnt(n), rev_pnt(n);

    for (int i = 0; i < m; i++)
    {
        int f, t;
        cin >> f >> t;
        f--, t--;
        dir[f].push_back(t);
        rev[t].push_back(f);
        s.insert({f, t});
        s.insert({t, f});
    }

    vector<vector<int> > g(n);
    for (auto e : s)
    {
        g[e.first].push_back(e.second);
    }

    vector<int> vis(n);
    vector<int> depth(n);

    vector<pair<int, int> > ans;
    map<pair<int, int>, int> mm;

    for (int i = 0; i < n; i++)
    {
        if (vis[i] == 0)
        {
            vector<pair<int, int> > order;
            dfs(i, -1, 0, g, vis, order, depth);
            sort(order.begin(), order.end());
            reverse(order.begin(), order.end());
            for (int j = 0; j < order.size(); j++)
            {
                int v = order[j].second;
                //cout << "Search from " << v << endl;
                int in_id = -1, out_id = -1;
                for (auto u : dir[v])
                {
                    if (mm[{v, u}] == 0)
                    {
                        assert(out_id == -1), out_id = u;
                        break;
                    }
                }
                for (auto u : rev[v])
                {
                    if (mm[{u, v}] == 0)
                    {
                        assert(in_id == -1), in_id = u;
                        break;
                    }
                }
                //cout << in_id << " " << out_id << endl;
                if (in_id != -1 && out_id != -1)
                {
                    assert(in_id == out_id);
                    ans.push_back({in_id, v});
                    ans.push_back({v, out_id});
                    mm[{in_id, v}] = 1;
                    mm[{v, out_id}] = 1;
                    continue;
                }
                if (in_id == -1 && out_id == -1)
                {
                    continue;
                }
                if (in_id == -1)
                {
                    int par = out_id;
                    int to = -1;
                    for (; dir_pnt[par] < dir[par].size(); dir_pnt[par]++)
                    {
                        int e = dir[par][dir_pnt[par]];
                        if (depth[e] != depth[par] - 1 && mm[{par, e}] == 0)
                        {
                            to = e;
                            break;
                        }
                    }
                    if (to != -1)
                    {
                        ans.push_back({v, par});
                        ans.push_back({par, to});
                        mm[{v, par}] = 1;
                        mm[{par, to}] = 1;
                        continue;
                    }
                    for (auto e : dir[par])
                    {
                        if (mm[{par, e}] == 0)
                        {
                            to = e;
                            break;
                        }
                    }
                    if (to != -1)
                    {
                        ans.push_back({v, par});
                        ans.push_back({par, to});
                        mm[{v, par}] = 1;
                        mm[{par, to}] = 1;
                        continue;
                    }
                    cout << "No\n";
                    return 0;
                }
                if (out_id == -1)
                {
                    int par = in_id;
                    int to = -1;
                    for (auto e : rev[par])
                    {
                        if (depth[e] != depth[par] - 1 && mm[{e, par}] == 0)
                        {
                            to = e;
                            break;
                        }
                    }
                    if (to != -1)
                    {
                        ans.push_back({to, par});
                        ans.push_back({par, v});
                        mm[{par, v}] = 1;
                        mm[{to, par}] = 1;
                        continue;
                    }
                    for (auto e : rev[par])
                    {
                        if (mm[{e, par}] == 0)
                        {
                            to = e;
                            break;
                        }
                    }
                    if (to != -1)
                    {
                        ans.push_back({to, par});
                        ans.push_back({par, v});
                        mm[{par, v}] = 1;
                        mm[{to, par}] = 1;
                        continue;
                    }
                    cout << "No\n";
                    return 0;
                }
            }
        }
    }

    cout << "Yes\n";
    for (int i = 0; i < ans.size(); i++)
    {
        cout << ans[i].first + 1 << " " << ans[i].second + 1 << " \n"[i % 2];
    }
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/
