#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>

using namespace std;

const int MAXN = 150001;

unordered_map<int, int> eg[MAXN];
unordered_set<int> g[MAXN];
bool oneIn[MAXN], oneOut[MAXN], ext[MAXN];
bool visited[MAXN];
vector<tuple<int, int, int>> aAns;


inline void print(int a, int b, int c) noexcept
{
	aAns.emplace_back(a, b, c);
}

bool initDp(int u, int prev) noexcept
{
	visited[u] = true;
	vector<int> in, out, inOut;
	for (const auto v : g[u])
	{
		if (v != prev)
		{
			if (!initDp(v, u))
				return false;

			if (oneIn[v] && oneOut[v])
				inOut.push_back(v);
			else if (oneIn[v])
				in.push_back(v);
			else if (oneOut[v])
				out.push_back(v);
		}
	}
	int prevE = 0;
	if (prev != -1)
		prevE = eg[prev][u];

	int bCnt = inOut.size();
	int stI = in.size();
	int stO = out.size();

	while (!inOut.empty())
	{
		if (out.size() > in.size() || (prevE == 2 && out.size() == in.size()))
			in.push_back(inOut.back());
		else
			out.push_back(inOut.back());
		inOut.pop_back();
	}

	int oneInCnt = in.size();
	int oneOutCnt = out.size();

	if (abs(oneInCnt - oneOutCnt) > bCnt + 1)
		return false;

	if (prev != -1)
	{
		if (prevE == 1)
		{
			if (oneInCnt == oneOutCnt)
				oneOut[u] = true;
			else if (oneOutCnt == oneInCnt + 1)
				ext[u] = true;
			else
				return false;
		}
		else if (prevE == 2)
		{
			if (oneInCnt == oneOutCnt)
				oneIn[u] = true;
			else if (oneOutCnt + 1 == oneInCnt)
				ext[u] = true;
			else
				return false;
		}
		else if (prevE == 3)
		{
			if (oneInCnt == oneOutCnt)
				ext[u] = true;
			if ((in.size() + out.size()) & 1)
			{
				if (stI - stO < bCnt)
					oneIn[u] = true;
				if (stO - stI < bCnt)
					oneOut[u] = true;
			}
		}
	}
	else
	{
		ext[u] = (oneInCnt == oneOutCnt);
		if (oneInCnt != oneOutCnt)
			return false;
	}

	return true;
}

inline void pushAns(int u, int v, int type) noexcept;

void setAns(int u, int prev, int type) noexcept
{
	vector<int> in, out, inOut;
	for (const auto& v : g[u])
	{
		if (v != prev)
		{
			if (oneIn[v] && oneOut[v])
				inOut.push_back(v);
			else if (oneIn[v])
				in.push_back(v);
			else if (oneOut[v])
				out.push_back(v);
			else
				pushAns(u, v, 0);
		}
	}

	while (!inOut.empty())
	{
		if (out.size() > in.size() || (type == 2 && out.size() == in.size()))
			in.push_back(inOut.back());
		else
			out.push_back(inOut.back());
		inOut.pop_back();
	}

	while (in.size() >= 1 && out.size() >= 1)
	{
		print(in.back(), u, out.back());
		pushAns(u, out.back(), 1);
		pushAns(u, in.back(), 2);
		in.pop_back(), out.pop_back();
	}

	int oneInCnt = in.size();
	int oneOutCnt = out.size();

	if (type == 1)
	{
		print(prev, u, out.back());
		pushAns(u, out.back(), 1);
	}
	else if (type == 2)
	{
		print(in.back(), u, prev);
		pushAns(u, in.back(), 2);
	}

	return;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0;
	scanf("%d %d", &n, &m);

	int u = 0, v = 0;
	for (int i = 0; i < m; ++i)
	{
		scanf("%d %d", &u, &v);
		eg[u - 1][v - 1] += 1;
		eg[v - 1][u - 1] += 2;
		g[u - 1].insert(v - 1);
		g[v - 1].insert(u - 1);
	}

	vector<int> vv;
	bool ok = true;
	for (int i = 0; i < n; ++i)
	{
		if (!visited[i])
		{
			vv.push_back(i);
			if (!initDp(i, -1))
				ok = false;
		}
	}

	if (ok)
	{
		printf("Yes\n");
		for (auto i : vv)
			setAns(i, -1, 0);
		for (const auto& [a, b, c] : aAns)
			printf("%d %d %d %d\n", a + 1, b + 1, b + 1, c + 1);
	}
	else
		printf("No\n");

	return 0;
}

inline void pushAns(int u, int v, int type) noexcept
{
	if (type == 0 && eg[u][v] == 3)
		print(u, v, u), type == 3;
	if ((eg[u][v] & type) == type)
		setAns(v, u, eg[u][v] ^ type);
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/
