#include <bits/stdc++.h>

const int inf = 0x3f3f3f3f;
using ll = long long;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
using pii = std::pair<int, int>;

int main() {
    int n, q;
    std::cin >> n >> q;
    pii a[n];
    for (auto &i : a) std::cin >> i.first >> i.second;

    while (q--) {
        int l, r;
        std::cin >> l >> r;
        l--, r--;

        bool dead[n];
        memset(dead, 0, sizeof(dead));
        int left[n], right[n];
        for (int i = 0; i < n; i++) {
            left[i] = i - 1, right[i] = i + 1;
        }

        auto canChopLeft = [&](const int &i) {
            return i != 0 && a[i].first - a[i].second >= a[0].first &&
                   (left[i] == -1 || a[i].first - a[left[i]].first >= a[i].second);
        };

        auto canChopRight = [&](const int &i) {
            return i != n - 1 && a[i].first + a[i].second <= a[n - 1].first &&
                   (right[i] == n || a[right[i]].first - a[i].first >= a[i].second);
        };

        std::stack<int> can;
        for (int i = l; i <= r; i++) {
            if (canChopLeft(i) && i != 0) can.push(i);
            else if (canChopRight(i) && i != n - 1) can.push(i);
        }

        while (!can.empty()) {
            int now = can.top();
            can.pop();
            if (dead[now]) continue;

            dead[now] = true;
            int i = now;
            if (left[i] != -1) right[left[i]] = right[i];
            if (right[i] != n) left[right[i]] = left[i];

            if(left[i] != -1 && canChopRight(left[i]) && left[i] >= l && left[i] <= r) can.push(left[i]);
            if(right[i] != n && canChopLeft(right[i]) && right[i] >= l && right[i] <= r) can.push(right[i]);
        }

        std::cout << std::count(dead, dead + n, 1) << '\n';
    }
}