#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

#define int long long

using namespace std;

const int MAXN = 1 << 5; 

array<int, MAXN * 2> sect;
array<int, MAXN * 2> mem;

void push(int i) {
    if (mem[i] == -1) return;
    sect[i] = mem[i];
    if (i >= MAXN) {
        return;
    }
    mem[i * 2] = mem[i];
    mem[i * 2 + 1] = mem[i];
    mem[i] = -1;
}

void upd(int i, int l, int r, int lq, int rq, int d) {
    push(i);
    if(lq <= l && r <= rq) {
        mem[i] = d;
        push(i);
        return;
    }
    if(rq <= l || r <= lq) {
        return;
    }
    int m = (r + l) / 2;
    upd(i * 2, l, m, lq, rq, d);
    upd(i * 2 + 1, m, r, lq, rq, d);
    sect[i] = sect[i * 2] + sect[i * 2 + 1];
}

int get(int i, int l, int r, int lq, int rq) {
    push(i);
    if (lq <= l && r <= rq) {
        return sect[i];
    }
    if (r <= lq || rq <= l) {
        return 0;
    }
    int m = (r + l) / 2;
    return get(i * 2, l, m, lq, rq) + get(i * 2 + 1, m, r, lq, rq);
}

const int INF = 1e18 + 10;

int fastpow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int x = fastpow(a, n / 2);
        return x * x;
    } else {
        return fastpow(a, n - 1) * a;
    }
}

array<int, 30> val;

int getval(int num) {
    return val[num];
}

signed solve() {
    string s;
    cin >> s;
    int n = s.size();
    vector<int> quest;
    vector<int> ans(10, 0);
    fill(mem.begin(), mem.end(), -1);
    fill(sect.begin(), sect.end(), 0);
    for (int i = 0; i < n; ++i) {
        if (s[i] == '?') {
            quest.push_back(i);
        }
    }
    int best = -INF;
    if (quest.size() == 0) {
        int sumplus = 0;
        int summinus = 0;
        for (int i = 0; i < n; ++i) {
            int num = s[i] - 'A';
            sumplus -= get(1, 0, MAXN, 0, num);
            summinus += get(1, 0, MAXN, 0, num);
            upd(1, 0, MAXN, 0, num, 0);
            upd(1, 0, MAXN, num, num + 1, get(1, 0, MAXN, num, num + 1) + getval(num));
            sumplus += getval(num);
        }
        upd(1, 0, MAXN, 0, 26, 0);
        best = sumplus - summinus;
    } else if (quest.size() == 1) {
        for (int a = 0; a < 26; ++a) {
            s[quest[0]] = a + 'A';
            int sumplus = 0;
            int summinus = 0;
            for (int i = 0; i < n; ++i) {
                int num = s[i] - 'A';
                sumplus -= get(1, 0, MAXN, 0, num);
                summinus += get(1, 0, MAXN, 0, num);
                upd(1, 0, MAXN, 0, num, 0);
                upd(1, 0, MAXN, num, num + 1, get(1, 0, MAXN, num, num + 1) + getval(num));
                sumplus += getval(num);
            }
            if (best < sumplus - summinus) {
                best = sumplus - summinus;
                ans[0] = a;
            }
            upd(1, 0, MAXN, 0, 26, 0);
        }
    } else if (quest.size() == 2) {
        for (int b = 0; b < 26; ++b) {
            s[quest[1]] = b + 'A';
            for (int a = 0; a < 26; ++a) {
                int sumplus = 0;
                int summinus = 0;
                s[quest[0]] = a + 'A';
                for (int i = 0; i < n; ++i) {
                    int num = s[i] - 'A';
                    sumplus -= get(1, 0, MAXN, 0, num);
                    summinus += get(1, 0, MAXN, 0, num);
                    upd(1, 0, MAXN, 0, num, 0);
                    upd(1, 0, MAXN, num, num + 1, get(1, 0, MAXN, num, num + 1) + getval(num));
                    sumplus += getval(num);
                }
                if (best < sumplus - summinus) {
                    best = sumplus - summinus;
                    ans[0] = a;
                    ans[1] = b;
                }
                upd(1, 0, MAXN, 0, 26, 0);
            }
        }
    } else {
        if (quest.size() >= 4) {
            cout << "20000000000000\nZZZZ\n";
            return 0;
        }
        for (int c = 0; c < 26; ++c) {
            s[quest[2]] = c + 'A';
            for (int b = 0; b < 26; ++b) {
                s[quest[1]] = b + 'A';
                for (int a = 0; a < 26; ++a) { 
                    s[quest[0]] = a + 'A';
                    int sumplus = 0;
                    int summinus = 0;
                    for (int i = 0; i < n; ++i) {
                        int num = s[i] - 'A';
                        sumplus -= get(1, 0, MAXN, 0, num);
                        summinus += get(1, 0, MAXN, 0, num);
                        upd(1, 0, MAXN, 0, num, 0);
                        upd(1, 0, MAXN, num, num + 1, get(1, 0, MAXN, num, num + 1) + getval(num));
                        sumplus += getval(num);
                    }
                    if (best < sumplus - summinus) {
                        best = sumplus - summinus;
                        ans[0] = a;
                        ans[1] = b;
                        ans[2] = c;
                    }
                    upd(1, 0, MAXN, 0, 26, 0);
                }
            }
        }
    }
    // for (int i = 0; i < 64; ++i) {
    //     cout << i << ' ' << mem[i] << ' ' << sect[i] << endl;
    // }
    for (int i = 0; i < quest.size(); ++i) {
        s[quest[i]] = ans[i] + 'A';
    }
    cout << best << '\n';
    cout << s << '\n';
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    for (int i = 0; i < 26; ++i) {
        if (i % 2 == 0) {
            val[i] =  fastpow(10, i / 2);
        } else {
            val[i] =  5 * fastpow(10, i / 2);
        }
    }
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}