import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;

public class E {
    private static final BigInteger[] vals = new BigInteger[26];
    static {
        BigInteger five = BigInteger.valueOf(5);
        for (int i = 0; i < 26; i++) {
            if (i % 2 == 0) vals[i] = BigInteger.valueOf(10).pow(i / 2);
            else vals[i] = vals[i - 1].multiply(five);
        }
    }

//    BigInteger toBigInteger(String moscowNum) {
//        BigInteger res = BigInteger.ZERO;
//        BigInteger max = vals[moscowNum.charAt(moscowNum.length() - 1) - 'A'];
//
//        for (int i = moscowNum.length() - 1; i >= 0; i--) {
//            int idx = moscowNum.charAt(i) - 'A';
//            BigInteger num = vals[idx];
//
//            if (num.compareTo(max) < 0) res = res.subtract(num);
//            else {
//                res = res.add(num);
//                max = num;
//            }
//        }
//
//        return res;
//    }

    static BigInteger toBigInteger(char[] moscowNum) {
        BigInteger res = BigInteger.ZERO;
        int lastIdx = moscowNum.length - 1;
        BigInteger max = vals[moscowNum[lastIdx] - 'A'];

        for (int i = lastIdx; i >= 0; i--) {
            int idx = moscowNum[i] - 'A';
            BigInteger num = vals[idx];

            if (num.compareTo(max) < 0) res = res.subtract(num);
            else {
                res = res.add(num);
                max = num;
            }
        }

        return res;
    }

    static BigInteger fixMoscowNum(char[] num) {
        int max = 0;
        ArrayList<Integer> ids = new ArrayList<>();
        ArrayList<Integer> maxes = new ArrayList<>();

        for (int i = 0; i < num.length; i++) {
            char ch = num[i];
            if (ch == '?') {
                ids.add(i);
                maxes.add(max);
            } else max = Math.max(max, num[i] - 'A');
        }

        char[] tmpNum = new char[num.length];
        System.arraycopy(num, 0, tmpNum, 0, num.length);
        return rec(tmpNum, ids, maxes, num, 0);
    }

    static BigInteger rec(char[] num, ArrayList<Integer> ids, ArrayList<Integer> maxes, char[] res, int idx) {
        if (idx == ids.size()) return toBigInteger(num);
        else {
            num[ids.get(idx)] = (char)('A' + maxes.get(idx));
            BigInteger val1 = rec(num, ids, maxes, res, idx + 1);

            num[ids.get(idx)] = 'Z';
            BigInteger val2 = rec(num, ids, maxes, res, idx + 1);

            if (val1.compareTo(val2) > 0) {
                res[ids.get(idx)] = (char)('A' + maxes.get(idx));
                return val1;
            } else {
                res[ids.get(idx)] = 'Z';
                return val2;
            }
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
        int q = Integer.parseInt(r.readLine());

        for (int i = 0; i < q; i++) {
            char[] num = r.readLine().toCharArray();
            System.out.print(fixMoscowNum(num));
            System.out.print('\n');
            for (char ch : num) System.out.print(ch);
            System.out.print('\n');
        }

        System.out.flush();
    }
}
