#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define x first
#define y second
//#define int long long
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int inf = 1e9;

vector<int> fenv;
int n;

int F(int x) {
	return (x & (-x));
}

int _get(int i) {
	int ans = 0;
	while (i > 0) {
		ans += fenv[i];
		i -= F(i);
	}
	return ans;
}

void upd(int i) {
	while (i <= n) {
		fenv[i]++;
		i += F(i);
	}
}

int get(int l, int r) {
	return _get(r) - _get(l);
}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int q;
	cin >> n >> q;

	fenv.resize(n + 1);
	
	vector<pair<int, int>> a(n);
	for (int i{}; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
	}

	vector<int> lt(n), rt(n);

	for (int i{}; i < n; ++i) {
		int x = (int)(lower_bound(all(a), make_pair(a[i].x + a[i].y, -1ll)) - a.begin());
		rt[i] = x - 1;
		x = (int)(lower_bound(all(a), make_pair(a[i].x - a[i].y + 1, -1ll)) - a.begin());
		lt[i] = x;
	}

	int mn = a[0].x, mx = a[n - 1].x;
	

	while (q) {
		q--;
		int l, r;
		cin >> l >> r;

		for (int i{}; i <= n; ++i) fenv[i] = 0;
		
		l--;
		r--;

		vector<int> used(n, false);
		set<int> toch;
		set<int> is;
		for (int i{ l }; i <= r; ++i) {
			toch.insert(i);
			is.insert(i);
		}

		int ans{};
		int tt{};
		
		while (!toch.empty()) {
			tt++;
			auto i = *toch.begin();
			toch.erase(toch.begin());

			if (a[i].x - a[i].y >= mn) {
				if (lt[i] == i || get(lt[i], i) == i - lt[i]) {
					used[i] = true;
					upd(i + 1);
					++ans;

					is.erase(i);
					auto x = is.lower_bound(i);
					if (x != is.end()) toch.insert(*x);
					if (x != is.begin()) toch.insert(*prev(x));
				}
			}

			if (used[i]) continue;
			if (a[i].x + a[i].y <= mx) {
				if (rt[i] == i || get(i + 1, rt[i] + 1) == rt[i] - i) {
					used[i] = true;
					upd(i + 1);
					++ans;

					is.erase(i);
					auto x = is.lower_bound(i);
					if (x != is.end()) toch.insert(*x);
					if (x != is.begin()) toch.insert(*prev(x));
				}
			}


		}
	
		cout << ans << '\n';

	}

	return 0;
}


/*
3 3
1 3
3 1
4 2
2 3
*/

/*
5 3
1 5
3 1
4 2
5 3
6 1
*/