#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

#pragma optimize("0fast");

using namespace std;

#define int long long

vector<int> from[150000];
vector<bool> banned_from[150000];
vector<int> to[150000];
vector<pair<int, int>> ans_beb, ans;
vector<pair<int, int>> path;
vector<bool> visited;

void dfs(int u)
{
	visited[u] = 1;
	for (int i = 0; i < from[u].size(); i++)
	{
		if (banned_from[u][i]) continue;
		//cout << u << " " << i << " not banned (" << u + 1 << " -> " << from[u][i] + 1 << ")" << endl;
		banned_from[u][i] = 1;
		path.push_back({u, from[u][i]});
		dfs(from[u][i]);
		banned_from[u][i] = 0;
		path.pop_back();
	}

	if (path.size() > ans_beb.size())
	{
		ans_beb.resize(path.size());
		for (int i = 0; i < path.size(); i++)
			ans_beb[i] = path[i];
	}
}

int32_t main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < m; i++)
	{
		int u, v;
		cin >> u >> v;
		from[u - 1].push_back(v - 1);
		banned_from[u - 1].push_back(0);
		to[v - 1].push_back(u - 1);
	}
	
	visited.resize(n);
	for (int i = 0; i < n; i++)
		visited[i] = 0;

	vector<pair<int, int>> bad;
	for (int i = 0; i < n; i++)
	{
		if (from[i].empty())
		{
			for (int j = 0; j < to[i].size(); j++)
			{
				bool flagilla = false;
				pair<int, int> banned;
				for (int k = 0; k < from[to[i][j]].size(); k++)
				{
					if (!banned_from[to[i][j]][k] && from[to[i][j]][k] == i)
					{
						flagilla = 1;
						banned_from[to[i][j]][k] = 1;
						banned = { to[i][j], k };
						//cout << "BAN " << to[i][j] << " " << k << " (" << to[i][j] + 1 << " -> " << i + 1 << ")" << endl;
						bad.push_back({to[i][j], i});
						break;
					}
				}

				if (!flagilla) continue;
				//cout << "flagilla = " << flagilla << endl;
				flagilla = false;
				for (int k = 0; k < to[to[i][j]].size(); k++)
				{
					if (flagilla) break;
					for (int z = 0; z < from[to[to[i][j]][k]].size(); z++)
					{
						if (!banned_from[to[to[i][j]][k]][z] && from[to[to[i][j]][k]][z] == to[i][j])
						{
							flagilla = 1;
							//cout << "BAN " << to[to[i][j]][k] << " " << z << " (" << to[to[i][j]][k] + 1 << " -> " << to[i][j] + 1 << ")" << endl;
							banned_from[to[to[i][j]][k]][z] = 1;
							bad.push_back({to[to[i][j]][k], to[i][j]});
							break;
						}
					}
				}
				//cout << "STOP IT!" << endl;
				if (!flagilla)
				{
					banned_from[banned.first][banned.second] = 0;
					bad.pop_back();
					//cout << "UNBAN " << banned.first << " " << banned.second << endl;
				}
			}
		}
	}

	for (int i = 0; i < n; i++)
	{
		if (to[i].empty())
		{
			for (int j = 0; j < from[i].size(); j++)
			{
				for (int z = 0; z < from[from[i][j]].size(); z++)
				{
					if (!banned_from[i][from[i][j]] && !banned_from[from[i][j]][from[from[i][j]][z]])
					{
						banned_from[i][from[i][j]] = 1; 
						banned_from[from[i][j]][from[from[i][j]][z]] = 1;
						bad.push_back({i, from[i][j]});
						bad.push_back({ from[i][j], from[from[i][j]][z] });
						break;
					}
				}
			}
		}
	}

	bool f = true;
	while (f)
	{
		f = false;
		int mn = 1e18, mni = -1;
		for (int i = 0; i < n; i++)
		{
			if (visited[i]) continue;
			int s = 0;
			for (int j = 0; j < from[i].size(); j++)
				s += !banned_from[i][j];
			if (s < mn)
			{
				f = true;
				mni = i;
				mn = s;
			}
		}

		if (f)
		{
			dfs(mni);
			for (auto& x : ans_beb)
			{
				banned_from[x.first][x.second] = 1;
				ans.push_back(x);
			}
			if (ans_beb.size() % 2 == 1)
				ans.pop_back();
			ans_beb.clear();
		}
	}
	
	//cout << ans.size() << " " << bad.size() << endl;
	if ((int)(ans.size()) + (int)(bad.size()) != m)
		cout << "No";
	else
	{
		cout << "Yes\n";

		for (int i = 0; i + 1 < bad.size(); i += 2)
		{
			cout << bad[i].first + 1 << " " << bad[i].second + 1 << " ";
			cout << bad[i + 1].first + 1 << " " << bad[i + 1].second + 1 << endl;
		}
		//cout << "those were bad" << endl;
		for (int i = 0; i + 1 < ans.size(); i += 2)
		{
			cout << ans[i].first + 1 << " " << ans[i].second + 1 << " ";
			cout << ans[i + 1].first + 1 << " " << ans[i + 1].second + 1 << endl;
		}
	}
}