#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;

#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define firn(i, n) for (int i = 1; i < (int)n; i++)
#define all(v) v.begin(), v.end()
#define x first
#define y second

template<typename T> bool uax(T &a, T b) { if (b > a) { a = b; return true; } return false; }
template<typename T> bool uin(T &a, T b) { if (b < a) { a = b; return true; } return false; }
mt19937 rnd(time(nullptr));

const char el = '\n';
const int inf = 1e9;

const int N = 300'001;

vector<int> p, h, mn;
void init(int n) {
    h.assign(n, 0);
    mn.assign(n, 2 * inf);
    p.resize(n);
    forn(i, n)
        p[i] = i;
}
int getp(int a) {
    return a == p[a] ? a : p[a] = getp(p[a]);
}
bool unite(int a, int b, int w = 2 * inf) {
    a = getp(a), b = getp(b);
    if (a == b) return false;
//    if (h[a] < h[b])
        swap(a, b);
    p[b] = a;
    uax(h[a], h[b] + 1);
    uin(mn[a], min(mn[b], w));
    return true;
}
struct edge {
    int v, u, w;
    edge() {}
    edge(int v, int u, int w): v(v), u(u), w(w) {}
};
bool operator <(const edge &a, const edge &b) {
    return a.w < b.w;
}
vector<pair<int, int>> g[N];
int pr[N], pp[N], mmx[N], tin[N], tout[N], cnt[N], d[N], timer = 0;
vector<int> ans, order;
void dfs(int v, int mn = inf, int mx = 0) {
    ans[v] = mn + mx;
    mmx[v] = mx;
    tin[v] = timer++;
    order.push_back(v);
    cnt[v] = 1;
    for (auto to : g[v]) {
        if (to.x != pr[v]) {
            pr[to.x] = v;
            pp[to.x] = to.y;
            d[to.x] = d[v] + 1;
            dfs(to.x, min(mn, to.y), max(mx, to.y));
            cnt[v] += cnt[to.x];
        }
    }
    tout[v] = timer;
}
struct node {
    int l, r, min;
    node() {
        min = 2 * inf;
    }
};
struct Segment_Tree {
    vector<node> t;
    void build(int l, int r, int v = 1) {
        t[v].l = l, t[v].r = r;
        if (l + 1 == r) {

        } else {
            int m = (l + r) / 2;
            build(l, m, v + v);
            build(m, r, v + v + 1);
        }
    }
    Segment_Tree() {}
    Segment_Tree(int n) {
        t.resize(4 * n);
        build(0, n);
    }
    void upd(int l, int r, int x, int v = 1) {
        if (l <= t[v].l && t[v].r <= r) {
            uin(t[v].min, x);
            return;
        }
        if (r <= t[v].l || t[v].r <= l)
            return;
        upd(l, r, x, v + v);
        upd(l, r, x, v + v + 1);
    }
    void clear(int pos, int v = 1) {
        if (t[v].l + 1 == t[v].r) {
            t[v].min = 2 * inf;
            return;
        }
        uin(t[v + v].min, t[v].min);
        uin(t[v + v + 1].min, t[v].min);
        t[v].min = 2 * inf;
        int m = (t[v].l + t[v].r) / 2;
        if (pos < m) clear(pos, v + v);
        else clear(pos, v + v + 1);
    }
    int get(int pos, int v = 1) {
        if (t[v].l + 1 == t[v].r)
            return t[v].min;
        int m = (t[v].l + t[v].r) / 2;
        if (pos < m) return min(t[v].min, get(pos, v + v));
        return min(t[v].min, get(pos, v + v + 1));
    }
};
inline bool ispr(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}
Segment_Tree T, S;
void add_edge(edge x) {
    int v = x.v, u = x.u;
    while (!ispr(getp(v), x.u)) {
        int to = pr[getp(v)], w = pp[getp(v)];
        unite(v, to, w);
    }
    while(!ispr(getp(u), x.v)) {
        int to = pr[getp(u)], w = pp[getp(u)];
        unite(u, to, w);
    }
    int root = getp(x.v);
    uin(mn[root], x.w);
    T.upd(tin[root], tin[root] + cnt[root], mn[root] + max(x.w, mmx[root]));
    S.upd(tin[root], tin[root] + cnt[root], mn[root]);
}
int on[N], joint[N];
void zhfs(int v) {
    joint[v] = 1;
    T.clear(tin[v]);
    uin(ans[v], S.get(tin[v]) + mmx[v]);
    for (auto to : g[v]) {
        if (to.x != pr[v] && on[to.x]) {
            zhfs(to.x);
        }
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    joint[0] = on[0] = 1;
    int n, m;
    cin >> n >> m;
    vector<edge> r(m);
    forn(i, m) {
        cin >> r[i].v >> r[i].u >> r[i].w;
        r[i].v--; r[i].u--;
    }
    sort(all(r));
    vector<edge> a, b;
    init(n);
    forn(i, m) {
        if (unite(r[i].v, r[i].u)) {
            a.emplace_back(r[i]);
            g[r[i].v].emplace_back(r[i].u, r[i].w);
            g[r[i].u].emplace_back(r[i].v, r[i].w);
        } else b.emplace_back(r[i]);
    }
    ans.assign(n, 2 * inf);
    dfs(0);
    init(n);
    T = Segment_Tree(n);
    S = Segment_Tree(n);
    int l = 0;
    forn(i, b.size()) {
        while(l < (int)a.size() && a[l].w <= b[i].w) {
            if (d[a[l].v] > d[a[l].u]) swap(a[l].v, a[l].u);
            on[a[l].u] = 1;
            if (joint[a[l].v]) {
                zhfs(a[l].u);
            }
            l++;
        }
        add_edge(b[i]);
    }
    while(l < (int)a.size()) {
        if (d[a[l].v] > d[a[l].u]) swap(a[l].v, a[l].u);
        on[a[l].u] = 1;
        if (joint[a[l].v]) {
            zhfs(a[l].u);
        }
        l++;
    }
    forn(i, n) {
        uin(ans[i], T.get(tin[i]));
    }
    firn(i, n)
        cout << ans[i] << el;
    return 0;
}
