#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pil = pair<int, ll>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
using ld = long double;
template<typename T1, typename T2> bool chkmin(T1 &x, T2 y)
{
    return y < x ? (x = y, true) : false;
}
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y)
{
    return y > x ? (x = y, true) : false;
}
void debug_out()
{
    cerr << endl;
}
template<typename T1, typename... T2> void debug_out(T1 A, T2... B)
{
    cerr << ' ' << A;
    debug_out(B...);
}
template<typename T> void mdebug_out(T* a, int n)
{
    for (int i = 0; i < n; ++i)
        cerr << a[i] << ' ';
    cerr << endl;
}
#ifdef DEBUG
    #define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
    #define mdebug(a, n) cerr << #a << ": ", mdebug_out(a, n)
#else
    #define debug(...) 1337
    #define mdebug(a, n) 1337
#endif
template<typename T> ostream& operator << (ostream& stream, const vector<T>& a)
{
    for (auto x : a)
        stream << x << ' ';
    return stream;
}
template<typename T1, typename T2> ostream& operator << (ostream& stream, const pair<T1, T2>& p)
{
    return stream << p.first << ' ' << p.second;
}

const int maxN = 500005;
const int quadN = 10004;
int n, Q;
int X[maxN], H[maxN];

int V;
const int maxV = 2 * quadN;
int banv[2 * maxN];
bitset<maxV> G[maxV];
void addEdgeG(int a, int b)
{
//    debug(a, b);
    G[a][b] = 1;
}
int ord[maxV];
bool used[maxV];
int scc[maxV];
int ptr;
int taken[maxV];

int bans[maxV];
int indegc[maxV];
int indegc1[maxV];
int csz[maxV];
int cvtx[maxV];
bitset<maxV> C[maxV];

void dfs1(int v)
{
    used[v] = true;
    for (int u = 0; u < V; ++u)
        if (!used[u] && G[v][u])
            dfs1(u);
    ord[ptr++] = v;
}
int S;
void dfs2(int v)
{
    scc[v] = S;
    if (++csz[S] == 1)
        cvtx[S] = v;
    for (int u = 0; u < V; ++u)
        if (G[u][v] && scc[u] == -1)
            dfs2(u);
}

struct Query
{
    int l, r;
} qr[maxN];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> Q;
    for (int i = 0; i < n; ++i)
        cin >> X[i] >> H[i];
    for_each(qr, qr + Q, [&](Query& q)
    {
        cin >> q.l >> q.r;
        --q.l;
        --q.r;
    });
    for (int i = 0; i < n; ++i)
    {
        if (X[i] - H[i] >= X[0])
        {
            for (int j = i - 1; j >= 0; --j)
            {
                if (X[j] <= X[i] - H[i]) break;
                addEdgeG(2 * j, 2 * i);
                addEdgeG(2 * j + 1, 2 * i);
            }
        }
        else banv[2 * i] = 1;
        if (X[i] + H[i] <= X[n - 1])
        {
            for (int j = i + 1; j < n; ++j)
            {
                if (X[j] >= X[i] + H[i]) break;
                addEdgeG(2 * j, 2 * i + 1);
                addEdgeG(2 * j + 1, 2 * i + 1);
            }
        }
        else banv[2 * i + 1] = 1;
    }
    V = 2 * n;
    // scc
    for (int v = 0; v < V; ++v)
        if (!used[v])
            dfs1(v);
    reverse(ord, ord + V);
    memset(scc, 255, sizeof scc);
    S = 0;
    for (int i = 0; i < V; ++i)
    {
        int v = ord[i];
        if (scc[v] == -1)
        {
            dfs2(v);
            ++S;
        }
    }
    for (int v = 0; v < V; ++v)
        for (int u = 0; u < V; ++u)
            if (G[v][u])
            {
                int sv = scc[v];
                int su = scc[u];
                if (sv != su && !C[sv][su])
                {
                    C[sv][su] = 1;
                    ++indegc[su];
                }
            }

    /*debug(S);
    mdebug(scc, V);
    mdebug(indegc, S);
    mdebug(csz, S);
    mdebug(cvtx, S);
    for (int s = 0; s < S; ++s)
        for (int t = 0; t < S; ++t)
            if (C[s][t])
                debug(s, t);*/
                    
    for_each(qr, qr + Q, [&](Query& q)
    {
        for (int i = 0; i < q.l; ++i)
        {
            ++banv[2 * i];
            ++banv[2 * i + 1];
        }
        for (int i = q.r + 1; i < n; ++i)
        {
            ++banv[2 * i];
            ++banv[2 * i + 1];
        }
        for (int v = 0; v < V; ++v)
            if (banv[v])
                ++bans[scc[v]];
        
        for (int s = 0; s < S; ++s)
            indegc1[s] = indegc[s];
        for (int v = 0; v < V; ++v)
            taken[v] = 0;
        for (int s = 0; s < S; ++s)
        {
            if (indegc1[s] == 0 && !bans[s] && csz[s] == 1)
            {
                taken[cvtx[s]] = 1;
                for (int t = 0; t < S; ++t)
                    if (C[s][t])
                        --indegc1[t];
            }
        }
        int ans = 0;
        for (int i = q.l; i <= q.r; ++i)
            if (taken[2 * i] || taken[2 * i + 1])
                ++ans;
        cout << ans << '\n';

        for (int v = 0; v < V; ++v)
            if (banv[v])
                --bans[scc[v]];
        for (int i = 0; i < q.l; ++i)
        {
            --banv[2 * i];
            --banv[2 * i + 1];
        }
        for (int i = q.r + 1; i < n; ++i)
        {
            --banv[2 * i];
            --banv[2 * i + 1];
        }
        
    });

    return 0;
}