#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cstring>
#define int long long
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
using namespace std;

const int N = 3e5;

vector<pii> g[N];
int n, m, mx[N], mn[N];


void dfs(int v, int p, int mmx, int mmn) {
	mx[v] = mmx;
	mn[v] = mmn;
	for (auto to : g[v]) {
		if (to.X != p)
		dfs(to.X, v, max(mmx, to.Y), min(mmn, to.Y));
	}
}

void solve1() {
	dfs(0, 0, 0, 1e9);
	for (int i = 1; i < n; ++i)
		cout << mn[i] + mx[i] << "\n";

}

int p[N];

void init(int n) {
	for (int i = 0; i < n; ++i)
		p[i] = i;
}

int find(int v) {
	if (v == p[v])
		return v;
	return p[v] = find(p[v]);
}

void unit(int u, int v) {
	u = find(u);
	v = find(v);
	if (rand() & 1)
		swap(u, v);
	p[u] = v;
}

vector<pair<int, pii>> e;

void solve2() {
	vi res(n, 1e9);
	res[0] = 0;
	set<pii> d;
	d.insert({ res[0], 0 });
	while (d.size()) {
		int v = d.begin()->Y;
		d.erase(*d.begin());
		for (auto to : g[v])
			if (res[to.X] > max(res[v], to.Y)) {
				d.erase({ res[to.X], to.X });
				res[to.X] = max(res[v], to.Y);
				d.insert({ res[to.X], to.X });
			}
	}
	for (int i = 1; i < n; ++i)
		cout << res[i] << "\n";
}

vi res(N, 2e9);
vi used2(N, 0);

void dfs2(int v, int mn, int mx) {
	used2[v] = 1;
	for (auto to : g[v])
		if (!used2[to.X])
			dfs2(to.X, min(mn, to.Y), max(mx, to.Y));
	used2[v] = 0;
}

void solve3() {
	dfs2(0, 1e9, 0);
	for (int i = 1; i < n; ++i)
		cout << res[i] << " ";
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin >> n >> m;
	int mx = 0;
	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		--u; --v;
		if (u == 0 || v == 0)
			mx = max(mx, t);
		e.push_back({ t, {u, v} });
		g[u].push_back({ v, t });
		g[v].push_back({ u, t });
	}
	if (m + 1 == n) {
		solve1();
		return 0;
	}
	if (mx == 0) {
		solve2();
		return 0;
	}
	solve3();
}