#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <cstring>
#include <string>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

typedef long long ll;
typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back
#define all(a) (a).begin(), (a).end()

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

void solve();

int main() {
    setup();
    int t = 1;
//    cin >> t;
    range(i, t) {
        solve();
    }
}

const int MAXN = 15e4 + 10;
int n, m;
set<int> in[MAXN];
set<int> out[MAXN];
set<int> tin[MAXN];
set<int> tout[MAXN];

void er(int v, int u) {
    // v -> u
    tin[u].erase(v);
    in[u].erase(v);
    tout[v].erase(u);
    out[v].erase(u);
}

vector<pair<pii, pii>> ans;
void toDo(int v);

void process(int a, int v, int b) {
    ans.push_back({{a, v}, {v, b}});
    er(a, v);
    er(v, b);
    m -= 2;
    toDo(a);
    toDo(v);
    toDo(b);
}

void toDo(int v) {
    bool smt = 0;
    auto &ti = tin[v];
    auto &to = tout[v];
    auto &ip = in[v];
    auto &op = out[v];
    if (ip.size() == 1 && op.empty()) {
        int a = *ip.begin();
        tout[a].insert(v);
        if (in[a].empty()) {
            cout << "No\n"; exit(0);
        }
        tin[v].insert(a);
        toDo(a);
        return;
    }
    if (op.size() == 1 && ip.empty()) {
        int b = *op.begin();
        tin[b].insert(v);
        if (out[b].empty()) {
            cout << "No\n"; exit(0);
        }
        tout[v].insert(b);
        toDo(b);
        return;
    }
    if (!ti.empty() && !to.empty()) {
        smt = 1;
        int a = *ti.begin();
        int b = *to.begin();
        process(a, v, b);
    }
    if (ip.size() == 1 && !to.empty()) {
        smt = 1;
        process(*ip.begin(), v, *to.begin());
    }
    if (op.size() == 1 && !ti.empty()) {
        smt = 1;
        process(*ti.begin(), v, *op.begin());
    }
    if (ip.size() == 1 && op.size() == 1) {
        int a = *ip.begin();
        int b = *op.begin();
        if (a == b) {
            smt = 1;
            process(a, v, b);
        }
    }
}

void solve() {
    cin >> n >> m;
    range(i, m) {
        int a, b; cin >> a >> b; --a; --b;
        out[a].insert(b);
        in[b].insert(a);
    }
    range(i, n) {
        toDo(i);
    }
    if (m) {
        cout << "No" << '\n';
    } else {
        cout << "Yes" << '\n';
        for (auto[fe, se] : ans) {
            cout << fe.fi + 1<< ' ' << fe.se + 1 << ' ' << se.fi + 1 << ' ' << se.se + 1 << '\n';
        }
    }
}



