#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MAXN = 200;
const ll INF = 1e18 + 1e17;

int n, m;
vector<pair<ll, ll>> g[MAXN];
int used[MAXN][MAXN];

pair<ll, ll> dfs(int v, int to) {
    pair<ll, ll> ans = {INF, INF};
    for (auto [u, w] : g[v]) {
        if (used[v][u] || used[u][v]) {
            continue;
        }

        used[v][u] = true;
        if (u == to) {
            if (ans.first + ans.second > 2 * w || (ans.first + ans.second == 2 * w && ans.second > w)) {
                ans = {w, w};
            }
        }

        pair<ll, ll> x = dfs(u, to);
        if (min(x.first, w) + max(x.second, w) < ans.first + ans.second
            || (min(x.first, w) + max(x.second, w) == ans.first + ans.second && max(x.second, w) < ans.second) {
            ans = {min(x.first, w), max(x.second, w)};
        }

        used[v][u] = false;
    }

    return ans;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        ll u, v, w;
        cin >> u >> v >> w;

        u--;
        v--;

        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }

    for (int i = 1; i < n; i++) {
        pair<ll, ll> a = dfs(0, i);
        //cerr << a.first << " " << a.second << "\n";
        assert(a.first != INF && a.second != INF);
        cout << (a.first + a.second) << "\n";
    }

    return 0;
}