#include <bits/stdc++.h>
#include <stdio.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("vpt")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")


const int MAXN = 2e5;

struct Edge{
    int u, v, col, num;
    Edge(int up = 0, int vp = 0, int colp = 0, int nump = 0)
    {
        u = up;
        v = vp;
        col = colp;
        num = nump;
    }
};


pair<int, int> dp[MAXN];
Edge dp_ans[MAXN];

vector<pair<int, int>> ans;
vector<Edge> all;

vector<Edge> gr[MAXN];
vector<Edge> grin[MAXN];
vector<int> ugr[MAXN];
int used[MAXN];
int root = 1;
bool cor = true;
vector<int> f_z, f_n, loc_z, loc_n;


void fill()
{
    for (int i = 0; i < MAXN; i++)
        used[i] = 0;
}


void dfs_color(int v, int c)
{
    used[v] = 1;
    for (auto &e : gr[v])
        e.col = c;
    for (auto &e : grin[v])
        e.col = 1 - c;
    for (auto u : ugr[v])
        if (used[u] == 0)
            dfs_color(u, 1 - c);
}


void dp_dfs(int v, int p)
{
    used[v] = 1;
    for (auto u : ugr[v])
    {
        if (used[u] == 0)
            dp_dfs(u, v);
        if (!cor)
            return;
    }
    loc_z.clear();
    loc_n.clear();
    f_n.clear();
    f_z.clear();
    for (auto &e : gr[v])
        if (e.v != p)
        {
            if (e.col == 0)
                loc_z.push_back(e.num);
            else
                loc_n.push_back(e.num);
        }
    for (auto &e : grin[v])
        if (e.u != p)
        {
            if (e.col == 0)
                loc_z.push_back(e.num);
            else
                loc_n.push_back(e.num);
        }

    for (auto &e : loc_z)
    {
        int an = all[e].u + all[e].v - v;
        if (dp[an].second == 1)
            ans.push_back({e, dp_ans[an].num});
        else if (dp[an].second == 0)
            f_z.push_back(e);
        else
            cor = false;
    }
    for (auto &e : loc_n)
    {
        int an = all[e].u + all[e].v - v;
        if (dp[an].first == 1)
            ans.push_back({e, dp_ans[an].num});
        else if (dp[an].first == 0)
            f_n.push_back(e);
        else
            cor = false;
    }
    if (cor)
    {
        int l = 0, r = 0;
        while (l < f_z.size() && r < f_n.size())
        {
            ans.push_back({f_z[l], f_n[r]});
            l++;
            r++;
        }
        int cnt_z = (int)f_z.size() - l, cnt_n = (int)f_n.size() - r;
        if (cnt_n > 1)
            cor = false;
        if (cnt_z > 1)
            cor = false;
        if (cnt_n == 1)
            dp_ans[v] = all[f_n.back()];
        if (cnt_z == 1)
            dp_ans[v] = all[f_z.back()];
        dp[v] = {cnt_z, cnt_n};
    }
    else
        return;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    loc_z.reserve(5e5);
    loc_n.reserve(5e5);
    f_z.reserve(5e5);
    f_n.reserve(5e5);
    int n, m; cin >> n >> m;
    vector<set<int>> vr(n + 1);
    for (int i = 0; i < m; i++)
    {
        int u, v; cin >> u >> v;
        gr[u].push_back(Edge(u, v, 0, i));
        grin[v].push_back(Edge(u, v, 0, i));
        all.push_back(Edge(u, v, 0, i));
        //gr[v].push_back(Edge(u, v, 0));
        vr[u].insert(v);
        vr[v].insert(u);
    }
    for (int i = 1; i < n + 1; i++)
        for (auto &v : vr[i])
            ugr[i].push_back(v);

    fill();
    for (int i = 1; i < n + 1; i++)
        if (used[i] == 0)
            dfs_color(i, 0);

    fill();
    for (int i = 1; i < n + 1; i++)
        if (used[i] == 0)
        {
            dp_dfs(i, -1);
            if (dp[i] != make_pair(0, 0))
                cor = false;
            if (!cor)
            {
                cout << "No" << endl;
                return 0;
            }
        }

    if (cor)
    {
        cout << "Yes" << endl;
        for (int i = 0; i < ans.size(); i++)
        {
            if (all[ans[i].first].v ==  all[ans[i].second].u)
                printf("%i %i %i %i\n", all[ans[i].first].u, all[ans[i].first].v, all[ans[i].second].u, all[ans[i].second].v);
            else if (all[ans[i].second].v == all[ans[i].first].u)
                printf("%i %i %i %i\n", all[ans[i].second].u, all[ans[i].second].v, all[ans[i].first].u, all[ans[i].first].v);
        }

    }
    else
        cout << "No" << endl;
    return 0;
}