#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int maxn = 3e5, INF = 1e9 + 7;
int ans[maxn];
bool used[maxn];


struct Edge {
    int u, v, t, ind;
    bool used;
    Edge(){};
    Edge(int uu, int vv, int tt, int indd) {
        u = uu;
        v = vv;
        t = tt;
        ind = indd;
        used = false;
    }
};

vector<Edge> adj[maxn];
Edge edges[maxn];
bool can[1 << 20][20];

void dfs_tree(int u, int minn = INF, int maxx = -INF) {
    ans[u] = minn + maxx;
    for (auto edge : adj[u]) {
        if (!edge.used) {
            edge.used = true;
            adj[edge.v][edge.ind].used = true;
            dfs_tree(edge.v, min(minn, edge.t), max(maxx, edge.t));
        }
    }
}


signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u; --v;
        adj[u].emplace_back(u, v, t, adj[v].size());
        adj[v].emplace_back(v, u, t, (int)adj[u].size() - 1);
        edges[i] = Edge(u, v, t, -1);
    }
    if (n - 1 == m) {
        dfs_tree(0);
        for (int i = 1; i < n; ++i) {
            cout << ans[i] << " ";
        }
        return 0;
    }
    if (n <= 20 && m <= 20) {
        can[0][0] = true;
        for (int mask = 1; mask < (1 << m); ++mask) {
            for (int last_e = 0; last_e < m; ++last_e) {
                if ((mask >> last_e) & 1) {
                    if (can[mask ^ (1 << last_e)][edges[last_e].v]) {
                        can[mask][edges[last_e].u] = true;
                    }
                    if (can[mask ^ (1 << last_e)][edges[last_e].u]) {
                        can[mask][edges[last_e].v] = true;
                    }
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            int best = 2 * INF;
            for (int mask = 0; mask < (1 << m); ++mask) {
                if (!can[mask][i]) continue;
                int minn = INF;
                int maxx = -INF;
                for (int last_e = 0; last_e < m; ++last_e) {
                    if ((mask >> last_e) & 1) {
                        minn = min(minn, edges[last_e].t);
                        maxx = max(maxx, edges[last_e].t);
                    }
                }
                best = min(minn + maxx, best);
            }
            cout << best << " ";
        }
        return 0;
    }
    priority_queue<pair<int, int> > q;
    q.push(make_pair(0, 0));
    while (!q.empty()) {
        int u = q.top().second;
        if (used[u]) {
            q.pop();
            continue;
        }
        ans[u] = -q.top().first;
        used[u] = true;
        for (auto edge : adj[u]) {
            if (!used[edge.v]) {
                q.push(make_pair(-max(ans[u], edge.t), edge.v));
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << " ";
    }
}
/*
3 3
1 2 2
1 3 1
2 3 1


 */