#include <bits/stdc++.h>
using namespace std;
//#define int long long
typedef vector<int> vi;
typedef vector<vi> v2i;
typedef pair<int, int> pii;
typedef vector<pii> vp;
typedef vector<vp> v2p;
typedef vector<vector<pair<int, pair<int, int>>>> graph;
const int inf = 2e9, big = 1e9;

void dfs_bri(int v, vi& used, graph& g, vi& deep, vi& fup, vi& bri) {
    fup[v] = deep[v];
    for (size_t i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first, t = g[v][i].second.first;
        int id = g[v][i].second.second;
        if (!used[id]) {
            if (deep[to] == -1) {
                used[id] = 1;
                deep[to] = deep[v] + 1;
                dfs_bri(to, used, g, deep, fup, bri);
                fup[v] = min(fup[v], fup[to]);
                if (deep[v] < fup[to])
                    bri[id] = 1;
            }
            else
                fup[v] = min(fup[v], deep[to]);
        }
    }
}

void dfs_paint(int v, graph& g, vi& bri, vi& color, int p) {
    color[v] = p;
    for (size_t i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first, t = g[v][i].second.first;
        int id = g[v][i].second.second;
        if (color[to] == -1)
            dfs_paint(to, g, bri, color, p);
    }
}

void dfs(int v, int p, v2p& g, vi& ans) {
    for (auto[to, t] : g[v])
        if (to != p) {
            ans[to] = min(ans[to], t);
            dfs(to, v, g, ans);
        }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    graph g(n);
    for (int i = 0; i < m; ++i) {
        int v, u, t;
        cin >> v >> u >> t;
        --v, --u;
        g[v].emplace_back(u, make_pair(t, i));
        g[u].emplace_back(v, make_pair(t, i));
    }
    vi used(m), deep(n, -1), fup(n), bri(m);
    dfs_bri(0, used, g, deep, fup, bri);
    vi color(n, -1);
    int paint = 0;
    for (int v = 0; v < n; ++v)
        if (color[v] == -1)
            dfs_paint(v, g, bri, color, paint++);
    v2p g2(paint);
    vi comp(paint, inf);
    for (int v = 0; v < n; ++v)
        for (size_t i = 0; i < g[v].size(); ++i) {
            int to = g[v][i].first, t = g[v][i].second.first;
            if (color[v] != color[to])
                g2[color[v]].emplace_back(color[to], t);
            else
                comp[color[v]] = min(comp[color[v]], t);
        }
    dfs(0, -1, g2, comp);
    for (int v = 1; v < n; ++v)
        cout << big + comp[color[v]] << '\n';
}
