#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e18 + 10;
const int MOD = (int)1e9 + 7;

void dfs1(int v, vector<vii>& a, vc& used) {
	used[v] = 1;
	for (auto x : a[v]) {
		if (used[x.first])
			continue;
		dfs1(x.first, a, used);
	}
	return;
}

void dfs(int v, vector<vii>& a, vector<pair<pii, int>>& p) {
	for (int j = 0; j < a[v].size(); ++j) {
		if (a[v][j].second == -1)
			continue;
		int c = a[v][j].second;
		a[v][j].second = -1;
		dfs(a[v][j].first, a, p);
		p.pb({ {v, a[v][j].first}, c });
	}
	return;
}

void solve() {
	
	int n, m;
	cin >> n >> m;
	vector<set<pii>> a1(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		a1[u].insert({ v, 1 });
	}
	for (int i = 0; i < n; ++i) {
		for (auto j : a1[i]) {
			if (a1[j.first].find({ i, 1 }) == a1[j.first].end())
				a1[j.first].insert({ i, 0 });
		}
	}
	vector<vii> a(n);
	for (int i = 0; i < n; ++i) {
		for (auto x : a1[i])
			a[i].pb(x);
	}
	vi rt;
	vc used(n);
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			rt.pb(i);
			dfs1(i, a, used);
		}
	}
	for (int i = 1; i < rt.size(); ++i) {
		a[rt[0]].pb({ rt[i], 0 });
		a[rt[i]].pb({ rt[0], 0 });
	}
	vector<pair<pii, int>> p;
	dfs(0, a, p);
	reverse(p.begin(), p.end());
	int j = 0;
	for (int i = 0; i < (2 * n - 2); ++i) {
		if (!p[i].second) {
			j = i;
			break;
		}
	}
	vector<pair<pii, pii>> ans;
	for (int i = j;; i = (i + 2) % (2 * n - 2)) {
		while (!p[i].second)
			i = (i + 1) % (2 * n - 2);
		int k = (i + 1) % (2 * n - 2);
		if (!p[k].second) {
			cout << "No";
			return;
		}
		ans.pb({ p[i].first, p[k].first });
		if (ans.size() == m / 2)
			break;
	}
	cout << "Yes\n";
	for (int i = 0; i < m / 2; ++i)
		cout << ans[i].first.first + 1 << ' ' << ans[i].first.second + 1 << ' '\
		<< ans[i].second.first + 1 << ' ' << ans[i].second.second + 1 << endl;

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}