#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e18 + 10;
const int MOD = (int)1e9 + 7;

void dfs(int v, vector<vii>& a, vii& p) {
	for (int j = 0; j < a[v].size(); ++j) {
		if (a[v][j].second == -1)
			continue;
		int c = a[v][j].second;
		a[v][j].second = -1;
		dfs(a[v][j].first, a, p);
		if (c)
			p.pb({v, a[v][j].first});
	}
	return;
}

void solve() {
	
	int n, m;
	cin >> n >> m;
	if (m == 0)
		return;
	vector<set<pii>> a1(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		a1[u].insert({ v, 1 });
	}
	for (int i = 0; i < n; ++i) {
		for (auto j : a1[i]) {
			if (a1[j.first].find({ i, 1 }) == a1[j.first].end())
				a1[j.first].insert({ i, 0 });
		}
	}
	vector<vii> a(n);
	for (int i = 0; i < n; ++i) {
		for (auto x : a1[i])
			a[i].pb(x);
	}
	vector<pair<pii, pii>> ans;
	for (int st = 0; st < n; ++st) {
		vii p;
		dfs(st, a, p);
		reverse(p.begin(), p.end());
		int sz = p.size();
		if (!sz)
			continue;
		vc ok(sz);
		for (int i = 0; i < sz; ++i) {
			if (p[i].second == p[(i + 1) % sz].first)
				ok[i] = 1;
		}
		int j = 0;
		for (int i = 0; i < sz; ++i) {
			if (!ok[i]) {
				j = i;
				break;
			}
		}
		if (j % 2 == 0) {
			if (!ok[sz - 1]) {
				cout << "No";
				return;
			}
			ans.pb({ p.back(), p[0] });
			for (int i = 1; i < sz - 1; i += 2) {
				if (!ok[i]) {
					cout << "No";
					return;
				}
				ans.pb({ p[i], p[i + 1] });
			}
		}
		else {
			for (int i = 0; i < sz; i += 2) {
				if (!ok[i]) {
					cout << "No";
					return;
				}
				ans.pb({ p[i], p[i + 1] });
			}
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < m / 2; ++i)
		cout << ans[i].first.first + 1 << ' ' << ans[i].first.second + 1 << ' '\
		<< ans[i].second.first + 1 << ' ' << ans[i].second.second + 1 << endl;

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}