#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)3e5 + 10;
const int INF = (int)2e9 + 10;
const int MOD = (int)1e9 + 7;

int input() {
	int x = 0;
	char c = ' ';
	while (!isdigit(c))
		c = _getchar_nolock();
	while (isdigit(c)) {
		x = x * 10 + (c - '0');
		c = _getchar_nolock();
	}
	return x;
}

void print(int x) {
	for (char c : to_string(x))
		_putchar_nolock(c);
	_putchar_nolock(endl);
	return;
}

vi p(N, -1);

int up(int v) {
	if (p[v] < 0)
		return v;
	return p[v] = up(p[v]);
}

void merge(int u, int v) {
	if (p[v] < p[u])
		swap(u, v);
	if (p[v] = p[u])
		--p[u];
	p[v] = u;
	return;
}

void dfs(int v, vvi& g, vi& ans, int t, int p = -1) {
	ans[v] = t;
	for (int u : g[v]) {
		if (u == p)
			continue;
		dfs(u, g, ans, t, v);
	}
	return;
}

void solve() {
	int n = input(), m = input();
	vector<pair<pii, int>> e(m);
	for (int i = 0; i < m; ++i) {
		e[i].first.first = input() - 1;
		e[i].first.second = input() - 1;
		e[i].second = input();
	}
	sort(e.begin(), e.end(), [](pair<pii, int>& a, pair<pii, int>& b) {
		return a.second < b.second;
		});
	vvi g(n);
	vi ans(n);
	for (int i = 0; i < m; ++i) {
		int u = e[i].first.first, v = e[i].first.second, t = e[i].second;
		u = up(u); v = up(v);
		if (u == v)
			continue;
		if (v == up(0))
			swap(u, v);
		if (u == up(0))
			dfs(v, g, ans, t);
		merge(u, v);
		g[u].pb(v);
		g[v].pb(u);
	}
	for (int i = 1; i < n; ++i)
		print(ans[i]);
	
	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}