#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <deque>
#include <tuple>

using namespace std;

typedef long long ll;

//#define int ll
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

const int N = 3e5 + 7, INF = 1e9 + 7;

vector <pi> g[N];
int dist[N];

void dijkstra() {
	loop(i, N)
		dist[i] = INF;
	dist[0] = 0;
	priority_queue <pi, vector <pi>, greater<pi> > q;
	q.push({ 0, 1 });
	while (!q.empty()) {
		int v = q.top().S, dv = q.top().F;
		q.pop();
		if (dist[v] < dv)
			continue;
		for (pi e : g[v])
			if (dist[e.F] > max(dist[e.F], e.S)) {
				dist[e.F] = max(dist[e.F], e.S);
				q.push({ dist[e.F] , e.F });
			}
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	loop(i, m) {
		int u, v, c;
		cin >> u >> v >> c;
		g[u].push_back({ v, c });
		g[v].push_back({ u, c });
	}
	dijkstra();
	for (int i = 2; i <= n; ++i)
		cout << dist[i] << " ";
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}