#include <bits/stdc++.h>

using namespace std;

vector<int> x, h;
int n;

vector<int> reduce(vector<int> a, vector<int> b, int vl, int vr) {
	reverse(b.begin(), b.end());
	bool upd;
	do {
		upd = false;
		if(a.size() > 0) {
			if(b.size() > 0) {
				if(x[a.back()] + h[a.back()] <= x[b.back()]) {
					a.pop_back();
					upd = true;
				}
			} else {
				if(x[a.back()] + h[a.back()] <= x[vr == n ? n - 1 : vr]) {
					a.pop_back();
					upd = true;
				}
			}
		}
		if(b.size() > 0) {
			if(a.size() > 0) {
				if(x[b.back()] - h[b.back()] >= x[a.back()]) {
					b.pop_back();
					upd = true;
				}
			} else {
				if(x[b.back()] - h[b.back()] >= x[vl == 0 ? 0 : vl - 1]) {
					b.pop_back();
					upd = true;
				}
			}
		}
	} while(upd);
	a.insert(a.end(), b.rbegin(), b.rend());
	return a;
}

class SegmentTree {
public:
	vector< vector<int> > a;
	int n;

	SegmentTree(int n): n(n) {
		a.resize(4 * n);
		build(1, 0, n);
	}

	void build(int v, int vl, int vr) {
		if(vr - vl == 1) {
			a[v] = min(reduce({vl}, {}, vl, vr), reduce({}, {vl}, vl, vr));
		} else {
			int vm = (vl + vr) / 2;
			build(v * 2, vl, vm);
			build(v * 2 + 1, vm, vr);
			a[v] = reduce(a[v * 2], a[v * 2 + 1], vl, vr);
		}
	}

	vector<int> get(int v, int vl, int vr, int l, int r) {
		if(l == vl && r == vr) {
			return a[v];
		} else {
			int vm = (vl + vr) / 2;
			if(r <= vm) {
				return get(v * 2, vl, vm, l, r);
			} else if(l >= vm) {
				return get(v * 2 + 1, vm, vr, l, r);
			} else {
				return reduce(get(v * 2, vl, vm, l, vm), get(v * 2 + 1, vm, vr, vm, r), l, r);
			}
		}
	}
	vector<int> get(int l, int r) {
		return get(1, 0, n, l, r);
	}
};

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int q;
	cin >> n >> q;

	x.resize(n);
	h.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> x[i] >> h[i];
	}

	SegmentTree st(n);

	for(int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--; r--;
		r++;
		cout << (r - l - st.get(l, r).size()) << "\n";
	}

	return 0;
}