#include <bits/stdc++.h>

using namespace std;

const int INF = 1000000001;

class DSU {
public:
	vector< vector<int> > items;
	vector<int> parent;

	DSU(int n) {
		items.resize(n);
		parent.resize(n);
		for(int i = 0; i < n; i++) {
			items[i].push_back(i);
			parent[i] = i;
		}
	}

	int get(int i) {
		return i == parent[i] ? i : parent[i] = get(parent[i]);
	}

	void unite(int u, int v) {
		u = get(u);
		v = get(v);
		assert(u != v);
		if(items[u].size() > items[v].size()) {
			swap(u, v);
		}
		for(int x: items[u]) {
			parent[x] = v;
			items[v].push_back(x);
		}
		items[u].clear();
	}
};

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	vector< tuple<int, int, int> > edges;
	for(int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		edges.emplace_back(u, v, t);
	}

	DSU dsu(n);
	vector<int> ans(n, -1);

	sort(edges.begin(), edges.end(), [](auto a, auto b) {
		return get<2>(a) < get<2>(b);
	});
	for(auto [u, v, t]: edges) {
		u = dsu.get(u);
		v = dsu.get(v);
		if(u == v) {
			continue;
		}
		if(v == dsu.get(0)) {
			swap(u, v);
		}
		if(u == dsu.get(0)) {
			for(int x: dsu.items[v]) {
				ans[x] = t;
			}
		}
		dsu.unite(u, v);
	}

	for(int i = 1; i < n; i++) {
		cout << ans[i] << " ";
	}
	cout << endl;

	return 0;
}