#include <bits/stdc++.h>

using namespace std;

const int INF = 1000000000;


vector< vector< tuple<int, int, int> > > adj;
vector<int> used, tin, fup;
int curtm;
vector<bool> isbridge;

void dfs(int u, int pe) {
	used[u] = 1;
	tin[u] = curtm++;
	fup[u] = tin[u];
	for(auto [v, e, t]: adj[u]) {
		if(e == pe) {
			continue;
		}
		if(used[v] == 1) {
			fup[u] = min(fup[u], tin[v]);
		} else if(used[v] == 0) {
			dfs(v, e);
			fup[u] = min(fup[u], fup[v]);
			if(fup[v] > tin[u]) {
				isbridge[e] = true;
			}
		}
	}
	used[u] = 2;
}

vector<int> compof;
vector<int> minincomp;
vector< vector<int> > adjbr;
void dfs2(int u, int p, int c) {
	used[u] = 1;
	compof[u] = c;
	for(auto [v, e, t]: adj[u]) {
		if(v == p) {
			continue;
		}
		if(isbridge[e]) {
			minincomp.push_back(t);
			adjbr.emplace_back();
			adjbr[c].push_back(minincomp.size() - 1);
			dfs2(v, u, minincomp.size() - 1);
		} else {
			minincomp[c] = min(minincomp[c], t);
			if(!used[v]) {
				dfs2(v, u, c);
			}
		}
	}
}

vector<int> recmincomp;
void dfs3(int u, int curmin) {
	curmin = min(curmin, minincomp[u]);
	recmincomp[u] = curmin;
	for(int v: adjbr[u]) {
		dfs3(v, curmin);
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	vector< vector< tuple<int, int, int> > > adj1(n);
	vector<int> weights;
	for(int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		adj1[u].emplace_back(v, i, t);
		adj1[v].emplace_back(u, i, t);
		weights.push_back(t);
	}
	sort(weights.begin(), weights.end());

	vector<int> ans(n, INF * 2 + 1);

	for(int w = 0; w < weights.size(); w++) {
		adj.clear();
		adj.resize(n);
		for(int u = 0; u < n; u++) {
			for(auto [v, i, t]: adj1[u]) {
				if(t <= weights[w]) {
					adj[u].emplace_back(v, i, t);
				}
			}
		}

		curtm = 0;
		used.clear();
		used.resize(n);
		tin.resize(n);
		fup.resize(n);
		isbridge.clear();
		isbridge.resize(m);
		dfs(0, -1);

		used.clear();
		used.resize(n);
		minincomp.clear();
		minincomp.push_back(INF);
		adjbr.clear();
		adjbr.emplace_back();
		compof.clear();
		compof.resize(n, -1);
		dfs2(0, -1, 0);

		recmincomp.resize(minincomp.size());
		dfs3(0, INF);

		for(int i = 1; i < n; i++) {
			if(compof[i] != -1 && ans[i] == 2 * INF + 1) {
				ans[i] = weights[w] + recmincomp[compof[i]];
			}
		}
	}

	for(int i = 1; i < n; i++) {
		cout << ans[i] << "\n";
	}

	return 0;
}