#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

void dfs(int32_t vertex, int32_t parent, std::vector<std::pair<int32_t, int32_t> >* graph, int32_t min, int32_t max, std::pair<int32_t, int32_t>* answers) {
    answers[vertex] = {min, max};
    for(auto it = graph[vertex].begin(); it != graph[vertex].end(); it++) {
        if(it->first == parent) {
            continue;
        } else {
            dfs(it->first, vertex, graph, std::min(min, it->second), std::max(max, it->second), answers);
        }
    }
    graph[vertex].clear();
}


int main() {
    int32_t n, m;
    std::cin >> n >> m;

    std::vector<std::pair<int32_t, int32_t> >* graph = new std::vector<std::pair<int32_t, int32_t>> [n];
    for(int32_t i = 0; i < m; i++) {
        int32_t src, dst, weight;
        std::cin >> src >> dst >> weight;
        src--;
        dst--;

        graph[src].emplace_back(dst, weight);
        graph[dst].emplace_back(src, weight);
    }

    /*int32_t* arr = new int32_t[n];
    for(int32_t i = 0; i < n; i++)
        arr[i] = i;
    while(std::next_permutation(arr, arr + n)) {
        for(int32_t i = 0; i < n; i++)
            if()
    }*/

    std::pair<int32_t, int32_t>* answers = new std::pair<int32_t, int32_t>[n];
    dfs(0, -1, graph, INT32_MAX, INT32_MIN, answers);

    for(int32_t i = 1; i < n; i++)
        std::cout << answers[i].first + answers[i].second << "\n";
    return 0;
}