#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

#define endl '\n'

const int Base = 3e5 + 10;
const long long inf = 1e18;

struct List
{
	List *prev, *next;
	int id;
	int leftSpace, rightSpace;
};

int n, q;
int x[Base];
int h[Base];
List tree[Base];

int tryDel(List* t)
{
	if (t == nullptr)
	{
		return 0;
	}

	if (h[t->id] <= max(t->leftSpace, t->rightSpace))
	{
		if (t->next != nullptr)
		{
			t->next->leftSpace += t->leftSpace;
			t->next->prev = t->prev;
		}
		if (t->prev != nullptr)
		{
			t->prev->rightSpace += t->rightSpace;
			t->prev->next = t->next;
		}

		if (t->next != nullptr)
		{
			return 1 + tryDel(t->next);
		}
		else
		{
			return 1 + tryDel(t->prev);
		}
	}
	else
	{
		return tryDel(t->prev);
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> q;

	for (int i = 0; i < n; i++)
	{
		cin >> x[i] >> h[i];
	}

	while (q--)
	{
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		int cnt = 0;

		for (int i = l; i <= r; i++)
		{
			tree[i].id = i;

			if (i > l)
			{
				tree[i].prev = &tree[i - 1];
				tree[i].leftSpace = x[i] - x[i - 1];
			}
			else
			{
				tree[i].prev = nullptr;
				if (l > 0)
				{
					tree[i].leftSpace = x[i] - x[i - 1];
				}
				else
				{
					tree[i].leftSpace = 0;
				}
			}

			if (i < r)
			{
				tree[i].next = &tree[i + 1];
				tree[i].rightSpace = x[i + 1] - x[i];
			}
			else
			{
				tree[i].next = nullptr;
				if (r < n - 1)
				{
					tree[i].rightSpace = x[i + 1] - x[i];
				}
				else
				{
					tree[i].rightSpace = 0;
				}
			}
		}

		cout << tryDel(&tree[r]) << endl;
	}
}