#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <vector>

using namespace std;

#define endl '\n'

const int Base = 3e5 + 10;
const long long inf = 1e18;

struct Edge
{
	int a, b;
	long long t;
	bool used = false;
};

int n, m;
Edge allE[Base];
vector<int> e[Base];
long long ans[Base];

void dfs(int x, long long Min, long long Max)
{
	ans[x] = min(ans[x], Min + Max);

	for (auto id : e[x])
	{
		if (!allE[id].used)
		{
			allE[id].used = true;
			dfs(allE[id].a + allE[id].b - x, min(Min, allE[id].t), max(Max, allE[id].t));
			allE[id].used = false;
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 0; i <= n; i++)
	{
		ans[i] = 1e11;
	}

	for (int i = 0; i < m; i++)
	{
		int a, b, t;
		cin >> a >> b >> t;
		allE[i].a = a;
		allE[i].b = b;
		allE[i].t = t;
		e[a].push_back(i);
		e[b].push_back(i);
	}

	dfs(1, 1e9, 0);

	for (int i = 2; i <= n; i++)
	{
		cout << ans[i] << endl;
	}

}