#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cstring>
#include <cassert>
#include <map>

using namespace std;

//#define int long long
const int MAXN = 150020;
const long long INF = 1e8;

vector<pair<pair<int, int>, pair<int, int> > > ans;

vector<pair<int, int>> g1;
vector<pair<int, int>> g2;
vector<pair<int, int>> g[MAXN];
vector<int> gTo[MAXN];
vector<int> gFrom[MAXN];
int d[MAXN];

void dfs(int v, int dnow) {
	d[v] = dnow;
	for (pair<int, int> p : g[v]) {
		if (d[p.first] == -1) {
			dfs(p.first, dnow + 1);
		}
	}
}

bool used2[MAXN];

vector<int> g1To[MAXN];

inline bool check(pair<int, int> e1, pair<int, int> e2) {
	return e1.second == e2.first || e2.second == e1.first;
}

map<pair<int, int>, int> mp;

int to[MAXN];
int used[MAXN];
bool kuhn(int v, int num) {
	int verv = g1[v].first;
	int veru = g1[v].second;
	for (int c : gTo[veru]) {
		int j = mp[make_pair(veru, c)];
		if (to[j] == -1 && used[j] < num) {
			to[j] = v;
			return true;
		}
	}
	for (int c : gFrom[verv]) {
		int j = mp[make_pair(c, verv)];
		if (to[j] == -1 && used[j] < num) {
			to[j] = v;
			return true;
		}
	}
	for (int c : gTo[veru]) {
		int j = mp[make_pair(veru, c)];
		if (used[j] < num) {
			int tmp = to[j];
			to[j] = v;
			used[j] = num;
			if (kuhn(tmp, num)) return true;
			to[j] = tmp;
		}
	}
	for (int c : gFrom[verv]) {
		int j = mp[make_pair(c, verv)];
		if (used[j] < num) {
			int tmp = to[j];
			to[j] = v;
			used[j] = num;
			if (kuhn(tmp, num)) return true;
			to[j] = tmp;
		}
	}
	return false;
}

signed main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v; --u;
		g[v].push_back(make_pair(u, 1));
		g[u].push_back(make_pair(v, -1));
		gTo[v].push_back(u);
		gFrom[u].push_back(v);
	}
	for (int v = 0; v < n; ++v) {
		random_shuffle(gTo[v].begin(), gTo[v].end());
		random_shuffle(gFrom[v].begin(), gFrom[v].end());
	}
	memset(d, -1, sizeof d);
	for (int v = 0; v < n; ++v) {
		if (d[v] == -1) dfs(v, 0);
	}
	for (int v = 0; v < n; ++v) {
		for (int i = 0; i < g[v].size(); ++i) {
			pair<int, int> p = g[v][i];
			if (p.second == 1) {
				if (d[v] & 1) {
					//g[v][i].second = (int)g2.size();
					g2.push_back(make_pair(v, p.first));
					mp[make_pair(v, p.first)] = (int)g2.size() - 1;
				}
				else {
					g1.push_back(make_pair(v, p.first));
					//g[v][i].second = -1;
				}
			}
		}
	}
	/*for (int v = 0; v < n; ++v) {
		cout << "v = " << v << ":\n";
		for (int i = 0; i < g[v].size(); ++i) {
			cout << g[v][i].first << " " << g[v][i].second << "\n";
		}
	}*/
	/*for (int i = 0; i < g1.size(); ++i) {
		cout << g1[i].first << " " << g1[i].second << "\n";
	}
	cout << "\n\n";
	for (int i = 0; i < g2.size(); ++i) {
		cout << g2[i].first << " " << g2[i].second << "\n";
	}*/
	if (g1.size() != g2.size()) {
		cout << "No\n";
		return 0;
	}
	/*for (int i = 0; i < g1.size(); ++i) {
		int u = g1[i].second;
		for (pair<int, int> p : g[u]) {
			if (p.second != -1) {
				g1To[i].push_back(p.second);
				cout << "!" << p.second << "\n";
			}
		}
	}*/
	memset(to, -1, sizeof to);
	memset(used, 0, sizeof used);
	int num = 1;
	for (int i = 0; i < g1.size(); ++i) {
		if (!kuhn(i, num)) {
			cout << "No\n";
			return 0;
		}
		++num;
	}
	cout << "Yes\n";
	for (int i = 0; i < g2.size(); ++i) {
		cout << g2[i].first + 1 << " " << g2[i].second + 1 << " " << g1[to[i]].first + 1 << " " << g1[to[i]].second + 1 << "\n";
	}
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/

/*
4 4
2 1
2 3
2 4
4 2
*/