#include <iostream>
#include <iomanip>
#include <cstdlib>

#include <cmath>
#include <algorithm>
#include <functional>

#include <set>
#include <stack>
#include <string>
#include <vector>
#include <map>
using namespace std;

const long long int INF = 5 * 1e16;

int main() {
	int n, m;
	cin >> n >> m;
	int v, u;
	vector <set <int>> graf_in(n);
	vector <set <int>> graf_out(n);
	for (int i = 0; i < m; i++) {
		cin >> v >> u;
		graf_out[v - 1].insert(u - 1);
		graf_in[u - 1].insert(v - 1);
	}

	vector <int> father(n, -1);
	int root = 0;
	vector <bool> deleted(n, false);
	vector <int> dis(n, -1);
	vector <bool> dp_used(n, false);
	set<pair<int, int>> leaves;
	vector <set<int>> graf_in1(n);
	vector <set<int>> graf_out1(n);

	function <void(int)> dfs = [&](int a) {
		dp_used[a] = true;
		for (auto i = graf_in[a].begin(); i != graf_in[a].end(); i++) {
			int b = *i;
			if (b != father[a]) {
				graf_in1[a].insert(b);
			}
			if (!dp_used[b]) {
				dis[b] = dis[a] + 1;
				father[b] = a;
				dfs(b);
			}
		}
		for (auto i = graf_out[a].begin(); i != graf_out[a].end(); i++) {
			int b = *i;
			if (father[a] != b) {
				graf_out1[a].insert(b);
			}
			if (!dp_used[b]) {
				dis[b] = dis[a] + 1;
				father[b] = a;
				dfs(b);
			}
		}
		if ((graf_in1[a].size() == 0) && (graf_out1[a].size() == 0)) {
			leaves.insert(make_pair((-1) * dis[a], a));
		}
	};

	int w;
	vector <pair<pair<int, int>, pair<int, int>>> ans;
	while (root < n) {
		dis[root] = 0;
		father[root] = -1;
		dfs(root);

		while (leaves.size() != 0) {
			v = (*leaves.begin()).second;
			if (v == root) {
				leaves.clear();
				continue;
			}
			if ((graf_in[v].size() == 0) && (graf_out[v].size() == 0)) {
				leaves.erase(leaves.find(make_pair((-1) * dis[v], v)));
				u = father[v];
				if (((graf_in1[u].size() == 0) && (graf_out1[u].size() == 0)) && (leaves.find(make_pair((-1) * dis[u], u)) == leaves.end())) {
					leaves.insert(make_pair((-1) * dis[u], u));
				}
				continue;
			}
			u = father[v];
			if (graf_in[v].size() == 1) {
				if (graf_in[u].size() == 0) {
					cout << "No";
					return 0;
				}
				if (graf_in1[u].size() > 0) {
					w = *graf_in1[u].begin();
					graf_in1[u].erase(graf_in1[u].find(w));
				}
				else {
					w = *graf_in[u].begin();
					graf_out1[w].erase(graf_out1[w].find(u));
				}
				graf_in[u].erase(graf_in[u].find(w));
				graf_out[w].erase(graf_out[w].find(u));

				ans.push_back(make_pair(make_pair(u, v), make_pair(w, u)));

				graf_in[v].erase(graf_in[v].begin());
				graf_out1[u].erase(graf_out1[u].find(v));
				graf_out[u].erase(graf_out[u].find(v));
			}
			if (graf_out[v].size() == 1) {
				if (graf_out[u].size() == 0) {
					cout << "No";
					return 0;
				}
				if (graf_out1[u].size() > 0) {
					w = *graf_out1[u].begin();
					graf_out1[u].erase(graf_out1[u].find(w));
				}
				else {
					w = *graf_out[u].begin();
					graf_in1[w].erase(graf_in1[w].find(u));
				}
				graf_out[u].erase(graf_out[u].begin());
				graf_in[w].erase(graf_in[w].find(u));

				ans.push_back(make_pair(make_pair(v, u), make_pair(u, w)));

				graf_out[v].erase(graf_out[v].begin());
				graf_in[u].erase(graf_in[u].find(v));
				graf_in1[u].erase(graf_in1[u].find(v));
			}

			leaves.erase(leaves.find(make_pair((-1) * dis[v], v)));
			if ((leaves.find(make_pair((-1) * dis[u], u)) == leaves.end()) && ((graf_in1[u].size() == 0) && (graf_out1[u].size() == 0))) {
				leaves.insert(make_pair((-1) * dis[u], u));
			}
		}

		while ((root < n) && (dp_used[root])) {
			root++;
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < m/2; i++) {
		cout << ans[i].first.first + 1 << " " << ans[i].first.second + 1 << " " << ans[i].second.first + 1 << " " << ans[i].second.second + 1 << "\n";
	}
//	system("pause");
	return 0;
}