#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 150000;
vector<pair<int, int>> g[maxn];
vector<int> gr[maxn * 2];
int color[maxn * 2];
int pr[maxn * 2];
bool used[maxn * 2];
int m;

void dfs(int v, int c) {
    color[v] = c;
    for (int i = 0; i < gr[v].size(); ++i) {
        int to = gr[v][i];
        if (color[to] != -1) {
            if (color[to] == c) {
                cout << "No";
                exit(0);
            }
        } else {
            dfs(to, 1 - c);
        }
    }
}

bool kuhn(int v) {
    used[v] = true;
    for (int i = 0; i < gr[v].size(); ++i) {
        int to = gr[v][i];
        if (pr[to] == -1) {
            pr[to] = v;
            return true;
        }
        if (used[pr[to]])continue;
        if (kuhn(pr[to])) {
            pr[to] = v;
            return true;
        }
    }
    return false;
}

int parsoch() {
    int ans = 0;
    bool has[m];
    for (int i = 0; i < m; ++i) {
        has[i] = false;
        if (color[i] == 1) {
            continue;
        }
        int sz = gr[i].size();
        int p = gr[i][rand() % sz];
        if (pr[p] != -1) {
            continue;
        }
        has[i] = true;
        pr[p] = i;
        ans++;
    }
    for (int i = 0; i < m; ++i) {
        if (color[i] == 1 || has[i]) {
            continue;
        }
        for (int j = 0; j < m; ++j) {
            used[j] = false;
        }
        if (kuhn(i))ans++;
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    for (int i = 0; i < maxn * 2; ++i) {
        color[i] = -1;
        pr[i] = -1;
    }
    int n;
    cin >> n >> m;
    vector<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        edges.push_back({a, b});
        g[a].push_back({b, i});
    }
    int cnt = 0;
    for (int i = 0; i < edges.size(); ++i) {
        int b = edges[i].second;
        for (int j = 0; j < g[b].size(); ++j) {
            gr[i].push_back(g[b][j].second);
            gr[g[b][j].second].push_back(i);
            cnt += 2;
        }
    }
    for (int i = 0; i < m; ++i) {
        if (color[i] == -1)
            dfs(i, 0);
    }
    int y = parsoch();
    if (y != m / 2) {
        cout << "No";
        exit(0);
    }
    cout << "Yes\n";
    vector<pair<int, int>> ans;
    for (int i = 0; i < m; ++i) {
        if (color[i] == 1) {
            ans.push_back({pr[i], i});
        }
    }
    for (int i = 0; i < ans.size(); ++i) {
        cout << edges[ans[i].first].first + 1 << " " << edges[ans[i].first].second + 1 << " "
             << edges[ans[i].second].first + 1
             << " " << edges[ans[i].second].second + 1 << "\n";
    }
}
