#include <iostream>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <queue>

typedef long long ll;


const int N = 2e4;
const int alp = 26;
const ll inf = 1e18;

using namespace std;

int x[N], h[N];

bool canl[N];
bool canr[N];

vector<int> stopl[N];
vector<int> stopr[N];
vector<int> lft[N];
vector<int> rht[N];

int main()
{
	int n;
	int query;
	cin >> n >> query;
	for (int q = 0; q < n; q++)
	{
		cin >> x[q] >> h[q];
	}
	for (int q = 0; q < n; q++)
	{
		if (x[q] - h[q] >= x[0])
		{
			canl[q] = true;
			for (int w = q - 1; w > -1; w--)
			{
				if (x[q] - h[q] < x[w] && x[q] > x[w])
				{
					lft[q].push_back(w);
					stopl[w].push_back(q);
				}
			}
		}
		else
		{
			canl[q] = false;
		}
	}
	for (int q = 0; q < n; q++)
	{
		if (x[q] + h[q] <= x[n - 1])
		{
			canr[q] = true;
			for (int w = q + 1; w < n; w++)
			{
				if (x[q] + h[q] > x[w] && x[q] < x[w])
				{
					rht[q].push_back(w);
					stopr[w].push_back(q);
				}
			}
		}
		else
		{
			canr[q] = false;
		}
	}
	while (query--)
	{
		int l, r;
		cin >> l >> r; l--; r--;
		queue<int> can;
		vector<int> cntl(n);
		vector<int> cntr(n);
		vector<bool> used(n);
		for (int q = 0; q < n; q++)
		{
			cntl[q] = lft[q].size();
			cntr[q] = rht[q].size();
		}
		for (int q = l; q <= r; q++)
		{
			if ((canl[q] == true && lft[q].size() == 0) || (canr[q] == true && rht[q].size() == 0))
			{
				used[q] = true;
				can.push(q);
			}
		}
		int ans = 0;
		while (can.size() != 0)
		{
			int x = can.front();
			can.pop();
			if (x >= l && x <= r)
			{
				ans++;
				for (int q = 0; q < stopl[x].size(); q++)
				{
					if (used[stopl[x][q]] == false)
					{
						cntl[stopl[x][q]]--;
						if (cntl[stopl[x][q]] == 0)
						{
							can.push(stopl[x][q]);
							used[stopl[x][q]] = true;
						}
					}
				}
				for (int q = 0; q < stopr[x].size(); q++)
				{
					if (used[stopr[x][q]] == false)
					{
						cntr[stopr[x][q]]--;
						if (cntr[stopr[x][q]] == 0)
						{
							can.push(stopr[x][q]);
							used[stopr[x][q]] = true;
						}
					}
				}
			}
		}
		cout << ans << '\n';
	}
}