#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()

using namespace std;

const int N = 2e5 + 100;
set <int> edges[N];
vector <int> g[N];

bool used[N];

vector <array <int, 4>> ans;

pair <int, int> dfs(int v, int p) {
    used[v] = true;
    vector <int> in, out;

    for (int i : g[v]) {
        if (i == p)
            continue;

        auto [from, to] = dfs(i, v);
        bool edge_to = edges[v].count(i), edge_from = edges[i].count(v);
        if (from != -1 && edge_to) {
            ans.push_back({v, i, i, from});
            from = -1;
            edge_to = false;
        }
        if (to != -1 && edge_from) {
            ans.push_back({to, v, v, i});
            to = -1;
            edge_from = false;
        }
        if (edge_from && edge_to) {
            ans.push_back({i, v, v, i});
            edge_from = false, edge_to = false;
        }

        if (from != -1 || to != -1) {
            cout << "No\n";
            exit(0);
        }

        if (edge_to) {
            out.push_back(i);
        }
        if (edge_from)
            in.push_back(i);
    }

    while (!in.empty() && !out.empty()) {
        int a = in.back(), b = out.back();
        in.pop_back(), out.pop_back();
        ans.push_back({a, v, v, b});
    }

    if (in.size() >= 2 || out.size() >= 2) {
        cout << "No\n";
        exit(0);
    }
    return {(out.empty() ? -1 : out.front()), (in.empty() ? -1 : in.front())};
}


signed main() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
        edges[a].insert(b);
    }

    for (int i = 0; i < n; i++) {
        sort(all(g[i]));
        g[i].erase(unique(all(g[i])), g[i].end());
    }

    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            auto [a, b] = dfs(i, -1);
            if (a != -1 || b != -1) {
                cout << "No\n";
                return 0;
            }
        }
    }

    cout << "Yes\n";
    for (auto [a, b, c, d] : ans)
        cout << a + 1 << " " << b + 1 << " " << c + 1 << " " << d + 1 << "\n";
    return 0;
}
