#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <numeric>
#include <cmath>

using namespace std;

vector<vector<pair<int, long long>>> g;
vector<long long> d, dmin, dmax;

void dfs(int v, int pr) {
    for (auto ut : g[v]) {
        if (ut.first != pr) {
            if (v == 0) {
                dmin[ut.first] = ut.second;
                dmax[ut.first] = ut.second;
            }
            else {
                dmin[ut.first] = min(dmin[v], ut.second);
                dmax[ut.first] = max(dmax[v], ut.second);
            }
            d[ut.first] = dmin[ut.first] + dmax[ut.first];
            dfs(ut.first, v);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        long long t;
        cin >> v >> u >> t;
        --v;
        --u;
        g[v].emplace_back(u, t);
        g[u].emplace_back(v, t);
    }
    if (m == n - 1) {
         d.resize(n, 0);
         dmin.resize(n, 0);
         dmax.resize(n, 0);
         dfs(0, -1);
         for (int i = 1; i < n; ++i) {
             cout << d[i] << "\n";
         }
    }

    return 0;
}
