#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
#include <set>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 3e5 + 228;
const int INF = 1e9 + 228;

vector<array<int, 3>> G[N];
int tin[N], timer = 0, mx_up[N];
bool used[N];
set<int> c;

void dfs(int v, int id) {
	used[v] = 1;
	tin[v] = mx_up[v] = timer++;
	for (auto i : G[v]) {
		if (used[i[0]]) {
			if (id != i[2])
				mx_up[v] = min(mx_up[v], tin[i[0]]);
		} else {
			dfs(i[0], i[2]);
			if (mx_up[i[0]] > tin[v])
				c.insert(i[2]);
			mx_up[v] = min(mx_up[v], mx_up[i[0]]);
		}
	}
}

int dop[N];
int tmp_res = INF;
int ans[N];

void dfs_res(int v, int val) {
	ans[v] = min(tmp_res, val);
	used[v] = 1;
	for (auto i : G[v]) {
		if (!used[i[0]])
			dfs_res(i[0], min(val, dop[i[0]]));
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b, t;
		cin >> a >> b >> t;
		G[a - 1].push_back({b - 1, t, i});
		G[b - 1].push_back({a - 1, t, i});
	}
	fill(dop, dop + n, INF);
	dfs(0, -1);
	for (int i = 0; i < n; ++i) {
		for (auto j : G[i]) {
			if (c.count(j[2])) {
				if (tin[i] > tin[j[0]])
					dop[i] = min(dop[i], j[1]);
				else
					tmp_res = min(tmp_res, j[1]);
			}
		}
	}
	fill(used, used + n, 0);
	dfs_res(0, 0);
	for (int i = 1; i < n; ++i)
		cout << ans[i] + 1e9 << '\n';
}