#include <iostream>
#include <vector>
#include <algorithm>
#include <array>
#include <set>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 3e5 + 228;
const int INF = 1e9 + 228;

vector<array<int, 3>> G[N];
int tin[N], timer = 0, mx_up[N];
bool used[N];
bool most[N];

void dfs(int v, int id) {
	used[v] = 1;
	tin[v] = mx_up[v] = timer++;
	for (auto i : G[v]) {
		if (used[i[0]]) {
			if (id != i[2])
				mx_up[v] = min(mx_up[v], tin[i[0]]);
		} else {
			dfs(i[0], i[2]);
			if (mx_up[i[0]] > tin[v])
				most[i[2]] = 1;
			mx_up[v] = min(mx_up[v], mx_up[i[0]]);
		}
	}
}

int who[N];
int val[N];

void dfs_cond(int v) {
	used[v] = 1, who[v] = timer;
	for (auto i : G[v]) {
		if (!most[i[2]]) {
			dfs_cond(i[0]);
		}
	}
}

vector<pair<int, int>> _G[N];

void dfs_solve(int v, int p) {
	for (auto i : _G[v]) {
		if (i.first == p)
			continue;
		val[i.first] = min(val[i.first], min(val[v], i.second));
		dfs_solve(i.first, v);
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b, t;
		cin >> a >> b >> t;
		G[a - 1].push_back({b - 1, t, i});
		G[b - 1].push_back({a - 1, t, i});
	}
	dfs(0, -1);

	fill(used, used + n, 0);
	timer = -1;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			timer++;
			dfs_cond(i);
		}
	}
	fill(val, val + n, INF);
	for (int i = 0; i < n; ++i) {
		for (auto j : G[i]) {
			if (most[j[2]]) {
				_G[who[i]].emplace_back(who[j[0]], j[1]);
			} else {
				val[who[i]] = min(val[who[i]], j[1]);
			}
		}
	}

	dfs_solve(0, 0);
	for (int i = 1; i < n; ++i) {
		cout << val[who[i]] << '\n';
	}
}