#include <iostream>
#include "vector"

using namespace std;

int INF = 1000000001;
vector<int> ans;
vector<bool> used;

struct edge {
    int v, w, x;
    edge(int v, int w, int x): v(v), w(w), x(x) {};
};

vector<vector<edge>> g;

void dfs(int v, int mn = 2 * INF, int mx = -1) {
    ans[v] = min(ans[v], mn + mx);
    for (auto el : g[v]) {
        if (not used[el.x]) {
            used[el.x] = true;
            dfs(el.v, min(mn, el.w), max(mx, el.w));
            used[el.x] = false;
        }
    }
}

signed main() {
    int n, m; cin >> n >> m;
    ans.resize(n, 2 * INF);
    used.resize(m, false);
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b, w; cin >> a >> b >> w;
        a--; b--;
        g[a].push_back({b, w, i});
        g[b].push_back({a, w, i});
    }
    dfs(0);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << endl;
    }
}