#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <unordered_map>

using namespace std;

const long long int MAX = 3000000000000000001;

unordered_map<char, long long int> alphabet;
void init() {
	char ch = 'A';
	long long int now = 1;
	bool x5 = true;
	while (ch <= 'Z') {
		alphabet[ch] = now;
		ch++;
		if (x5) now *= 5;
		else now *= 2;
		x5 = !x5;
	}
}

long long int calc(string& s, char change, int from, int to) {
	long long int answ = 0;
	vector<int> first_larger(s.size());
	stack<int> help;
	for (int i = s.size() - 1; i >= 0; i--) {
		while (!help.empty()) {
			char a = s[i];
			char b = s[help.top()];
			if (a == '?') a = change;
			if (b == '?') b = change;
			if (a < b) break;
			help.pop();
		}
		if (help.empty()) first_larger[i] = -1;
		else first_larger[i] = help.top();
		help.push(i);
	}
	for (int i = from; i < to; i++) {
		char a = s[i];
		if (a == '?') a = change;
		if (from <= first_larger[i] && first_larger[i] < to) answ -= alphabet[a];
		else answ += alphabet[a];
	}
	return answ;
}

void solve() {
	string line;
	cin >> line;
	vector<vector<long long int>> dp(line.length(), vector<long long int>(26, -MAX));
	stack<int> last_choice;
	if (line[0] == '?') {
		for (int i = 0; i < 26; i++) dp[0][i] = alphabet[i + 'A'];
		last_choice.push(0);
	}
	else if (line.size() == 1) {
		cout << calc(line, '?', 0, 1) << endl;
		cout << line << endl;
		return;
	}

	vector<vector<int>> pred(line.size(), vector<int>(26, -1));
	vector<int> maxs(line.size(), 0);
	for (int i = line.size() - 1; i >= 0; i--) {
		if (line[i] != '?') maxs[i] = line[i] - 'A';
		if (i != line.size() - 1) maxs[i] = max(maxs[i], maxs[i + 1]);
	}
	for (int i = 1; i < line.size(); i++) {
		if (line[i] == '?') {
			for (int j = maxs[i]; j < 26; j++) {
				long long int answ = 0;
				if (!last_choice.empty()) {
					answ = calc(line, 'A' + j, last_choice.top() + 1, i + 1);
					long long int max_before = -MAX;
					int targ = 0;
					for (int k = j; k < 26; k++) {
						long long int now = dp[last_choice.top()][k];
						if (max_before < now) {
							max_before = now;
							targ = k;
							targ = k;
						}
					}
					answ += max_before;
					pred[i][j] = targ;
				}
				else {
					answ = calc(line, 'A' + j, 0, i + 1);
					pred[i][j] = -1;
				}
				dp[i][j] = answ;
			}
			last_choice.push(i);
		}
		else if (i == line.size() - 1) {
			long long int answ = 0;
			if (!last_choice.empty()) {
				answ = calc(line, '?', last_choice.top() + 1, i + 1);
				long long int max_before = -MAX;
				int targ = 0;
				for (int j = 0; j < 26; j++) {
					long long int now = dp[last_choice.top()][j];
					if (max_before < now) {
						max_before = now;
						targ = j;
					}
				}
				answ += max_before;
				pred[i][line[i] - 'A'] = targ;
			}
			else {
				answ = calc(line, '?', 0, i + 1);
			}

			dp[i][line[i] - 'A'] = answ;
		}
	}
	long long int answ = dp[(int)line.size() - 1][0];
	long long int last_pos = 0;
	for (int i = 1; i < 26; i++) {
		if (dp[(int)line.size() - 1][i] > answ) {
			answ = dp[(int)line.size() - 1][i];
			last_pos = i;
		}
	}
	if (line[line.size() - 1] == '?') {
		line[line.size() - 1] = 'A' + last_pos;
		last_choice.pop();
	}
	int now = line.size() - 1;
	char ch = line[now];
	while (!last_choice.empty()) {
		line[last_choice.top()] = pred[now][ch - 'A'] + 'A';
		now = last_choice.top();
		ch = line[now];
		last_choice.pop();
	}

	cout << answ << endl;
	cout << line << endl;

}

int main() {
	init();
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) solve();
}