#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <unordered_map>

using namespace std;

struct tree {
	int x;
	int h;
	tree() {
		x = 0;
		h = 0;
	}
};
struct v {
	vector<int> trees;
	int answ;
	v() {
		trees = vector<int>(0, 0);
		answ = 0;
	}
};

vector<tree> arr;
vector<v> t;

pair<int, vector<int>> merge(vector<int>& t1, vector<int>& t2, int L, int R) {
	int l1 = 0, r2 = t2.size() - 1;
	int cnt = 0;
	while (l1 < t1.size() && arr[t1[l1]].h <= arr[t1[l1]].x - L) {
		cnt++;
		l1++;
	}
	while (r2 >= 0 && arr[t2[r2]].h <= R - arr[t2[r2]].x) {
		cnt++;
		r2--;
	}
	int r1 = t1.size() - 1;
	int l2 = 0;
	while (r1 >= l1 && r2 >= l2) {
		while (r1 >= l1 && r2 >= l2 && arr[t1[r1]].h <= arr[t2[l2]].x - arr[t1[r1]].x) {
			cnt++;
			r1--;
		}
		if (!(r1 >= l1 && r2 >= l2)) break;
		while (r1 >= l1 && r2 >= l2 && arr[t2[l2]].h <= arr[t2[l2]].x - arr[t1[r1]].x) {
			cnt++;
			l2++;
		}
		if (!(r1 >= l1 && r2 >= l2)) break;
		int dist = arr[t2[l2]].x - arr[t1[r1]].x;
		if (dist < arr[t2[l2]].h && dist < arr[t1[r1]].h) break;
	}
	// t1 ended
	if (r1 < l1) {
		while (r2 >= l2 && arr[t2[l2]].h <= arr[t2[l2]].x - L) {
			cnt++;
			l2++;
		}
	}
	// t2 ended
	if (r2 < l2) {
		while (r1 >= l1 && arr[t1[r1]].h >= R - arr[t1[r1]].x) {
			cnt++;
			r1--;
		}
	}

	vector<int> answ;
	for (int i = l1; i < r1; i++) answ.push_back(t1[i]);
	for (int i = l2; i < r2; i++) answ.push_back(t2[i]);
	return {cnt, answ};
}
int solo_answ(vector<int>& t1, int L, int R) {
	int l1 = 0, r1 = t1.size() - 1;
	int answ = 0;
	while (l1 <= r1 && arr[t1[l1]].h <= arr[t1[l1]].x - L) {
		l1++;
		answ++;
	}
	while (l1 <= r1 && arr[t1[r1]].h <= R - arr[t1[r1]].x) {
		r1--;
		answ++;
	}
	return answ;
}

void build(int i, int l, int r, int L, int R) {
	if (r - l == 1) {
		int dist = max(arr[l].x - L, R - arr[l].x);
		if (arr[l].h < dist) {
			t[i].answ = 1;
		}
		else {
			t[i].trees.push_back(l);
		}
	}
	else {
		int m = (r + l) / 2;
		int child_l = L;
		if (m > 0) child_l = arr[m - 1].x;
		build(2 * i + 1, l, m, L, arr[m].x);
		build(2 * i + 2, m, r, child_l, R);
		auto ans = merge(t[2 * i + 1].trees, t[2 * i + 2].trees, L, R);
		t[i].answ = ans.first + t[2 * i + 1].answ + t[2 * i + 2].answ;
		t[i].trees = ans.second;
	}
}


vector<vector<int>> to_merge;
int get_answ(int i, int l, int r, int targ_l, int targ_r) {
	if (l >= targ_r || targ_l >= r) return 0;
	if (targ_l <= l && r <= targ_r) {
		to_merge.push_back(t[i].trees);
		return t[i].answ;
	}
	int m = (l + r) / 2;
	int answ = get_answ(2 * i + 1, l, m, targ_l, targ_r);
	answ += get_answ(2 * i + 2, m, r, targ_l, targ_r);
	return answ;
}

int main() {
	int n, q;
	cin >> n >> q;
	arr = vector<tree>(n);
	t = vector<v>(4 * n);
	for (auto& elem : arr) cin >> elem.x >> elem.h;

	build(0, 0, n, arr[0].x, arr[n - 1].x);

	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		to_merge.clear();
		int answ_0 = get_answ(0, 0, n, l, r);
		int L = arr[max(l - 1, 0)].x;
		int R = arr[min(r, n - 1)].x;
		if (!to_merge.empty()) {
			vector<int> now = to_merge[0];
			for (int i = 1; i < to_merge.size(); i++) {
				int j = i + 1;
				while (j < to_merge.size() && to_merge[j].empty()) j++;
				int R_now = 0;
				if (j < to_merge.size()) R_now = arr[to_merge[j][0]].x;
				else R_now = R;
				auto ans = merge(now, to_merge[i], L, R_now);
				answ_0 += ans.first;
				now = ans.second;
			}
			answ_0 += solo_answ(now, L, R);
		}
		cout << answ_0 << endl;
	}
}