#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <unordered_map>

using namespace std;
int MAX = 2000000000;

struct edge {
	int other;
	int t;
	edge() {
		other = 0;
		t = 0;
	}
	edge(int other, int t) {
		this->t = t;
		this->other = other;
	}
};

vector<vector<edge>> graph;
vector<int> answers;
void dfs(int v, int pred, int Max, int Min) {
	answers[v] = min(Max + Min, answers[v]);
	for (auto& other : graph[v]) {
		if (other.other == pred) continue;
		dfs(other.other, v, max(Max, other.t), min(Min, other.t));
	}
}

int main() {
	int n, m;
	cin >> n >> m;
	graph = vector<vector<edge>>(n);
	for (int i = 0; i < m; i++) {
		int a, b, t;
		cin >> a >> b >> t;
		a--;
		b--;
		graph[a].push_back(edge(b, t));
		graph[b].push_back(edge(a, t));
	}
	
	answers = vector<int>(n, MAX);
	dfs(0, -1, 0, MAX);
	for (int i = 1; i < n; i++) cout << answers[i] << endl;
}