#include <iostream>
#include <vector>
#include <set>

using namespace std;

int n, m;
vector <int> sum;
vector <vector <pair <int, int>>> g;

void dfs(int v, int p, int mx) {
    sum[v] = mx;
    for (auto &[u, t]: g[v]) {
        if (u != p) {
            int t2 = max(t, mx);
            dfs(u, v, t2);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        v--, u--;
        g[v].push_back(make_pair(u, t));
        g[u].push_back(make_pair(v, t));
    }

    vector <int> dist(n, 1e9 + 2);
    vector <int> from(n);
    dist[0] = 0;
    set <pair <int, int>> q;
    q.insert(make_pair(0, 0));
    while (!q.empty()) {
        auto [d, v] = *q.begin();
        q.erase(q.begin());
        for (auto &[u, t]: g[v]) {
            if (dist[u] > t) {
                q.erase(make_pair(dist[u], u));
                dist[u] = t, from[u] = v;
                q.insert(make_pair(dist[u], u));
            }
        }
    }

    g.clear();
    g.resize(n);
    for (int v = 1; v < n; v++) {
        int u = from[v];
        g[v].push_back(make_pair(u, dist[v]));
        g[u].push_back(make_pair(v, dist[v]));
    }

    sum.resize(n);
    dfs(0, 0, 0);
    for (int i = 1; i < n; i++)
        cout << sum[i] + 1e9 << endl;

    return 0;
}
