#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

vector<vector<int>> g, g2;

vector<int> used;
vector<vector<int>> dp; // {0: none edges, 1: edge down, 2: edge up}

set<pair<int, int>> has;

void dfs1(int v) {
    used[v] = 1;
    int down = 0;
    int up = 0;
    for (int u : g2[v]) {
        if (!used[u]) {
            if (has.count({v, u}))
                down++;
            if (has.count({u, v}))
                up++;
            dfs1(u);
            if (!dp[u][0]) {
                assert(dp[u][1] + dp[u][2] != 2);
                if (dp[u][1]) {
                    if (!has.count({v, u})) {
                        return; 
                    }
                    down--;
                } else if (dp[u][2]) {
                    if (!has.count({u, v})) {
                        return;
                    }
                    up--;
                } else {
                    return;
                }
            }
        }
    }
    if (down == up) {
        dp[v][0] = 1;
    } else if (down == up + 1) {
        dp[v][1] = 1;
    } else if (down == up - 1) {
        dp[v][2] = 1;
    }
}

vector<vector<int>> ans;

void dfs2(int v, int a = -1, int b = -1) {
    used[v] = 1;
    set<pair<int, int>> up;
    set<pair<int, int>> down;
    if (a == v) {
        down.insert({a, b});
    } else if (b == v) {
        assert(b == v);
        up.insert({a, b});
    }
    for (int u : g2[v]) {
        if (used[u])
            continue;
        if (has.count({v, u})) {
            down.insert({v, u});
        }
        if (has.count({u, v})) {
            up.insert({u, v});
        }
    }
    for (int u : g2[v]) {
        if (!used[u]) {
            if (dp[u][0]) {
                dfs2(u);
            } else if (dp[u][1]) {
                down.erase({v, u});
                dfs2(u, v, u);
            } else {
                up.erase({u, v});
                dfs2(u, u, v);
            }
        }
    }
    assert(up.size() == down.size());
    auto it1 = up.begin();
    auto it2 = down.begin();
    while (it1 != up.end()) {
        ans.push_back({it1->first, it1->second, it2->first, it2->second});
        it1++;
        it2++;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    g2.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g2[a].push_back(b);
        g2[b].push_back(a);
        has.insert({a, b});
    }
    used.assign(n, 0);
    dp.resize(n, vector<int> (3));
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs1(i);
            if (!dp[i][0]) {
                cout << "No" << endl;
                return 0;
            }
        }
    }
    used.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs2(i);
        }
    }
    assert(2 * ans.size() == m);
    cout << "Yes" << endl;
    for (auto el : ans) {
        for (int el1 : el) {
            cout << el1 + 1 << " ";
        }
        cout << endl;
    }
}
