#include <iostream>
#include <vector>

using namespace std;

struct Edge {
    int from, to;
    explicit Edge() {
    }
    Edge(int f, int t) {
        from = f;
        to = t;
    }
};

const int MAX_N = 6666;

vector<int> graph[MAX_N];
int match[MAX_N];
int used[MAX_N];

int timer = 1;

bool findChain(int v) {
    if (used[v] == timer) {
        return false;
    }
    used[v] = timer;
    for (int u : graph[v]) {
        if (used[u] != timer && (match[u] == -1 || findChain(match[u]))) {
            match[u] = v;
            match[v] = u;
            return true;
        }
    }
    return false;
}


int main() {
    int n; cin >> n;
    int m; cin >> m;
    vector<Edge> edges;
    for (int i = 0; i < m; i++) {
        int f, t; cin >> f >> t;
        edges.emplace_back(f, t);
    }
    for (int i = 0; i < m; i++) {
        for (int j = i + 1; j < m; j++) {
            Edge a = edges[i];
            Edge b = edges[j];
            if (a.to == b.from || b.to == a.from) {
                graph[i].push_back(j);
                graph[j].push_back(i);
            }
        }
    }
    fill(match, match + MAX_N, -1);
    for (int i = 0; i < m; i++) {
        if (match[i] == -1) {
            for (int j : graph[i]) {
                if (match[j] == -1) {
                    match[i] = j;
                    match[j] = i;
                    break;
                }
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (match[i] == -1) {
            findChain(i);
            timer++;
        }
    }
    fill(used, used + MAX_N, false);
    vector<pair<Edge, Edge>> answer;
    for (int i = 0; i < m; i++) {
        if (match[i] == -1) {
            cout << "No" << endl;
            return 0;
        } else {
            if (!used[i]) {
                used[i] = used[match[i]] = true;
                answer.emplace_back(edges[i], edges[match[i]]);
            }
        }
    }
    cout << "Yes" << endl;
    for (auto x : answer) {
        cout << x.first.from << ' ' << x.first.to << ' ' << x.second.from << ' ' << x.second.to << endl;
    }
}
