#include <bits/stdc++.h>

template<class T>
std::istream& operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}
template<class T>
std::ostream& operator<<(std::ostream &out, const std::vector<T> &a) {
    for (auto &x : a)
        out << x << " ";
    return out;
}

template<class T, class U>
std::istream& operator>>(std::istream &in, std::pair<T, U> &a) {
    in >> a.first >> a.second;
    return in;
}
template<class T, class U>
std::ostream& operator<<(std::ostream &out, const std::pair<T, U> &a) {
    out << a.first << " " << a.second;
    return out;
}

int n, m;
std::vector<std::pair<int, int>> e;
std::vector<std::vector<int>> fg;
std::vector<std::set<int>> g, rg;
std::vector<int> used, h, childs, par;
std::set<std::pair<int, int>> leaf_q;

void dfs(int v) {
    used[v] = true;
    for (auto &to : fg[v]) {
        if (!used[to]) {
            childs[v]++;
            h[to] = h[v] - 1;
            par[to] = v;
            dfs(to);
        }
    }
    if (!childs[v])
        leaf_q.emplace(h[v], v);
}
void TARAH_BABAH() {
    std::cout << "No\n";
    std::exit(0);
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0), std::cout.tie(0);
    std::cin >> n >> m;
    g.resize(n);
    rg.resize(n);
    fg.resize(n);
    std::vector<int32_t> income(n), outcome(m);
    for (int ind = 0; ind < m; ++ind) {
        int u, v;
        std::cin >> u >> v, --u, --v;
        g[u].emplace(e.size());
        rg[v].emplace(e.size());
        e.emplace_back(u, v);
        fg[u].emplace_back(v);
        fg[v].emplace_back(u);
    }
    used.assign(n, 0);
    h.assign(n, 0);
    childs.assign(n, 0);
    par.assign(n, -1);
    std::vector<std::pair<int, int>> ans;
    for (int root = 0; root < n; ++root) {
        if (!used[root]) {
            dfs(root);
            while (!leaf_q.empty()) {
                int v = leaf_q.begin()->second;
                leaf_q.erase(leaf_q.begin());
                if (!g[v].empty() && !rg[v].empty()) {
                    assert(g[v].size() == 1 && rg[v].size() == 1);
                    ans.emplace_back(*g[v].begin(), *rg[v].begin());
                    int p = e[*g[v].begin()].second;
                    g[p].erase(*rg[v].begin());
                    rg[p].erase(*g[v].begin());
                    g[v].erase(*g[v].begin());
                    rg[v].erase(*rg[v].begin());
                    childs[p]--;
                    if (childs[p] == 0) {
                        leaf_q.emplace(h[p], p);
                    }
                } else if (!g[v].empty()) {
                    assert(g[v].size() == 1);
                    int p = e[*g[v].begin()].second;
                    if (g[p].size() > 0) { //
                        int othind = *g[p].begin();
                        int oth = e[othind].second; // e[g[p]] = {p, oth};
                        if (oth == par[p] && g[p].size() == 1) { // go kill edge to grandpa
                            ans.emplace_back(*g[v].begin(), othind);
                            rg[p].erase(*g[v].begin());
                            g[v].erase(*g[v].begin());
                            childs[p]--; // now there is no childs
                            if (childs[p]) {
                                /*
                                 * EHAT HAT MEANS??
                                 * that means that we stil have edge from some child to p
                                 * but we can't pair it
                                 * so it is easy to see that this is no situation
                                 */
                                TARAH_BABAH(); // go to JAIL
                            }
                            g[p].erase(othind);
                            rg[oth].erase(othind);
                            if (rg[p].size()) { // has backedge from grandpa
                                leaf_q.emplace(h[p], p);
                            } else {
                                --childs[oth];
                                if (childs[oth] == 0) {
                                    leaf_q.emplace(h[oth], oth);
                                }
                            }
                        } else { // go kill edge to oth child;
                            if (oth == par[p]) {
                                othind = *(++g[p].begin());
                                oth = e[othind].second; // now it is child (sibling)
                            }
                            assert(childs[oth] == 0);
                            ans.emplace_back(*g[v].begin(), othind);
                            rg[p].erase(*g[v].begin());
                            g[v].erase(*g[v].begin());
                            childs[p]--;
                            g[p].erase(othind);
                            rg[oth].erase(othind);
                            if (g[oth].empty()) {
                                --childs[p];
                                leaf_q.erase(std::make_pair(h[oth], oth));
                            }
                            if (childs[p] == 0) {
                                leaf_q.emplace(h[p], p);
                            }
                        }
                    } else { // there is no oth edges go to jail
                        TARAH_BABAH();
                    }
                } else if (!rg[v].empty()) { // COPYPASTE IS BAD SO CHECK HERE IF BUG
                    assert(rg[v].size() == 1);
                    int p = e[*rg[v].begin()].first;
                    if (rg[p].size() > 0) { //
                        int othind = *rg[p].begin();
                        int oth = e[othind].first; // e[rg[p]] = {oth, p};
                        if (oth == par[p] && rg[p].size() == 1) { // go kill edge from grandpa
                            ans.emplace_back(*rg[v].begin(), othind);
                            g[p].erase(*rg[v].begin());
                            rg[v].erase(*rg[v].begin());
                            childs[p]--; // now there is no childs
                            if (childs[p]) {
                                /*
                                 * EHAT HAT MEANS??
                                 * that means that we stil have edge from p to some child
                                 * but we can't pair it
                                 * so it is easy to see that this is no situation
                                 */
                                TARAH_BABAH(); // go to JAIL
                            }
                            rg[p].erase(othind);
                            g[oth].erase(othind);
                            if (g[p].size()) { // has edge to grandpa
                                leaf_q.emplace(h[p], p);
                            } else {
                                --childs[oth];
                                if (childs[oth] == 0) {
                                    leaf_q.emplace(h[oth], oth);
                                }
                            }
                        } else { // go kill edge from oth child;
                            if (oth == par[p]) {
                                othind = *(++rg[p].begin());
                                oth = e[othind].first; // now it is child (sibling)
                            }
                            assert(childs[oth] == 0);
                            ans.emplace_back(*rg[v].begin(), othind);
                            g[p].erase(*rg[v].begin());
                            rg[v].erase(*rg[v].begin());
                            childs[p]--;
                            rg[p].erase(othind);
                            g[oth].erase(othind);
                            if (rg[oth].empty()) {
                                --childs[p];
                                leaf_q.erase(std::make_pair(h[oth], oth));
                            }
                            if (childs[p] == 0) {
                                leaf_q.emplace(h[p], p);
                            }
                        }
                    } else { // there is no oth edges go to jail
                        TARAH_BABAH();
                    }
                } else {
                    continue;
                }
            }
        }
    }
    std::cout << "Yes\n";
    for (auto &[i, j] : ans) {
        if (e[i].second != e[j].first)
            std::swap(i, j);
        std::cout << e[i].first + 1 << " " << e[i].second + 1 << " " <<
                e[j].first + 1 << " " << e[j].second + 1 << "\n";
    }
    return 0;
}
