#include <bits/stdc++.h>

template<class T>
std::istream& operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}
template<class T>
std::ostream& operator<<(std::ostream &out, const std::vector<T> &a) {
    for (auto &x : a)
        out << x << " ";
    return out;
}

template<class T, class U>
std::istream& operator>>(std::istream &in, std::pair<T, U> &a) {
    in >> a.first >> a.second;
    return in;
}
template<class T, class U>
std::ostream& operator<<(std::ostream &out, const std::pair<T, U> &a) {
    out << a.first << " " << a.second;
    return out;
}

const int64_t INF = 1e9;

std::vector<std::vector<int>> g;
std::vector<std::pair<std::pair<int, int>, int64_t>> e;
std::vector<int64_t> tin, fup, used;
std::vector<int64_t> bridges, is_bridge;
std::vector<int64_t> col;
int curtime = 0;
void dfsb(int v, int pind = -1) {
    tin[v] = fup[v] = curtime++;
    used[v] = true;
    for (auto ind : g[v]) {
        if (ind == pind)
            continue;
        int to = e[ind].first.first ^ e[ind].first.second ^ v;
        if (used[to]) {
            fup[v] = std::min(fup[v], tin[to]);
        } else {
            dfsb(to, ind);
            fup[v] = std::min(fup[v], fup[to]);
            if (fup[to] > tin[v]) {
                bridges.emplace_back(ind);
                is_bridge[ind] = true;
            }
        }
    }
}
std::vector<std::vector<std::pair<int, int64_t>>> cg;
std::vector<int64_t> cmin;
void dfs_paint(int v, int curcol, int p = -1) {
    col[v] = curcol;
    for (auto ind : g[v]) {
        int to = e[ind].first.first ^ e[ind].first.second ^ v;
        if (!is_bridge[ind])
            cmin[curcol] = std::min(cmin[curcol], e[ind].second);
        if (to == p)
            continue;
        if (is_bridge[ind]) {
            if (col[to] != -1)
                cg[col[v]].emplace_back(col[to], e[ind].second), cg[col[to]].emplace_back(col[v], e[ind].second);
            continue;
        }
        cmin[curcol] = std::min(cmin[curcol], e[ind].second);
        if (col[to] == -1)
            dfs_paint(to, curcol, v);
    }
}

std::vector<int64_t> min;
void cdfs(int v, int p = -1) {
    min[v] = std::min(min[v], cmin[v]);
    for (auto &[to, t] : cg[v]) {
        if (to == p)
            continue;
        min[to] = std::min(min[v], t);
        cdfs(to, v);
    }
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0), std::cout.tie(0);
    int n, m;
    std::cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        std::cin >> u >> v >> t, --u, --v;
        g[u].emplace_back(e.size());
        g[v].emplace_back((e.size()));
        e.emplace_back(std::pair{u, v}, t);
    }
    is_bridge.assign(m, 0);
    tin.assign(n, 0);
    fup.assign(n, 0);
    col.assign(n, -1);
    used.assign(n, 0);
    dfsb(0);
    //std::cerr << fup << "   !!   " << tin << std::endl;
    //std::cerr << bridges;
    int curcol = 0;
    for (int v = 0; v < n; ++v) {
        if (col[v] == -1) {
            cg.emplace_back(std::vector<std::pair<int, int64_t>>(0));
            cmin.emplace_back(INF);
            min.emplace_back(INF);
            dfs_paint(v, curcol++);
        }
    }
    cdfs(0);
    for (int i = 1; i < n; ++i)
        std::cout << min[col[i]] + INF << "\n";
    return 0;
}
