#include <bits/stdc++.h>

template<class T>
std::istream& operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}
template<class T>
std::ostream& operator<<(std::ostream &out, const std::vector<T> &a) {
    for (auto &x : a)
        out << x << " ";
    return out;
}

template<class T, class U>
std::istream& operator>>(std::istream &in, std::pair<T, U> &a) {
    in >> a.first >> a.second;
    return in;
}
template<class T, class U>
std::ostream& operator<<(std::ostream &out, const std::pair<T, U> &a) {
    out << a.first << " " << a.second;
    return out;
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0), std::cout.tie(0);
    int n, m;
    std::cin >> n >> m;
    //assert(n < 7);
    std::vector<std::vector<int>> g(n);
    std::vector<std::pair<std::pair<int, int>, int64_t>> e;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        std::cin >> u >> v >> t, --u, --v;
        g[u].emplace_back(e.size());
        g[v].emplace_back((e.size()));
        e.emplace_back(std::pair{u, v}, t);
    }
    std::vector<std::vector<bool>> dp(n, std::vector<bool>(1<<m));
    dp[0][0] = 1;
    for (int mask = 0; mask < 1 << m; ++mask) {
        for (int v = 0; v < n; ++v) {
            if (dp[v][mask]) {
                for (int ind : g[v]) {
                    if (!(mask >> ind & 1)) {
                        int to = e[ind].first.first ^e[ind].first.second ^v;
                        dp[to][mask | (1 << ind)] = 1;
                    }
                }
            }
        }
    }
    std::vector<int64_t> calc(1 << m);
    for (int mask = 0; mask < 1 << m; ++mask) {
        int64_t min = 1e9, max = 0;
        for (int ind = 0; ind < m; ++ind) {
            if (mask >> ind & 1)
                min = std::min(min, e[ind].second), max = std::max(max, e[ind].second);
        }
        calc[mask] = min + max;
    }
    for (int v = 1; v < n; ++v) {
        int64_t best = 2e9;
        for (int mask = 0; mask < 1 << m; ++mask) {
            if (dp[v][mask])
                best = std::min(best, calc[mask]);
        }
        std::cout << best << "\n";
    }
    return 0;
}
