#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define pb push_back
#define ff first
#define ss second
#define mp make_pair
#define rep(i, n) for(int i = 0; i < (n); ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)

using namespace std;

const int inf = 2e9;

struct Edge {
    int v, to, w;

    Edge() {}

    Edge(int v, int to, int w) : v(v), to(to), w(w) {}
};

struct DSU {
    vector<int> pr;
    vector<vector<int>> sets;

    DSU() {}

    DSU(int n) {
        rep(i, n) pr.pb(i);
        sets.resize(n);
        rep(i, n) {
            sets[i].pb(i);
        }
    }

    int get(int a) {
        if (a == pr[a]) return a;
        pr[a] = get(pr[a]);
        return pr[a];
    }

    void unite(int a, int b) {
        a = get(a);
        b = get(b);
        if (sets[a].size() < sets[b].size()) swap(a, b);
        for (auto el : sets[b]) {
            sets[a].pb(el);
        }
        sets[b].clear();
        pr[b] = a;
    }
};

void run() {
    int n, m;
    cin >> n >> m;
    vector<Edge> edges;
    DSU dsu(n);
    rep(i, m) {
        int v, to, w;
        cin >> v >> to >> w;
        v--;
        to--;
//        if (v == 0 || to == 0) dsu.unite(v, to);
        edges.pb(Edge(v, to, w));
    }
    sort(all(edges), [](Edge e1, Edge e2) {
        return e1.w < e2.w;
    });
    edges.pb(Edge(-1, -1, -1));

    vector<int> mx(n, -inf);
    vector<int> cur;
    int last = -2;
    for (auto edge : edges) {
        if (edge.v == -1) continue;
        if (dsu.get(edge.v) == dsu.get(edge.to)) continue;
        if (dsu.get(edge.v) == dsu.get(0)) {
            for (auto el : dsu.sets[dsu.get(edge.to)]) {
                mx[el] = max(mx[el], edge.w);
            }
        } else if (dsu.get(edge.to) == dsu.get(0)) {
            for (auto el : dsu.sets[dsu.get(edge.v)]) {
                mx[el] = max(mx[el], edge.w);
            }
        }
        dsu.unite(edge.v, edge.to);
    }
    rep(i, n) {
        if (i == 0) continue;
        cout << mx[i] << '\n';
    }
}

signed main() {
//    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        run();
    return 0;
}
