#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <unordered_set>
#include <set>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <utility>
#include <climits>
#define all(z) z.begin(), z.end()
#define pb push_back
#define eb emplace_back
using namespace std;
using vi  = vector<int>;
using pii  = pair<int, int>;


constexpr int N{150000};
map<int, int> E[N];
bool used[N];
vector<tuple<int, int, int>> ans;
const pii no_e = {-1, -1};


pii dfs(int v, int from = -1)
{
    assert(!used[v]);
    used[v] = true;
    vector<int> dw, up; // edges that go down and up
    for (auto [u, vt] : E[v])
    {
        if (u == from)
            continue;

        auto [fr, to] = dfs(u, v);
        int ut = (to == u) - (fr == u);
        //cout <<"! " << v+1 << ' ' << u+1 << ' ' << vt << ' ' << ut << '\n';

        if (vt == ut)
        {
            if (vt == 1)
                ans.eb(fr, u, v);
            else if (vt == -1)
                ans.eb(v, u, to);
            else
                ans.eb(v, u, v);
        }
        else if (vt + ut == 0)
        {
            cout << "No";
            exit(0);
        }
        else if (vt == 0)
        {
            if (ut == 1)
            {
                ans.eb(fr, u, v);
                dw.pb(u);
            }
            else // vu == 2
            {
                assert(ut == -1);
                ans.eb(v, u, to);
                up.pb(u);
            }
        }
        else if (vt == 1)
            up.pb(u);
        else
        {
            assert(vt == -1);
            dw.pb(u);
        }
    }

    while (!dw.empty() && !up.empty())
    {
        ans.eb(up.back(), v, dw.back());
        up.pop_back();
        dw.pop_back();
    }

    int sup = up.size(), sdw = dw.size();

    if (max(sup, sdw) >= 2)
    {
        cout << "No";
        exit(0);
    }
    if (!sup && !sdw)
        return no_e;
    if (sup)
        return {up[0], v};
    else
    {
        assert(sdw == 1);
        return {v, dw[0]};
    }
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        u--; v--;
        E[u][v]--;
        E[v][u]++;
    }

    bool ok = true;
    for (int v = 0; v < n && ok; v++)
        if (!used[v])
            ok = dfs(v) == no_e;

    if (!ok)
        cout << "No";
    else
    {
        cout << "Yes\n";
        for (auto [u, v, w] : ans)
        {
            cout << u+1 << ' ' << v+1 << ' ' << v+1 << ' ' << w+1 << '\n';
        }
    }

    return 0;
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/
