#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <utility>
#include <queue>
#define pb push_back
#define eb emplace_back
using namespace std;
using vi  = vector<int>;
using pii  = pair<int, int>;


struct Edge
{
    int to, t, id;
    Edge(int _to, int _t, int _id):
        to(_to), t(_t), id(_id) {}
};


constexpr int N{300000};
constexpr int INF{1000000000};
vector<Edge> E[N];
int ans[N];

constexpr int M{20}, M2{1ll << M};
int d[M][M];
bool dp[M2][M];
int  mn[M2][M], mx[M2][M];

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    setvbuf(stdout, nullptr, _IOFBF, 8192);
    setvbuf(stdin , nullptr, _IOFBF, 8192);

    int n, m;
    scanf("%d %d", &n, &m);

    for (int i = 0; i < m; i++)
    {
        int u, v, t;
        scanf("%d %d %d", &u, &v, &t);
        u--; v--;
        E[v].eb(u, t, i);
        E[u].eb(v, t, i);
    }

    dp[0][0] = true;
    mn[0][0] = INF;
    mx[0][0] = 0;

    for (int mask = 0; mask < 1ll<<m; mask++)
    {
        for (int v = 0; v < n; v++)
        {
            if (!dp[mask][v])
                continue;
            for (auto [u, t, id] : E[v])
            {
                int mask2 = mask | (1ll << id);
                if (mask2 != mask)
                {
                    dp[mask2][u] = true;
                    mn[mask2][u] = min(t, mn[mask][v]);
                    mx[mask2][u] = max(t, mx[mask][v]);
                }
            }
        }
    }

    fill_n(ans, n, 2*INF);
    for (int mask = 0; mask < 1ll<<m; mask++)
    {
        for (int v = 0; v < n; v++)
            if (dp[mask][v])
            {
                ans[v] = min(ans[v], mn[mask][v]+mx[mask][v]);
            }
    }

    for (int i = 1; i < n; i++)
        printf("%d ", ans[i]);

    return 0;
}
/*
4 3
1 2 1
2 3 5
3 4 0

4 4
1 2 0
1 3 0
3 4 7
2 4 9
*/

