#include <bits/stdc++.h>

using namespace std;

#define Edge pair<int, int>
#define t second
#define u first

const int MAXN = 3e5 + 100;
bitset<MAXN> vis;
vector<vector<Edge>> graph;
vector<set<int>> gg;
vector<vector<int>> ggv;

void dfs0(int v) {
    vis[v] = true;
    for (int u : ggv[v]) {
        if (vis[u])
            continue;
        if (!gg[u].count(v)) {
            graph[v].push_back({u, -1});
        } else if (!gg[v].count(u)) {
            graph[v].push_back({u, 1});
        } else {
            graph[v].push_back({u, 0});
        }
        dfs0(u);
    }
}

const Edge INV = {-100, -100};

vector<pair<Edge, Edge>> ans;

void addedg(int v, int u, int w) {
    ans.push_back({{v, u}, {u, w}});
}

Edge dfs(int v) {
    if (graph[v].empty())
        return {-1, 0};
    int bal = 0;
    vector<Edge> e1, em1;
    for (auto &e : graph[v]) {
        auto re = dfs(e.u);
        int rr = re.t;
        int r;
        if (re == INV)
            return INV;
        if (e.t == 1 && rr == -1)
            return INV;
        if (e.t == -1 && rr == 1)
            return INV;
        if (e.t == 1 && rr == 1)
            r = 0, addedg(re.u, e.u, v);
        if (e.t == -1 && rr == -1)
            r = 0, addedg(v, e.u, re.u);
        if (e.t == 0 && rr == -1)
            r = 1, addedg(v, e.u, re.u);
        if (e.t == 0 && rr == 1)
            r = -1, addedg(re.u, e.u, v);
        if (e.t == 1 && rr == 0)
            r = 1;
        if (e.t == -1 && rr == 0)
            r = -1;
        if (e.t == 0 && rr == 0)
            r = 0, addedg(v, e.u, v);
        bal += r;
        if (r == -1)
            em1.emplace_back(e.u, -1);
        if (r == 1)
            e1.emplace_back(e.u, 1);
        while (!e1.empty() && !em1.empty()) {
            addedg(e1.back().u, v, em1.back().u);
            e1.pop_back();
            em1.pop_back();
        }
    }
    if (bal < -1 || bal > 1)
        return INV;
    if (bal == 0)
        return {-1, 0};
    if (bal == 1)
        return e1.back();
    return em1.back();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    gg.resize(n);
    ggv.resize(n);
    graph.resize(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        ggv[v].push_back(u);
        ggv[u].push_back(u);
        gg[v].insert(u);
    }
    vector<int> rts;
    for (int v = 0; v < n; ++v) {
        if (vis[v])
            continue;
        rts.push_back(v);
        dfs0(v);
    }
    for (int v : rts) {
        auto bal = dfs(v);
        if (bal.t != 0) {
            cout << "No";
            return 0;
        }
    }
    cout << "Yes\n";
    for (auto pp : ans) {
        cout << pp.first.first + 1 << ' ' << pp.first.second + 1 << ' ';
        cout << pp.second.first + 1 << ' ' << pp.second.second + 1 << '\n';
    }
}