#include <bits/stdc++.h>

using namespace std;

struct Edge {
    int u, t;

    bool operator<(const Edge &o) const {
        return t < o.t;
    }
};

int n, m;

vector<vector<Edge>> graph;
vector<int> ans;
const int MAXN = 3e5 + 100;
bitset<MAXN> used;

void dfsTree(int v, int p, vector<int> &mxx, vector<int> &mnn, int mx, int mn) {
    mxx[v] = mx;
    mnn[v] = mn;
    for (auto &e : graph[v]) {
        if (e.u == p)
            continue;
        dfsTree(e.u, v, mxx, mnn, max(mx, e.t), min(mn, e.t));
    }
}

void solve1() {
    vector<int> mxx(n), mnn(n);
    dfsTree(0, -1, mxx, mnn, 0, 1e9);
    for (int i = 1; i < n; ++i) {
        cout << mxx[i] + mnn[i] << '\n';
    }
}

void solve2() {
    vector<int> dist(n, 1e9);
    dist[0] = 0;
    set<pair<int, int>> Q;
    Q.emplace(0, 0);
    while (!Q.empty()) {
        auto[d, v] = *Q.begin();
        Q.erase(Q.begin());
        for (auto &e : graph[v]) {
            int nd = max(d, e.t);
            if (dist[e.u] <= nd)
                continue;
            Q.erase(make_pair(dist[e.u], e.u));
            Q.emplace(nd, e.u);
            dist[e.u] = nd;
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << dist[i] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    ans.resize(n);
    graph.resize(n);
    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--, u--;
        graph[v].push_back({u, w});
        graph[u].push_back({v, w});
    }
    if (m == n - 1) {
        solve1();
        return 0;
    }
    int mx1 = max_element(graph[0].begin(), graph[0].end())->t;
    int mn1 = min_element(graph[0].begin(), graph[0].end())->t;
    if (mx1 == 0) {
        solve2();
        return 0;
    }
}