#include <iostream>
#include <vector>
#include <bitset>
#include <map>
#include <deque>
#include <cassert>
#include <set>
#include <functional>
#include <queue>
#include <unordered_set>

using namespace std;

#pragma GCC optimize("Ofast")

 int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> x(n);
    vector<int> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    for (int t = 0; t < q; ++t) {
        int l, r;
        cin >> l >> r;
        --l; --r;
        int left = x[0];
        int right = x.back();
        if (l != 0) {
            left = x[l - 1];
        }
        if (r != n - 1) {
            right = x[r + 1];
        }
        queue<int> q;
        set<int> alive;
        vector<bool> used(n, false);
        for(int i = l; i <= r; ++i) {
            alive.insert(i);
        }
        for (int i = l; i < r; ++i) {
            if (!used[i] && x[i] + h[i] <= x[i + 1]) {
                used[i] = true;
                q.push(i);
            }
        }
        if (!used[l] && x[l] - h[l] >= left) {
            used[l] = true;
            q.push(l);
        }
        if (!used[r] && x[r] + h[r] <= right) {
            used[r] = true;
            q.push(r);
        }
        for (int i = l + 1; i <= r; ++i) {
            if (!used[i] && x[i] - h[i] >= x[i - 1]) {
                q.push(i);
                used[i] = true;
            }
        }
        int ans = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            ++ans;
            auto ptr = alive.lower_bound(v);
            int pr = left;
            int prev = -1;
            int next = -1;
            int nx = right;
            ++ptr;
            if (ptr != alive.end()) {
                next = *ptr;
                nx = x[next];
            }
            --ptr;
            if (ptr != alive.begin()) {
                --ptr;
                prev = *ptr;
                pr = x[prev];
            }
            alive.erase(v);
            if (next != -1 && !used[next] && x[next] - h[next] >= pr) {
                used[next] = true;
                q.push(next);
            }
            if (prev != -1 && !used[prev] && x[prev] + h[prev] <= nx) {
                used[prev] = true;
                q.push(prev);
            }
        }
        cout << ans << '\n';
    }
}
/*
 5 6
 1 2
 2 1
 1 5
 2 3
 2 4
 4 2


 4 4
 2 1
 2 3
 2 4
 4 2


 4 4
 1 2
 2 1
 3 4
 4 3
 */