#include <iostream>
#include <vector>
#include <bitset>
#include <map>
#include <set>

using namespace std;

#define int long long

void solveg2(int n, int m, vector<vector<pair<int, int>>> &g) {
    set<pair<int, int>> q;
    q.insert({ 0, 0 });
    vector<int> dist(n, 1e18);
    dist[0] = 0;
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto [u, w] : g[v]) {
            if (dist[u] > max(dist[v], w)) {
                q.erase({ dist[u], u });
                dist[u] = max(dist[v], w);
                q.insert({ dist[u], u });
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << dist[i] << ' ';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    bool g2 = true;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        if (w != 0) {
            g2 = false;
        }
        g[u].push_back({ v, w });
        g[v].push_back({ u, w });
    }
    if (g2) {
        solveg2(n, m, g);
        return 0;
    }
    return 0;
}
/*
 5 6
 1 2
 2 1
 1 5
 2 3
 2 4
 4 2


 4 4
 2 1
 2 3
 2 4
 4 2


 4 4
 1 2
 2 1
 3 4
 4 3
 */