#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define left left228
#define right right228
#define all(v) v.begin(), v.end()

const int N = 300 * 1000 + 7;
const int INF = 1e18 + 228;

int n, m;
vector< pair<int, int> > g[N];

int mint[N];
int maxt[N];

void treefs(int v, int tMin = INF, int tMax = -INF, int par = -1) {
	mint[v] = tMin;
	maxt[v] = tMax;
	for (pair<int, int> go : g[v]) {
		int to = go.first;
		int t = go.second;

		if (to != par) {
			treefs(to, min(tMin, t), max(tMax, t), v);
		}
	}
}


struct edge
{
	int u, v, t;
	edge() {}
	edge(int _u, int _v, int _t) {
		u = _u;
		v = _v;
		t = _t;
	}
};

vector< edge > edges;

int T[N];
int a[N];
int pref_min[N], pref_max[N];

void solve() {
	for (int i = 1; i <= n; ++i) {
		a[i] = INF;
	}
	for (int v = 1; v < n; ++v) {
		for (pair<int, int> go : g[v]) {
			int to = go.first;
			int t = T[go.second];
			if (to == v + 1 && t < a[v]) {
				a[v] = t;
			}
			if (to == v - 1 && t < a[v - 1]) {
				a[v - 1] = t;
			}
		}
	}
	pref_min[0] = INF;
	for (int i = 1; i <= n; ++i) {
		pref_max[i] = max(pref_max[i - 1], a[i]);
		pref_min[i] = min(pref_min[i - 1], a[i]);
	}

	for (int i = 2; i <= n; ++i) {
		cout << pref_max[i - 1] + pref_min[i - 1] << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;

	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		g[u].emplace_back(v, i);
		g[v].emplace_back(u, i);
		T[i] = t;
		edges.emplace_back(u, v, t);
	}

	solve();
	return 0;
}


/*

4 4
1 2 2
3 2 0
2 4 3
4 3 1

*/