#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <cassert>

#define IO
#define endl '\n'
#define int long long
#define float long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

vector<int> mos;

const int inf = 1e18;

void solve(string &s) {
	int n = s.size();
	for (int i = 0; i < n; ++i) {
		if (s[i] == '?') {
			s[i] = -1;
		} else {
			s[i] -= 'A';
		}
	}
	vector<vector<int>> dp(n, vector<int>(26, -inf)), dx(n, vector<int>(26, -1));
	vector<vector<int>> byk(26, vector<int>(n, -inf));
	if (s[n - 1] == -1) {
		for (int i = 0; i < 26; ++i) {
			dp[n - 1][i] = mos[i];
			dx[n - 1][i] = n - 1;
			byk[i][n - 1] = mos[i];
		}
	} else {
		for (int i = s[n - 1]; i < 26; ++i) {
			dp[n - 1][i] = mos[s[n - 1]];
			dx[n - 1][i] = n - 1;
			byk[i][n - 1] = mos[s[n - 1]];
		}
	}
	for (int i = n - 2; i >= 0; --i) {
		for (int j = 0; j < 26; ++j) {
			for (int k = i + 1; k < n; ++k) {
				int a = s[k] == -1 ? j : s[k];
				if (s[i] == -1) {
					--byk[j][k];
				} else {
					if (s[i] < a) {
						byk[j][k] -= mos[s[i]];
					} else {
						byk[j][k] = -inf;
					}
				}
			}
			int a = s[i] == -1 ? j : s[i];
			byk[j][i] = mos[a] + dp[i + 1][a];
		}
		int c = 0;
		for (int j = i; j < n; ++j) {
			if (s[j] != -1 && s[j] > c) {
				c = s[j];
			}
		}
		for (int j = c; j < 26; ++j) {
			for (int k = i; k < n; ++k) {
				if (dp[i][j] < byk[j][k]) {
					dp[i][j] = byk[j][k];
					dx[i][j] = k;
				}
			}
		}
	}
	cout << dp[0][25] << endl;
	string ans(n, 0);
	for (int i = 0, j = 25; i < n;) {
		int k = dx[i][j];
		assert(k != -1);
		int a = s[k] == -1 ? j : s[k];
		for (int l = i; l < k; ++l) {
			if (s[l] == -1) {
				ans[l] = 0;
			} else {
				ans[l] = s[l];
			}
		}
		ans[k] = a;
		i = k + 1;
		j = a;
	}
	for (int i = 0; i < n; ++i) {
		ans[i] += 'A';
	}
	cout << ans << endl;
}

#ifdef int
#undef int
int
#define int long long
#else
int
#endif
main() {
#ifdef IO
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	int n;
	cin >> n;
	vector<string> s(n);
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	mos.resize(26);
	mos[0] = 1;
	mos[1] = 5;
	for (int i = 0; i + 2 < 26; ++i) {
		mos[i + 2] = mos[i] * 10;
	}
	for (int i = 0; i < n; ++i) {
		solve(s[i]);
	}
	return 0;
}