#include <iostream>
#include <vector>
#include <sstream>
#include <set>
#include <map>
#include <assert.h>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long LL;
typedef unsigned long long ULL;

map<char, LL> vals;

void initVals() {
	LL current = 1;
	for (char v = 'A'; v <= 'Z'; v++)
	{
		vals[v] = current;
		if ((v - 'A') % 2 == 0) {
			current *= 5;
		}
		else {
			current *= 2;
		}
	}
}

LL calcOnSubstring(string& s, int from, int to, char maxLeft) {
	char maxChar = maxLeft;
	LL answer = 0ll;
	for (int i = to - 1; i >= from; i--)
	{
		if (s[i] >= maxChar) {
			answer += vals[s[i]];
		}
		else {
			answer -= vals[s[i]];
		}
		maxChar = max(maxChar, s[i]);
	}

	return answer;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	initVals();

	int t;
	cin >> t;
	while (t--) {
		string s;
		cin >> s;
		vector<bool> predefined(s.size(), false);

		char maxChar = 'A';
		//bool foundX = false;
		char maxOnLast = 'A';

		int questionCnt = 0;
		vector<int> questionPos;

		for (int i = s.size() - 1; i >= 0; i--)
		{
			if (s[i] == '?') {
				questionCnt++;
				continue;
			}
			if (s[i] < maxChar) {
				predefined[i] = true;
			}
			if (s[i] > maxChar) {
				maxChar = s[i];
				if (questionCnt == 0) {
					maxOnLast = maxChar;
				}
			}
			if (questionCnt == 0) {
				predefined[i] = true;
			}
		}


		string predef = "", s1 = "";

		questionPos.push_back(-1);

		for (int i = 0; i < s.size(); i++)
		{
			if (predefined[i]) {
				predef += s[i];
			}
			else {
				if (s[i] == '?') {
					questionPos.push_back(s1.size());
				}
				s1 += s[i];
			}
		}
		vector<vector<LL>> dp(questionCnt + 1, vector<LL>(26, 0));

		//int lastPos = -1;
		for (int i = 1; i < questionPos.size(); i++)
		{
			for (char c = maxOnLast; c <= 'Z'; c++)
			{
				LL res = LLONG_MIN;
				for (char v = c; v <= 'Z'; v++)
				{
					LL cur = dp[i - 1][v - 'A'];
					res = max(res, cur);
				}

				res += calcOnSubstring(s1, questionPos[i - 1] + 1, questionPos[i], c) + vals[c];

				dp[i][c - 'A'] = res;
			}
		}

		LL answer = calcOnSubstring(predef, 0, predef.size(), 'A');
		
		LL maxAns = LLONG_MIN;
		char chosen = 'A';
		for (char i = 0; i < 26; i++)
		{
			if (dp[questionCnt][i] > maxAns) {
				maxAns = max(maxAns, dp[questionCnt][i]);
				chosen = 'A' + i;
			}
			
		}
		if (questionCnt == 0) {
			maxAns = 0;
		}



		LL ans = maxAns;
		if (questionCnt > 0) {
			for (int i = questionCnt - 1; i > 0; i--)
			{
				s1[questionPos[i + 1]] = chosen;
				ans -= calcOnSubstring(s1, questionPos[i] + 1, questionPos[i + 1], chosen) + vals[chosen];
				char nchosen = '\0';
				for (char j = chosen; j <= 'Z'; j++)
				{
					if (dp[i][j - 'A'] == ans) {
						nchosen = j;
						break;
					}
				}

				assert(nchosen != '\0');
				chosen = nchosen;
			}

			s1[questionPos[1]] = chosen;
		}
		

		string a = "";
		int sId = 0, pId = 0;

		for (int i = 0; i < predefined.size(); i++)
		{
			if (predefined[i]) {
				a += predef[pId];
				pId++;
			}
			else {
				a += s1[sId];
				sId++;
			}
		}

		cout << answer + maxAns << endl;
		cout << a << endl;
	}
}