//#define _GLIBCXX_DEBUG
#include <iostream>
#include <string>
#include <queue>
#include <climits>
#include <set>
#include <random>
#include <cmath>
#include <cstdio>
#include <vector>
#include <array>

std::vector<char> e_used;
std::vector<int> ans;
std::vector<int> edges;
std::vector<std::vector<std::pair<int,int>>> graph;
void dfs(int at, int ei, int min, int max)
{
	ans[at] = std::min(ans[at], min+max);
	e_used[ei] = true;
	for(auto[to, ei2] : graph[at])
	{
		if(e_used[ei2]) continue;
		dfs(to, ei2, std::min(min, edges[ei2]), std::max(max, edges[ei2]));
	}
	e_used[ei] = false;
}
int main(int argc, char*argv[])
{
	int n, m; std::cin >> n >> m;
	//for each min edge use the path in a minimum spanning tree including it
	//max is fixed -> find min bottleneck path
	graph.resize(n);
	e_used.resize(m+1); edges.resize(m);
	ans.resize(n, INT_MAX);
	for(int i = 0; i < m; i++)
	{
		int u,v,w; scanf("%d%d%d", &u, &v, &w); u--; v--;
		graph[u].push_back({v, i});
		graph[v].push_back({u, i});
		edges[i] = w;
	}
	dfs(0, m, INT_MAX, INT_MIN);
	for(int i = 1; i < n; i++)
		printf("%d\n", ans[i]);
}
