#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <cmath>

using namespace std;

int cnt12;
int cnt21;

void dfs2(int v, vector <vector<pair<pair<int, int>, int>>> &graph, vector <int> &usedd, vector <int> &ans, int maxx) {
    if (v != 0) {
        ans[v] = min(ans[v], maxx);
    }
    for (auto nw : graph[v]) {
        if (usedd[nw.first.first] == 0) {
            int stmax = maxx;
            if (maxx < nw.first.second) {
                maxx = nw.first.second;
            }
            usedd[nw.first.first] = 1;
            dfs2(nw.first.first, graph, usedd, ans, maxx);
            usedd[nw.first.first] = 0;
            maxx = stmax;
        }
    }
}


void dfs(int v,vector <int> &ans, vector <vector<pair<pair<int, int>, int>>> &graph, vector<int> &used, int minn, int maxx) {
    if (v != 0) {
        ans[v] = min(ans[v], minn + maxx);
    }
    for (auto nw : graph[v]) {
        if (used[nw.second] == 0) {
            int stmin = minn;
            int stmax = maxx;
            if (minn > nw.first.second) {
                minn = nw.first.second;
            }
            if (maxx < nw.first.second) {
                maxx = nw.first.second;
            }
            used[nw.second] = 1;
            dfs(nw.first.first, ans, graph, used, minn, maxx);
            used[nw.second] = 0;
            minn = stmin;
            maxx = stmax;
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    vector <vector<pair<pair<int, int>, int>>> graph(n);
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        v--;
        u--;
        graph[v].push_back({{u, t}, i});
        graph[u].push_back({{v, t}, i});
    }
    vector <int> ans(n, 2000000009);
    int minn = 2000000000;
    int maxx = -1;
    vector <int> used(m);
    if (m == n - 1 or (n <= 20 and m <= 20)) {
        dfs(0, ans, graph, used, minn, maxx);
        for (int y = 1; y < n; y++) {
            cout << ans[y] << "\n";
        }
    }
    else {
        set <pair<int, int>> deq;
        deq.insert({-1, 0});
        while (deq.size() != 0) {
            int v = deq.begin() -> second;
            int nm = deq.begin() -> first;
            for (auto nw : graph[v]) {
                int nmax = max(nm, nw.second);
                if (ans[nw.first.first] < nmax) {
                    deq.erase({ans[nw.first.first], nw.first.first});
                    ans[nw.first.first] = nmax;
                    deq.insert({ans[nw.first.first], nw.first.first});
                }
            }
        }
        for (int y = 1; y < n; y++) {
            cout << ans[y] << "\n";
        }
    }
}