from functools import lru_cache


d = {'A': 1, 'B': 5,
     'C': 10, 'D': 50,
     'E': 100, 'F': 500,
     'G': 10 ** 3, 'H': 5 * 10 ** 3,
     'I': 10 ** 4, 'J': 5 * 10 ** 4,
     'K': 10 ** 5, 'L': 5 * 10 ** 5,
     'M': 10 ** 6, 'N': 5 * 10 ** 6,
     'O': 10 ** 7, 'P': 5 * 10 ** 7,
     'Q': 10 ** 8, 'R': 5 * 10 ** 8,
     'S': 10 ** 9, 'T': 5 * 10 ** 9,
     'U': 10 ** 10, 'V': 5 * 10 ** 10,
     'W': 10 ** 11, 'X': 5 * 10 ** 11,
     'Y': 10 ** 12, 'Z': 5 * 10 ** 12}

def score(s, rpl=''):
    res = 0
    mxch = 'A'
    i = 0
    for ch in reversed(s):
        if ch == '?':
            ch = rpl[i]
            i += 1
        if ch < mxch:
            res -= d[ch]
        else:
            mxch = ch
            res += d[ch]
    return res

def get_all(n, mins):
    if n == 1:
        return list([ch for ch in d.keys() if ch >= mins[0]])
    prev = get_all(n - 1, mins[1:])
    res = []
    for el in prev:
        res.extend([ch + el for ch in d.keys()
            if ch >= max(mins[0], el[0])])
    return res

def solve(s):
    if '?' not in s:
        return [score(s), s]
    pec = s.split('?')
    m = len(pec) - 1
    dps = [dict() for _ in range(m)]
    dp = [dict() for _ in range(m)]
    for i, k in enumerate(pec[:-1]):
        for ch in d.keys():
            dps[i][ch] = score(k + ch)
    sc = score(pec[-1])
    dp.append({ch: [sc, None] for ch in d.keys()})
    for i in reversed(range(m)):
        mx = dp[i + 1]['A'][0]
        mxch = 'A'
        for ch in sorted(d.keys()):
            if dp[i + 1][ch][0] > mx:
                mx = dp[i + 1][ch][0]
                mxch = ch
            dp[i][ch] = [mx + dps[i][ch], mxch]
    res = ''
    fsc, fch = dp[0]['A'][0], 'A'
    for x in d.keys():
        if dp[0][x][0] > fsc:
            fsc, fch = dp[0][x][0], x
    for i, k in enumerate(pec[:-1]):
        res += k
        res += fch
        fch = dp[i][fch][1]
    res += pec[-1]
    return fsc, res


rs = []
for _ in range(int(input())):
    rs.extend(solve(input()))
print(*rs, sep='\n')
