#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e18;
const ll MOD = 228228227;

map <char, ll> alphabet;

inline ll get_answer(vector <char> &s, vector <char> &result, vector <bool> &sign, ll &result_answer, ll current_answer) {
    ll right_largest = 0;
    for (int i = (int) s.size() - 1; i >= 0; i--) {
        if (s[i] == '?') {
           ll current, new_answer = -INF;
           for (char c = 'A'; c <= 'Z'; c++) {
                current = alphabet[c];
                if (right_largest > current) current *= -1;
                sign[i] = right_largest <= current;
                s[i] = c;

                vector <bool> prevsign = sign;
                for (int j = 0; j < i; j++) {
                    if (s[j] != '?' && sign[j] && c > s[j]) {
                        current -= alphabet[s[j]] * 2;
                        sign[j] = false;
                    }
                }

                new_answer = max(new_answer, get_answer(s, result, sign, result_answer, current_answer + current));
                sign = prevsign;
           }

           s[i] = '?';
           return new_answer;
        }

        right_largest = max(right_largest, alphabet[s[i]]);
    }

    if (result_answer < current_answer) {
        result = s;
        result_answer = current_answer;
    }

    return current_answer;
}

inline void solve() {
    string str_s;
    cin >> str_s;

    vector <char> s(str_s.begin(), str_s.end());

    int n = s.size();
    deque <pair <ll, int>> maxdq;
    for (int i = 0; i < n; i++) {
        if (s[i] == '?') continue;
        while (!maxdq.empty() && alphabet[s[i]] > maxdq.back().first)
            maxdq.pop_back();

        maxdq.push_back({alphabet[s[i]], i});
    }

    vector <bool> sign(n);

    ll answer = 0;
    for (int i = 0; i < n; i++) {
        if (!maxdq.empty() && maxdq.front().second == i)
            maxdq.pop_front();

        if (s[i] == '?') {
            continue;
        } else {
            if (!maxdq.empty() && maxdq.front().first > alphabet[s[i]]) {
                answer -= alphabet[s[i]];
            } else {
                answer += alphabet[s[i]];
            }
        }

        if (!maxdq.empty() && maxdq.front().first > alphabet[s[i]]) {
            sign[i] = false;
        } else {
            sign[i] = true;
        }
    }

    vector <char> result;
    ll result_answer = -INF;

    get_answer(s, result, sign, result_answer, answer);

    cout << result_answer << '\n';
    for (char x: result)
        cout << x;
    cout << '\n';
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    alphabet['A'] = 1;
    for (char c = 'B'; c <= 'Z'; c++) {
        alphabet[c] = alphabet[(char)(c - 1)] * ((c - 'A') % 2 == 0 ? 2 : 5);
    }

    int t;
    cin >> t;

    while (t--)
    solve();
}
