#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e18;
const ll MOD = 228228227;

map <char, ll> alphabet;

inline void solve() {
    string str_s;
    cin >> str_s;

    vector <char> s(str_s.begin(), str_s.end());

    int n = s.size();
    deque <pair <ll, int>> maxdq;
    for (int i = 0; i < n; i++) {
        if (s[i] == '?') continue;
        while (!maxdq.empty() && alphabet[s[i]] > maxdq.back().first)
            maxdq.pop_back();

        maxdq.push_back({alphabet[s[i]], i});
    }

    vector <bool> isq(n);
    for (int i = 0; i < n; i++)
        isq[i] = s[i] == '?';

    vector <bool> sign(n);
    map <char, ll> qcount, positive_count;

    deque <pair <char, int>> qchanges;

    ll answer = 0;
    for (int i = 0; i < n; i++) {
        if (!maxdq.empty() && maxdq.front().second == i)
            maxdq.pop_front();

        ll maxright = !maxdq.empty() ? maxdq.front().first : 0;

        if (s[i] == '?') {
            ll current_change, new_change = -INF, new_ch = '-';
            for (char c = 'A'; c <= 'Z'; c++) {
                if (maxright > alphabet[c]) continue;

                current_change = alphabet[c];

                for (int cq = 'A'; cq < c; cq++) {
                    current_change += qcount[cq] * alphabet[c] - qcount[cq] * alphabet[cq];
                }

                for (int cx = 'A'; cx < c; cx++) {
                    current_change -= positive_count[cx] * alphabet[cx] * 2;
                }

                if (current_change > new_change) {
                    new_change = current_change;
                    new_ch = c;
                }
            }

            for (char c = 'A'; c < new_ch; c++) {
                qcount[new_ch] += qcount[c];
                qcount[c] = 0;

                positive_count[c] = 0;
            }

            while (!qchanges.empty() && qchanges.back().first < new_ch) {
                    qchanges.pop_back();
            }

            qchanges.push_back({new_ch, i});
            answer += new_change;
        } else {
            if (!maxdq.empty() && maxdq.front().first > alphabet[s[i]]) {
                answer -= alphabet[s[i]];
            } else {
                answer += alphabet[s[i]];
                positive_count[s[i]]++;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (s[i] == '?') {
            while (qchanges.front().second < i)
                qchanges.pop_front();

            s[i] = qchanges.front().first;
        }
    }

    cout << answer << '\n';
    for (char x: s)
        cout << x;
    cout << '\n';
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    alphabet['A'] = 1;
    for (char c = 'B'; c <= 'Z'; c++) {
        alphabet[c] = alphabet[(char)(c - 1)] * ((c - 'A') % 2 == 0 ? 2 : 5);
    }

    int t;
    cin >> t;

    while (t--)
    solve();
}
