#pragma  GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e9;
const ll MOD = 228228227;

inline void solve() {
    int n, q;
    cin >> n >> q;

    int x, h;
    vector <pair <int, int>> trees(n);
    for (auto &tree:  trees)
        cin >> tree.first >> tree.second;

    vector <pair <int, int>> spaces(n);
    for (int i = 0; i < n; i++) {
        if (i - 1 >= 0) spaces[i].first = trees[i].first - trees[i - 1].first;
        if (i + 1 < n) spaces[i].second = trees[i + 1].first - trees[i].first;
    }

    int l, r;
    set <pair <int, int>> noncut;
    vector <pair <int, int>> qspaces;
    vector <bool> cut;

    auto can_cut = [&] (int i) {
        int frx = trees[i].first + trees[i].second;
        bool rc = qspaces[i].second >= trees[i].second && frx <= trees[n - 1].first;

        int flx = trees[i].first - trees[i].second;
        bool lc = qspaces[i].first >= trees[i].second && flx >= trees[0].first;

        return rc || lc;
    };

    for (int i = 0; i < n; i++)
        noncut.insert({trees[i].first, i});

    while (q--) {
        cut.assign(n, false);
        qspaces = spaces;

        cin >> l >> r;
        l--; r--;

        int answer = 0;
        for (int k = l; k < r + 1; k++) {
            bool fucked = true;
            for (int i = l; i < r + 1; i++) {
                if (cut[i]) continue;

                if (can_cut(i)) {
                    cut[i] = true;
                    noncut.erase({trees[i].first, i});

                    answer++;
                    fucked = false;

                    if (noncut.empty()) break;
                    auto rit = noncut.upper_bound({trees[i].first, 0});
                    if (rit != noncut.end()) qspaces[(*rit).second].first += qspaces[i].first;

                    auto lit = prev(rit);
                    if (lit != noncut.end()) qspaces[(*lit).second].second += qspaces[i].second;
                }
            }

            if (fucked) break;
        }

        for (int i = l; i < r + 1; i++) {
            if (cut[i]) {
                noncut.insert({trees[i].first, i});
            }
        }

        cout << answer << '\n';
    }
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
