#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>

#define maxN 500000
#define k 71

struct Tree {
	long long x, h;
} trees[maxN];

struct Forest {
	long long l, r;
	std::vector<long long> t;
} blocks[k];

struct Request {
	long long l, r, i;
} r[maxN];

long long n, q, ans[maxN];
std::deque<long long> st1;
std::vector<long long> st2;

long long cut(long long xl, long long xr) {
	if (st1.empty()) {
		return xr;
	}
	long long curTree = st1[st1.size() - 1];
	st1.pop_back();
	if (trees[curTree].x - xl >= trees[curTree].h) {
		return cut(xl, xr);
	}
	else {
		long long xrNow = cut(trees[curTree].x, xr);
		if (xrNow - trees[curTree].x >= trees[curTree].h) {
			return cut(xl, xr);
		}
		st1.push_back(curTree);
	}
	return trees[curTree].x;
}

void build(long long i) {
	for (long long j = std::min((i + 1) * k, n) - 1; j >= i * k ; j--) {
		st1.push_back(j);
	}
	cut(blocks[i].l, blocks[i].r);
	while (!st1.empty()) {
		blocks[i].t.push_back(st1[st1.size() - 1]);
		st1.pop_back();
	}
	return;
}

long long cut2(long long xl, long long xr) {
	if (st2.empty()) {
		return xr;
	}
	long long curTree = st2[st2.size() - 1];
	st2.pop_back();
	if (trees[curTree].x - xl >= trees[curTree].h) {
		return cut2(xl, xr);
	}
	else {
		long long xrNow = cut(trees[curTree].x, xr);
		if (xrNow - trees[curTree].x >= trees[curTree].h) {
			return cut2(xl, xr);
		}
		st2.push_back(curTree);
	}
	return trees[curTree].x;
}

bool cmp(Request& r1, Request& r2) {
	if (r1.l / k < r2.l / k) {
		return true;
	}
	if (r1.l / k > r2.l / k) {
		return false;
	}
	if (r1.l < r2.l) {
		return true;
	}
	if (r1.l > r2.l) {
		return false;
	}
	if (r1.i < r2.i) {
		return true;
	}
	return false;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cin >> n >> q;
	for (long long i = 0; i < n; i++) {
		std::cin >> trees[i].x >> trees[i].h;
	}
	blocks[0].l = trees[0].x;
	for (long long i = 1; i < (n + k - 1) / k; i++) {
		blocks[i - 1].r = trees[i * k].x;
		blocks[i].l = trees[i * k - 1].x;
	}
	blocks[(n - 1) / k].r = trees[n - 1].x;
	for (long long i = 0; i < (n + k - 1) / k; i++) {
		build(i);
	}
	for (long long i = 0; i < q; i++) {
		std::cin >> r[i].l >> r[i].r;
		r[i].l--;
		r[i].i = i;
	}
	std::sort(r, r + q, cmp);
	long long lastBlock = 0, lastR = k;
	for (long long i = 0; i < q; i++) {
		if (r[i].l / k == lastBlock) {
			for (long long j = lastR; j < r[i].r; j++) {
				if (j % k == 0 && j + k <= r[i].r) {
					for (long long h = 0; h < blocks[j / k].t.size(); h++) {
						st1.push_front(blocks[j / k].t[h]);
					}
					j += k - 1;
				}
				else {
					st1.push_front(j);
				}
				lastR = j + 1;
			}
			cut(trees[std::min((lastBlock + 1) * k, n) - 1].x, trees[std::min(r[i].r, n) - 1].x);
			st2 = {};
			for (long long j = (long long)st1.size() - 1; j >= 0; j--) {
				st2.push_back(st1[j]);
			}
			for (long long j = std::min((lastBlock + 1) * k, r[i].r) - 1; j >= r[i].l; j--) {
				st2.push_back(j);
			}
			cut2(trees[std::max(r[i].l - 1, (long long)0)].x, trees[std::min(r[i].r, n) - 1].x);
			ans[r[i].i] = r[i].r - r[i].l - st2.size();
		}
		else {
			lastBlock = r[i].l / k;
			st1 = {};
			lastR = (lastBlock + 1) * k;
			i--;
		}
	}
	for (long long i = 0; i < q; i++) {
		std::cout << ans[i] << "\n";
	}
	return 0;
}