#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
 
#define all(x) (x).begin(), (x).end()
#define print(x) {for (auto xxxxx : (x)) cout << xxxxx << ' '; cout << '\n';}
 
const ll inf = 2e18;
const int intf = 2e9;

#define fi first
#define se second

bool bit(int mask, int j) {
    return ((mask >> j) & 1);
}

struct edge {
    int u, v, t;
};

int n, m;
vector < vector <pii> > g;
vector <edge> e;
vector <bool> avail, was;

int dfs(int v) {
    was[v] = true;
    int ans = 1;
    for (auto to : g[v]) {
        if (was[to.first] || !avail[to.second])
            continue;
        ans += dfs(to.first);
    }
    return ans;
}

int DEBUG;

int try_find() {
    vector <int> sz(n, 0);
    was.assign(n, false);
    int odd = 0, cnt = 0;
    int snd;
    for (int v = 0; v < n; v++) {
        bool f = false;
        for (auto to : g[v]) {
            sz[v] += avail[to.second];
            f |= avail[to.second];
        }
        cnt += f;
        odd += (sz[v] % 2);
        if ((sz[v] % 2))
            snd = v;
    }
    if ((odd == 2 && sz[0] % 2 == 1 && dfs(0) == cnt))
        return snd;
    else
        return -1;
}

void solve_eul() {
    avail.resize(m);
    vector <int> d(n, intf);
    for (int mask = 0; mask < (1 << m); mask++) {
        DEBUG = mask;
        int mn = intf, mx = 0;
        avail.assign(m, false);
        for (int j = 0; j < m; j++) {
            if (bit(mask, j)) {
                avail[j] = true;
                mn = min(mn, e[j].t);
                mx = max(mx, e[j].t);
            }
        }

        int x = try_find();
        if (x == -1)
            continue;
        d[x] = min(d[x], mn + mx);
    }
    for (int i = 1; i < n; i++) {
        cout << d[i] << '\n';
    }
}

vector <ll> r_mn, r_mx;

void dfs_tree(int v, int p = -1) {
    for (auto to : g[v]) {
        if (to.first == p)
            continue;
        r_mn[to.first] = min(r_mn[v], (ll)e[to.second].t);
        r_mx[to.first] = max(r_mx[v], (ll)e[to.second].t);
        dfs_tree(to.first, v);
    }
}

void solve_tree() {
    r_mn.resize(n, 0);
    r_mx.resize(n, 0);
    dfs_tree(0);
    for (int i = 1; i < n; i++) {
        cout << r_mn[i] + r_mx[i] << '\n';
    }
}

void solve() {
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v, t; cin >> u >> v >> t; u--, v--;
        g[u].emplace_back(v, i);
        g[v].emplace_back(u, i);
        e.push_back({u, v, t});
    }
    if (m == n - 1) {
        solve_tree();
        return;
    }
    if (m <= 20) {
        solve_eul();
        return;
    }
}
 
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.precision(20);
 
    int t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }
 
    return 0;
}