#include <iostream>
#include <vector>
#include <cstdio>
#include <cassert>
#include <algorithm>
#include <cmath>

using namespace std;
#define all(x) x.begin(), x.end()
#define x first
#define y second

const int N   = 5e5 + 10;
int K;
const int B   = N / 10 + 1;
const int INF = 1e9;
const int H   = 1e7;

int *ptr[H];
int  val[H];
int  len;

void save(int &x) {
	ptr[len] = &x;
	val[len] =  x;
	++len;
}
void backup(int to) {
	while (len > to) {
		--len;
		*ptr[len] = val[len];
	}
}

struct qt {
	int l;
	int r;
	int i;
	qt(int a, int b, int c) : l(a), r(b), i(c) {}
};
bool operator<(qt a, qt b) {
	return a.r < b.r;
}

int n, q, saved[N];
pair<int, int> a[N];
vector<qt> bl[B];

int deq[2  * N];
int dl = N, dr = N - 1;
int clef = N, crig = 0;

void add_rig(int i) {
	clef = min(clef, i);
	crig = max(crig, i);
	int p = dl <= dr ? deq[dr] : clef - 1;
	if (a[i].x - a[i].y < a[p].x) {
		save(dr);
		++dr;
		save(deq[dr]);
		deq[dr] = i;
	}
	while (dl <= dr && a[deq[dr]].x + a[deq[dr]].y <= a[i + 1].x) {
		save(dr);
		--dr;
	}
}

void add_lef(int i) {
	clef = min(clef, i);
	crig = max(crig, i);
	int p = dl <= dr ? deq[dl] : crig + 1;
	if (a[i].x + a[i].y > a[p].x) {
		save(dl);
		--dl;
		save(deq[dl]);
		deq[dl] = i;
	}
	while (dl <= dr && a[deq[dl]].x - a[deq[dl]].y >= a[i - 1].x) {
		save(dl);
		++dl;
	}
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> q;
	K = (int)sqrt(max((int)sqrt((double)n * n), 100));
	for (int i = 1; i <= n; ++i) {
		cin >> a[i].x >> a[i].y;
	}
	a[0] = {a[1].x, INF};	
	a[n + 1] = {a[n].x, INF};

	for (int l, r, i = 0; i < q; ++i) {
		cin >> l >> r;
		bl[l / K].emplace_back(l, r, i);
	}

	for (int b = 0; b <= n / K; ++b) {
		sort(all(bl[b]));
		int ff = (b + 1) * K;
		backup(0);
		clef = N, crig = 0;
		for (qt e : bl[b]) {
			while (ff <= e.r) {
				add_rig(ff++);
			}
			int point = len;
			int was = clef;
			for (int i = min(e.r, (b + 1) * K - 1); i >= e.l; --i) {
				add_lef(i);
			}
			saved[e.i] = (e.r - e.l + 1) - (dr - dl + 1);
			backup(point);
			clef = was;
		}
	}

	for (int i = 0; i < q; ++i) {
		cout << saved[i] << "\n";
	}
#ifdef LC
	cout << 1000 * clock() / CLOCKS_PER_SEC << "ms" << endl;
#endif
	return 0;
}