#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple
#define x first
#define y second
#define int ll

const int N   = 3e5 + 10;
const int INF = 1e18;

struct dsu_t {
	int par[N];
	dsu_t() {
		iota(par, par + N, 0);
	}
	int get(int v) {
		return par[v] == v ? v : (par[v] = get(par[v]));
	}
	bool merge(int v, int u) {
		v = get(v), u = get(u);
		par[v] = u;
		return v != u;
	}
} dsu;

int n, m;
vector<tuple<int, int, int>> sorted;
vector<pair<int, int>> mst[N], g[N];
int saved[N];

int in[N], up[N], ti;

void bridge_dfs(int v, int pv, int pw) {
	in[v] = up[v] = ti++;
	for (auto &e : g[v]) {
		int u = e.x;
		if (u == pv && e.y == pw) {
			continue;
		}
		if (!in[u]) {
			bridge_dfs(u, v, e.y);
			up[v] = min(up[v], up[u]);
		} else {
			up[v] = min(up[v], in[u]);
		}
	}
}

bool bridge(int v, int u) {
	return in[v] < up[u] || in[u] < up[v];
}

int comp[N], cmin[N], cc;

void comp_dfs(int v) {
	comp[v] = cc;
	for (auto e : g[v]) {
		int u = e.x;
		if (bridge(v, u)) {
			continue;
		}
		cmin[cc] = min(cmin[cc], e.y);
		if (!comp[u]) {
			comp_dfs(u);
		}
	}
}

void solve_dfs(int v, int p, int mx, int mn) {
	mn = min(mn, cmin[comp[v]]);
	saved[v] = min(saved[v], mn + mx);
	for (auto e : mst[v]) {
		int u = e.x;
		if (u == p) {
			continue;
		}
		solve_dfs(u, v, max(mx, e.y), min(mn, e.y));
	}
}

void solve(int value) {
	for (int i = 0; i < n; ++i) {
		g[i].clear();
		in[i] = 0;
		up[i] = 0;
		comp[i] = 0;
	}
	for (auto e : sorted) {
		int w, v, u;
		tie(w, v, u) = e;
		if (w <= value) {
			g[v].emplace_back(u, w);
			g[u].emplace_back(v, w);
		} else {
			break;
		}
	}
	ti = 1;
	for (int v = 0; v < n; ++v) {
		if (in[v]) {
			continue;
		}
		bridge_dfs(v, -1, -1);
	}
	cc = 0;
	for (int v = 0; v < n; ++v) {
		if (comp[v]) {
			continue;
		}
		++cc;
		cmin[cc] = INF;
		comp_dfs(v);
	}
	solve_dfs(0, -1, value, INF);
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> m;
	for (int v, u, w, i = 0; i < m; ++i) {
		cin >> v >> u >> w;
		--v, --u;
		sorted.emplace_back(w, v, u);
	}
	sort(all(sorted));
	vector<int> values;
	for (auto e : sorted) {
		int w, v, u;
		tie(w, v, u) = e;
		if (dsu.merge(v, u)) {
			// cout << v + 1 << " " << u + 1 << " " << w << endl;
			mst[v].emplace_back(u, w);
			mst[u].emplace_back(v, w);
		} else {
			values.push_back(w);
		}
	}
	assert(is_sorted(all(values)));
	values.erase(unique(all(values)), values.end());

	fill_n(saved, N, (int)2e9);
	solve(-1);
	for (int e : values) {
		solve(e);
	}
	for (int i = 1; i < n; ++i) {
		cout << saved[i] << "\n";
	}
	return 0;
}