#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
#define int long long

int n, m;

struct edge
{
	int u, v;
	int w;
	int i;
	int s;

	edge() {}

	edge(int u, int v, int w, int i, int s) : u(u), v(v), w(w), i(i), s(s) {}
};

vector <int> g[100];
vector <edge> eds;
vector <int> used;
int c = 1;

inline void add_edge(int u, int v, int w, int i)
{
	g[u].push_back(eds.size());
	eds.push_back({ u, v, w, i, (int)eds.size() + 1 });
	g[v].push_back(eds.size());
	eds.push_back({ v, u, w, i, (int)eds.size() - 1 });
}

int ans[100];

void dfs(int u, int mini, int maxi)
{
	ans[u] = min(ans[u], mini + maxi);
	for (auto v : g[u]) if (used[v] != c)
	{
		used[v] = c;
		used[eds[v].s] = c;

		dfs(eds[v].v, min(mini, eds[v].w), max(maxi, eds[v].w));

		used[v] = 0;
		used[eds[v].s] = 0;
	}
}
signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 1; i <= m; ++i)
	{
		int u, v, w;
		cin >> u >> v >> w;
		add_edge(u, v, w, i);
	}

	for (int i = 1; i <= n; ++i) ans[i] = 2e9 + 10;

	used.resize(eds.size());

	dfs(1, 1e9 + 1, 0);

	for (int i = 2; i <= n; ++i) cout << ans[i] << '\n';
	return 0;
}