#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
#define int long long

int n, m;

struct edge
{
	int u, v;
	int w;
	int i;
	int s;

	edge() {}

	edge(int u, int v, int w, int i, int s) : u(u), v(v), w(w), i(i), s(s) {}
};

vector <int> g[300010];
vector <edge> eds;

inline void add_edge(int u, int v, int w, int i)
{
	g[u].push_back(eds.size());
	eds.push_back({ u, v, w, i, (int)eds.size() + 1 });
	g[v].push_back(eds.size());
	eds.push_back({ v, u, w, i, (int)eds.size() - 1 });
}

vector <bool> banned;
int was[300010];
int tin[300010];
int fup[300010];
int timer;

void dfs(int u, int p)
{
	was[u] = true;
	tin[u] = fup[u] = timer++;

	for (auto v : g[u]) if (eds[v].i != p)
	{
		if (was[eds[v].v])
		{
			fup[u] = min(fup[u], tin[eds[v].v]);
		}
		else
		{
			dfs(eds[v].v, eds[v].i);
			fup[u] = min(fup[u], fup[eds[v].v]);
			if (fup[eds[v].v] > tin[u])
			{
				banned[eds[v].i] = true;
			}
		}
	}
}

int cmp[300010];
vector <vector <int>> cmps;

inline void clear()
{
	for (int i = 1; i <= n; ++i) was[i] = false;
}

void dfs_cmp(int u)
{
	if (was[u]) return;
	was[u] = true;
	cmps.back().push_back(u);
	cmp[u] = cmps.size();

	for (auto v : g[u]) if (!banned[eds[v].i])
	{
		dfs_cmp(eds[v].v);
	}
}

vector <pair <int, int>> gn[300010];
int cmp_ans[300010];

int ans[300010];

void dfs_ans(int u, int ans_p)
{
	ans_p = min(ans_p, cmp_ans[u]);

	for (auto i : cmps[u]) ans[i] = ans_p;

	for (auto v : gn[u])
	{
		dfs_ans(v.first, min(ans_p, v.second));
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 1; i <= m; ++i)
	{
		int u, v, w;
		cin >> u >> v >> w;
		add_edge(u, v, w, i);
	}

	banned.resize(m + 1);

	clear();
	for (int i = 1; i <= n; ++i)
	{
		if (was[i]) continue;
		dfs_cmp(i);
	}

	for (int i = 0; i < eds.size(); ++i)
	{
		if (!banned[eds[i].i]) continue;
		gn[cmp[eds[i].u]].push_back({ cmp[eds[i].v], eds[i].w });
	}

	for (int i = 0; i < cmps.size(); ++i)
	{
		cmp_ans[i] = 1e9 + 1;
		for (auto u : cmps[i])
		{
			for (auto v : g[u])
			{
				if (!banned[eds[v].i]) cmp_ans[i] = min(cmp_ans[i], eds[v].w);
			}
		}
	}

	dfs_ans(1, 1e9 + 1);

	for (int i = 2; i <= n; ++i)
	{
		cout << ans[i] + 1000000000 << '\n';
	}
	return 0;
}