#include <cassert>
#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
using namespace std;


pair < long long, string > ch(string s) {
	int n = s.length();
	vector < long long > vl(26);
	vl[0] = 1;
	for (int i = 1; i < 26; i++) {
		if (i % 2)
			vl[i] = vl[i - 1] * 5;
		else
			vl[i] = vl[i - 1] * 2;
	}

	vector < int > id(n, -1);
	for (int i = 0; i < n; i++) {
		if (s[i] != '?')
			id[i] = s[i] - 'A';
	}

	vector < vector < int > > p1(n, vector < int >(26));
	vector < vector < int > > p2(n, vector < int >(26));
	vector < vector < long long > > dp(n, vector < long long >(26));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 26; j++) {
			if (i == 0) {
				if (s[i] == '?') {
					dp[i][j] = 'Z';
					p1[i][j] ='Z' - 'A';
					p2[i][j] = -1;
				}
				else {
					if (id[i] >= j) {
						dp[i][j] = vl[id[i]];
						p1[i][j] = id[i];
						p2[i][j] = -1;
					}
					else {
						dp[i][j] = -vl[id[i]];
						p1[i][j] = id[i];
						p2[i][j] = -1;
					}
				}
			}
			else {
				if (s[i] == '?') {
					dp[i][j] = -2e18;
					for (int k = 0; k < 26; k++) {
						if (k >= j) {
							if (dp[i][j] < dp[i - 1][k] + vl[k]) {
								dp[i][j] = dp[i - 1][k] + vl[k];
								p1[i][j] = k;
								p2[i][j] = k;
							}
						}
						else {
							if (dp[i][j] < dp[i - 1][j] - vl[k]) {
								dp[i][j] = dp[i - 1][j] - vl[k];
								p1[i][j] = k;
								p2[i][j] = j;
							}
						}
					}
				}
				else {
					if (id[i] >= j) {
						dp[i][j] = dp[i - 1][id[i]] + vl[id[i]];
						p1[i][j] = id[i];
						p2[i][j] = id[i];
					}
					else {
						dp[i][j] = dp[i - 1][j] - vl[id[i]];
						p1[i][j] = id[i];
						p2[i][j] = j;
					}
				}
			}
		}
	}

	long long res = -2e18, st;
	for (int i = 0; i < 26; i++) {
		if (res < dp[n - 1][i]) {
			res = dp[n - 1][i];
			st = i;
		}
	}

	int i = n - 1;
	string ans = "";
	while (i >= 0 && st > -1) {
		ans += p1[i][st] + 'A';
		st = p2[i][st];
		i--;
	}
	reverse(ans.begin(), ans.end());

	return { res, ans };
}


int main() {
	iostream::sync_with_stdio(0);
	vector < long long > vl(26);
	vl[0] = 1;
	for (int i = 1; i < 26; i++) {
		if (i % 2)
			vl[i] = vl[i - 1] * 5;
		else
			vl[i] = vl[i - 1] * 2;
	}

	int t;
	cin >> t;

	for (; t; t--) {
		string s;
		cin >> s;
		
		
		int n = s.length();

		vector < int > id;
		for (int i = 0; i < n; i++) {
			if (s[i] == '?')
				id.push_back(i);
		}

		pair < long long, string > cch = ch(s);
		cout << cch.first << "\n" << cch.second << "\n";
	}

	/*for (int seed = 1; seed <= 1000; seed++) {
		int n = 1000;
		cout << seed << "\n";
		srand(seed);
		string s;
		for (int i = 0; i < n; i++)
			s += rand() % 26 + 'A';
		int ft = rand() % n;
		int sd = rand() % n;
		int fd = rand() % n;
		s[ft] = '?';
		s[sd] = '?';
		s[fd] = '?';

		cout << s << "\n";
		pair < long long, string > cch = ch(s);


		vector < int > id;
		for (int i = 0; i < n; i++) {
			if (s[i] == '?')
				id.push_back(i);
		}

		string rs;
		long long max_res = -2e18;
		if (id.size() == 1) {
			for (int i = 0; i < 26; i++) {
				s[id[0]] = i + 'A';
				long long res = 0;
				char mn = 'A';
				for (int i = n - 1; i >= 0; i--) {
					if (s[i] >= mn) {
						res += vl[s[i] - 'A'];
						mn = s[i];
					}
					else
						res -= vl[s[i] - 'A'];
				}
				if (max_res < res)
					rs = s;
				max_res = max(max_res, res);
			}
		}
		else  if (id.size() == 2) {
			for (int i = 0; i < 26; i++)
				for (int j = 0; j < 26; j++) {
					s[id[0]] = i + 'A';
					s[id[1]] = j + 'A';
					long long res = 0;
					char mn = 'A';
					for (int i = n - 1; i >= 0; i--) {
						if (s[i] >= mn) {
							res += vl[s[i] - 'A'];
							mn = s[i];
						}
						else
							res -= vl[s[i] - 'A'];
					}
					if (max_res < res)
						rs = s;
					max_res = max(max_res, res);
				}
		}
		else  if (id.size() == 3) {
			for (int i = 0; i < 26; i++)
				for (int j = 0; j < 26; j++)
					for (int k = 0; k < 26; k++) {
						s[id[0]] = i + 'A';
						s[id[1]] = j + 'A';
						s[id[2]] = k + 'A';
						long long res = 0;
						char mn = 'A';
						for (int i = n - 1; i >= 0; i--) {
							if (s[i] >= mn) {
								res += vl[s[i] - 'A'];
								mn = s[i];
							}
							else
								res -= vl[s[i] - 'A'];
						}
						if (max_res < res)
							rs = s;
						max_res = max(max_res, res);
					}
		}

		assert(max_res == cch.first && rs == cch.second);
	}*/
	return 0;
}
/*
4
BBBC
????
A?B?C?D
YYYYY?
*/