#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

vector<pair<long long, pair<long long, long long>>> trees;  // <x, <h, ind>>
long long taken[8192], launch = 1;
long long n, x, h, qr, l, r, left_border, right_border;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> qr;
    for (int i = 0; i < n; i++) {
        cin >> x >> h;
        trees.push_back({x, {h, i}});
    }

    queue<pair<long long, pair<long long, long long>>> q;
    pair<long long, pair<long long, long long>> cur;
    long long count;
    set<pair<long long, pair<long long, long long>>>::iterator left, right;

    while (qr--) {
        launch++;
        cin >> l >> r;
        set<pair<long long, pair<long long, long long>>> temp;

        if (l == 1) left_border = trees[l - 1].first;
        else left_border = trees[l - 2].first;
        if (r == n) right_border = trees[r - 1].first;
        else right_border = trees[r].first;

        for (long long i = l - 1; i < r; i++) {
            if (i > 0 and trees[i].first - trees[i - 1].first >= trees[i].second.first) {
                q.push(trees[i]);
                taken[trees[i].second.second] = launch;
            } else if (i < n - 1 and trees[i + 1].first - trees[i].first >= trees[i].second.first) {
                q.push(trees[i]);
                taken[trees[i].second.second] = launch;
            }
            temp.insert(trees[i]);
        }
        count = 0;
        while (!q.empty()) {
            cur = q.front();
            left = temp.lower_bound(cur);
            right = left;
            right++;
            if (right != temp.end() and left != temp.begin()) {
                left--;

                // O(1)
                if (right->first - left->first >= right->second.first) {
                    if (taken[right->second.second] != launch) {
                        q.push(*right);
                        taken[right->second.second] = launch;
                    }
                }

                // O(1)
                if (right->first - left->first >= left->second.first) {
                    if (taken[left->second.second] != launch) {
                        q.push(*left);
                        taken[left->second.second] = launch;
                    }
                }
            } else if (right != temp.end()) {
                // O(1)
                if (right->second.first <= right->first - left_border) {
                    if (taken[right->second.second] != launch) {
                        q.push(*right);
                        taken[right->second.second] = launch;
                    }
                }
            } else if (left != temp.begin()) {
                // O(1)
                left--;
                if (left->second.first <= right_border - left->first) {
                    if (taken[left->second.second] != launch) {
                        q.push(*left);
                        taken[left->second.second] = launch;
                    }
                }
            }
            // O(log n)
            temp.erase(cur);
            count++;
            q.pop();
        }
        cout << count << '\n';
    }
}