#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

struct Tree {
    int x = 0, h = 0;

    Tree(int x = 0, int h = 0, int i = 0) {
        this->x = x;
        this->h = h;
    }

    bool operator<(Tree other) const {
        return x < other.x;
    }
};

vector<Tree> trees;
set<Tree> temp;
int n, x, h, q, l, r, left_border, right_border;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> x >> h;
        trees.emplace_back(x, h);
    }

    while (q--) {
        cin >> l >> r;
        temp.clear();
        queue<Tree> q;
        Tree left, right, cur;
        set<int> taken;

        if (l == 1) left_border = trees[l - 1].x;
        else left_border = trees[l - 2].x;
        if (r == n) right_border = trees[r - 1].x;
        else right_border = trees[r].x;

        for (int i = l - 1; i < r; i++) {
            if (i > 0 and trees[i].x - trees[i - 1].x >= trees[i].h) {
                q.push(trees[i]);
                taken.insert(trees[i].x);
            } else if (i < n - 1 and trees[i + 1].x - trees[i].x >= trees[i].h) {
                q.push(trees[i]);
                taken.insert(trees[i].x);
            }
            temp.insert(trees[i]);
        }
        int count = 0;
        while (!q.empty()) {
            cur = q.front();
            auto next_right_p = temp.upper_bound(cur), next_left_p = temp.lower_bound(cur);
            if (next_right_p != temp.end() and next_left_p != temp.begin()) {
                right = *next_right_p;
                next_left_p--;
                left = *next_left_p;
                if (right.x - left.x >= right.h) {
                    if (taken.find(right.x) == taken.end()) {
                        q.push(right);
                        taken.insert(right.x);
                    }
                }
                if (right.x - left.x >= left.h) {
                    if (taken.find(left.x) == taken.end()) {
                        q.push(left);
                        taken.insert(left.x);
                    }
                }
            } else if (next_right_p != temp.end()) {
                right = *next_right_p;
                if (right.h <= right.x - left_border) {
                    if (taken.find(right.x) == taken.end()) {
                        q.push(right);
                        taken.insert(right.x);
                    }
                }
            } else if (next_left_p != temp.begin()) {
                next_left_p--;
                left = *next_left_p;
                if (left.h <= right_border - left.x){
                    if (taken.find(left.x) == taken.end()) {
                        q.push(left);
                        taken.insert(left.x);
                    }
                }
            }
            temp.erase(cur);
            count++;
            q.pop();
        }
        cout << count << endl;
    }
}