#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

#define SZ(c) (int)c.size()

const int N = 150'000;

int n, m;
vector<int> g1[N], g2[N], g3[N];
bool used[N];
vector<vector<int>> ans;

int dfs(int v, int last) {
  vector<int> cnt[3];
  used[v] = true;
  for (int u : g1[v]) {
    if (u != last && !used[u]) {
      cnt[dfs(u, v)].push_back(u);
    }
  }
  while (!cnt[0].empty() && !cnt[2].empty()) {
    ans.push_back({cnt[0].back(), v, v, cnt[2].back()});
    cnt[0].pop_back();
    cnt[2].pop_back();
  }
  bool flag1 = false, flag2 = false;
  for (int u : g2[v]) {
    if (u == last) {
      if (!cnt[0].empty()) {
        ans.push_back({cnt[0].back(), v, v, u});
        cnt[0].pop_back();
      } else {
        flag1 = true;
      }
    }
  }
  for (int u : g3[v]) {
    if (u == last) {
      if (!cnt[2].empty()) {
        ans.push_back({u, v, v, cnt[2].back()});
        cnt[2].pop_back();
      } else {
        flag2 = true;
      }
    }
  }
  if (!cnt[0].empty() || !cnt[2].empty()) {
    cout << "No\n";
    exit(0);
  }
  if (flag1 && flag2) {
    ans.push_back({v, last, last, v});
    return 1;
  } else if (flag1) {
    return 0;
  } else if (flag2) {
    return 2;
  } else {
    return 1;
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    int v, u;
    cin >> v >> u;
    --v, --u;
    g1[v].push_back(u);
    g1[u].push_back(v);
    g2[v].push_back(u);
    g3[u].push_back(v);
  }
  for (int v = 0; v < n; ++v) {
    if (!used[v]) {
      dfs(v, v);
    }
  }
  cout << "Yes\n";
  for (auto e : ans) {
    for (int v : e) {
      cout << v + 1 << ' ';
    }
    cout << '\n';
  }
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/
