#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

#define SZ(c) (int)c.size()

const int N = 5e5 + 7;

int n, nq;
int x[N], h[N];
pair<pair<int, int>, int> q[N];
int lx[N], rx[N];

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cout.tie(NULL);
  cin >> n >> nq;
  for (int i = 0; i < n; ++i) {
    cin >> x[i] >> h[i];
  }
  for (int i = 0; i < nq; ++i) {
    int l, r;
    cin >> l >> r;
    --l, --r;
    q[i] = {{l, r}, i};
  }
  for (int i = 0; i < n; ++i) {
    lx[i] = x[i] - h[i];
    int j = i - 1;
    int last = i;
    while (j >= 0 && x[j] > lx[i]) {
      if (x[j] + h[j] > x[last]) {
        lx[i] = min(lx[i], x[j] - h[j]);
        last = j;
      }
      --j;
    }
  }
  for (int i = 0; i < n; ++i) {
    rx[i] = x[i] + h[i];
    int j = i + 1;
    int last = i;
    while (j < n && x[j] < rx[i]) {
      if (x[j] - h[j] < x[last]) {
        rx[i] = max(rx[i], x[j] + h[j]);
      }
      ++j;
    }
  }
  for (int i = 0; i < nq; ++i) {
    int l = q[i].first.first, r = q[i].first.second;
    int clx = (l == 0 ? x[l] : x[l - 1]), crx = (r == n - 1 ? x[r] : x[r + 1]);
    int res = 0;
    for (int j = l; j <= r; ++j) {
      res += (lx[j] >= clx || rx[j] <= crx);
    }
    cout << res << '\n';
  }
  return 0;
}
