#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    for (int c = 0; c < t; ++c) solve();
}

using edge = tuple<int, int, int>;

struct dsu {
    vector<int> p;
    vector<int> sz;

    explicit dsu(int n) : p(n, -1), sz(n, 1) { iota(p.begin(), p.end(), 0); }

    int find(int x) { return p[x] = (p[x] == x ? x : find(p[x])); }

    void unite(int x, int y) {
        x = find(x);
        y = find(y);
        if (x == y) return;
        if (sz[x] < sz[y]) {
            p[x] = y;
            sz[y] += sz[x];
        } else {
            p[y] = x;
            sz[x] += sz[y];
        }
    }

    bool connected(int x, int y) { return find(x) == find(y); }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<edge> edges;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        edges.emplace_back(u, v, t);
    }
    sort(edges.begin(), edges.end(), [](auto e1, auto e2) { return get<2>(e1) < get<2>(e2); });
    dsu kruskal(n);
    vector<vector<pair<int, int>>> mst(n);
    vector<edge> other;
    for (auto[u, v, t] : edges) {
        if (kruskal.connected(u, v)) {
            other.emplace_back(u, v, t);
            continue;
        }
        kruskal.unite(u, v);
        mst[u].emplace_back(v, t);
        mst[v].emplace_back(u, t);
    }
    vector<vector<pair<int, int>>> b(20, vector<pair<int, int>>(n));
    vector<int> root_max(n);
    int t = 0;
    vector<int> tin(n), tout(n);
    function<void(int, int, int)> dfs = [&](int cur, int prev, int max) {
        tin[cur] = t++;
        root_max[cur] = max;
        for (auto[next, t] : mst[cur]) {
            if (next == prev) {
                b[0][cur] = {next, t};
            } else {
                dfs(next, cur, ::max(max, t));
            }
        }
        tout[cur] = t++;
    };
    dfs(0, 0, -1);
    b[0][0] = {0, (int) 1e9};
    for (int l = 1; l < 20; ++l) {
        for (int i = 0; i < n; ++i) {
            b[l][i] = {b[l - 1][b[l - 1][i].first].first,
                       min(b[l - 1][b[l - 1][i].first].second, b[l - 1][i].second)};
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) ans[i] = root_max[i] + b[19][i].second;
    for (auto[u, v, t] : other) {
        int mnu = b[19][u].second;
        int mnv = b[19][v].second;
        int mx = t;
        for (int i = 0; i < n; ++i) {
            if (tin[i] <= tin[v] && tout[v] <= tout[i]) {
                ans[i] = min(ans[i], mnu + mx);
            }
            if (tin[v] <= tin[i] && tout[i] <= tout[v]) {
                ans[i] = min(ans[i], mnu + mx);
            }
            if (tin[i] <= tin[u] && tout[u] <= tout[i]) {
                ans[i] = min(ans[i], mnv + mx);
            }
            if (tin[u] <= tin[i] && tout[i] <= tout[u]) {
                ans[i] = min(ans[i], mnv + mx);
            }
        }
    }
    for (int i = 1; i < n; ++i) cout << ans[i] << '\n';
}