#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    for (int c = 0; c < t; ++c) solve();
}

using edge = tuple<int, int, int>;

struct dsu {
    vector<int> p;
    vector<int> sz;

    explicit dsu(int n) : p(n, -1), sz(n, 1) { iota(p.begin(), p.end(), 0); }

    int find(int x) { return p[x] = (p[x] == x ? x : find(p[x])); }

    void unite(int x, int y) {
        x = find(x);
        y = find(y);
        if (x == y) return;
        if (sz[x] < sz[y]) {
            p[x] = y;
            sz[y] += sz[x];
        } else {
            p[y] = x;
            sz[x] += sz[y];
        }
    }

    bool connected(int x, int y) { return find(x) == find(y); }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<edge> edges;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        edges.emplace_back(u, v, t);
    }
    sort(edges.begin(), edges.end(), [](auto e1, auto e2) { return get<2>(e1) < get<2>(e2); });
    dsu kruskal(n);
    vector<vector<pair<int, int>>> mst(n);
    map<int, int> lowest;
    for (auto[u, v, t] : edges) {
        if (kruskal.connected(u, v)) continue;
        kruskal.unite(u, v);
        mst[u].emplace_back(v, t);
        mst[v].emplace_back(u, t);
        lowest[t] = t;
    }
    lowest[0] = 1e9;
    function<void(int, int, int)> dfs1 = [&](int cur, int prev, int max) {
        for (auto[next, t] : mst[cur]) {
            if (next == prev) continue;
            lowest[max] = min(lowest[max], t);
            dfs1(next, cur, ::max(max, t));
        }
    };
    dfs1(0, 0, -1);
    vector<pair<int, int>> conditions(lowest.begin(), lowest.end());
    int prefix_min = 1e9;
    for (auto &[high, low] : conditions) {
        low = min(low, prefix_min);
        prefix_min = low;
        lowest[high] = low;
    }
    vector<int> ans(n);
    function<void(int, int, int)> dfs2 = [&](int cur, int prev, int max) {
        ans[cur] = max + lowest[max];
        for (auto[next, t] : mst[cur]) {
            if (next == prev) continue;
            dfs2(next, cur, ::max(max, t));
        }
    };
    dfs2(0, 0, -1);
    for (int k = 1; k < n; ++k) cout << ans[k] << ' ';
}