#include "bits/stdc++.h"

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define all(x) x.begin(), x.end()

namespace {
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {return in >> p.first >> p.second;}
    template<typename T>
    istream& operator>>(istream& in, vector<T>& v) {
        for (auto & e : v)
            in >> e;
        return in;
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("gen.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    while(t--)
    solve();
}

void solve() {
    string s;
    cin >> s;
    int n = s.size();

    vector<ll> values = {1, 5};
    while (values.size() < 26) {
        values.push_back(values.back() * 2);
        values.push_back(values.back() * 5);
    }
    assert(values.size() == 26);

    int prevQuestion = -1;
//    int curAns = 25;

    vector<vector<ll>> prefs(26, vector<ll>(n + 1));

    for (int ch = 0; ch < 26; ch++) {
        prefs[ch][0] = 0;
        for (int i = 0; i < n; i++) {
            prefs[ch][i + 1] = prefs[ch][i];
            if (s[i] - 'A' < ch)
                prefs[ch][i + 1] += values[s[i] - 'A'];
        }
    }

    vector<ll> sParsed(n);
    int ma = 0;
    for (int i = n - 1; i >= 0; i--) {
        int ch = s[i] - 'A';
        if (s[i] == '?')
            sParsed[i] = 0;
        else if (ch < ma)
            sParsed[i] = -values[ch];
        else
            sParsed[i] = values[ch];
        ma = max(ma, ch);
    }

    auto getPrefix = [&](int prevQuestion, int question, int ans) {
        ll destroyed = 0;
        // FIXME precalc
        for (int i = prevQuestion + 1; i < question; i++) {
            if (sParsed[i] > 0 && s[i] - 'A' < ans)
                destroyed -= values[s[i] - 'A'];
        }
        return destroyed;
    };

    for (int i = 0; i < n; i++) {
        if (s[i] != '?')
            continue;
        ll mi = -1e18;
        int miAns = -1;

        for (int ans = 0; ans < 26; ans++) {
            ll cans = getPrefix(prevQuestion, i, ans) + values[ans];
            if (cans > mi) {
                mi = cans;
                miAns = ans;
            }
        }

        s[i] = 'A' + miAns;
        prevQuestion = i;
    }
    // recovery
    ll answer = 0;
    ma = 0;
    for (int i = n - 1; i >= 0; i--) {
        int ch = s[i] - 'A';
        if (ch < ma)
            answer -= values[ch];
        else
            answer += values[ch];
        ma = max(ma, ch);
    }
    cout << answer << '\n' << s << '\n';
}