#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

const ll INFL = 2e18;
const int INF = 2e9;
const int MAXN = 3e5 + 1;

struct edge {
    int t, w, i;

    bool operator<(const edge &a) const {
        return w > a.w || w == a.w && t < a.t;
    }
};

int ans[MAXN];

void dfs(vector<vector<edge>> &g, int v, int p, int mn, int mx) {
    ans[v] = min(ans[v], mn + mx);
    for (auto &i : g[v])
        if (i.t != p)
            dfs(g, i.t, v, min(mn, i.w), max(mx, i.w));
}

void dfs1(vector<vector<edge>> &g, vector<int> &used, int v, int mn, int mx) {
    ans[v] = min(ans[v], mn + mx);
    for (auto &i : g[v])
        if (!used[i.i]) {
            used[i.i] = 1;
            dfs1(g, i.t, min(mn, i.w), max(mx, i.w));
        }
}


int main() {
    input();
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    vector<int> usede(m);
    for (int i = 0; i < n; i++)
        ans[i] = INF;
    for (int i = 0; i < m; i++) {
        int u, v, t;
        cin >> u >> v >> t;
        --u, --v;
        g[u].push_back({v, t, i});
        g[v].push_back({u, t, i});
    }
    bool zeros = true, infs = true;
    for (int i = 0; i < g[0].size(); i++)
        zeros &= g[0][i].w == 0;
    if (m == n - 1) {
        vector<int> mn(n), mx(n);
        dfs(g, 0, -1, INF, 0);
        for (int i = 1; i < n; i++)
            cout << ans[i] << "\n";
    } else if (zeros) {
        priority_queue<edge> verts;
        vector<int> dist(n, INF);
        vector<int> used(n);
        dist[0] = 0;
        verts.push({0, 0});
        while (!verts.empty()) {
            while (!verts.empty() && used[verts.top().t])
                verts.pop();
            if (verts.empty())
                break;
            auto[v, d] = verts.top();
            used[v] = 1;
            verts.pop();
            for (auto &i : g[v]) {
                if (dist[i.t] > max(dist[v], i.w)) {
                    dist[i.t] = max(dist[v], i.w);
                    verts.push({i.t, dist[i.t]});
                }
            }
        }
        for (int i = 1; i < n; i++)
            cout << dist[i] << "\n";
    } else {
        dfs1(g, usede, 0, INF, 0);
        for (int i = 1; i < n; i++)
            cout << ans[i] << "\n";
    }
    return 0;
}