#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ios>
#include <cassert>
#include <queue>
using namespace std;

const int INF = 1e9;

vector<vector<tuple<int, int, int>>> g;
vector<char> used_edge;
vector<set<int>> possible_sums;

void dfs(int v, int cur_min, int cur_max) {
	possible_sums[v].insert(cur_min + cur_max);
	for (auto& [w, t, index] : g[v]) {
		if (used_edge[index])
			continue;
		used_edge[index] = true;
		dfs(w, min(cur_min, t), max(cur_max, t));
		used_edge[index] = false;
	}
}

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, m;
	cin >> n >> m;
	g.resize(n);
	used_edge.resize(m);
	possible_sums.resize(n);

	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--; b--;
		g[a].push_back({ b, c, i });
		g[b].push_back({ a, c, i });
	}
	dfs(0, INF, -INF);
	for (int i = 1; i < n; i++) {
		cout << *possible_sums[i].begin() << "\n";
	}
}