#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cassert>

#define x first
#define y second


using namespace std;


typedef pair<int, int> pii;

#pragma GCC optimize("O3")
#pragma warning(disable:4996)


set<pii> here;


bool check(int x, int y) {
	if (here.find(make_pair(x, y)) != here.end())
		return 1;
	return 0;
}


const int maxn = 3e3 + 10;
bool used[maxn];
vector<int> g[maxn];
bool dp[maxn][maxn * 2];
int per[maxn][maxn * 2];
int buf[maxn];
vector<pair<pii, pii>> ans;


int op = maxn - 2;


void dfs(int v, int p) {
	used[v] = 1;
	vector<pii> up;
	vector<pii> dow;
	for (int u : g[v]) {
		if (u == p)
			continue;
		dfs(u, v);
		if (check(v, u) && check(u, v)) {
			ans.push_back({ {u, v}, {v, u} });
		}
		else {
			if (check(v, u))
				dow.push_back({ v, u });
			else if (check(u, v))
				up.push_back({u, v});
		}
	}
	if (abs((int)up.size() - (int)dow.size()) > 1) {
		cout << "No\n";
		exit(0);
	}
	int x = min(up.size(), dow.size());
	for (int i = 0; i < x; i++) {
		ans.push_back({ up[i], dow[i]});
	}
	if (up.size() > x) {
		if (!check(v, p)) {
			cout << "No";
			exit(0);
		}
		ans.push_back({ up.back(), {v, p}});
		here.erase({ v, p });
	}
	if (dow.size() > x) {
		if (!check(p, v)) {
			cout << "No";
			exit(0);
		}
		ans.push_back({ dow.back(), {p, v} });
		here.erase({ p, v });
	}
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		here.insert({ u, v });
		g[u].push_back(v);
		g[v].push_back(u);
	}
	for (int i = 0; i < n; i++) {
		sort(g[i].begin(), g[i].end());
		g[i].resize(unique(g[i].begin(), g[i].end()) - g[i].begin());
	}
	for (int i = 0; i < n; i++) {
		if (!used[i])
			dfs(i, -1);
	}
	cout << "Yes\n";
	for (auto el : ans) {
		cout << el.x.x + 1 << ' ' << el.x.y + 1 << ' ' << el.y.x + 1 << ' ' << el.y.y + 1 << '\n';
	}
}
