#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cassert>


#define x first
#define y second


using namespace std;


#pragma GCC optimize("O3")
#pragma warning(disable:4996)


const int maxn = 3e5 + 10;
vector<pair<int, int>> g[maxn];
int dist[maxn];


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--;
		v--;
		g[u].push_back({ v, w });
		g[v].push_back({ u, w });
	}
	set<pair<int, int>> q;
	for (int i = 0; i < n; i++)
		dist[i] = 1e9 + 10;
	for (auto e : g[0]) {
		dist[e.x] = 0;
		q.insert({0, e.x});
	}
	while (!q.empty()) {
		auto v = *q.begin();
		q.erase(q.begin());
		for (auto e : g[v.x]) {
			if (dist[e.x] < max(v.x, e.y)) {
				q.erase({dist[e.x], e.x});
				dist[e.x] = max(v.x, e.y);
				q.insert({dist[e.x], e.x});
			}
		}
	}
	for (int i = 1; i < n; i++) {
		cout << dist[i] << '\n';
	}
}
