#include <bits/stdc++.h>
#define int long long

using namespace std;

const int inf = 10000000000;

int n;
vector <vector <pair <int, int> > > g;

ostream& operator<<(ostream& os, vector <int> a)
{
    for (auto x : a)
    {
        os << x << " ";
    }
    return os;
}

ostream& operator<<(ostream& os, pair <int, int> a)
{
    os << a.first << " " << a.second;
    return os;
}

vector <int> mx, mn;
vector <bool> used;

void dfs1(int v, int mini, int maxi)
{
    used[v] = true;
    mx[v] = maxi;
    mn[v] = mini;
    for (auto rib : g[v])
    {
        int u = rib.first, w = rib.second;
        if (!used[u])
        {
            dfs1(u, min(mini, w), max(maxi, w));
        }
    }
}

void solve1()
{
    mx.assign(n, -inf);
    mn.assign(n, inf);
    used.assign(n, false);
    dfs1(0, inf, -inf);
    for (int i = 1; i < n; i++)
    {
        cout << mx[i] + mn[i] << endl;
    }
}

vector <int> p;
vector <int> rnk;

bool cmp(vector <int>& a, vector <int>& b)
{
    return a[2] < b[2];
}

int par(int v)
{
    if (p[v] == v)
    {
        return v;
    }
    p[v] = par(p[v]);
    return p[v];
}

bool one(int v, int u)
{
    return par(v) == par(u);
}

void merge(int v, int u)
{
    v = par(v);
    u = par(u);
    if (rnk[u] > rnk[v])
    {
        swap(u, v);
    }
    p[u] = v;
    rnk[v] += rnk[u];
}

void solve2()
{
    vector <vector <int> > ribs;
    for (int i = 0; i < n; i++)
    {
        for (auto rib : g[i])
        {
            if (rib.first > i)
            {
                vector <int> temp(1, i);
                temp.push_back(rib.first);
                temp.push_back(rib.second);
                ribs.push_back(temp);
            }
        }
    }
    sort(ribs.begin(), ribs.end(), cmp);

    vector <vector <int> > get;
    for (int i = 0; i < n; i++)
    {
        p.push_back(i);
        rnk.push_back(1);
    }

    for (auto rib : ribs)
    {
        if (!one(rib[0], rib[1]))
        {
            merge(rib[0], rib[1]);
            get.push_back(rib);
        }
    }

    vector <pair <int, int> > temp2;
    vector <vector <pair <int, int> > > g2(n, temp2);
    for (auto rib : get)
    {
        int v = rib[0], u = rib[1], w = rib[2];
        g2[v].push_back(make_pair(u, w));
        g2[u].push_back(make_pair(v, w));
    }
    g = g2;
    solve1();

}

int32_t main()
{
    int m;
    cin >> n >> m;
    vector <pair <int, int> > temp;
    g.assign(n, temp);
    for (int i = 0; i < m; i++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        v--; u--;
        g[v].push_back(make_pair(u, w));
        g[u].push_back(make_pair(v, w));
    }
    if (m == n - 1)
    {
        solve1();
    }
    else
    {
        solve2();
    }
    return 0;
}
/*
6 7
1 2 0
1 3 0
1 4 0
4 5 2
3 5 3
5 6 4
2 6 5
*/
