#include <bits/stdc++.h>
using namespace std;

//#define int long long
#define F first
#define S second
#define mp make_pair
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#ifdef MY
    #define endl '\n'
#endif // MY

typedef long long ll;
typedef double db;
typedef pair < int, int > pii;

struct Edge {
    int v, u, t;
    Edge (int v = 0, int u = 0, int t = 0) : v(v), u(u), t(t) {}
};

const int N = 3e5 + 5;
const int inf = 1e9 + 7;
vector < pii > gr[N];
Edge edge[N];
int ans[N];
int used[N];
int mn[N], mx[N];

void dfst(int v, int a = inf, int b = 0, int prv = -1) {
    if (v) {
        a = min(a, mn[v]);
        b = max(b, mn[v]);
    }
    ans[v] = a + b;
//    bool fl = 0;
    for (auto p : gr[v]) {
        int u = p.F, t = edge[p.S].t;
        if (u == prv) {
            continue;
        }
        mn[u] = min(mn[u], t);
        dfst(u, a, b, v);
    }
}

void dij(int n) {
    fill(ans + 1, ans + n, inf);
    set < pii > cur;
    for (auto p : gr[0]) {
        cur.insert(mp(edge[p.S].t, p.S));
    }
    used[0] = 1;
    while (sz(cur)) {
        pii p = *(cur.begin());
        cur.erase(cur.begin());
        int i = p.S, t = p.F;
        int v = edge[i].v, u = edge[i].u;
        ans[u] = min(ans[u], max(ans[v], t));
        ans[v] = min(ans[v], max(ans[u], t));
        if (used[v]) {
            swap(v, u);
        }
        if (!used[v]) {
            used[v] = 1;
            for (auto p : gr[v]) {
                if (!used[p.F]) {
                    int i = p.S;
                    cur.insert({edge[i].t, i});
                }
            }
        }
    }
}

void dfs(int v, int mask, int a = inf, int b = 0) {
    ans[v] = min(ans[v], a + b);
    for (auto p : gr[v]) {
        int u = p.F, i = p.S;
        if ((mask & (1 << i)) == 0) {
            continue;
        }
        a = min(a, edge[i].t);
        b = max(b, edge[i].t);
        if (ans[u] >= a + b) {
            dfs(u, mask ^ (1 << i), a, b);
        }
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        v--, u--;
        gr[v].pb({u, i});
        gr[u].pb({v, i});
        edge[i] = {v, u, t};
    }
    if (m + 1 == n) {
        fill(mn, mn + n, inf);
        dfst(0);
        for (int i = 1; i < n; i++) {
            cout << ans[i] << endl;
        }
        return 0;
    }
    if (n <= 20 && m <= 20) {
        fill(ans + 1, ans + n, 2 * inf);
        dfs(0, (1 << m) - 1);
//        for (int mask = 0; mask < (1 << m); mask++) {
//            dfs(0, mask);
//        }
        for (int i = 1; i < n; i++) {
            cout << ans[i] << endl;
        }
        return 0;
    }
    dij(n);
    for (int i = 1; i < n; i++) {
        cout << ans[i] << endl;
    }
    return 0;
}
