#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(o) o.begin(), o.end()


vector<vector<pair<int, int>>> graph;

vector<bool> visited;
vector<int> dists;


void d() {
    priority_queue<pair<int, int>> q;
    q.push({0, 0});

    while (!q.empty()) {
        auto p = q.top();
        q.pop();
        int v = p.second, d = p.first;
        visited[v] = true;
        for (auto edge : graph[v]) {
            int u = edge.first;
            if (!visited[u]) {
                int dist = max(d, edge.second);
                dists[u] = max(dists[u], dist);
                q.push({dist, u});
            }
        }
    }
}


void solve() {
    int n, m;
    cin >> n >> m;

    graph.assign(n, vector<pair<int, int>>());
    visited.assign(n, false);
    dists.assign(n, 0);

    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        graph[v].push_back({u, w});
        graph[u].push_back({v, w});
    }

    d();
    for (int i = 1; i < n; ++i) {
        cout << dists[i] << "\n";
    }
}


int main() {
#if ELT
    freopen("../D.txt", "r", stdin);
    int q;
    cin >> q;
    while (q--) {
        cout << " -- TEST --\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
#endif
    return 0;
}
