#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>

#define INF 4000000000000000000

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

vector<vector<pii>> g;
vector<int> used;
vector<pii> ans;

void dfs(int v) {
	used[v] = 1;
	for (pii c : g[v]) {
		int to = c.first, t = c.second;
		if (!used[to]) {
			ans[to] = { min(t, ans[v].first), max(t, ans[v].second) };
			dfs(to);
		}
	}
}

int main() {
	int n, m;
	cin >> n >> m;
	g.resize(n);
	used.resize(n);
	ans.resize(n);
	ans[0] = { 1000000000, 0 };
	for (int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		g[--u].push_back({ --v, t });
		g[v].push_back({ u, t });
	}
	dfs(0);
	for (int i = 1; i < n; i++)
		cout << ans[i].first + ans[i].second << "\n";
}