#include <iostream>
#include <map>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

map<int, int>* gr;
bool* used;
int* p_type;

bool** dp;

void dfs(int v, int p, int type)
{
	p_type[v] = type;
	used[v] = 1;
	int cnt[3] = { 0, 0, 0 };
	for (const auto& to : gr[v])
	{
		int u = to.first, child_type = to.second;
		if (u == p)
			continue;
		dfs(u, v, child_type);
		if (dp[u][2])
			continue;
		if (dp[u][0] && dp[u][1])
			cnt[2]++;
		else if (dp[u][0])
			cnt[0]++;
		else
			cnt[1]++;
	}
	dp[v] = new bool[3];
	dp[v][0] = 0, dp[v][1] = 0, dp[v][2] = 0;
	int others = abs(cnt[0] - cnt[1]) - cnt[2];
	int stay_type;
	if (others > 1)
		return;
	if (others == 0)
		stay_type = 2;
	else if (others < 0 && others % 2 == 0)
		stay_type = 2;
	else if (others < 0)
		stay_type = 3;
	else
		stay_type = (cnt[0] > cnt[1] ? 0 : 1);
	if (type == stay_type || (type < 2 && stay_type == 3))
		dp[v][2] = 1;
	else
	{
		if (type == 2)
		{
			if (stay_type == 3)
				dp[v][0] = dp[v][1] = 1;
			else
				dp[v][1 - stay_type] = 1;
		}
		else
		{
			if (stay_type == 2)
				dp[v][type] = 1;
		}
	}
}

vector<pair<pair<int, int>, pair<int, int>>> ans;

void build_ans(int v, int p, int need_type)
{
	used[v] = 1;
	vector<int> children_of_type[3];
	for (const auto& to : gr[v])
	{
		int u = to.first, child_type = to.second;
		if (u == p)
			continue;
		if (dp[u][2])
		{
			build_ans(u, v, 2);
			continue;
		}
		if (dp[u][0] && dp[u][1])
			children_of_type[2].push_back(u);
		else if (dp[u][0])
			children_of_type[0].push_back(u);
		else
			children_of_type[1].push_back(u);
	}
	int cnt[3] = { children_of_type[0].size(), children_of_type[1].size(), children_of_type[2].size() };
	
	for (int i = 0; i < cnt[0] && i < cnt[1]; i++)
	{
		ans.push_back({ { children_of_type[0][i], v }, { v, children_of_type[1][i] } });
		build_ans(children_of_type[0][i], v, 0);
		build_ans(children_of_type[1][i], v, 1);
	}

	if (cnt[0] > cnt[1])
	{
		for (int i = cnt[1]; i < cnt[2]; i++)
		{
			ans.push_back({ { children_of_type[0][i], v }, { v, children_of_type[2][i - cnt[1]] } });
			build_ans(children_of_type[0][i], v, 0);
			build_ans(children_of_type[2][i - cnt[1]], v, 1);
		}
	}
	else
	{
		for (int i = cnt[0]; i < cnt[2]; i++)
		{
			ans.push_back({ { children_of_type[2][i - cnt[0]], v }, { v, children_of_type[1][i] } });
			build_ans(children_of_type[2][i - cnt[0]], v, 0);
			build_ans(children_of_type[1][i], v, 1);
		}
	}
	for (int i = abs(cnt[0] - cnt[1]); i + 1 < cnt[2]; i += 2)
	{
		ans.push_back({ { children_of_type[2][i], v }, { v, children_of_type[2][i + 1] } });
		build_ans(children_of_type[2][i], v, 0);
		build_ans(children_of_type[2][i + 1], v, 1);
	}


	int others = abs(cnt[0] - cnt[1]) - cnt[2];
	int stay_type, last_child;
	if (others == 0)
		stay_type = 2;
	else if (others < 0 && others % 2 == 0)
		stay_type = 2;
	else if (others < 0)
	{
		stay_type = 3;
		last_child = children_of_type[2].back();
	}
	else
	{
		stay_type = (cnt[0] > cnt[1] ? 0 : 1);
		last_child = children_of_type[stay_type].back();
	}
	
	if (p_type[v] == stay_type || (p_type[v] < 2 && stay_type == 3))
	{
		dp[v][2] = 1;
		if (p_type[v] == 0)
		{
			ans.push_back({ { v, p }, { last_child, v } });
			build_ans(last_child, v, 0);
		}
		else if (p_type[v] == 1)
		{
			ans.push_back({ { p, v }, { v, last_child } });
			build_ans(last_child, v, 1);
		}
		else if (p != -1)
		{
			ans.push_back({ { p, v }, { v, p } });
		}
	}
	else
	{
		if (p_type[v] == 2)
		{
			if (stay_type == 3)
				dp[v][0] = dp[v][1] = 1;
			else
				dp[v][1 - stay_type] = 1;
			if (need_type == 0)
			{
				ans.push_back({ { p, v }, { v, last_child } });
				build_ans(last_child, v, 0);
			}
			else
			{
				ans.push_back({ { last_child, v }, { v, p } });
				build_ans(last_child, v, 1);
			}
		}
		else
		{
			if (stay_type == 2)
				dp[v][p_type[v]] = 1;
		}
	}
}

int main()
{
	int n, m;
	cin >> n >> m;
	gr = new map<int, int>[n];
	int u, v;
	for (int i = 0; i < m; i++)
	{
		cin >> u >> v;
		u--, v--;
		if (gr[u].count(v) == 0)
		{
			gr[u][v] = 1;
			gr[v][u] = 0;
		}
		else
		{
			gr[u][v] = 2;
			gr[v][u] = 2;
		}
	}
	dp = new bool* [n];
	used = new bool[n];
	p_type = new int[n];
	memset(used, 0, n * sizeof(bool));
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			dfs(i, -1, 2);
			if (!dp[i][2])
			{
				cout << "No" << "\n";
				return 0;
			}
		}
	}
	/*for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < 3; j++)
		{
			cout << "dp[" << i << "][" << j << "] = " << dp[i][j] << "\n";
		}
	}*/
	cout << "Yes" << "\n";
	memset(used, 0, n * sizeof(bool));
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
			build_ans(i, -1, 2);
	}
	for (const auto& el : ans)
		cout << el.first.first + 1 << " " << el.first.second + 1 << " " << el.second.first + 1 << " " << el.second.second + 1 << "\n";
}
