#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

vector <bool> used;

vvi g;
vi par;
vector <bool> up, down;

set <pair <int, int>> e;

void dfs(int v, int p = -1) {
  used[v] = true;
  for (int u : g[v]) {
    if (!used[u]) {
      par[u] = v;
      up[u] = (e.find({u, v}) != e.end());
      down[u] = (e.find({v, u}) != e.end());
      dfs(u, v);
    }
  }
}

vector <pair <pii, pii>> ans;

int solve(int v, int p = -1) {
  used[v] = true;
  vector <pii> left, right;
  for (int u : g[v]) {
    if (!used[u]) {
      int res = solve(u, v);
      if (res == 0) {
        continue;
      }
      if (res == 1) {
        left.push_back({u, v});
      } else {
        right.push_back({v, u});
      }
    }
  }
  while (!left.empty() && !right.empty()) {
    ans.push_back({left.back(), right.back()});
    left.pop_back();
    right.pop_back();
  }
  if (right.size() > 1 || left.size() > 1) {
    cout << "No\n";
    exit(0);
  }
  if (!right.empty()) {
    if (down[v]) {
      down[v] = false;
      ans.push_back({{p, v}, right[0]});
    } else {
      cout << "No\n";
      exit(0);
    }
  }
  if (!left.empty()) {
    if (up[v]) {
      up[v] = false;
      ans.push_back({left[v], {v, p}});
    } else {
      cout << "No\n";
      exit(0);
    }
  }
  if (up[v] && down[v]) {
    up[v] = down[v] = false;
    ans.push_back({{v, p}, {p, v}});
  }
  if (up[v]) {
    return 1;
  }
  if (down[v]) {
    return -1;
  }
  return 0;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  g.resize(n), par.resize(n);
  for (int i = 0; i < m; i++) {
    int u, v;
    cin >> u >> v;
    u--, v--;
    g[u].push_back(v);
    g[v].push_back(u);
    e.insert({u, v});
  }
  used.assign(n, false);
  up.assign(n, false), down.assign(n, false);
  for (int i = 0; i < n; i++) {
    if (!used[i]) {
      dfs(i);
    }
  }
  used.assign(n, false);
  for (int i = 0; i < n; i++) {
    if (!used[i]) {
      if (solve(i)) {
        cout << "No";
        return 0;
      }
    }
  }
  cout << "Yes\n";
  for (auto &now : ans) {
    cout << now.first.first + 1 << ' ' << now.first.second + 1 << ' ' << now.second.first + 1 << ' ' << now.second.second + 1 << '\n';
  }
  return 0;
}

/*
5 6
 1 2
 2 1
 1 5
 2 3
 2 4
4 2
 */