#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;
typedef vector <pii> vpii;
typedef vector <vpii> vvpii;

const int INF = 1e9;

vvpii g;
vi mi, ma;

void dfs(int v, int p = -1) {
  for (auto [u, w] : g[v]) {
    if (u == p) {
      continue;
    }
    if (p == -1) {
      mi[u] = ma[u] = w;
    } else {
      mi[u] = min(mi[v], w);
      ma[u] = max(ma[v], w);
    }
    dfs(u, v);
  }
}

int main() {
  int n, m;
  cin >> n >> m;
  g.resize(n);
  bool group2 = true, group3 = true;
  for (int i = 0; i < m; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    u--, v--;
    if (u > v) {
      swap(u, v);
    }
    g[u].push_back({v, w});
    g[v].push_back({u, w});
    if (u == 0) {
      if (w != 0) {
        group2 = false;
      }
      if (w != INF) {
        group3 = false;
      }
    }
  }
  if (group2) {
    set <pair <int, int>> s;
    vector <int> d(n, INF);
    d[0] = 0;
    for (int v = 0; v < n; v++) {
      s.insert({d[v], v});
    }
    while (!s.empty()) {
      int v = s.begin()->second;
      s.erase(s.begin());
      for (auto [u, w] : g[v]) {
        if (max(d[v], w) < d[u]) {
          s.erase({d[u], u});
          d[u] = max(d[v], w);
          s.insert({d[u], u});
        }
      }
    }
    for (int v = 1; v < n; v++) {
      cout << d[v] << ' ';
    }
    return 0;
  }
  if (group3) {
    set <pair <int, int>> s;
    vector <int> d(n, INF + 1);
    d[0] = INF + 1;
    for (int v = 0; v < n; v++) {
      s.insert({d[v], v});
    }
    while (!s.empty()) {
      int v = s.rbegin()->second;
      s.erase({d[v], v});
      for (auto [u, w] : g[v]) {
        if (min(d[v], w) < d[u]) {
          s.erase({d[u], u});
          d[u] = min(d[v], w);
          s.insert({d[u], u});
        }
      }
    }
    for (int v = 1; v < n; v++) {
      cout << d[v] << ' ';
    }
    return 0;
  }
  mi.resize(n), ma.resize(n);
  dfs(0);
  for (int v = 1; v < n; v++) {
    cout << mi[v] + ma[v] << '\n';
  }
  return 0;
}

/*
4 5
1 2 0
1 3 0
2 4 5
2 4 2
3 4 3
 */