#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e17;

ll n, m, k, q;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

struct edge {
	ll u, c;

	edge(ll u = 0, ll c = 0) : u(u), c(c) {};
};

#define x first
#define y second

vector <vector <edge>> g;

vector <vector <pair <ll, ll>>> dp;
vector <vector <ll>> p;

void dfs(int v, int pr = -1, ll c = -1) {
	if (pr != -1) {
		p[v][0] = pr;
		for (int i = 1; i < 20; ++i) {
			p[v][i] = p[p[v][i - 1]][i - 1];
		}
		dp[v][0] = { c, c };
		for (int i = 1; i < 20; ++i) {
			dp[v][i].x = min(dp[v][i - 1].x, dp[p[v][i - 1]][i - 1].x);
			dp[v][i].y = max(dp[v][i - 1].y, dp[p[v][i - 1]][i - 1].y);
		}
	}
	for (auto& x : g[v]) {
		if (x.u == pr) continue;
		dfs(x.u, v, x.c);
	}
}

int main() {
	cin >> n >> m;
	g.resize(n);
	dp.resize(n, vector <pair <ll, ll>>(20, make_pair(INF, -INF)));
	p.resize(n, vector <ll>(20));
	for (int i = 0; i < m; ++i) {
		ll a, b, c;
		cin >> a >> b >> c;
		--a; --b;
		g[a].push_back(edge(b, c));
		g[b].push_back(edge(a, c));
	}
	dfs(0);
	for (int i = 1; i < n; ++i) {
		cout << dp[i][19].x + dp[i][19].y << '\n';
	}
	return 0;
}
/*
5 4
1 2 5
2 3 2
2 4 8
1 5 10
*/