#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e17;

ll n, m, k, q;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll g[10][10];

int main() {
	cin >> n >> m;
	for (int i = 0; i < 10; ++i) {
		for (int j = 0; j < 10; ++j) {
			g[i][j] = -INF;
		}
	}

	for (int i = 0; i < m; ++i) {
		ll a, b, c;
		cin >> a >> b >> c;
		--a; --b;
		g[a][b] = g[b][a] = c;
	}

	vector <ll> perm(n);
	iota(perm.begin(), perm.end(), 0);
	
	vector <ll> ans(n, INF);

	do {
		ll mine = INF, maxe = -INF;
		for (int i = 1; i < n; ++i) {
			ll cost = g[perm[i - 1]][perm[i]];
			if (cost != -INF) {
				maxi(maxe, cost);
				mini(mine, cost);
				mini(ans[perm[i]], mine + maxe);
			}
			else {
				break;
			}
		}

	} while (next_permutation(perm.begin() + 1, perm.end()));

	for (int i = 1; i < n; ++i) {
		cout << ans[i] << '\n';
	}

	return 0;
}