#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <array>
#include <bitset>
#include <algorithm>
#include <functional>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cmath>
#include <cassert>
#include <limits>
#include <time.h>

using namespace std;

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

#define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const long long INF = 1e18;

const int N = 21;

struct edge {
	int u, w, id;
	edge() {}
	edge(int u_, int w_, int id_) {
		u = u_, w = w_, id = id_;
	}
};

int n, m;
vector<edge> g[N];
int ans[N];

void f(int v, int mn, int mx, vector<int>& used) {
	chkmin(ans[v], mn + mx);
	for (auto w : g[v]) {
		if (!used[w.id]) {
			used[w.id] = 1;
			f(w.u, min(mn, w.w), max(mx, w.w), used);
			used[w.id] = 0;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--, v--;
		g[u].pb(edge(v, w, i));
		g[v].pb(edge(u, w, i));
	}
	for (int i = 0; i < n; i++) {
		ans[i] = INF;
	}
	vector<int> used(m, 0);
	f(0, INF, -INF, used);
	for (int i = 1; i < n; i++) {
		cout << ans[i] << "\n";
	}
}
/*

*/