#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <numeric>
#include <queue>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

v<v<pa<ll, ll>>> graph;

v<ll> res;

void dfs(ll vert, ll parent, ll L = -1, ll R = -1) {
	if (L != -1) {
		res[vert] = L + R;
	}
	for (auto [overt, t] : graph[vert]) {
		if (overt != parent) {
			ll nL, nR;
			if (L == -1) {
				nL = nR = t;
			}
			else {
				nL = min(L, t);
				nR = max(R, t);
			}
			dfs(overt, vert, nL, nR);
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll n, m;
	cin >> n >> m;
	graph = v<v<pa<ll, ll>>>(n);
	for (ll i = 0; i < m; ++i) {
		ll ui, vi, ti;
		cin >> ui >> vi >> ti;
		--ui;
		--vi;
		graph[ui].push_back({ vi, ti });
		graph[vi].push_back({ ui, ti });
	}
	v<ll> ma(n);
	v<ll> mi(n);
	ma[0] = mi[0] = -1;
	for (ll i = 0; i < n - 1; ++i) {
		ll cma = ma[i];
		ll cmi = mi[i];
		ll miedg = 1e18;
		for (auto [overt, t] : graph[i]) {
			if (overt != i - 1) {
				miedg = min(miedg, t);
			}
		}
		ll nma, nmi;
		if (cma == -1) {
			nma = nmi = miedg;
		}
		else {
			nma = max(cma, miedg);
			nmi = min(cmi, miedg);
		}
		ma[i + 1] = nma;
		mi[i + 1] = nmi;
	}
	v<ll> res(n);
	for (ll i = 0; i < n; ++i) {
		if (ma[i] == -1 || mi[i] == -1) {
			res[i] = -1;
		}
		else {
			res[i] = ma[i] + mi[i];
		}
	}
	for (ll i = 1; i < n; ++i) {
		cout << res[i] << '\n';
	}
}