#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
using namespace std;

int n, m;
vector<vector<pair<int, int>>> graph;

int main()
{
	cin >> n >> m;
	graph.resize(n);
	for (int i = 0; i < m; ++i)
	{
		int a, b, t; cin >> a >> b >> t; --a; --b;
		graph[a].emplace_back(b, t);
		graph[b].emplace_back(a, t);
	}

	vector<int> dist(n, 1e9); dist[0] = 0;
	set<pair<int, int>> ord;
	for (int i = 0; i < n; ++i)
		ord.emplace(dist[i], i);

	while (ord.size())
	{
		int v = ord.begin()->first; ord.erase(ord.begin());
		for (auto& i : graph[v])
		{
			int u = i.first, c = max(dist[v], i.second);
			if (dist[u] > c)
			{
				ord.erase({ dist[u], u });
				dist[u] = c;
				ord.emplace(dist[u], u);
			}
		}
	}

	for (int i = 1; i < n; ++i)
		cout << dist[i] << '\n';

	return 0;
}