#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <functional>
#include <map>
#include <bitset>
#include <utility>
#include <cstring>
#include <algorithm>
#include <chrono>
#include <random>
#include <cassert>

#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fx(x, a) for (auto &x : a)
#define mp make_pair
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define ppb pop_back()
#define all(x) x.begin(),x.end()


#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl
#else
	#define dbg(x)
#endif

using namespace std;


template<typename T1, typename T2> inline void mine(T1 &x, const T2 &y) {if (y < x) x = y;}
template<typename T1, typename T2> inline void maxe(T1 &x, const T2 &y) {if (x < y) x = y;}

typedef vector<int> vi;
typedef char ch;
typedef string str;
typedef pair<int, int> pii;
typedef vector<char> vch;
typedef vector<pii> vpii;
typedef vector<vi> vvi;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 2010;
const int INF = 2e9 + 228;

struct edge {
    int a;
    int b;
    int id;
    int w;
    edge(int _a, int _b, int _id, int _w) {
        a = _a;
        b = _b;
        id = _id;
        w = _w;
    }
    int to(int v) {
    	return a ^ b ^ v;
    }
    bool operator < (const edge &e) const {
    	return w < e.w;
    }
};

vector<edge> e;
int curmx;
int tin[N], fup[N], timer = 1;
bool br[N];
vi g[N];

void dfsb(int v, int prid) {
	tin[v] = fup[v] = timer++;
	fx(id, g[v]) {
		if (id == prid) continue;
		int to = e[id].to(v);
		if (tin[to]) {
			mine(fup[v], tin[to]);
		} else {
			dfsb(to, id);
			mine(fup[v], fup[to]);
			if (fup[to] > tin[v]) {
				br[id] = true;
			}
		}
	}
}


int pr[N];
vi in[N];
int mn[N];
 
int get(int v) {
    if (pr[v] == v) return v;
    return pr[v] = get(pr[v]);
}

void unite(int id) {
	int a = e[id].a;
	int b = e[id].b;
	int w = e[id].w;
	a = get(a);
	b = get(b);
	if (a == b) {
		mine(mn[a], w);
		return;
	}
	if (in[a].size() < in[b].size()) swap(a, b);
	fx(v, in[b]) in[a].pb(v);
	pr[b] = a;
	mine(mn[a], w);
	mine(mn[a], mn[b]);
}

int ans[N];
vpii gc[N];

void dfs(int v, int prv, int mn2) {
	mine(mn2, mn[v]);
	fx(u, in[v]) {
		mine(ans[u], mn2 + curmx);
	}
	for (auto[to, w] : gc[v]) {
		if (to == prv) continue;
		dfs(to, v, min(mn2, w));
	}
}




int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	fi(0, m) {
		int a, b, t;
		cin >> a >> b >> t;
		--a, --b;
		e.pb(edge(a, b, i, t));
	}		
	fill(ans, ans + n, INF);
	sort(all(e));
	for (int ce = 0; ce < m; ++ce) {
		dbg(ce);
		dbg(e[ce].a);
		dbg(e[ce].b);
		g[e[ce].a].pb(ce);
		g[e[ce].b].pb(ce);
		curmx = e[ce].w;
		memset(br, 0, sizeof(br));
		memset(tin, 0, sizeof(tin));
		timer = 1;
		dfsb(0, -1);
		fi(0, n) {
			mn[i] = INF;
			pr[i] = i;
			in[i] = {i};
		}
		fi(0, ce + 1) {
			if (!br[i]) {
				dbg(i);
				unite(i);
			}
		}
		fi(0, n) {
			gc[i].clear();
		}
		fi(0, ce + 1) {
			if (br[i]) {
				int a = get(e[i].a);
				int b = get(e[i].b);
				assert(a != b);
				gc[a].pb({b, e[i].w});
				gc[b].pb({a, e[i].w});
			}
		}
		dfs(get(0), -1, INF);
	}
	fi(1, n) {
		cout << ans[i] << '\n';
	}
}
