//#pragma GCC optimize("Ofast")

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <cassert>
#include <queue>

//const int MAX_MEM = 1e9;
//char MEM[MAX_MEM];
//int m_pos = 0;
//
//void* operator new(size_t n) {
//    assert((m_pos += n) <= MAX_MEM);
//    return (void*) (MEM + m_pos - n);
//}
//
//void operator delete(void*) {}

using namespace std;
#define int long long
#define mp make_pair
const int SZ = 3e5 + 4;
const int inf = 2e18;

int n, q;
int x[SZ];
int h[SZ];

void read() {
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
}

void solve() {
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        set<int> y;
        for (int j = l; j < r; ++j) {
            y.insert(j);
        }

        auto check_left = [&](int p) {
            auto it = y.lower_bound(p);
            if (it == y.begin()) {
                if (x[p] - h[p] >= x[0]) {
                    if (l == 0 || x[p] - h[p] >= x[l - 1]) {
                        return true;
                    }
                }
            } else {
                --it;
                if (x[p] - h[p] >= x[*it]) {
                    return true;
                }
                ++it;
            }
            return false;
        };

        auto check_right = [&](int p) {
            auto it = y.lower_bound(p);
            ++it;
            if (it == y.end()) {
                if (x[p] + h[p] <= x[n - 1]) {
                    if (r == n || x[p] + h[p] <= x[r]) {
                        return true;
                    }
                }
            } else {
                if (x[p] + h[p] <= x[*it]) {
                    return true;
                }
            }
            return false;
        };

        vector<char> used(n, false);
        queue<int> s;
        for (auto p : y) {
            if (check_left(p)) {
                s.push(p);
                used[p] = true;
            }
            else if (check_right(p)) {
                used[p] = true;
                s.push(p);
            }
        }
        int ans = 0;

        while (!s.empty()) {
            int u = s.front();
            s.pop();

            ++ans;
            y.erase(u);
            auto it = y.lower_bound(u);
            if (it != y.end()) {
                if (!used[*it] && check_left(*it)) {
                    used[*it] = true;
                    s.push(*it);
                }
            }
            if (it != y.begin()) {
                --it;
                if (!used[*it] && check_right(*it)) {
                    used[*it] = true;
                    s.push(*it);
                }
            }
        }

        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}
