#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <random>
#include <iomanip>
#include <fstream>
#include <queue>
#include <numeric>
#include <deque>
#include <set>
#include <map>
#include <ctime>
// #pragma GCC optimize("Ofast,O2,O3")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;
const int MAXN = 3e5;
vector<int> G[MAXN];
int depth[MAXN];
const int MAXM = MAXN * 2;
pair<int, int> E[MAXM];
bitset<MAXM> used;


void dfs(int v, int p) {
    depth[v] = depth[p] + 1;
    for (int u : G[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
}


vector<int> H[MAXN];


vector<pair<int, int>> res;


void add(int i, int j) {
    used[i] = true;
    used[j] = true;
    res.emplace_back(i, j);
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        G[a].push_back(b);
        G[b].push_back(a);
        E[i] = make_pair(a, b);
        H[a].push_back(i);
        H[b].push_back(i);
    }
    //
    for (int v = 0; v < n; ++v) {
        if (depth[v] == 0) {
            depth[v] = -1;
            dfs(v, v);
        }
    }
    vector<pair<int, int>> order(n);
    for (int v = 0; v < n; ++v) {
        order[v] = make_pair(depth[v], v);
    }
    sort(order.rbegin(), order.rend());
    for (auto [_, v] : order) {
        int p_in = -1, p_out = -1;
        vector<int> in, out;
        for (int i : H[v]) {
            if (used[i]) {
                continue;
            }
            if (E[i].first == v) {
                if (depth[E[i].second] < depth[v]) {
                    p_out = i;
                } else {
                    out.push_back(i);
                }
            } else {
                if (depth[E[i].first] < depth[v]) {
                    p_in = i;
                } else {
                    in.push_back(i);
                }
            }
        }
        //
        while (!out.empty() && !in.empty()) {
            add(out.back(), in.back());
            out.pop_back();
            in.pop_back();
        }
        //
        if (!out.empty() && p_in != -1) {
            add(out.back(), p_in);
        }
        if (!in.empty() && p_out != -1) {
            add(in.back(), p_out);
        }
    }
    //
    if (res.size() != m / 2) {
        cout << "No\n";
        return 0;
    }
    cout << "Yes\n";
    for (auto [i, j] : res) {
        cout << E[i].first + 1 << " " << E[i].second + 1 << " " << E[j].first + 1 << " " << E[j].second + 1 << "\n";
    }
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}