#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>

#define int long long

using namespace std;

vector<int> ans;

void dfs(int v, vector<vector<pair<int, int>>> &g, int parent, int res1, int res2){
    ans[v] = res1 + res2;
    for (auto p : g[v]){
        int u = p.first;
        if (u == parent){
            continue;
        }
        dfs(u, g, v, min(p.second, res1), max(p.second, res2));
    }
}

signed main(){
    int n, m;
    cin >> n >> m;
    ans.resize(n);
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i){
        int a, b, t;
        cin >> a >> b >> t;
        a--;
        b--;
        g[a].push_back({b, t});
        g[b].push_back({a, t});
    }
    if (m == n - 1){
        dfs(0, g, -1, 1e9, -1e9);
        for (int i = 1; i < n; ++i){
            cout << ans[i] << endl;
        }
    } else {
        vector<int> used(n);
        vector<int> dist(n);
        set<pair<int, int>> s;
        s.insert({0, 0});
        while(s.size()){
            int v = (*s.begin()).second;
            s.erase(s.begin());
            for (auto p : g[v]){
                int u = p.first;
                int tt = p.second;
                if (used[u]){
                    continue;
                }
                dist[u] = max(dist[v], tt);
                used[u] = 1;
                s.insert({tt, u});
            }
        }
        for (int i = 1; i < n; ++i){
            cout << dist[i];
        }
    }
    return 0;
}
/*


*/
