#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int inf = 1e9;

vector < long long > x;
vector < long long > fall;

bool comp(int i, int j) {
	if (fall[i] == fall[j]) return x[i] < x[j];
	return fall[i] < fall[j];
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, q;
	cin >> n >> q;
	x.assign(n, 0);
	vector < long long > h(n);
	for (int i = 0; i < n; i++) cin >> x[i] >> h[i];

	if (n == 1) {
		for (int i = 0; i < q; i++) {
			int l, r;
			cin >> l >> r;
			cout << "0\n";
		}
		return 0;
	}

	vector < int > left(n);
	vector < int > right(n);
	for (int i = 0; i < n; i++) {
		int id = i;
		while (id > 0 && x[i] - x[id - 1] < h[i]) id--;
		left[i] = id;
		id = i;
		while (id < n - 1 && x[id + 1] - x[i] < h[i]) id++;
		right[i] = id;
	}

	vector < int > ln(n, -1);
	vector < int > rn(n, -1);
	ln[0] = 0; rn[n - 1] = n - 1;
	rn[0] = 1; ln[n - 1] = n - 1;
	for (int i = 1; i < n - 1; i++) {
		ln[i] = i - 1;
		rn[i] = i + 1;
	}

	vector < int > nln, nrn;

	int w = 0;
	fall.assign(n, inf);
	while (true) {
		bool fallen = false;
		nln = ln;
		nrn = rn;
		for (int i = 0; i < n; i++) {
			if (fall[i] < w) continue;
			if (x[rn[i]] - x[i] >= h[i] || x[i] - x[ln[i]] >= h[i]) {
				fall[i] = w;
				fallen = true;
				nln[rn[i]] = ln[i];
				nrn[ln[i]] = rn[i];
			}
		}
		rn = nrn;
		ln = nln;
		w++;
		if (!fallen) break;
	}

	vector < vector < int > > order(w);
	for (int i = 0; i < w; i++) {
		for (int j = 0; j < n; j++) {
			if (fall[j] == i) order[i].push_back(j);
		}
	}

	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--; r--;

		vector < int > lnt;
		vector < int > rnt;
		for (int j = l; j <= r; j++) {
			if (j > 0) ln[j] = j - 1;
			else ln[j] = j;
			if (j < n - 1) rn[j] = j + 1;
			else rn[j] = j;
		}
		int res = 0;

		for (int j = 0; j < w; j++) {
			for (int k = 0; k < order[j].size(); k++) {
				int t = order[j][k];
				if (t < l || t > r) continue;
				if (right[t] <= r && x[rn[t]] - x[t] >= h[t]) {
					res++;
					rn[ln[t]] = rn[t];
					ln[rn[t]] = ln[t];
				}
				else if (left[t] >= l && x[t] - x[ln[t]] >= h[t]) {
					res++;
					rn[ln[t]] = rn[t];
					ln[rn[t]] = ln[t];
				}
			}
		}

		cout << res << "\n";
	}
}