#include <iostream>
#include <algorithm>
#include <vector>

#define all(x) (x).begin(), (x).end()

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef vector <long long> vll;

const long long INFll = 2e18;

void solve() {
    string s; cin >> s;
    int n = s.size();

    vector <vll> dp(n + 1, vll(26, -INFll));
    vector <vi> p(n + 1, vi(26, -1));
    vector <vector <char>> d(n + 1, vector <char>(26, 0));
    fill(all(dp[n]), 0ll);

    vll val(26);
    val[0] = 1;
    val[1] = 5;
    for (int i = 2; i < 26; i++)
        val[i] = 10 * val[i - 2];

    for (int i = n - 1; i > -1; i--) {
        if (s[i] != '?') {
            ll d0 = 0;
            for (int j = 0; j < 26; j++) {
                if (dp[i + 1][j] > dp[i + 1][d0])
                    d0 = j;
                if (s[i] - 'A' >= j) {
                    if (dp[i][s[i] - 'A'] < dp[i + 1][d0] + val[s[i] - 'A']) {
                        dp[i][s[i] - 'A'] = dp[i + 1][d0] + val[s[i] - 'A'];
                        p[i][s[i] - 'A'] = d0;
                        d[i][s[i] - 'A'] = s[i];
                    }
                } else {
                    if (dp[i][j] < dp[i + 1][j] - val[s[i] - 'A']) {
                        dp[i][j] = dp[i + 1][j] - val[s[i] - 'A'];
                        p[i][j] = j;
                        d[i][j] = s[i];
                    }
                }
            }
        } else {
            ll d0 = 0;
            for (int j = 0; j < 26; j++) {
                if (dp[i + 1][j] > dp[i + 1][d0])
                    d0 = j;
                for (int k = 0; k < j; k++) {
                    if (dp[i][j] < dp[i + 1][j] - val[k]) {
                        dp[i][j] = dp[i + 1][j] - val[k];
                        p[i][j] = j;
                        d[i][j] = k + 'A';
                    }
                }
                for (int k = j; k < 26; k++) {
                    if (dp[i][k] < dp[i + 1][d0] + val[k]) {
                        dp[i][k] = dp[i + 1][d0] + val[k];
                        p[i][k] = d0;
                        d[i][k] = k + 'A';
                    }
                }
            }
        }
    }

    cout << *max_element(all(dp[0])) << "\n";
    for (int i = 0, j = max_element(all(dp[0])) - dp[0].begin(); i < n; i++) {
        cout << d[i][j];
        j = p[i][j];
    }
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int t; cin >> t;
    while (t--) {
        solve();
    }
}
