#include <iostream>
#include <algorithm>
#include <vector>

#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef pair <int, int> pii;
typedef vector <pii> vii;
typedef vector <long long> vll;

const long long INFll = 2e18;
const int N = 3e5;

vi g0[N];
bool was[N];

int par[N];
bool fp[N], tp[N];

void dfs(int v) {
    was[v] = true;
    for (int i : g0[v]) {
        if (!was[i]) {
            par[i] = v;
            dfs(i);
        }
    }
}

vector <pair <pii, pii>> ans;
vi g[N];

void dfs2(int v, int p) {
    was[v] = true;
    vi ie, oe;
    for (int i : g[v]) {
        dfs2(i, v);
        if (fp[i] && tp[i]) {
            ans.pb(mp(mp(i, v), mp(v, i)));
        } else if (fp[i]) {
            oe.pb(i);
        } else if (tp[i]) {
            ie.pb(i);
        }
    }

    if (ie.size() == oe.size()) {
        for (int i = 0; i < ie.size(); i++)
            ans.pb(mp(mp(ie[i], v), mp(v, oe[i])));
        return;
    }
    if (par[v] == 0) {
        cout << "No\n"; exit(0);
    }
    if (ie.size() == oe.size() + 1 && tp[v]) {
        for (int i = 0; i < oe.size(); i++)
            ans.pb(mp(mp(ie[i], v), mp(v, oe[i])));
        ans.pb(mp(mp(ie.back(), v), mp(v, par[v])));
        tp[v] = false;
        return;
    }
    if (oe.size() == ie.size() + 1 && fp[v]) {
        for (int i = 0; i < ie.size(); i++)
            ans.pb(mp(mp(ie[i], v), mp(v, oe[i])));
        ans.pb(mp(mp(par[v], v), mp(v, oe.back())));
        fp[v] = false;
        return;
    }
    //cout << v << ' ' << ie.size() << ' ' << oe.size() << endl;
    cout << "No\n"; exit(0);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vii e;
    for (int i = 0; i < m; i++) {
        int x, y; cin >> x >> y;
        e.pb(x, y);
        g0[x].pb(y);
        g0[y].pb(x);
    }

    for (int i = 1; i <= n; i++) {
        if (!was[i])
            dfs(i);
    }

    for (auto p : e) {
        if (p.se == par[p.fi]) {
            tp[p.fi] = true;
        }
        if (p.fi == par[p.se]) {
            g[p.fi].pb(p.se);
            fp[p.se] = true;
        }
    }

    //for (int i = 1; i <= n; i++)
    //    cout << i << ' ' << par[i] << ' ' << fp[i] << ' ' << tp[i] << endl;

    fill(was, was + N, false);
    for (int i = 1; i <= n; i++) {
        if (!was[i])
            dfs2(i, 0);
    }

    cout << "Yes\n";
    for (auto p : ans)
        cout << p.fi.fi << ' ' << p.fi.se << ' ' << p.se.fi << ' ' << p.se.se << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    solve();
}
