#include <map>
#include <set>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 150000;

vector<pair<int, int>> G[MAXN];
bool dp[MAXN][3];
bool used[MAXN];

void dfs(int v) {
  used[v] = true;
  int bal_mn = 0;
  int bal_mx = 0;
  for (auto t : G[v]) {
    if (used[t.first])
      continue;
    dfs(t.first);
    if (t.second == 0) {
      if (dp[t.first][1] && dp[t.first][2]) {
        ++bal_mx;
      } else if (dp[t.first][1]) {
        ++bal_mn;
        ++bal_mx;
      } else if (dp[t.first][2]) {
        ;
      } else {
        cout << "No\n";
        exit(0);
      }
    } else if (t.second == 1) {
      if (dp[t.first][0] && dp[t.first][1]) {
        --bal_mn;
      } else if (dp[t.first][0]) {
        ;
      } else if (dp[t.first][1]) {
        --bal_mn;
        --bal_mx;
      } else {
        cout << "No\n";
        exit(0);
      }
    } else {
      int delta_max = -2;
      int delta_min = 2;
      if (dp[t.first][0]) {
        delta_max = max(delta_max, 1);
        delta_min = min(delta_min, 1);
      }
      if (dp[t.first][1]) {
        delta_max = max(delta_max, 0);
        delta_min = min(delta_min, 0);
      }
      if (dp[t.first][2]) {
        delta_max = max(delta_max, -1);
        delta_min = min(delta_min, -1);
      }
      if (delta_max == -2) {
        cout << "No\n";
        exit(0);
      }
      bal_mx += delta_max;
      bal_mn += delta_min;
    }
  }
  for (int i = -1; i <= 1; ++i) {
    if (bal_mn <= i && i <= bal_mx)
      dp[v][i + 1] = true;
  }
}

vector<int> ans_in[MAXN];
vector<int> ans_out[MAXN];

void zhfs(int v, int p, int need) {
  used[v] = true;
  int bal_mn = 0;
  int bal_mx = 0;
  for (auto t : G[v]) {
    if (t.first == p)
      continue;
    if (t.second == 0) {
      if (dp[t.first][1] && dp[t.first][2]) {
        ++bal_mx;
      } else if (dp[t.first][1]) {
        ++bal_mn;
        ++bal_mx;
      } else if (dp[t.first][2]) {
        ;
      } else {
        cout << "No\n";
        exit(0);
      }
    } else if (t.second == 1) {
      if (dp[t.first][0] && dp[t.first][1]) {
        --bal_mn;
      } else if (dp[t.first][0]) {
        --bal_mn;
        --bal_mx;
      } else if (dp[t.first][1]) {
        ;
      } else {
        cout << "No\n";
        exit(0);
      }
    } else {
      int delta_max = -2;
      int delta_min = 2;
      if (dp[t.first][0]) {
        delta_max = max(delta_max, 1);
        delta_min = min(delta_min, 1);
      }
      if (dp[t.first][1]) {
        delta_max = max(delta_max, 0);
        delta_min = min(delta_min, 0);
      }
      if (dp[t.first][2]) {
        delta_max = max(delta_max, -1);
        delta_min = min(delta_min, -1);
      }
      bal_mx += delta_max;
      bal_mn += delta_min;
    }
  }
  int cur = need;
  for (int i = int(G[v].size()) - 1; i >= 0; --i) {
    auto t = G[v][i];
    if (t.first == p)
      continue;
    if (t.second == 0) {
      if (dp[t.first][1] && dp[t.first][2]) {
        if (cur == bal_mx) {
          --cur;
          zhfs(t.first, v, 0);
          ans_out[v].emplace_back(t.first);
        } else {
          zhfs(t.first, v, 1);
          ans_in[t.first].emplace_back(v);
        }
        --bal_mx;
      } else if (dp[t.first][1]) {
        --cur;
        zhfs(t.first, v, 0);
        ans_out[v].emplace_back(t.first);
        --bal_mn;
        --bal_mx;
      } else if (dp[t.first][2]) {
        zhfs(t.first, v, 1);
        ans_in[t.first].emplace_back(v);
      }
    } else if (t.second == 1) {
      if (dp[t.first][0] && dp[t.first][1]) {
        if (cur == bal_mn) {
          ++cur;
          zhfs(t.first, v, 0);
          ans_in[v].emplace_back(t.first);
        } else {
          zhfs(t.first, v, -1);
          ans_out[t.first].emplace_back(v);
        }
        ++bal_mn;
      } else if (dp[t.first][0]) {
        zhfs(t.first, v, -1);
        ans_out[t.first].emplace_back(v);
      } else if (dp[t.first][1]) {
        ++cur;
        zhfs(t.first, v, 0);
        ans_in[v].emplace_back(t.first);
        ++bal_mn;
        ++bal_mx;
      }
    } else {
      int delta_max = -2;
      int delta_min = 2;
      if (dp[t.first][0]) {
        delta_max = max(delta_max, 1);
        delta_min = min(delta_min, 1);
      }
      if (dp[t.first][1]) {
        delta_max = max(delta_max, 0);
        delta_min = min(delta_min, 0);
      }
      if (dp[t.first][2]) {
        delta_max = max(delta_max, -1);
        delta_min = min(delta_min, -1);
      }
      if (delta_max == 1 && cur == bal_mx) {
        --cur;
        zhfs(t.first, v, -1);
        ans_out[t.first].emplace_back(v);
        ans_out[v].emplace_back(t.first);
      } else if (delta_min == -1 && cur == bal_mn) {
        ++cur;
        zhfs(t.first, v, 1);
        ans_in[t.first].emplace_back(v);
        ans_in[v].emplace_back(t.first);
      } else {
        zhfs(t.first, v, 0);
        ans_in[v].emplace_back(t.first);
        ans_out[v].emplace_back(t.first);
      }
      bal_mx -= delta_max;
      bal_mn -= delta_min;
    }
  }
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, m;
  cin >> n >> m;
  while (m--) {
    int a, b;
    cin >> a >> b;
    --a;
    --b;
    G[a].emplace_back(b, 0);
    G[b].emplace_back(a, 1);
  }
  for (int i = 0; i < n; ++i) {
    sort(G[i].begin(), G[i].end());
    for (int j = 1; j < G[i].size(); ++j) {
      if (G[i][j].first == G[i][j - 1].first) {
        G[i][j - 1].second = 2;
        G[i][j].second = 2;
      }
    }
    G[i].resize(unique(G[i].begin(), G[i].end()) - G[i].begin());
  }
  for (int i = 0; i < n; ++i) {
    if (!used[i]) {
      dfs(i);
      if (!dp[i][1]) {
        cout << "No\n";
        return 0;
      }
    }
  }
  cout << "Yes\n";
  fill(used, used + n, false);
  for (int i = 0; i < n; ++i) {
    if (!used[i])
      zhfs(i, -1, 0);
  }
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < ans_in[i].size(); ++j)
      cout << ans_in[i][j] + 1 << ' ' << i + 1 << ' ' << i + 1 << ' ' << ans_out[i][j] + 1 << '\n';
  }
  return 0;
}
