#include <map>
#include <set>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int INF = 1e9;

map<int, int> dp[(1 << 20) + 228][20];
pair<int, int> edges[20];
int cost[20];

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    int a, b, c;
    cin >> a >> b >> c;
    edges[i] = make_pair(a - 1, b - 1);
    cost[i] = c;
  }
  vector<int> ans(n, 2 * INF);
  dp[0][0][INF] = 0;
  for (int mask = 1; mask < (1 << m); ++mask) {
    for (int last = 0; last < m; ++last) {
      if (!(mask & (1 << last)))
        continue;
      int a = edges[last].first, b = edges[last].second;
      int c = cost[last];
      for (auto t : dp[mask ^ (1 << last)][a]) {
        int new_mn = min(t.first, c);
        int new_mx = max(t.second, c);
        if (!dp[mask][b].count(new_mn))
          dp[mask][b][new_mn] = new_mx;
        else
          dp[mask][b][new_mn] = min(dp[mask][b][new_mn], new_mx);
      }
      for (auto t : dp[mask ^ (1 << last)][b]) {
        int new_mn = min(t.first, c);
        int new_mx = max(t.second, c);
        if (!dp[mask][a].count(new_mn))
          dp[mask][a][new_mn] = new_mx;
        else
          dp[mask][a][new_mn] = min(dp[mask][a][new_mn], new_mx);
      }
    }
    for (int i = 0; i < n; ++i) {
      for (auto t : dp[mask][i])
        ans[i] = min(ans[i], t.first + t.second);
    }
  }
  for (int i = 1; i < n; ++i)
    cout << ans[i] << '\n';
  return 0;
}
