#include <map>
#include <set>
#include <deque>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>
 
using namespace std;
 
const int INF = 1e9;
const int MAXN = 300000;
 
vector<pair<int, int>> G[MAXN];
int tin[MAXN];
int tup[MAXN];
int ttime = 0;
 
bool is_bridge[MAXN];
int cost[MAXN];
 
void dfs1(int v, int p) {
  ++ttime;
  tin[v] = tup[v] = ttime;
  for (auto t : G[v]) {
    if (t.second == p)
      continue;
    if (tin[t.first]) {
      tup[v] = min(tup[v], tin[t.first]);
    } else {
      dfs1(t.first, t.second);
      tup[v] = min(tup[v], tup[t.first]);
      if (tup[t.first] > tin[v])
        is_bridge[t.second] = true;
    }
  }
}
 
int used[MAXN];
vector<int> comps[MAXN];
 
void dfs2(int v, int c) {
  used[v] = c;
  comps[c].emplace_back(v);
  for (auto t : G[v]) {
    if (is_bridge[t.second])
      continue;
    if (used[t.first] != -1)
      continue;
    dfs2(t.first, c);
  }
}
 
int dp[MAXN];
 
void calc(int c, int v, int p) {
  int mn = dp[v];
  for (int vertex : comps[c]) {
    for (auto t : G[vertex]) {
      if (is_bridge[t.second])
        continue;
      mn = min(mn, cost[t.second]);
    }
  }
  for (int vertex : comps[c])
    dp[vertex] = mn;
  for (int vertex : comps[c]) {
    for (auto t : G[vertex]) {
      if (!is_bridge[t.second])
        continue;
      if (used[t.first] == p)
        continue;
      dp[t.first] = min(dp[vertex], cost[t.second]);
      calc(used[t.first], t.first, c);
    }
  }
}
 
 
int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif
 
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    int a, b;
    cin >> a >> b >> cost[i];
    G[a - 1].emplace_back(b - 1, i);
    G[b - 1].emplace_back(a - 1, i);
  }
  dfs1(0, -1);
  fill(used, used + n, -1);
  int k = 0;
  for (int i = 0; i < n; ++i) {
    if (used[i] != -1)
      continue;
    dfs2(i, k);
    ++k;
  }
  dp[0] = INF;
  calc(used[0], 0, -1);
  for (int i = 1; i < n; ++i)
    cout << INF + dp[i] << '\n';
  return 0;
}