#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
using namespace std;
#define int long long

void dfs(int u, int par, vector <int>& used, vector <vector <int>>& w, vector <pair <int, int>>& eg, vector <int>& h, int depth) {
	h[u] = depth;
	used[u] = true;
	for (auto ind : w[u]) {
		int v = (eg[ind].first == u ? eg[ind].second : eg[ind].first);
		if (v == par) continue;
		dfs(v, u, used, w, eg, h, depth + 1);
	}
}

bool kunh(int u, vector <vector <int>>& w, vector <int>& used, vector <int>& mt) {
	if (used[u]) {
		return false;
	}
	used[u] = true;
	for (int v : w[u]) {
		if (mt[v] == -1 || kunh(mt[v], w, used, mt)) {
			mt[v] = u;
			return true;
		}
	}
	return false;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <pair <int, int>> eg(m);
	for (int i = 0; i < m; ++i) {
		cin >> eg[i].first >> eg[i].second;
		--eg[i].first;
		--eg[i].second;
	}
	vector <vector <int>> egIn(n), egOut(n);
	for (int i = 0; i < m; ++i) {
		egIn[eg[i].first].push_back(i);
		egOut[eg[i].second].push_back(i);
	}
	// m = 2 * n - 4
	set <pair <int, int>> st;
	for (auto vt : eg) {
		st.insert({ vt.first, vt.second });
		st.insert({ vt.second, vt.first });
	}
	for (auto vt : eg) {
		st.erase(vt);
	}
	if (st.size() == 0) {
		cout << "Yes\n";
		set <pair <int, int>> printed;
		for (int i = 0; i < m; ++i) {
			if (printed.find(eg[i]) == printed.end()) {
				cout << eg[i].first + 1 << " " << eg[i].second + 1 << " " << eg[i].second + 1 << " " << eg[i].first + 1 << "\n";
				printed.insert({ eg[i].first, eg[i].second });
				printed.insert({ eg[i].second, eg[i].first });
			}
		} 
		return;
	}
	auto f1 = (*st.begin());
	st.erase(st.begin());
	auto f2 = (*st.begin());
	st.erase(st.begin());
	if (f2.second == f1.first) {
		swap(f1, f2);
	}
	if (f1.second != f2.first) {
		cout << "No\n";
		return;
	}
	else {
		cout << "Yes\n";
		cout << f2.second + 1 << " " << f2.first + 1 << " " << f2.first + 1 << " " << f1.first + 1 << "\n";
		set <pair <int, int>> printed;
		printed.insert(f1);
		printed.insert(f2);
		printed.insert({ f1.second, f1.first });
		printed.insert({ f2.second, f2.first });
		for (int i = 0; i < m; ++i) {
			if (printed.find(eg[i]) == printed.end()) {
				cout << eg[i].first + 1 << " " << eg[i].second + 1 << " " << eg[i].second + 1 << " " << eg[i].first + 1 << "\n";
				printed.insert({ eg[i].first, eg[i].second });
				printed.insert({ eg[i].second, eg[i].first });
			}
		}
	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test = 1;
	//cin >> test;
	while (test--) solve();
}