#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <deque>
using namespace std;
#define int long long

struct base {
	int x, h;
};

const int MAXN = 500000;
int t[4 * MAXN];

void update(int tpos, int tl, int tr, int pos, int val) {
	if (pos > tr || pos < tl) {
		return;
	}
	if (tl == tr && tl == pos) {
		t[tpos] = val;
		return;
	}
	update(2 * tpos + 1, tl, (tl + tr) / 2, pos, val);
	update(2 * tpos + 2, (tl + tr) / 2 + 1, tr, pos, val);
	t[tpos] = t[2 * tpos + 1] + t[2 * tpos + 1];
}

int findr(int tpos, int tl, int tr, int L) {
	if (t[tpos] == 0 || tr < L) {
		return -1;
	}
	if (tl == tr) {
		return tl;
	}
	int ql = findr(2 * tpos + 1, tl, (tl + tr) / 2, L);
	if (ql != -1) return ql;
	return findr(2 * tpos + 2, (tl + tr) / 2 + 1, tr, L);
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector <base> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].h;
	}
	for (int it = 0; it < q; ++it) {
		int l, r;
		cin >> l >> r;
		--l, --r;
		for (int i = 0; i < 4 * n; ++i) {
			t[i] = 0;
		}
		deque <int> st;
		vector <int> down(n);
		int ans = 0;
		for (int i = l; i <= r; ++i) {
			if (i >= 1 && a[i].x - a[i].h >= a[i - 1].x ||
				i + 1 < n && a[i].x + a[i].h < a[i + 1].x) {
				st.push_back(i);
				down[i] = true;
			}
		}
		while (!st.empty()) {
			int u = st.front();
			st.pop_front();
			++ans;
			int bl = -1, br = -1;
			for (int i = u; i >= 0; --i) {
				if (down[i] == 0) {
					bl = i;
					break;
				}
			}
			for (int i = u; i < n; ++i) {
				if (down[i] == 0) {
					br = i;
					break;
				}
			}
			br = findr(0, 0, n - 1, u);
			int LEFT = (bl == -1 ? a[0].x : a[bl].x);
			int RIGHT = (br == -1 ? a[n - 1].x : a[br].x);
			if (bl != -1 && bl >= l && bl <= r && down[bl] == 0 && a[bl].x + a[bl].h <= RIGHT) {
				down[bl] = 1;
				st.push_back(bl);
			}
			if (br != -1 && br >= l && br <= r && down[br] == 0 && a[br].x - a[br].h >= LEFT) {
				down[br] = 1;
				st.push_back(br);
			}
		}
		cout << ans << "\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test = 1;
	//cin >> test;
	while (test--) solve();
}