#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <deque>
using namespace std;
#define int long long
const int INF = 1e10;
struct base {
	int u, v, cost;
	base() { u = 0, v = 0, cost = 0; }
	base(int u, int v, int cost) : u(u), v(v), cost(cost) {};
};

void dfs(int u, int p, int mn, int mx, vector <vector <base>>& w, vector <int>& ans) {
	ans[u] = mn + mx;
	for (auto vt : w[u]) {
		if (vt.v == p) continue;
		dfs(vt.v, vt.u, min(mn, vt.cost), max(mx, vt.cost), w, ans);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <vector <base>> w(n);
	vector <base> eg(m);
	for (int i = 0; i < m; ++i) {
		int u, v, cost;
		cin >> u >> v >> cost;
		--u, --v;
		w[u].emplace_back(u, v, cost);
		w[v].emplace_back(v, u, cost);
		eg[i] = base(u, v, cost);
	}
	vector <int> ans(n);
	dfs(0, 0, INF, -INF, w, ans);
	for (int i = 1; i < n; ++i) {
		cout << ans[i] << "\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test = 1;
	//cin >> test;
	while (test--) solve();
}