#include <bits/stdc++.h>
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define mp std::make_pair
typedef long long ll;
const int N = 3e5 + 10, K = 26, INF = 1e9;
struct edge
{
	int to;
	int cost;
	int i;
};
std::vector<edge> g[N];
int h[N];
bool isBridge[N], used[N];
void findBridge(int v, int p = -1) {
	used[v] = 1;
	for (auto e : g[v]) {
		if (!used[e.to]) {
			findBridge(e.to, e.i);
			h[v] += h[e.to];
		}
		else if (used[e.to] == 1) {
			h[v]++;
			h[e.to]--;
		}
	}
	if (h[v] == 0 && p != -1) {
		isBridge[p] = 1;
	}
	used[v] = 2;
}
int cycCount = 0;
int inCyc[N];
std::vector<edge> compressedEdges[N];
void compress(int v) {
	used[v] = 1;
	inCyc[v] = cycCount;
	for (auto e : g[v]) {
		if (!isBridge[e.i] && !used[e.to]) {
			compress(e.to);
		}
	}
}
int minCompress[N];
int minCyc[N];
void findMinCompress(int v, int p = -1) {
	for (auto e : compressedEdges[v]) {
		if (e.to == p) continue;
		minCompress[e.to] = std::min(minCompress[e.to], e.cost);
		findMinCompress(e.to, v);
	}
}
void findMinCyc(int v) {
	used[v] = 1;
	for (auto e : g[v]) {
		if (!isBridge[e.i] && !used[e.to]) {
			findMinCyc(e.to);
		}
		if (!isBridge[e.i]) {
			minCyc[inCyc[v]] = std::min(minCyc[inCyc[v]], e.cost);
		}
	}
}
int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    int n, m;
    std::cin >> n >> m;
    FOR(i, m) {
    	int a, b, c;
    	std::cin >> a >> b >> c;
    	--a; --b;
    	g[a].pb({b, c, i});
    	g[b].pb({a, c, i});
    }
    findBridge(0);
    for (auto e : g[0]) {
    	assert(e.cost == 1e9);
    }
    memset(used, 0, sizeof(used));
    FOR(i, n) {
    	if (!used[i]) {
    		compress(i);
    		cycCount++;
    	}
    }
    FOR(i, n) {
    	for (auto e : g[i]) {
    		if (isBridge[e.i]) {
    			compressedEdges[inCyc[i]].pb({inCyc[e.to], e.cost, e.i});
    		}
    	}
    }
    memset(minCompress, 0x3f, sizeof(minCompress));
    memset(minCyc, 0x3f, sizeof(minCyc));
    memset(used, 0, sizeof(used));
    findMinCompress(0);
    FOR(i, n) {
    	if (!used[i]) {
    		findMinCyc(i);
    	}
    }
    for (int i = 1; i < n; ++i) {
    	// debug(inCyc[i])
    	// debug(minCompress[inCyc[i]])
    	// debug(minCyc[inCyc[i]])

    	std::cout << std::min(minCompress[inCyc[i]], minCyc[inCyc[i]]) + (int)1e9 << '\n';
    }
}