#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <string>
#include <array>

#define ar array

using namespace std;
using ll=long long;
using ld=long double;
const ll inf=4e18;

int n, m;
vector<vector<int>> g1, g;
vector<ar<int,2>> e;
vector<ar<ar<int,2>,2>> ans;
vector<int> par;
vector<ar<vector<int>,2>> qup;

vector<bool> used;

void dfs1(int v) {
	used[v]=1;
	for (auto u : g1[v]) {
		if (!used[u]) {
			par[u]=v;
			dfs1(u);
		}
	}
}
void dfs(int v) {
	used[v]=1;
	for (auto i : g[v]) {
		int u=(e[i][1]==v?e[i][0]:e[i][1]);
		if (used[u]) continue;
		dfs(u);
	}
	vector<int> s0, s1;
	for (auto i : g[v]) {
		int u=(e[i][1]==v?e[i][0]:e[i][1]);
		if (u==par[v]) continue;
		if (e[i][1] == u) {
			if (qup[u][0].size()) {
				ans.push_back({e[i],e[qup[u][0].back()]});
				qup[u][0].pop_back();
			}
			else s0.push_back(i);
		}
		else {
			if (qup[u][1].size()) {
				ans.push_back({e[qup[u][1].back()],e[i]});
				qup[u][1].pop_back();
			}
			else s1.push_back(i);
		}
	}
	while (s0.size() && s1.size()) {
		ans.push_back({e[s1.back()],e[s0.back()]});
		s1.pop_back(); s0.pop_back();
	}
	qup[v]={s0,s1};
}

void solve() {
	cin >> n >> m;
	g.assign(n,{}); g1.assign(n,{});
	e.clear(); ans.clear();
	for (int i = 0; i < m; ++i) {
		int u, v; cin >> u >> v; --u, --v;
		g1[u].push_back(v);
		g1[v].push_back(u);
		g[u].push_back(e.size());
		g[v].push_back(e.size());
		e.push_back({u,v});
	}
	par.resize(n); qup.resize(n);
	used.assign(n,0);
	for (int i=0; i<n; ++i) {
		if (!used[i]) {
			par[i]=i;
			dfs1(i);
		}
	}
	used.assign(n,0);
	for (int i = 0; i < n; ++i) {
		if (!used[i]) dfs(i);
	}
	for (auto x : qup) {
		if (x[0].size() || x[1].size()) {
			cout << "No";
			return;
		}
	}
	cout << "Yes\n";
	for (auto x : ans) {
		cout << x[0][0]+1 << " " << x[0][1]+1 << " ";
		cout << x[1][0]+1 << " " << x[1][1]+1 << "\n";
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int test_case=1;
	for (int i = 0; i < test_case; ++i) {
		solve();
		cout << "\n";
	}
}