#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 2000, INF = 1e10;

vector<pair<int, int>> g[MAXN];
vector<pair<int, int>> mg[MAXN];

int tin[MAXN], up[MAXN];
bool used[MAXN];

int height[MAXN], parent[MAXN], dist[MAXN];

map<pair<int, int>, int> cnt;

inline void init(int n) {
    for (int i = 0; i < n; i++) {
        height[i] = 0;
        parent[i] = i;
        used[i] = false;
        dist[i] = INF;
        mg[i].clear();
    }
}

int get_parent(int v) {
    if (parent[v] == v) {
        return v;
    }
    return parent[v] = get_parent(parent[v]);
}

inline void merge(int v, int u) {
    v = get_parent(v), u = get_parent(u);
    if (v == u) {
        return;
    }
    if (height[v] == height[u]) {
        height[v]++;
    }
    if (height[v] > height[u]) {
        parent[u] = v;
    } else {
        parent[v] = u;
    }
}

int dfs(int v = 0, int prev = -1) {
    static int time = 0;
    tin[v] = up[v] = time++;
    used[v] = true;
    int x = 0;
    for (auto &[u, w] : g[v]) {
        if (u != prev) {
            if (!used[u]) {
                int y = dfs(u, v);
                up[v] = min(up[v], up[u]);
                if (up[u] <= tin[v] || y > 1) {
                    merge(v, u);
                }
            } else {
                up[v] = min(up[v], tin[u]);
            }
        } else {
            x++;
        }
    }
    return x;
}

void mini_dfs(int v, int prev = -1, int cur_mn = INF) {
//    cout << v << endl;
    cur_mn = min(cur_mn, dist[v]);
    dist[v] = cur_mn;
    for (auto &[u, w] : mg[v]) {
        if (u != prev) {
            mini_dfs(u, v, min(cur_mn, w));
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> val;
    map<int, vector<pair<int, int>>> e;
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        val.emplace_back(t);
        e[t].emplace_back(v - 1, u - 1);
    }
    sort(val.begin(), val.end());
    val.erase(unique(val.begin(), val.end()), val.end());
    vector<int> ans(n, INF);
    ans[0] = 0;
    for (auto &t : val) {
        for (auto &[v, u] : e[t]) {
            cnt[minmax(v, u)]++;
            g[v].emplace_back(u, t);
            g[u].emplace_back(v, t);
        }
        init(n);
        dfs();
        for (int v = 0; v < n; v++) {
            if (used[v]) {
                for (auto &[u, w] : g[v]) {
                    if (get_parent(v) == get_parent(u)) {
                        dist[get_parent(v)] = min(dist[get_parent(v)], w);
                    } else {
                        mg[get_parent(v)].emplace_back(get_parent(u), w);
                        mg[get_parent(u)].emplace_back(get_parent(v), w);
                    }
                }
            }
        }
        mini_dfs(get_parent(0));
        for (int i = 0; i < n; i++) {
            ans[i] = min(ans[i], dist[get_parent(i)] + t);
        }
    }
    for (int i = 1; i < n; i++) {
        cout << ans[i] << '\n';
    }
    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9
*/