#include <bits/stdc++.h>

#define endl "\n"
using namespace std;

#define double long double
#define int long long

#ifdef int
#define IMIN INT64_MIN
#define IMAX INT64_MAX
#endif

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

struct rb_t {
    int a, b;
    bool used;
};

vector<pair<int, int>> res;

void dfs(int v, int p, bool *used, vector<int> *gr_in, vector<int> *gr_out, rb_t *rbs) {
    used[v] = true;

    for (int r : gr_out[v]) {
        if (!used[rbs[r].b]) {
            dfs(rbs[r].b, v, used, gr_in, gr_out, rbs);
        }
    }
    for (int r : gr_in[v]) {
        if (!used[rbs[r].a]) {
            dfs(rbs[r].a, v, used, gr_in, gr_out, rbs);
        }
    }


    vector<int> rb_out;
    vector<int> rb_in;
    for (int r : gr_out[v]) {
        int g = rbs[r].b;
        if (g == p || rbs[r].used) {
            continue;
        }
        rb_out.push_back(r);
    }
    for (int r : gr_in[v]) {
        int g = rbs[r].a;
        if (g == p || rbs[r].used) {
            continue;
        }
        rb_in.push_back(r);
    }
    while (!rb_out.empty() && !rb_in.empty()) {
        int a = rb_out.back();
        int b = rb_in.back();
        res.emplace_back(a, b);
        rbs[a].used = rbs[b].used = true;
        rb_out.pop_back();
        rb_in.pop_back();
    }

    int rbp_out = -1;
    for (int r : gr_out[v]) {
        if (rbs[r].b == p && !rbs[r].used) {
            rbp_out = r;
            break;
        }
    }
    int rbp_in = -1;
    for (int r : gr_in[v]) {
        if (rbs[r].a == p && !rbs[r].used) {
            rbp_in = r;
            break;
        }
    }

    if (!rb_out.empty() && rbp_in != -1) {
        int a = rb_out.back();
        int b = rbp_in;
        rbp_in = -1;
        res.emplace_back(a, b);
        rbs[a].used = rbs[b].used = true;
    }
    if (!rb_in.empty() && rbp_out != -1) {
        int a = rb_in.back();
        int b = rbp_out;
        rbp_out = -1;
        res.emplace_back(a, b);
        rbs[a].used = rbs[b].used = true;
    }

    if (rbp_in != -1 && rbp_out != -1) {
        int a = rbp_in;
        int b = rbp_out;
        res.emplace_back(a, b);
        rbs[a].used = rbs[b].used = true;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> gr_out[n];
    vector<int> gr_in[n];
    rb_t rbs[m];
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        rbs[i] = {.a = a, .b = b, .used = false};
        gr_out[a].push_back(i);
        gr_in[b].push_back(i);
    }

    bool used[n];
    memset(used, false, sizeof(used));
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, -1, used, gr_in, gr_out, rbs);
        }
    }

    if ((int) res.size() == m / 2) {
        cout << "Yes\n";
        for (auto r : res) {
            auto a = rbs[r.first];
            auto b = rbs[r.second];
            cout << a.a + 1 << " " << a.b + 1 << " " << b.a + 1 << " " << b.b + 1 << endl;
        }
    } else {
        cout << "No\n";
    }
}

//#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t _t;
    cin >> _t;
    while (_t--)
#endif
    solve();
    return 0;
}
