#include <bits/stdc++.h>

using namespace std;


string encode(string s) {
	int n = s.size();

	uint32_t sum_ones_pos = 0;
	for(int i = 0; i < n; i++) {
		if(s[i] == '1') {
			sum_ones_pos += i + 1;
		}
	}
	sum_ones_pos &= ((1 << 17) - 1);

	int sum_mod3 = 0;
	for(int i = 0; i < n; i++) {
		sum_mod3 += s[i] - '0';
	}
	sum_mod3 %= 3;

	stringstream ss;
	ss << s << bitset<17>(sum_ones_pos) << bitset<2>(sum_mod3);
	return ss.str();
}


string decode(string t) {
	int n = t.size() - 19;

	uint32_t sum_ones_pos = 0;
	for(int i = n; i < n + 17; i++) {
		sum_ones_pos = sum_ones_pos * 2 + (t[i] - '0');
	}

	uint32_t cur_sum_ones_pos = 0;
	for(int i = 0; i < n; i++) {
		if(t[i] == '1') {
			cur_sum_ones_pos += i + 1;
		}
	}
	cur_sum_ones_pos &= ((1 << 17) - 1);

	string s = t.substr(0, n);

	if(sum_ones_pos == cur_sum_ones_pos) {
		return s;
	}

	int sum_mod3 = (t[n + 17] - '0') * 2 + (t[n + 18] - '0');

	int cur_sum_mod3 = 0;
	for(int i = 0; i < n; i++) {
		cur_sum_mod3 += t[i] - '0';
	}
	cur_sum_mod3 %= 3;

	if(sum_mod3 == cur_sum_mod3) {
		return s;
	}

	if((sum_mod3 + 1) % 3 == cur_sum_mod3) {
		// added one
		uint32_t pos = (cur_sum_ones_pos - sum_ones_pos - 1) & ((1 << 17) - 1);
		assert(s[pos] == '1');
		s[pos] = '0';
	} else {
		// removed one
		uint32_t pos = (sum_ones_pos - cur_sum_ones_pos - 1) & ((1 << 17) - 1);
		assert(s[pos] == '0');
		s[pos] = '1';
	}

	return s;
}


signed main() {
	int t;
	cin >> t;

	string s;
	cin >> s;

	if(t == 1) {
		cout << encode(s) << endl;
	} else {
		cout << decode(s) << endl;
	}

	return 0;
}