#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define len(x) (ll)(x.size())

void init() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(20);
}

void solve();

int main() {
    init();
    solve();
}

const ll p = 2017;
const ll m = 131072;


#define HP(c) (c == '1' ? 13 : 7)
#define INV(c) (c == '1' ? '0' : '1')

template<class Iterator>
ll hash01(Iterator begin, Iterator end) {
    ll P = 1;
    ll h = 0;
    for (auto e = begin; e != end; ++e) {
        P *= p;
        P %= m;
        h += P * HP(*e);
        h %= m;
    }
    return h;
}

template<class Iterator>
ll frombin(Iterator begin, Iterator end) {
    ll res = 0;
    for (auto e = begin; e != end; ++e) {
        res <<= 1;
        res |= (*e == '1');
    }
    return res;
}

vector<bool> bin(ll x) {
    vector<bool> r;
    for (ll i = 0; i < 17; ++i) {
        r.push_back(x & 1);
        x >>= 1;
    }
    reverse(r.begin(), r.end());
    return r;
}

ll modpow(ll base, ll exp, ll mod) {
    ll res = 1;
    while (exp > 0) {
        if (exp % 2 == 0) {
            exp /= 2;
            base *= base;
            base %= mod;
        } else {
            exp -= 1;
            res *= base;
            res %= mod;
        }
    }
    return res;
}

void solve() {
    ll var;
    cin >> var;
    if (var == 1) {
        string x;
        cin >> x;
        cout << x;
        for (auto e: bin(hash01(x.begin(), x.end()))) {
            cout << (e ? '1' : '0');
        }
        cout << endl;
    } else {
        string z;
        cin >> z;
        ll cache = 0;
        for (ll i = -1; i < len(z); ++i) {
            if (i != -1) {
                // update
                z[i] = INV(z[i]);
            }
//            cerr << "try " << z << endl;
            if (i == -1) {
                cache = hash01(z.begin(), z.end() - 17);
            } else if (i == 0) {
                char s2 = INV(z[i]);
                ll P = modpow(p, i + 1, m);
                cache -= P * HP(s2);
                cache += P * HP(INV(s2));
                while (cache < 0) cache += m;
                cache %= m;
            } else if (i == len(z) - 17) {
                char s1 = INV(z[i - 1]);
                ll P = modpow(p, i, m);
                cache -= P * HP(s1);
                cache += P * HP(INV(s1));
                while (cache < 0) cache += m;
                cache %= m;
            } else if (i < len(z) - 17) {
                ll P;

                char s1 = INV(z[i - 1]);
                P = modpow(p, i, m);
                cache -= P * HP(s1);
                cache += P * HP(INV(s1));
                while (cache < 0) cache += m;
                cache %= m;

                char s2 = INV(z[i]);
                P = modpow(p, i + 1, m);
                cache -= P * HP(s2);
                cache += P * HP(INV(s2));
                while (cache < 0) cache += m;
                cache %= m;
            }
//            string cc, rc;
//            for (auto e: bin(cache)) {
//                cc.push_back(e ? '1' : '0');
//            }
//            for (auto e: bin(hash01(z.begin(), z.end() - 17))) {
//                rc.push_back(e ? '1' : '0');
//            }
//            cerr << "cache  " << cc << endl;
//            cerr << "real   " << rc << endl;
            if (cache == frombin(z.end() - 17, z.end())) {
                cout << z.substr(0, len(z) - 17) << endl;
            }
            // restore
            if (i != -1) {
                z[i] = INV(z[i]);
            }
        }
    }
}