#pragma GCC target("avx,avx2")
#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>

#include <ctime>
#include <chrono>
#include <random>


std::mt19937 rnd(2532);
constexpr int n = 1000;

int gr[n][n];


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);
	std::cout.precision(3);
	std::cout << std::fixed;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			gr[i][j] = rnd() % (int(1e9));
		}
	}

	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
#pragma GCC ivdep
			for (int j = 0; j < n; j++) {
				gr[i][j] = std::min(gr[i][j], gr[i][k] + gr[k][j]);
			}
		}
	}

	int s = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			s += gr[i][j];
		}
	}

	std::cout << CLOCKS_PER_SEC << " ";
	std::cout << clock() * 1.0 / CLOCKS_PER_SEC << "\n";

	std::cout << s << "\n";

	return 0;
}