//#pragma GCC optimize("O3", "Ofast", "unroll-loops", "unswitch-loops", "fast-math", "no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define size(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

const int mx_MEM = 1e8;
int mpos = 0;
char mem[mx_MEM];

inline void *operator new(size_t n) {
    assert((mpos += n) <= mx_MEM);
    return (void *) (mem + mpos - n);
}

inline void operator delete(void *) noexcept {}

struct big {
    vector<int> a;
    int d = 0, t = 1;

    big add(big &x, big &y) {
        big ans;
        int r = 0;
        for (int i = 0; i < max(x.d, y.d); ++i) {
            int nw = r;
            if (i < x.d) nw += x.a[i];
            if (i < y.d) nw += y.a[i];
            ans.a.push_back(nw % 10);
            r = nw / 10;
        }
        while (r > 0) {
            ans.a.push_back(r % 10);
            r /= 10;
        }
        ans.d = size(ans.a);
        return ans;
    }

    bool less(big &x) {
        if (x.d < d) return false;
        if (x.d > d) return true;
        for (int i = d - 1; i >= 0; --i) {
            if (x.a[i] > a[i]) return true;
            if (x.a[i] < a[i]) return false;
        }
        return false;
    }

    big sub(big &x, big &y) {
        if (x.less(y)) {
            big ans = sub(y, x);
            ans.t = -1;
            return ans;
        }
        big ans;
        int r = 0;
        for (int i = 0; i < x.d; ++i) {
            int nw = x.a[i] + r;
            r = 0;
            if (y.d > i) nw -= y.a[i];
            if (nw < 0) {
                r = -1;
                nw += 10;
            }
            ans.a.push_back(nw);
        }
        ans.d = size(ans.a);
        return ans;
    }

    void rev() {
        reverse(all(a));
    }
};

signed main() {
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    big a, b;
    string s1, s2;
    cin >> s1 >> s2;
    int p1 = 0, p2 = 0;
    if (s1[0] == '-') {
        a.t = -1;
        p1++;
    }
    if (s2[0] == '-') {
        b.t = -1;
        p2++;
    }
    for (int i = p1; i < size(s1); ++i) {
        a.a.push_back(s1[i] - '0');
        a.d++;
    }
    for (int i = p2; i < size(s2); ++i) {
        b.a.push_back(s2[i] - '0');
        b.d++;
    }
    a.rev();
    b.rev();

    big ans;
    if (p1 == 1 && p2 == 1) {
        ans = a.add(a, b);
        ans.t = -1;
    } else if (p1 == 1) {
        ans = b.sub(b, a);
    } else if (p2 == 1) {
        ans = a.sub(a, b);
    } else {
        ans = a.add(a, b);
    }
    if (ans.t == -1) cout << "-";
    for (int i = ans.d - 1; i >= 0; --i) {
        cout << ans.a[i];
    }
    cout << endl;
}